// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(_) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function n(e) {
        return e.split("");
    }
    function cn(e, n) {
        return n.indexOf(e) >= 0;
    }
    function ln(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function Z(e, n) {
        if (n <= 0) return "";
        if (n == 1) return e;
        var t = Z(e, n >> 1);
        t += t;
        return n & 1 ? t + e : t;
    }
    function t(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function i(e, n) {
        this.message = e;
        this.defs = n;
    }
    i.prototype = Object.create(Error.prototype);
    i.prototype.constructor = i;
    i.prototype.name = "DefaultsError";
    t(i);
    function be(e, n, t) {
        if (t) for (var r in e) {
            if (kn(e, r) && !kn(n, r)) throw new i("`" + r + "` is not a supported option", n);
        }
        for (var r in e) {
            if (kn(e, r)) n[r] = e[r];
        }
        return n;
    }
    function pn() {}
    function dn() {
        return false;
    }
    function vn() {
        return true;
    }
    function hn() {
        return this;
    }
    function mn() {
        return null;
    }
    var _n = function() {
        function e(e, n) {
            var t = [];
            for (var r = 0; r < e.length; r++) {
                var i = n(e[r], r);
                if (i === a) continue;
                if (i instanceof o) {
                    t.push.apply(t, i.v);
                } else {
                    t.push(i);
                }
            }
            return t;
        }
        e.is_op = function(e) {
            return e === a || e instanceof o;
        };
        e.splice = function(e) {
            return new o(e);
        };
        var a = e.skip = {};
        function o(e) {
            this.v = e;
        }
        return e;
    }();
    function gn(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function bn(e, r) {
        return e.replace(/\{([^{}]+)\}/g, function(e, n) {
            var t = r[n];
            return t instanceof nn ? t.print_to_string() : t;
        });
    }
    function yn(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function wn(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function en(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function xn() {
        this.values = Object.create(null);
    }
    xn.prototype = {
        set: function(e, n) {
            if (e == "__proto__") {
                this.proto_value = n;
            } else {
                this.values[e] = n;
            }
            return this;
        },
        add: function(e, n) {
            var t = this.get(e);
            if (t) {
                t.push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return e == "__proto__" ? this.proto_value : this.values[e];
        },
        del: function(e) {
            if (e == "__proto__") {
                delete this.proto_value;
            } else {
                delete this.values[e];
            }
            return this;
        },
        has: function(e) {
            return e == "__proto__" ? "proto_value" in this : e in this.values;
        },
        all: function(e) {
            for (var n in this.values) if (!e(this.values[n], n)) return false;
            if ("proto_value" in this && !e(this.proto_value, "__proto__")) return false;
            return true;
        },
        each: function(e) {
            for (var n in this.values) e(this.values[n], n);
            if ("proto_value" in this) e(this.proto_value, "__proto__");
        },
        size: function() {
            return Object.keys(this.values).length + ("proto_value" in this);
        },
        map: function(e) {
            var n = [];
            for (var t in this.values) n.push(e(this.values[t], t));
            if ("proto_value" in this) n.push(e(this.proto_value, "__proto__"));
            return n;
        },
        clone: function() {
            var t = new xn();
            this.each(function(e, n) {
                t.set(n, e);
            });
            return t;
        },
        toObject: function() {
            var t = {};
            this.each(function(e, n) {
                t["$" + n] = e;
            });
            return t;
        }
    };
    xn.fromObject = function(e) {
        var n = new xn();
        for (var t in e) if (kn(e, t)) n.set(t.slice(1), e[t]);
        return n;
    };
    function kn(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function En(e, n, t) {
        var r = e.parent(-1);
        for (var i = 0, a; a = e.parent(i++); r = a) {
            if (Gn(a)) {
                return n && a.value === r;
            } else if (a instanceof sn) {
                if (a.left === r) continue;
            } else if (a.TYPE == "Call") {
                if (a.expression === r) continue;
            } else if (a instanceof Jt) {
                if (a.condition === r) continue;
            } else if (a instanceof Pt) {
                return t;
            } else if (a instanceof Lt) {
                if (a.expression === r) continue;
            } else if (a instanceof an) {
                if (a.expressions[0] === r) continue;
            } else if (a instanceof tn) {
                return true;
            } else if (a instanceof Sr) {
                if (a.tag === r) continue;
            } else if (a instanceof Gt) {
                if (a.expression === r) continue;
            }
            return false;
        }
    }
    function r(r, e) {
        if (e.length > 31) throw new Error("Too many properties: " + e.length + "\n" + e.join(", "));
        e.forEach(function(e, n) {
            var t = 1 << n;
            Object.defineProperty(r.prototype, e, {
                get: function() {
                    return !!(this._bits & t);
                },
                set: function(e) {
                    if (e) this._bits |= t; else this._bits &= ~t;
                }
            });
        });
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e, n, t, r) {
        if (typeof r === "undefined") r = nn;
        n = n ? n.split(/\s+/) : [];
        var i = n;
        if (r && r.PROPS) n = n.concat(r.PROPS);
        var a = [ "return function AST_", e, "(props){", "this._bits=0;", "if(props){" ];
        n.forEach(function(e) {
            a.push("this.", e, "=props.", e, ";");
        });
        a.push("}");
        var o = Object.create(r && r.prototype);
        if (t.initialize || o.initialize) a.push("this.initialize();");
        a.push("};");
        var s = new Function(a.join(""))();
        s.prototype = o;
        s.prototype.CTOR = s;
        s.prototype.TYPE = s.TYPE = e;
        if (r) {
            s.BASE = r;
            r.SUBCLASSES.push(s);
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        s.PROPS = n;
        s.SELF_PROPS = i;
        s.SUBCLASSES = [];
        for (var f in t) if (kn(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.DEFMETHOD(f, t[f]);
            }
        }
        if (typeof _ !== "undefined") _["AST_" + e] = s;
        return s;
    }
    var ee = e("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var nn = e("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new Hr(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: function() {
            if (this.TYPE == "Node") throw new Error("should not instantiate AST_Node");
        },
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        },
        validate_ast: function() {
            var n = {};
            this.walk(new Ir(function(e) {
                if (e.validate_visited === n) {
                    throw new Error(bn("cannot reuse {type} from [{file}:{line},{col}]", {
                        type: "AST_" + e.TYPE,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    }));
                }
                e.validate_visited = n;
            }));
        }
    }, null);
    r(nn, [ "_optimized", "_squeezed", "call_only", "collapse_scanning", "defined", "evaluating", "falsy", "in_arg", "in_bool", "is_undefined", "inlined", "length_read", "nested", "new", "optional", "private", "pure", "redundant", "static", "terminal", "truthy", "uses_eval", "uses_with" ]);
    (nn.log_function = function(n, e) {
        if (typeof n != "function") {
            nn.info = nn.warn = pn;
            return;
        }
        var t = Object.create(null);
        nn.info = e ? function(e, n) {
            r("INFO: " + bn(e, n));
        } : pn;
        nn.warn = function(e, n) {
            r("WARN: " + bn(e, n));
        };
        function r(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var a = [];
    nn.enable_validation = function() {
        nn.disable_validation();
        (function e(n) {
            n.SUBCLASSES.forEach(e);
            if (!kn(n.prototype, "transform")) return;
            var r = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = r.call(this, e, n);
                if (t instanceof nn) {
                    t.validate();
                } else if (!(t === null || n && _n.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            a.push(function() {
                n.prototype.transform = r;
            });
        })(this);
    };
    nn.disable_validation = function() {
        var e;
        while (e = a.pop()) e();
    };
    var Sn = e("Statement", null, {
        $documentation: "Base class of all statements",
        _validate: function() {
            if (this.TYPE == "Statement") throw new Error("should not instantiate AST_Statement");
        }
    });
    var Tn = e("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, Sn);
    var An = e("Directive", "quote value", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Sn);
    var Dn = e("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, Sn);
    function On(e) {
        return e instanceof Sn && !(e instanceof lt) && !(e instanceof Wn);
    }
    function o(e, n, t, r, i) {
        t = t ? "contain" : "be";
        if (!(e instanceof nn)) throw new Error(n + " must " + t + " AST_Node");
        if (e instanceof It) throw new Error(n + " cannot " + t + " AST_DefaultValue");
        if (e instanceof Zt) throw new Error(n + " cannot " + t + " AST_Destructured");
        if (e instanceof Mr && !i) throw new Error(n + " cannot " + t + " AST_Hole");
        if (e instanceof Vt && !r) throw new Error(n + " cannot " + t + " AST_Spread");
        if (On(e)) throw new Error(n + " cannot " + t + " AST_Statement");
        if (e instanceof cr) {
            throw new Error(n + " cannot " + t + " AST_SymbolDeclaration");
        }
    }
    function s(e, n) {
        o(e[n], n);
    }
    var tn = e("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            s(this, "body");
        }
    }, Sn);
    var $n = e("BlockScope", "_var_names enclosed functions make_def parent_scope variables", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            functions: "[Dictionary/S] like `variables`, but only lists function declarations",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            variables: "[Dictionary/S] a map of name ---\x3e SymbolDef for all variables/functions defined in this scope"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            if (this.functions) n.functions = this.functions.clone();
            if (this.variables) n.variables = this.variables.clone();
            return n;
        },
        pinned: function() {
            return this.resolve().pinned();
        },
        resolve: function() {
            return this.parent_scope.resolve();
        },
        _validate: function() {
            if (this.TYPE == "BlockScope") throw new Error("should not instantiate AST_BlockScope");
            if (this.parent_scope == null) return;
            if (!(this.parent_scope instanceof $n)) throw new Error("parent_scope must be AST_BlockScope");
            if (!(this.resolve() instanceof Ln)) throw new Error("must be contained within AST_Scope");
        }
    }, Sn);
    function qn(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var zn = e("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                qn(n, e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Block") throw new Error("should not instantiate AST_Block");
            this.body.forEach(function(e) {
                if (!On(e)) throw new Error("body must contain AST_Statement");
            });
        }
    }, $n);
    var rn = e("BlockStatement", null, {
        $documentation: "A block statement"
    }, zn);
    var j = e("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (this.TYPE == "StatementWithBody") throw new Error("should not instantiate AST_StatementWithBody");
            if (!On(this.body)) throw new Error("body must be AST_Statement");
        }
    }, $n);
    var Cn = e("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var r = this.label;
                n.walk(new Ir(function(e) {
                    if (e instanceof bt) {
                        if (!e.label || e.label.thedef !== r) return;
                        e.label.thedef = t;
                        t.references.push(e);
                        return true;
                    }
                    if (e instanceof Ln) return true;
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof Se)) throw new Error("label must be AST_Label");
        }
    }, j);
    var Mn = e("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it.",
        _validate: function() {
            if (this.TYPE == "IterationStatement") throw new Error("should not instantiate AST_IterationStatement");
        }
    }, j);
    var Fn = e("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _validate: function() {
            if (this.TYPE == "DWLoop") throw new Error("should not instantiate AST_DWLoop");
            s(this, "condition");
        }
    }, Mn);
    var Pn = e("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, Fn);
    var jn = e("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, Fn);
    var Nn = e("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof nn)) throw new Error("init must be AST_Node");
                if (On(this.init) && !(this.init instanceof $t)) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) s(this, "condition");
            if (this.step != null) s(this, "step");
        }
    }, Mn);
    var In = e("ForEnumeration", "init object", {
        $documentation: "Base class for enumeration loops, i.e. `for ... in`, `for ... of` & `for await ... of`",
        $propdoc: {
            init: "[AST_Node] the assignment target during iteration",
            object: "[AST_Node] the object to iterate over"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ForEnumeration") throw new Error("should not instantiate AST_ForEnumeration");
            if (this.init instanceof $t) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else {
                u(this.init, function(e) {
                    if (!(e instanceof Lt || e instanceof un)) {
                        throw new Error("init must be assignable: " + e.TYPE);
                    }
                });
            }
            s(this, "object");
        }
    }, Mn);
    var Hn = e("ForIn", null, {
        $documentation: "A `for ... in` statement"
    }, In);
    var ye = e("ForOf", null, {
        $documentation: "A `for ... of` statement"
    }, In);
    var Yn = e("ForAwaitOf", null, {
        $documentation: "A `for await ... of` statement"
    }, ye);
    var Rn = e("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    }, j);
    var Ln = e("Scope", "fn_defs may_call_this uses_eval uses_with", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement"
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        resolve: hn,
        _validate: function() {
            if (this.TYPE == "Scope") throw new Error("should not instantiate AST_Scope");
        }
    }, zn);
    var Bn = e("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Dictionary/S] a map of name ---\x3e SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return Vr([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new Hr(function(e) {
                if (e instanceof An && e.value == "$ORIG") {
                    return _n.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return Vr([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new Hr(function(e) {
                if (e instanceof An && e.value == "$ORIG") {
                    return _n.splice(t);
                }
            }));
        }
    }, Ln);
    var Un = e("Lambda", "argnames length_read rest safe_ids uses_arguments", {
        $documentation: "Base class for functions",
        $propdoc: {
            argnames: "[(AST_DefaultValue|AST_Destructured|AST_SymbolFunarg)*] array of function arguments and/or destructured literals",
            length_read: "[boolean/S] whether length property of this function is accessed",
            rest: "[(AST_Destructured|AST_SymbolFunarg)?] rest parameter, or null if absent",
            uses_arguments: "[boolean|number/S] whether this function accesses the arguments array"
        },
        each_argname: function(n) {
            var t = new Ir(function(e) {
                if (e instanceof It) {
                    e.name.walk(t);
                    return true;
                }
                if (e instanceof nr) {
                    e.value.walk(t);
                    return true;
                }
                if (e instanceof hr) n(e);
            });
            this.argnames.forEach(function(e) {
                e.walk(t);
            });
            if (this.rest) this.rest.walk(t);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                qn(e, n);
            });
        },
        _validate: function() {
            if (this.TYPE == "Lambda") throw new Error("should not instantiate AST_Lambda");
            this.argnames.forEach(function(e) {
                u(e, function(e) {
                    if (!(e instanceof hr)) throw new Error("argnames must be AST_SymbolFunarg[]");
                }, true);
            });
            if (this.rest != null) u(this.rest, function(e) {
                if (!(e instanceof hr)) throw new Error("rest must be AST_SymbolFunarg");
            });
        }
    }, Ln);
    var Vn = e("Accessor", null, {
        $documentation: "A getter/setter function",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, Un);
    var Wn = e("LambdaExpression", "inlined", {
        $documentation: "Base class for function expressions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined"
        },
        _validate: function() {
            if (this.TYPE == "LambdaExpression") throw new Error("should not instantiate AST_LambdaExpression");
        }
    }, Un);
    function Gn(e) {
        return e instanceof Qn || e instanceof Zn;
    }
    function Jn(e) {
        return e instanceof Zn || e instanceof at || e instanceof et || e instanceof ot || e instanceof nt;
    }
    function Xn(e) {
        return e instanceof ot || e instanceof nt || e instanceof ft || e instanceof rt;
    }
    function Kn(e, n) {
        if (Gn(e) && e.value) {
            e.value.walk(n);
        } else {
            qn(e, n);
        }
    }
    var Qn = e("Arrow", "value", {
        $documentation: "An arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    qn(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                s(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, Wn);
    var Zn = e("AsyncArrow", "value", {
        $documentation: "An asynchronous arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    qn(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                s(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, Wn);
    var et = e("AsyncFunction", "name", {
        $documentation: "An asynchronous function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof _r)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Wn);
    var nt = e("AsyncGeneratorFunction", "name", {
        $documentation: "An asynchronous generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof _r)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Wn);
    var tt = e("Function", "name", {
        $documentation: "A function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof _r)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Wn);
    var rt = e("GeneratorFunction", "name", {
        $documentation: "A generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof _r)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, Wn);
    var it = e("LambdaDefinition", "inlined name", {
        $documentation: "Base class for function definitions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined",
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (this.TYPE == "LambdaDefinition") throw new Error("should not instantiate AST_LambdaDefinition");
            if (!(this.name instanceof mr)) throw new Error("name must be AST_SymbolDefun");
        }
    }, Un);
    var at = e("AsyncDefun", null, {
        $documentation: "An asynchronous function definition"
    }, it);
    var ot = e("AsyncGeneratorDefun", null, {
        $documentation: "An asynchronous generator function definition"
    }, it);
    var st = e("Defun", null, {
        $documentation: "A function definition"
    }, it);
    var ft = e("GeneratorDefun", null, {
        $documentation: "A generator function definition"
    }, it);
    var ut = e("Class", "extends name properties", {
        $documentation: "Base class for class literals",
        $propdoc: {
            extends: "[AST_Node?] the super class, or null if not specified",
            properties: "[AST_ClassProperty*] array of class properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                if (e.extends) e.extends.walk(n);
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Class") throw new Error("should not instantiate AST_Class");
            if (this.extends != null) s(this, "extends");
            this.properties.forEach(function(e) {
                if (!(e instanceof pt)) throw new Error("properties must contain AST_ClassProperty");
            });
        }
    }, $n);
    var ct = e("DefClass", null, {
        $documentation: "A class definition",
        $propdoc: {
            name: "[AST_SymbolDefClass] the name of this class"
        },
        _validate: function() {
            if (!(this.name instanceof Ee)) throw new Error("name must be AST_SymbolDefClass");
        }
    }, ut);
    var lt = e("ClassExpression", null, {
        $documentation: "A class expression",
        $propdoc: {
            name: "[AST_SymbolClass?] the name of this class, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof gr)) throw new Error("name must be AST_SymbolClass");
            }
        }
    }, ut);
    var pt = e("ClassProperty", "key private static value", {
        $documentation: "Base class for `class` properties",
        $propdoc: {
            key: "[string|AST_Node] property name (AST_Node for computed property)",
            private: "[boolean] whether this is a private property",
            static: "[boolean] whether this is a static property",
            value: "[AST_Node?] property value (AST_Accessor for getters/setters, AST_LambdaExpression for methods, null if not specified for fields)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof nn) n.key.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ClassProperty") throw new Error("should not instantiate AST_ClassProperty");
            if (typeof this.key != "string") {
                if (!(this.key instanceof nn)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (this.value != null) {
                if (!(this.value instanceof nn)) throw new Error("value must be AST_Node");
            }
        }
    });
    var dt = e("ClassField", null, {
        $documentation: "A `class` field",
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    }, pt);
    var we = e("ClassGetter", null, {
        $documentation: "A `class` getter",
        _validate: function() {
            if (!(this.value instanceof Vn)) throw new Error("value must be AST_Accessor");
        }
    }, pt);
    var xe = e("ClassSetter", null, {
        $documentation: "A `class` setter",
        _validate: function() {
            if (!(this.value instanceof Vn)) throw new Error("value must be AST_Accessor");
        }
    }, pt);
    var vt = e("ClassMethod", null, {
        $documentation: "A `class` method",
        _validate: function() {
            if (!(this.value instanceof Wn)) throw new Error("value must be AST_LambdaExpression");
            if (Gn(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of class method's lambda must be null");
        }
    }, pt);
    var ht = e("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)",
        _validate: function() {
            if (this.TYPE == "Jump") throw new Error("should not instantiate AST_Jump");
        }
    }, Sn);
    var mt = e("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Exit") throw new Error("should not instantiate AST_Exit");
        }
    }, ht);
    var _t = e("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    }, mt);
    var gt = e("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            s(this, "value");
        }
    }, mt);
    var bt = e("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "LoopControl") throw new Error("should not instantiate AST_LoopControl");
            if (this.label != null) {
                if (!(this.label instanceof Te)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, ht);
    var yt = e("Break", null, {
        $documentation: "A `break` statement"
    }, bt);
    var wt = e("Continue", null, {
        $documentation: "A `continue` statement"
    }, bt);
    var xt = e("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            s(this, "condition");
            if (this.alternative != null) {
                if (!On(this.alternative)) throw new Error("alternative must be AST_Statement");
            }
        }
    }, j);
    var kt = e("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                qn(n, e);
            });
        },
        _validate: function() {
            s(this, "expression");
            this.body.forEach(function(e) {
                if (!(e instanceof Et)) throw new Error("body must be AST_SwitchBranch[]");
            });
        }
    }, zn);
    var Et = e("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches",
        _validate: function() {
            if (this.TYPE == "SwitchBranch") throw new Error("should not instantiate AST_SwitchBranch");
        }
    }, zn);
    var St = e("Default", null, {
        $documentation: "A `default` switch branch"
    }, Et);
    var Tt = e("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                qn(n, e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    }, Et);
    var At = e("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                qn(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof Dt)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof Ot)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, zn);
    var Dt = e("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[(AST_Destructured|AST_SymbolCatch)?] symbol for the exception, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.argname) n.argname.walk(e);
                qn(n, e);
            });
        },
        _validate: function() {
            if (this.argname != null) u(this.argname, function(e) {
                if (!(e instanceof br)) throw new Error("argname must be AST_SymbolCatch");
            });
        }
    }, zn);
    var Ot = e("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, zn);
    var $t = e("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Definitions") throw new Error("should not instantiate AST_Definitions");
            if (this.definitions.length < 1) throw new Error("must have at least one definition");
        }
    }, Sn);
    var qt = e("Const", null, {
        $documentation: "A `const` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Mt)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof lr)) throw new Error("name must be AST_SymbolConst");
                });
            });
        }
    }, $t);
    var zt = e("Let", null, {
        $documentation: "A `let` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Mt)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof dr)) throw new Error("name must be AST_SymbolLet");
                });
            });
        }
    }, $t);
    var Ct = e("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Mt)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof vr)) throw new Error("name must be AST_SymbolVar");
                });
            });
        }
    }, $t);
    var Mt = e("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    });
    var Ft = e("ExportDeclaration", "body", {
        $documentation: "An `export` statement",
        $propdoc: {
            body: "[AST_DefClass|AST_Definitions|AST_LambdaDefinition] the statement to export"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof ct || this.body instanceof $t || this.body instanceof it)) {
                throw new Error("body must be AST_DefClass, AST_Definitions or AST_LambdaDefinition");
            }
        }
    }, Sn);
    var Pt = e("ExportDefault", "body", {
        $documentation: "An `export default` statement",
        $propdoc: {
            body: "[AST_Node] the default export"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof ct || this.body instanceof it)) {
                s(this, "body");
            }
        }
    }, Sn);
    var ke = e("ExportForeign", "aliases keys path quote", {
        $documentation: "An `export ... from '...'` statement",
        $propdoc: {
            aliases: "[string*] array of aliases to export",
            keys: "[string*] array of keys to import",
            path: "[string] the path to import module",
            quote: "[string?] the original quote character"
        },
        _validate: function() {
            if (this.aliases.length != this.keys.length) {
                throw new Error("aliases:key length mismatch: " + this.aliases.length + " != " + this.keys.length);
            }
            this.aliases.forEach(function(e) {
                if (typeof e != "string") throw new Error("aliases must contain string");
            });
            this.keys.forEach(function(e) {
                if (typeof e != "string") throw new Error("keys must contain string");
            });
            if (typeof this.path != "string") throw new Error("path must be string");
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
        }
    }, Sn);
    var jt = e("ExportReferences", "properties", {
        $documentation: "An `export { ... }` statement",
        $propdoc: {
            properties: "[AST_SymbolExport*] array of aliases to export"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof yr)) throw new Error("properties must contain AST_SymbolExport");
            });
        }
    }, Sn);
    var Nt = e("Import", "all default path properties quote", {
        $documentation: "An `import` statement",
        $propdoc: {
            all: "[AST_SymbolImport?] the imported namespace, or null if not specified",
            default: "[AST_SymbolImport?] the alias for default `export`, or null if not specified",
            path: "[string] the path to import module",
            properties: "[(AST_SymbolImport*)?] array of aliases, or null if not specified",
            quote: "[string?] the original quote character"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.all) e.all.walk(n);
                if (e.default) e.default.walk(n);
                if (e.properties) e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.all != null) {
                if (!(this.all instanceof pr)) throw new Error("all must be AST_SymbolImport");
                if (this.properties != null) throw new Error("cannot import both * and {} in the same statement");
            }
            if (this.default != null) {
                if (!(this.default instanceof pr)) throw new Error("default must be AST_SymbolImport");
                if (this.default.key !== "") throw new Error("invalid default key: " + this.default.key);
            }
            if (typeof this.path != "string") throw new Error("path must be string");
            if (this.properties != null) this.properties.forEach(function(e) {
                if (!(e instanceof pr)) throw new Error("properties must contain AST_SymbolImport");
            });
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
        }
    }, Sn);
    var It = e("DefaultValue", "name value", {
        $documentation: "A default value declaration",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolDeclaration] name of the variable",
            value: "[AST_Node] value to assign if variable is `undefined`"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            s(this, "value");
        }
    });
    function f(e, n, t, r) {
        e[n].forEach(function(e) {
            o(e, n, true, t, r);
        });
    }
    var Ht = e("Call", "args expression optional pure terminal", {
        $documentation: "A function call expression",
        $propdoc: {
            args: "[AST_Node*] array of arguments",
            expression: "[AST_Node] expression to invoke as function",
            optional: "[boolean] whether the expression is optional chaining",
            pure: "[boolean/S] marker for side-effect-free call expression",
            terminal: "[boolean] whether the chain has ended"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            s(this, "expression");
            f(this, "args", true);
        }
    });
    var Yt = e("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties",
        _validate: function() {
            if (this.optional) throw new Error("optional must be false");
            if (this.terminal) throw new Error("terminal must be false");
        }
    }, Ht);
    var an = e("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            f(this, "expressions");
        }
    });
    function Rt(e) {
        while (e instanceof Lt) e = e.expression;
        return e;
    }
    var Lt = e("PropAccess", "expression optional property terminal", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            optional: "[boolean] whether the expression is optional chaining",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node",
            terminal: "[boolean] whether the chain has ended"
        },
        get_property: function() {
            var e = this.property;
            if (e instanceof Tr) return e.value;
            if (e instanceof on && e.operator == "void" && e.expression instanceof Tr) return;
            return e;
        },
        _validate: function() {
            if (this.TYPE == "PropAccess") throw new Error("should not instantiate AST_PropAccess");
            s(this, "expression");
        }
    });
    var Bt = e("Dot", null, {
        $documentation: "A dotted property access expression",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, Lt);
    var Ut = e("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            s(this, "property");
        }
    }, Lt);
    var Vt = e("Spread", "expression", {
        $documentation: "Spread expression in array/object literals or function calls",
        $propdoc: {
            expression: "[AST_Node] expression to be expanded"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var Wt = e("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Unary") throw new Error("should not instantiate AST_Unary");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            s(this, "expression");
        }
    });
    var on = e("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, Wt);
    var Gt = e("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, Wt);
    var sn = e("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            if (!(this instanceof fn)) s(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            s(this, "right");
        }
    });
    var Jt = e("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            s(this, "condition");
            s(this, "consequent");
            s(this, "alternative");
        }
    });
    var fn = e("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
            if (this.left instanceof Zt) {
                if (this.operator != "=") throw new Error("invalid destructuring operator: " + this.operator);
                u(this.left, function(e) {
                    if (!(e instanceof Lt || e instanceof un)) {
                        throw new Error("left must be assignable: " + e.TYPE);
                    }
                });
            } else if (!(this.left instanceof Fr || this.left instanceof zr || this.left instanceof Lt && !this.left.optional || this.left instanceof un || this.left instanceof Cr)) {
                throw new Error("left must be assignable");
            }
        }
    }, sn);
    var Xt = e("Await", "expression", {
        $documentation: "An await expression",
        $propdoc: {
            expression: "[AST_Node] expression with Promise to resolve on"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var Kt = e("Yield", "expression nested", {
        $documentation: "A yield expression",
        $propdoc: {
            expression: "[AST_Node?] return value for iterator, or null if undefined",
            nested: "[boolean] whether to iterate over expression as generator"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.expression) n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.expression != null) {
                s(this, "expression");
            } else if (this.nested) {
                throw new Error("yield* must contain expression");
            }
        }
    });
    var Qt = e("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            f(this, "elements", true, true);
        }
    });
    var Zt = e("Destructured", "rest", {
        $documentation: "Base class for destructured literal",
        $propdoc: {
            rest: "[(AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)?] rest parameter, or null if absent"
        },
        _validate: function() {
            if (this.TYPE == "Destructured") throw new Error("should not instantiate AST_Destructured");
        }
    });
    function u(e, n, t) {
        if (e instanceof It && t) return u(e.name, n);
        if (e instanceof Zt) {
            if (e.rest != null) u(e.rest, n);
            if (e instanceof er) return e.elements.forEach(function(e) {
                if (!(e instanceof Mr)) u(e, n, true);
            });
            if (e instanceof tr) return e.properties.forEach(function(e) {
                u(e.value, n, true);
            });
        }
        n(e);
    }
    var er = e("DestructuredArray", "elements", {
        $documentation: "A destructured array literal",
        $propdoc: {
            elements: "[(AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        }
    }, Zt);
    var nr = e("DestructuredKeyVal", "key value", {
        $documentation: "A key: value destructured property",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef] property value"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof nn) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof nn)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (!(this.value instanceof nn)) throw new Error("value must be AST_Node");
        }
    });
    var tr = e("DestructuredObject", "properties", {
        $documentation: "A destructured object literal",
        $propdoc: {
            properties: "[AST_DestructuredKeyVal*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof nr)) throw new Error("properties must be AST_DestructuredKeyVal[]");
            });
        }
    }, Zt);
    var rr = e("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[(AST_ObjectProperty|AST_Spread)*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof ir || e instanceof Vt)) {
                    throw new Error("properties must contain AST_ObjectProperty and/or AST_Spread only");
                }
            });
        }
    });
    var ir = e("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof nn) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ObjectProperty") throw new Error("should not instantiate AST_ObjectProperty");
            if (typeof this.key != "string") {
                if (!(this.key instanceof nn)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (!(this.value instanceof nn)) throw new Error("value must be AST_Node");
        }
    });
    var ar = e("ObjectKeyVal", null, {
        $documentation: "A key: value object property",
        _validate: function() {
            s(this, "value");
        }
    }, ir);
    var or = e("ObjectMethod", null, {
        $documentation: "A key(){} object property",
        _validate: function() {
            if (!(this.value instanceof Wn)) throw new Error("value must be AST_LambdaExpression");
            if (Gn(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of object method's lambda must be null");
        }
    }, ar);
    var sr = e("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.value instanceof Vn)) throw new Error("value must be AST_Accessor");
        }
    }, ir);
    var fr = e("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.value instanceof Vn)) throw new Error("value must be AST_Accessor");
        }
    }, ir);
    var ur = e("Symbol", "scope name thedef", {
        $documentation: "Base class for all symbols",
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        _validate: function() {
            if (this.TYPE == "Symbol") throw new Error("should not instantiate AST_Symbol");
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var cr = e("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, ur);
    var lr = e("SymbolConst", null, {
        $documentation: "Symbol defining a constant"
    }, cr);
    var pr = e("SymbolImport", "key", {
        $documentation: "Symbol defined by an `import` statement",
        $propdoc: {
            key: "[string] the original `export` name"
        },
        _validate: function() {
            if (typeof this.key != "string") throw new Error("key must be string");
        }
    }, lr);
    var dr = e("SymbolLet", null, {
        $documentation: "Symbol defining a lexical-scoped variable"
    }, cr);
    var vr = e("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, cr);
    var hr = e("SymbolFunarg", "unused", {
        $documentation: "Symbol naming a function argument"
    }, vr);
    var mr = e("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, cr);
    var _r = e("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, cr);
    var Ee = e("SymbolDefClass", null, {
        $documentation: "Symbol defining a class"
    }, lr);
    var gr = e("SymbolClass", null, {
        $documentation: "Symbol naming a class expression"
    }, lr);
    var br = e("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, cr);
    var Se = e("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, ur);
    var un = e("SymbolRef", "fixed in_arg redef", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, ur);
    var yr = e("SymbolExport", "alias", {
        $documentation: "Reference in an `export` statement",
        $propdoc: {
            alias: "[string] the `export` alias"
        },
        _validate: function() {
            if (typeof this.alias != "string") throw new Error("alias must be string");
        }
    }, un);
    var Te = e("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, ur);
    var wr = e("ObjectIdentity", null, {
        $documentation: "Base class for `super` & `this`",
        _validate: function() {
            if (this.TYPE == "ObjectIdentity") throw new Error("should not instantiate AST_ObjectIdentity");
        }
    }, ur);
    var xr = e("Super", null, {
        $documentation: "The `super` symbol",
        _validate: function() {
            if (this.name !== "super") throw new Error('name must be "super"');
        }
    }, wr);
    var kr = e("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.TYPE == "This" && this.name !== "this") throw new Error('name must be "this"');
        }
    }, wr);
    var Er = e("NewTarget", null, {
        $documentation: "The `new.target` symbol",
        initialize: function() {
            this.name = "new.target";
        },
        _validate: function() {
            if (this.name !== "new.target") throw new Error('name must be "new.target": ' + this.name);
        }
    }, kr);
    var Sr = e("Template", "expressions strings tag", {
        $documentation: "A template literal, i.e. tag`str1${expr1}...strN${exprN}strN+1`",
        $propdoc: {
            expressions: "[AST_Node*] the placeholder expressions",
            strings: "[string*] the raw text segments",
            tag: "[AST_Node] tag function, or null if absent"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.tag) e.tag.walk(n);
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length + 1 != this.strings.length) {
                throw new Error("malformed template with " + this.expressions.length + " placeholder(s) but " + this.strings.length + " text segment(s)");
            }
            f(this, "expressions");
            this.strings.forEach(function(e) {
                if (typeof e != "string") throw new Error("strings must contain string");
            });
            if (this.tag != null) s(this, "tag");
        }
    });
    var Tr = e("Constant", null, {
        $documentation: "Base class for all constants",
        _validate: function() {
            if (this.TYPE == "Constant") throw new Error("should not instantiate AST_Constant");
        }
    });
    var Ar = e("String", "quote value", {
        $documentation: "A string literal",
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] the contents of this string"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Tr);
    var Dr = e("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
            if (!isFinite(this.value)) throw new Error("value must be finite");
            if (this.value < 0) throw new Error("value cannot be negative");
        }
    }, Tr);
    var Or = e("BigInt", "value", {
        $documentation: "A BigInt literal",
        $propdoc: {
            value: "[string] the numeric representation"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
            if (this.value[0] == "-") throw new Error("value cannot be negative");
        }
    }, Tr);
    var $r = e("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, Tr);
    var g = e("Atom", null, {
        $documentation: "Base class for atoms",
        _validate: function() {
            if (this.TYPE == "Atom") throw new Error("should not instantiate AST_Atom");
        }
    }, Tr);
    var qr = e("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, g);
    var zr = e("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, g);
    var Cr = e("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, g);
    var Mr = e("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, g);
    var Fr = e("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, g);
    var Pr = e("Boolean", null, {
        $documentation: "Base class for booleans",
        _validate: function() {
            if (this.TYPE == "Boolean") throw new Error("should not instantiate AST_Boolean");
        }
    }, g);
    var jr = e("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, Pr);
    var Nr = e("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, Pr);
    function Ir(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    Ir.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || pn);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof Un) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof An && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            var e = this.stack.pop();
            if (e instanceof Un) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length - 1; --t >= 0; ) {
                var r = n[t];
                if (r instanceof e) return r;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof Ln) {
                for (var r = 0; r < t.body.length; ++r) {
                    var i = t.body[r];
                    if (!(i instanceof An)) break;
                    if (i.value == e) return i;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var r = n[t];
                if (r instanceof Cn && r.label.name == e.label.name) return r.body;
            } else for (var t = n.length; --t >= 0; ) {
                var r = n[t];
                if (r instanceof Mn || e instanceof yt && r instanceof kt) return r;
            }
        },
        in_boolean_context: function() {
            var e = this.self();
            for (var n = 0, t; t = this.parent(n); n++) {
                if (t instanceof Jt && t.condition === e || t instanceof Fn && t.condition === e || t instanceof Nn && t.condition === e || t instanceof xt && t.condition === e || t instanceof _t && t.in_bool || t instanceof an && t.tail_node() !== e || t instanceof tn || t instanceof on && t.operator == "!" && t.expression === e) {
                    return true;
                }
                if (t instanceof sn && (t.operator == "&&" || t.operator == "||") || t instanceof Jt || t.tail_node() === e) {
                    e = t;
                } else if (t instanceof _t) {
                    for (var r, i = t; r = this.parent(++n); i = r) {
                        if (r.TYPE == "Call") {
                            if (!(i instanceof Un) || i.name) return false;
                        } else if (i instanceof Un) {
                            return false;
                        }
                    }
                } else {
                    return false;
                }
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Hr(e, n) {
        Ir.call(this);
        this.before = e;
        this.after = n;
    }
    Hr.prototype = new Ir();
    (function(e) {
        function t(e, n) {
            return _n(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(nn, pn);
        e(Cn, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(tn, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(zn, function(e, n) {
            e.body = t(e.body, n);
        });
        e(Pn, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(jn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(Nn, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(In, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(Rn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(mt, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(bt, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(xt, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(kt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(Tt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(At, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(Dt, function(e, n) {
            if (e.argname) e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e($t, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(Mt, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(It, function(e, n) {
            e.name = e.name.transform(n);
            e.value = e.value.transform(n);
        });
        e(Un, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            e.body = t(e.body, n);
        });
        function n(e, n) {
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            if (e.value) {
                e.value = e.value.transform(n);
            } else {
                e.body = t(e.body, n);
            }
        }
        e(Qn, n);
        e(Zn, n);
        e(ut, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            if (e.extends) e.extends = e.extends.transform(n);
            e.properties = t(e.properties, n);
        });
        e(pt, function(e, n) {
            if (e.key instanceof nn) e.key = e.key.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(Ht, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(an, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(Xt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Kt, function(e, n) {
            if (e.expression) e.expression = e.expression.transform(n);
        });
        e(Bt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Ut, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(Vt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Wt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(sn, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(Jt, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(Qt, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(er, function(e, n) {
            e.elements = t(e.elements, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(nr, function(e, n) {
            if (e.key instanceof nn) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(tr, function(e, n) {
            e.properties = t(e.properties, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(rr, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(ir, function(e, n) {
            if (e.key instanceof nn) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(Ft, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(Pt, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(jt, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(Nt, function(e, n) {
            if (e.all) e.all = e.all.transform(n);
            if (e.default) e.default = e.default.transform(n);
            if (e.properties) e.properties = t(e.properties, n);
        });
        e(Sr, function(e, n) {
            if (e.tag) e.tag = e.tag.transform(n);
            e.expressions = t(e.expressions, n);
        });
    })(function(e, i) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, r;
            e.push(this);
            if (e.before) t = e.before(this, i, n);
            if (typeof t === "undefined") {
                t = this;
                i(t, e);
                if (e.after) {
                    r = e.after(t, n);
                    if (typeof r !== "undefined") t = r;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var Ae = "break case catch class const continue debugger default delete do else extends finally for function if in instanceof new return switch throw try typeof var void while with";
    var C = "false null true";
    var N = [ "abstract async await boolean byte char double enum export final float goto implements import int interface let long native package private protected public short static super synchronized this throws transient volatile yield", C, Ae ].join(" ");
    var M = "return new delete throw else case";
    Ae = wn(Ae);
    N = wn(N);
    M = wn(M);
    C = wn(C);
    var c = /^0b([01]+)$/i;
    var l = /^0x([0-9a-f]+)$/i;
    var p = /^0o?([0-7]+)$/i;
    var F = wn([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", "**", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", "**=", ">>=", "<<=", ">>>=", "&=", "|=", "^=", "&&", "||", "??", "&&=", "||=", "??=" ]);
    var P = "\n\r\u2028\u2029";
    var I = "+-*&%=<>!?|~^";
    var d = "[{(";
    var v = ",;:";
    var h = ")}]";
    var De = v + h;
    var H = d + v;
    var Y = H + "`" + h;
    var R = P + "  \t\f\v​             　\ufeff";
    var L = wn(n("./'\"#" + I + Y + R));
    P = wn(n(P));
    I = wn(n(I));
    De = wn(n(De));
    H = wn(n(H));
    Y = wn(n(Y));
    R = wn(n(R));
    function ne(e) {
        return e >= 55296 && e <= 56319;
    }
    function te(e) {
        return e >= 56320 && e <= 57343;
    }
    function B(e) {
        return e >= 48 && e <= 57;
    }
    function re(e) {
        return !L[e];
    }
    function Yr(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function Rr(e) {
        switch (e[0]) {
          case "b":
            return "\b";

          case "f":
            return "\f";

          case "n":
            return "\n";

          case "r":
            return "\r";

          case "t":
            return "\t";

          case "u":
            var n;
            if (e[1] == "{" && e.slice(-1) == "}") {
                n = e.slice(2, -1);
            } else if (e.length == 5) {
                n = e.slice(1);
            } else {
                return;
            }
            var t = parseInt(n, 16);
            if (t < 0 || isNaN(t)) return;
            if (t < 65536) return String.fromCharCode(t);
            if (t > 1114111) return;
            return String.fromCharCode((t >> 10) + 55232) + String.fromCharCode((t & 1023) + 56320);

          case "v":
            return "\v";

          case "x":
            if (e.length != 3) return;
            var t = parseInt(e.slice(1), 16);
            if (t < 0 || isNaN(t)) return;
            return String.fromCharCode(t);

          case "\r":
          case "\n":
            return "";

          default:
            if (e == "0") return "\0";
            if (e[0] >= "0" && e[0] <= "9") return;
            return e;
        }
    }
    function U(e) {
        var n;
        if (n = c.exec(e)) return parseInt(n[1], 2);
        if (n = l.exec(e)) return parseInt(n[1], 16);
        if (n = p.exec(e)) return parseInt(n[1], 8);
        var t = parseFloat(e);
        if (t == e) return t;
    }
    function Lr(e, n, t, r, i) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = r;
        this.pos = i;
    }
    Lr.prototype = Object.create(Error.prototype);
    Lr.prototype.constructor = Lr;
    Lr.prototype.name = "SyntaxError";
    t(Lr);
    function Oe(e, n, t, r, i) {
        throw new Lr(e, n, t, r, i);
    }
    function $e(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var V = {};
    function qe(d, v, h, m) {
        var i = {
            text: d,
            filename: v,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: [],
            read_template: e("Unterminated template literal", function(e) {
                var n = "";
                for (;;) {
                    var t = r();
                    switch (t) {
                      case "\\":
                        t += r();
                        break;

                      case "`":
                        e.push(n);
                        return;

                      case "$":
                        if (s() == "{") {
                            f();
                            e.push(n);
                            i.regex_allowed = true;
                            return true;
                        }
                    }
                    n += t;
                }
                function r() {
                    var e = f(true, true);
                    return e == "\r" ? "\n" : e;
                }
            })
        };
        var _ = false;
        function s() {
            return i.text.charAt(i.pos);
        }
        function f(e, n) {
            var t = i.text.charAt(i.pos++);
            if (e && !t) throw V;
            if (P[t]) {
                i.col = 0;
                i.line++;
                if (!n) i.newline_before = true;
                if (t == "\r" && s() == "\n") {
                    i.pos++;
                    t = "\n";
                }
            } else {
                i.col++;
            }
            return t;
        }
        function a(e) {
            while (e-- > 0) f();
        }
        function o(e) {
            return i.text.substr(i.pos, e.length) == e;
        }
        function g() {
            var e = i.text;
            for (var n = i.pos; n < i.text.length; ++n) {
                if (P[e[n]]) return n;
            }
            return -1;
        }
        function r(e, n) {
            var t = i.text.indexOf(e, i.pos);
            if (n && t == -1) throw V;
            return t;
        }
        function b() {
            i.tokline = i.line;
            i.tokcol = i.col;
            i.tokpos = i.pos;
        }
        function u(e, n, t) {
            i.regex_allowed = e == "operator" && !Br[n] || e == "keyword" && M[n] || e == "punc" && H[n];
            if (e == "punc" && n == ".") _ = true; else if (!t) _ = false;
            var r = {
                type: e,
                value: n,
                line: i.tokline,
                col: i.tokcol,
                pos: i.tokpos,
                endline: i.line,
                endcol: i.col,
                endpos: i.pos,
                nlb: i.newline_before,
                file: v
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                r.raw = d.substring(r.pos, r.endpos);
            }
            if (!t) {
                r.comments_before = i.comments_before;
                r.comments_after = i.comments_before = [];
            }
            i.newline_before = false;
            return new ee(r);
        }
        function y() {
            while (R[s()]) f();
        }
        function w(e) {
            var n = "", t;
            while ((t = s()) && e(t, n)) n += f();
            return n;
        }
        function c(e) {
            Oe(e, v, i.tokline, i.tokcol, i.tokpos);
        }
        function x(e) {
            return /^0[0-7_]+$/.test(e);
        }
        function k(e) {
            var t = false, r = false, i = false, a = e == ".";
            var n = w(function(e, n) {
                switch (e) {
                  case "x":
                  case "X":
                    return i ? false : i = true;

                  case "e":
                  case "E":
                    return i ? true : t ? false : t = r = true;

                  case "+":
                  case "-":
                    return r;

                  case r = false, ".":
                    return a || t || i || x(n) ? false : a = true;
                }
                return /[_0-9a-dfo]/i.test(e);
            });
            if (e) n = e + n;
            if (x(n)) {
                if (p.has_directive("use strict")) c("Legacy octal literals are not allowed in strict mode");
            } else {
                n = n.replace(i ? /([1-9a-f]|.0)_(?=[0-9a-f])/gi : /([1-9]|.0)_(?=[0-9])/gi, "$1");
            }
            var o = U(n);
            if (isNaN(o)) c("Invalid syntax: " + n);
            if (a || t || s() != "n") return u("num", o);
            return u("bigint", n.toLowerCase() + f());
        }
        function E(e) {
            var n = f(true, e);
            if (n >= "0" && n <= "7") return S(n);
            if (n == "u") {
                var t = f(true, e);
                n += t;
                if (t != "{") {
                    n += f(true, e) + f(true, e) + f(true, e);
                } else do {
                    t = f(true, e);
                    n += t;
                } while (t != "}");
            } else if (n == "x") {
                n += f(true, e) + f(true, e);
            }
            var r = Rr(n);
            if (typeof r != "string") c("Invalid escape sequence: \\" + n);
            return r;
        }
        function S(e) {
            var n = s();
            if (n >= "0" && n <= "7") {
                e += f(true);
                if (e[0] <= "3" && (n = s()) >= "0" && n <= "7") e += f(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && p.has_directive("use strict")) c("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        var T = e("Unterminated string constant", function(e) {
            var n = f(), t = "";
            for (;;) {
                var r = f(true, true);
                if (r == "\\") r = E(true); else if (P[r]) c("Unterminated string constant"); else if (r == n) break;
                t += r;
            }
            var i = u("string", t);
            i.quote = e;
            return i;
        });
        function l(e) {
            var n = i.regex_allowed;
            var t = g(), r;
            if (t == -1) {
                r = i.text.substr(i.pos);
                i.pos = i.text.length;
            } else {
                r = i.text.substring(i.pos, t);
                i.pos = t;
            }
            i.col = i.tokcol + (i.pos - i.tokpos);
            i.comments_before.push(u(e, r, true));
            i.regex_allowed = n;
            return p;
        }
        var n = e("Unterminated multiline comment", function() {
            var e = i.regex_allowed;
            var n = r("*/", true);
            var t = i.text.substring(i.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            a(t.length + 2);
            i.comments_before.push(u("comment2", t, true));
            i.regex_allowed = e;
            return p;
        });
        function A() {
            var e = false, n, t = false, r = s() == "#" ? f() : "";
            while (n = s()) {
                if (!e) {
                    if (n == "\\") t = e = true, f(); else if (re(n)) r += f(); else break;
                } else {
                    if (n != "u") c("Expecting UnicodeEscapeSequence -- uXXXX");
                    n = E();
                    if (!re(n)) c("Unicode char: " + n.charCodeAt(0) + " is not valid in identifier");
                    r += n;
                    e = false;
                }
            }
            if (Ae[r] && t) {
                var i = r.charCodeAt(0).toString(16).toUpperCase();
                r = "\\u" + "0000".substr(i.length) + i + r.slice(1);
            }
            return r;
        }
        var D = e("Unterminated regular expression", function(e) {
            var n = false, t, r = false;
            while (t = f(true)) if (P[t]) {
                c("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                r = true;
                e += t;
            } else if (t == "]" && r) {
                r = false;
                e += t;
            } else if (t == "/" && !r) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var i = A();
            try {
                var a = new RegExp(e, i);
                a.raw_source = e;
                return u("regexp", a);
            } catch (e) {
                c(e.message);
            }
        });
        function O(e) {
            function t(e) {
                if (!s()) return e;
                var n = e + s();
                if (F[n]) {
                    f();
                    return t(n);
                } else {
                    return e;
                }
            }
            return u("operator", t(e || f()));
        }
        function $() {
            f();
            switch (s()) {
              case "/":
                f();
                return l("comment1");

              case "*":
                f();
                return n();
            }
            return i.regex_allowed ? D("") : O("/");
        }
        function q() {
            f();
            var e = s();
            if (e == ".") {
                var n = ".";
                do {
                    n += ".";
                    f();
                } while (s() == ".");
                return u("operator", n);
            }
            return B(e.charCodeAt(0)) ? k(".") : u("punc", ".");
        }
        function z() {
            var e = A();
            if (_) return u("name", e);
            return C[e] ? u("atom", e) : !Ae[e] ? u("name", e) : F[e] ? u("operator", e) : u("keyword", e);
        }
        function e(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === V) c(n); else throw e;
                }
            };
        }
        function p(e) {
            if (e != null) return D(e);
            if (m && i.pos == 0 && o("#!")) {
                b();
                a(2);
                l("comment5");
            }
            for (;;) {
                y();
                b();
                if (h) {
                    if (o("\x3c!--")) {
                        a(4);
                        l("comment3");
                        continue;
                    }
                    if (o("--\x3e") && i.newline_before) {
                        a(3);
                        l("comment4");
                        continue;
                    }
                }
                var n = s();
                if (!n) return u("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return T(n);

                  case 46:
                    return q();

                  case 47:
                    var r = $();
                    if (r === p) continue;
                    return r;
                }
                if (B(t)) return k();
                if (Y[n]) return u("punc", f());
                if (o("=>")) return u("punc", f() + f());
                if (I[n]) return O();
                if (t == 35 || t == 92 || !L[n]) return z();
                break;
            }
            c("Unexpected character '" + n + "'");
        }
        p.context = function(e) {
            if (e) i = e;
            return i;
        };
        p.add_directive = function(e) {
            i.directive_stack[i.directive_stack.length - 1].push(e);
            if (i.directives[e]) i.directives[e]++; else i.directives[e] = 1;
        };
        p.push_directives_stack = function() {
            i.directive_stack.push([]);
        };
        p.pop_directives_stack = function() {
            var e = i.directive_stack.pop();
            for (var n = e.length; --n >= 0; ) {
                i.directives[e[n]]--;
            }
        };
        p.has_directive = function(e) {
            return i.directives[e] > 0;
        };
        return p;
    }
    var ze = wn("typeof void delete -- ++ ! ~ - +");
    var Br = wn("-- ++");
    var Ce = wn("= += -= /= *= %= **= >>= <<= >>>= &= |= ^= &&= ||= ??=");
    var Ur = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var r = e[t++];
            for (var i = 0; i < r.length; i++) {
                n[r[i]] = t;
            }
        }
        return n;
    }([ [ "??" ], [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ], [ "**" ] ], {});
    var Me = wn("atom bigint num regexp string");
    function Vr(e, l) {
        l = be(l, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var _ = {
            input: typeof e == "string" ? qe(e, l.filename, l.html5_comments, l.shebang) : e,
            in_async: false,
            in_directives: true,
            in_funarg: -1,
            in_function: 0,
            in_generator: false,
            in_loop: 0,
            labels: [],
            peeked: null,
            prev: null,
            token: null
        };
        _.token = b();
        function g(e, n) {
            return $e(_.token, e, n);
        }
        function p() {
            return _.peeked || (_.peeked = _.input());
        }
        function b() {
            _.prev = _.token;
            if (_.peeked) {
                _.token = _.peeked;
                _.peeked = null;
            } else {
                _.token = _.input();
            }
            _.in_directives = _.in_directives && (_.token.type == "string" || g("punc", ";"));
            return _.token;
        }
        function y() {
            return _.prev;
        }
        function s(e, n, t, r) {
            var i = _.input.context();
            Oe(e, i.filename, n != null ? n : i.tokline, t != null ? t : i.tokcol, r != null ? r : i.tokpos);
        }
        function f(e, n) {
            s(n, e.line, e.col);
        }
        function t(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function w(e) {
            if (e == null) e = _.token;
            f(e, "Unexpected token: " + t(e.type, e.value));
        }
        function u(e, n) {
            if (g(e, n)) return b();
            f(_.token, "Unexpected token: " + t(_.token.type, _.token.value) + ", expected: " + t(e, n));
        }
        function x(e) {
            return u("punc", e);
        }
        function o(e) {
            return e.nlb || !en(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function c() {
            return !l.strict && (g("eof") || g("punc", "}") || o(_.token));
        }
        function k(e) {
            if (g("punc", ";")) b(); else if (!e && !c()) x(";");
        }
        function d() {
            x("(");
            var e = me();
            x(")");
            return e;
        }
        function n(r) {
            return function() {
                var e = _.token;
                var n = r.apply(null, arguments);
                var t = y();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function T() {
            if (g("operator", "/") || g("operator", "/=")) {
                _.peeked = null;
                _.token = _.input(_.token.value.substr(1));
            }
        }
        var v = n(function() {
            T();
            switch (_.token.type) {
              case "string":
                var e = _.in_directives;
                var n = me();
                if (e) {
                    if (n instanceof Ar) {
                        var t = n.start.raw.slice(1, -1);
                        _.input.add_directive(t);
                        n.value = t;
                    } else {
                        _.in_directives = e = false;
                    }
                }
                k();
                return e ? new An(n) : new tn({
                    body: n
                });

              case "num":
              case "bigint":
              case "regexp":
              case "operator":
              case "atom":
                return m();

              case "name":
                switch (_.token.value) {
                  case "async":
                    if ($e(p(), "keyword", "function")) {
                        b();
                        b();
                        if (!g("operator", "*")) return E(at);
                        b();
                        return E(ot);
                    }
                    break;

                  case "await":
                    if (_.in_async) return m();
                    break;

                  case "export":
                    b();
                    return F();

                  case "import":
                    var r = p();
                    if (!(r.type == "punc" && /^[(.]$/.test(r.value))) {
                        b();
                        return N();
                    }
                    break;

                  case "let":
                    if (L()) {
                        b();
                        var i = U();
                        k();
                        return i;
                    }
                    break;

                  case "yield":
                    if (_.in_generator) return m();
                    break;
                }
                return $e(p(), "punc", ":") ? h() : m();

              case "punc":
                switch (_.token.value) {
                  case "{":
                    return new rn({
                        start: _.token,
                        body: I(),
                        end: y()
                    });

                  case "[":
                  case "(":
                  case "`":
                    return m();

                  case ";":
                    _.in_directives = false;
                    b();
                    return new Dn();

                  default:
                    w();
                }

              case "keyword":
                switch (_.token.value) {
                  case "break":
                    b();
                    return A(yt);

                  case "class":
                    b();
                    return O(ct);

                  case "const":
                    b();
                    var i = B();
                    k();
                    return i;

                  case "continue":
                    b();
                    return A(wt);

                  case "debugger":
                    b();
                    k();
                    return new Tn();

                  case "do":
                    b();
                    var n = _e(v);
                    u("keyword", "while");
                    var a = d();
                    k(true);
                    return new Pn({
                        body: n,
                        condition: a
                    });

                  case "while":
                    b();
                    return new jn({
                        condition: d(),
                        body: _e(v)
                    });

                  case "for":
                    b();
                    return $();

                  case "function":
                    b();
                    if (!g("operator", "*")) return E(st);
                    b();
                    return E(ft);

                  case "if":
                    b();
                    return C();

                  case "return":
                    if (_.in_function == 0 && !l.bare_returns) s("'return' outside of function");
                    b();
                    var t = null;
                    if (g("punc", ";")) {
                        b();
                    } else if (!c()) {
                        t = me();
                        k();
                    }
                    return new _t({
                        value: t
                    });

                  case "switch":
                    b();
                    return new kt({
                        expression: d(),
                        body: _e(H)
                    });

                  case "throw":
                    b();
                    if (o(_.token)) s("Illegal newline after 'throw'");
                    var t = me();
                    k();
                    return new gt({
                        value: t
                    });

                  case "try":
                    b();
                    return Y();

                  case "var":
                    b();
                    var i = V();
                    k();
                    return i;

                  case "with":
                    if (_.input.has_directive("use strict")) {
                        s("Strict mode may not include a with statement");
                    }
                    b();
                    return new Rn({
                        expression: d(),
                        body: v()
                    });
                }
            }
            w();
        });
        function h() {
            var n = ie(Se);
            if (!en(_.labels, function(e) {
                return e.name != n.name;
            })) {
                s("Label " + n.name + " defined twice");
            }
            x(":");
            _.labels.push(n);
            var e = v();
            _.labels.pop();
            if (!(e instanceof Mn)) {
                n.references.forEach(function(e) {
                    if (e instanceof wt) {
                        f(e.label.start, "Continue label `" + n.name + "` must refer to IterationStatement");
                    }
                });
            }
            return new Cn({
                body: e,
                label: n
            });
        }
        function m() {
            var e = me();
            k();
            return new tn({
                body: e
            });
        }
        function A(e) {
            var n = null, t;
            if (!c()) {
                n = ie(Te, true);
            }
            if (n != null) {
                t = ln(function(e) {
                    return e.name == n.name;
                }, _.labels);
                if (!t) f(n.start, "Undefined label " + n.name);
                n.thedef = t;
            } else if (_.in_loop == 0) s(e.TYPE + " not inside a loop or switch");
            k();
            var r = new e({
                label: n
            });
            if (t) t.references.push(r);
            return r;
        }
        function D(e) {
            if (!g("name", e)) return;
            var n = p();
            if (!n) return;
            if ($e(n, "operator", "=")) return;
            if (n.type == "punc" && /^[(;}]$/.test(n.value)) return;
            if (o(n)) return;
            return b();
        }
        function O(c) {
            var l = _.in_async;
            var p = _.in_generator;
            _.input.push_directives_stack();
            _.input.add_directive("use strict");
            var e;
            if (c === ct) {
                e = ie(Ee);
            } else {
                e = ie(gr, true);
            }
            var d = null;
            if (g("keyword", "extends")) {
                b();
                T();
                d = J(true);
            }
            x("{");
            var n = [];
            while (!g("punc", "}")) {
                if (g("punc", ";")) {
                    b();
                    continue;
                }
                var t = _.token;
                var r = !!D("static");
                var i = D("async");
                if (g("operator", "*")) {
                    b();
                    var a = g("name") && /^#/.test(_.token.value);
                    var o = ee();
                    var v = _.token;
                    var s = E(i ? nt : rt);
                    s.start = v;
                    s.end = y();
                    n.push(new vt({
                        start: t,
                        static: r,
                        private: a,
                        key: o,
                        value: s,
                        end: y()
                    }));
                    continue;
                }
                var a = g("name") && /^#/.test(_.token.value);
                var o = ee();
                if (g("punc", "(")) {
                    var h = _.token;
                    var f = E(i ? et : tt);
                    f.start = h;
                    f.end = y();
                    n.push(new vt({
                        start: t,
                        static: r,
                        private: a,
                        key: o,
                        value: f,
                        end: y()
                    }));
                    continue;
                }
                if (i) w(i);
                var m = null;
                if (g("operator", "=")) {
                    b();
                    _.in_async = false;
                    _.in_generator = false;
                    m = S();
                    _.in_generator = p;
                    _.in_async = l;
                } else if (!(g("punc", ";") || g("punc", "}"))) {
                    var u = null;
                    switch (o) {
                      case "get":
                        u = we;
                        break;

                      case "set":
                        u = xe;
                        break;
                    }
                    if (u) {
                        n.push(new u({
                            start: t,
                            static: r,
                            private: g("name") && /^#/.test(_.token.value),
                            key: ee(),
                            value: Q(),
                            end: y()
                        }));
                        continue;
                    }
                }
                k();
                n.push(new dt({
                    start: t,
                    static: r,
                    private: a,
                    key: o,
                    value: m,
                    end: y()
                }));
            }
            b();
            _.input.pop_directives_stack();
            _.in_generator = p;
            _.in_async = l;
            return new c({
                extends: d,
                name: e,
                properties: n
            });
        }
        function $() {
            var e = g("name", "await") && b();
            x("(");
            var n = null;
            if (e || !g("punc", ";")) {
                n = g("keyword", "const") ? (b(), B(true)) : g("name", "let") && L() ? (b(), U(true)) : g("keyword", "var") ? (b(), 
                V(true)) : me(true);
                var t;
                if (e) {
                    u("name", "of");
                    t = Yn;
                } else if (g("operator", "in")) {
                    b();
                    t = Hn;
                } else if (g("name", "of")) {
                    b();
                    t = ye;
                }
                if (t) {
                    if (n instanceof $t) {
                        if (n.definitions.length > 1) {
                            f(n.start, "Only one variable declaration allowed in for..in/of loop");
                        }
                        if (t !== Hn && n.definitions[0].value) {
                            f(n.definitions[0].value.start, "No initializers allowed in for..of loop");
                        }
                    } else if (!(ve(n) || (n = he(n)) instanceof Zt)) {
                        f(n.start, "Invalid left-hand side in for..in/of loop");
                    }
                    return i(t, n);
                }
            }
            return r(n);
        }
        function r(e) {
            x(";");
            var n = g("punc", ";") ? null : me();
            x(";");
            var t = g("punc", ")") ? null : me();
            x(")");
            return new Nn({
                init: e,
                condition: n,
                step: t,
                body: _e(v)
            });
        }
        function i(e, n) {
            T();
            var t = me();
            x(")");
            return new e({
                init: n,
                object: t,
                body: _e(v)
            });
        }
        function q(e) {
            if (e instanceof Qt) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof Vt) {
                    n = q(e.elements.pop().expression);
                }
                return new er({
                    start: e.start,
                    elements: e.elements.map(q),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof fn) return new It({
                start: e.start,
                name: q(e.left),
                value: e.right,
                end: e.end
            });
            if (e instanceof It) {
                e.name = q(e.name);
                return e;
            }
            if (e instanceof er) {
                e.elements = e.elements.map(q);
                if (e.rest) e.rest = q(e.rest);
                return e;
            }
            if (e instanceof tr) {
                e.properties.forEach(function(e) {
                    e.value = q(e.value);
                });
                if (e.rest) e.rest = q(e.rest);
                return e;
            }
            if (e instanceof Mr) return e;
            if (e instanceof rr) {
                var n = null;
                if (e.properties[e.properties.length - 1] instanceof Vt) {
                    n = q(e.properties.pop().expression);
                }
                return new tr({
                    start: e.start,
                    properties: e.properties.map(function(e) {
                        if (!(e instanceof ar)) f(e.start, "Invalid destructuring assignment");
                        return new nr({
                            start: e.start,
                            key: e.key,
                            value: q(e.value),
                            end: e.end
                        });
                    }),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof hr) return e;
            if (e instanceof un) return new hr(e);
            if (e instanceof Kt) return new hr({
                start: e.start,
                name: "yield",
                end: e.end
            });
            f(e.start, "Invalid arrow parameter");
        }
        function z(e, n, t) {
            var r = _.in_async;
            var i = _.in_generator;
            _.in_async = t;
            _.in_generator = false;
            var a = _.in_funarg;
            _.in_funarg = _.in_function;
            var c = e.map(q);
            var o = e.rest || null;
            if (o) o = q(o);
            _.in_funarg = a;
            x("=>");
            var s, f;
            var l = _.in_loop;
            var p = _.labels;
            ++_.in_function;
            _.in_directives = true;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            if (g("punc", "{")) {
                s = I();
                f = null;
            } else {
                s = [];
                T();
                f = S();
            }
            var d = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = l;
            _.labels = p;
            _.in_generator = i;
            _.in_async = r;
            var u = new (t ? Zn : Qn)({
                start: n,
                argnames: c,
                rest: o,
                body: s,
                value: f,
                end: y()
            });
            if (d) u.each_argname(re);
            return u;
        }
        var E = function(e) {
            var n = _.in_async;
            var t = _.in_generator;
            var r;
            if (/Defun$/.test(e.TYPE)) {
                r = ie(mr);
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
            } else {
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
                r = ie(_r, true);
            }
            if (r && e !== Vn && !(r instanceof cr)) w(y());
            x("(");
            var i = _.in_funarg;
            _.in_funarg = _.in_function;
            var a = X(")", !l.strict, false, function() {
                return oe(hr);
            });
            _.in_funarg = i;
            var o = _.in_loop;
            var s = _.labels;
            ++_.in_function;
            _.in_directives = true;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            var f = I();
            var c = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = o;
            _.labels = s;
            _.in_generator = t;
            _.in_async = n;
            var u = new e({
                name: r,
                argnames: a,
                rest: a.rest || null,
                body: f
            });
            if (c) {
                if (r) re(r);
                u.each_argname(re);
            }
            return u;
        };
        function C() {
            var e = d(), n = v(), t = null;
            if (g("keyword", "else")) {
                b();
                t = v();
            }
            return new xt({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function M() {
            return g("name") || Yr(_.token.value);
        }
        function F() {
            if (g("operator", "*")) {
                b();
                var e = "*";
                if (g("name", "as")) {
                    b();
                    if (!M()) u("name");
                    e = _.token.value;
                    b();
                }
                u("name", "from");
                var n = _.token;
                u("string");
                k();
                return new ke({
                    aliases: [ e ],
                    keys: [ "*" ],
                    path: n.value,
                    quote: n.quote
                });
            }
            if (g("punc", "{")) {
                b();
                var r = [];
                var t = [];
                while (M()) {
                    var i = _.token;
                    b();
                    t.push(i);
                    if (g("name", "as")) {
                        b();
                        if (!M()) u("name");
                        r.push(_.token.value);
                        b();
                    } else {
                        r.push(i.value);
                    }
                    if (!g("punc", "}")) x(",");
                }
                x("}");
                if (g("name", "from")) {
                    b();
                    var n = _.token;
                    u("string");
                    k();
                    return new ke({
                        aliases: r,
                        keys: t.map(function(e) {
                            return e.value;
                        }),
                        path: n.value,
                        quote: n.quote
                    });
                }
                k();
                return new jt({
                    properties: t.map(function(e, n) {
                        if (!$e(e, "name")) f(e, "Name expected");
                        var t = te(yr, e);
                        t.alias = r[n];
                        return t;
                    })
                });
            }
            if (g("keyword", "default")) {
                b();
                var a = _.token;
                var o = P();
                if (o) {
                    o.start = a;
                    o.end = y();
                } else {
                    T();
                    o = me();
                    k();
                }
                return new Pt({
                    body: o
                });
            }
            return new Ft({
                body: j()
            });
        }
        function a(e, n) {
            if (n.name) {
                n = new e(n);
                n.name = new (e === ct ? Ee : mr)(n.name);
            }
            return n;
        }
        function P() {
            if (g("name", "async")) {
                if (!$e(p(), "keyword", "function")) return;
                b();
                b();
                if (!g("operator", "*")) return a(at, E(et));
                b();
                return a(ot, E(nt));
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return a(ct, O(lt));

              case "function":
                b();
                if (!g("operator", "*")) return a(st, E(tt));
                b();
                return a(ft, E(rt));
            }
        }
        var j = n(function() {
            if (g("name")) switch (_.token.value) {
              case "async":
                b();
                u("keyword", "function");
                if (!g("operator", "*")) return E(at);
                b();
                return E(ot);

              case "let":
                b();
                var e = U();
                k();
                return e;
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return O(ct);

              case "const":
                b();
                var e = B();
                k();
                return e;

              case "function":
                b();
                if (!g("operator", "*")) return E(st);
                b();
                return E(ft);

              case "var":
                b();
                var e = V();
                k();
                return e;
            }
            w();
        });
        function N() {
            var e = null;
            var n = ie(pr, true);
            var t = null;
            if (n ? (n.key = "", g("punc", ",") && b()) : !g("string")) {
                if (g("operator", "*")) {
                    b();
                    u("name", "as");
                    e = ie(pr);
                    e.key = "*";
                } else {
                    x("{");
                    t = [];
                    while (M()) {
                        var r;
                        if ($e(p(), "name", "as")) {
                            var i = _.token.value;
                            b();
                            b();
                            r = ie(pr);
                            r.key = i;
                        } else {
                            r = ie(pr);
                            r.key = r.name;
                        }
                        t.push(r);
                        if (!g("punc", "}")) x(",");
                    }
                    x("}");
                }
            }
            if (e || n || t) u("name", "from");
            var a = _.token;
            u("string");
            k();
            return new Nt({
                all: e,
                default: n,
                path: a.value,
                properties: t,
                quote: a.quote
            });
        }
        function I() {
            x("{");
            var e = [];
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                e.push(v());
            }
            b();
            return e;
        }
        function H() {
            x("{");
            var e = [], n, t, r, i;
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                if (g("keyword", "case")) {
                    if (n) n.end = y();
                    t = [];
                    n = new Tt({
                        start: (i = _.token, b(), i),
                        expression: me(),
                        body: t
                    });
                    e.push(n);
                    x(":");
                } else if (g("keyword", "default")) {
                    if (n) n.end = y();
                    if (r) s("More than one default clause in switch statement");
                    t = [];
                    n = new St({
                        start: (i = _.token, b(), x(":"), i),
                        body: t
                    });
                    e.push(n);
                    r = n;
                } else {
                    if (!t) w();
                    t.push(v());
                }
            }
            if (n) n.end = y();
            b();
            return e;
        }
        function Y() {
            var e = I(), n = null, t = null;
            if (g("keyword", "catch")) {
                var r = _.token;
                b();
                var i = null;
                if (g("punc", "(")) {
                    b();
                    i = ae(br);
                    x(")");
                }
                n = new Dt({
                    start: r,
                    argname: i,
                    body: I(),
                    end: y()
                });
            }
            if (g("keyword", "finally")) {
                var r = _.token;
                b();
                t = new Ot({
                    start: r,
                    body: I(),
                    end: y()
                });
            }
            if (!n && !t) s("Missing catch/finally blocks");
            return new At({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function R(e, n) {
            var t = [];
            for (;;) {
                var r = _.token;
                var i = ae(e);
                var a = null;
                if (g("operator", "=")) {
                    b();
                    a = S(n);
                } else if (!n && (e === lr || i instanceof Zt)) {
                    s("Missing initializer in declaration");
                }
                t.push(new Mt({
                    start: r,
                    name: i,
                    value: a,
                    end: y()
                }));
                if (!g("punc", ",")) break;
                b();
            }
            return t;
        }
        function L() {
            var e = p();
            return $e(e, "name") || $e(e, "punc", "[") || $e(e, "punc", "{");
        }
        var B = function(e) {
            return new qt({
                start: y(),
                definitions: R(lr, e),
                end: y()
            });
        };
        var U = function(e) {
            return new zt({
                start: y(),
                definitions: R(dr, e),
                end: y()
            });
        };
        var V = function(e) {
            return new Ct({
                start: y(),
                definitions: R(vr, e),
                end: y()
            });
        };
        var W = function(e) {
            var n = _.token;
            u("operator", "new");
            var t;
            if (g("punc", ".") && $e(p(), "name", "target")) {
                b();
                b();
                t = new Er();
            } else {
                var r = J(false), i;
                if (g("punc", "(")) {
                    b();
                    i = X(")", !l.strict);
                } else {
                    i = [];
                }
                t = new Yt({
                    expression: r,
                    args: i
                });
            }
            t.start = n;
            t.end = y();
            return fe(t, e);
        };
        function G() {
            var e, n = _.token, t = n.value;
            switch (n.type) {
              case "num":
                if (isFinite(t)) {
                    e = new Dr({
                        value: t
                    });
                } else {
                    e = new Fr();
                    if (t < 0) e = new on({
                        operator: "-",
                        expression: e
                    });
                }
                break;

              case "bigint":
                e = new Or({
                    value: t
                });
                break;

              case "string":
                e = new Ar({
                    value: t,
                    quote: n.quote
                });
                break;

              case "regexp":
                e = new $r({
                    value: t
                });
                break;

              case "atom":
                switch (t) {
                  case "false":
                    e = new jr();
                    break;

                  case "true":
                    e = new Nr();
                    break;

                  case "null":
                    e = new qr();
                    break;

                  default:
                    w();
                }
                break;

              default:
                w();
            }
            b();
            e.start = e.end = n;
            return e;
        }
        var J = function(e) {
            if (g("operator", "new")) {
                return W(e);
            }
            var n = _.token;
            if (g("punc")) {
                switch (n.value) {
                  case "`":
                    return fe(se(null), e);

                  case "(":
                    b();
                    if (g("punc", ")")) {
                        b();
                        return z([], n);
                    }
                    var t = me(false, true);
                    var r = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = r;
                    if (r == 0 && n.comments_before.length > 0) {
                        var i = n.comments_before[0];
                        if (!i.nlb) {
                            i.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    x(")");
                    var a = y();
                    a.comments_before = t.end.comments_before;
                    a.comments_after.forEach(function(e) {
                        t.end.comments_after.push(e);
                        if (e.nlb) _.token.nlb = true;
                    });
                    a.comments_after.length = 0;
                    a.comments_after = t.end.comments_after;
                    t.end = a;
                    if (g("punc", "=>")) return z(t instanceof an ? t.expressions : [ t ], n);
                    return fe(t, e);

                  case "[":
                    return fe(K(), e);

                  case "{":
                    return fe(Z(), e);
                }
                w();
            }
            if (g("keyword")) switch (n.value) {
              case "class":
                b();
                var o = O(lt);
                o.start = n;
                o.end = y();
                return fe(o, e);

              case "function":
                b();
                var s;
                if (g("operator", "*")) {
                    b();
                    s = E(rt);
                } else {
                    s = E(tt);
                }
                s.start = n;
                s.end = y();
                return fe(s, e);
            }
            if (g("name")) {
                var f = te(un, n);
                b();
                if (f.name == "async") {
                    if (g("keyword", "function")) {
                        b();
                        var s;
                        if (g("operator", "*")) {
                            b();
                            s = E(nt);
                        } else {
                            s = E(et);
                        }
                        s.start = n;
                        s.end = y();
                        return fe(s, e);
                    }
                    if (g("name") && $e(p(), "punc", "=>")) {
                        n = _.token;
                        f = te(un, n);
                        b();
                        return z([ f ], n, true);
                    }
                    if (g("punc", "(")) {
                        var c = fe(f, e);
                        if (!g("punc", "=>")) return c;
                        var u = c.args;
                        if (u[u.length - 1] instanceof Vt) {
                            u.rest = u.pop().expression;
                        }
                        return z(u, n, true);
                    }
                }
                return g("punc", "=>") ? z([ f ], n) : fe(f, e);
            }
            if (Me[_.token.type]) {
                return fe(G(), e);
            }
            w();
        };
        function X(e, n, t, r) {
            if (!r) r = S;
            var i = true, a = [];
            while (!g("punc", e)) {
                if (i) i = false; else x(",");
                if (n && g("punc", e)) break;
                if (t && g("punc", ",")) {
                    a.push(new Mr({
                        start: _.token,
                        end: _.token
                    }));
                } else if (!g("operator", "...")) {
                    a.push(r());
                } else if (r === S) {
                    a.push(new Vt({
                        start: _.token,
                        expression: (b(), r()),
                        end: y()
                    }));
                } else {
                    b();
                    a.rest = r();
                    if (a.rest instanceof It) f(a.rest.start, "Invalid rest parameter");
                    break;
                }
            }
            x(e);
            return a;
        }
        var K = n(function() {
            x("[");
            return new Qt({
                elements: X("]", !l.strict, true)
            });
        });
        var Q = n(function() {
            return E(Vn);
        });
        var Z = n(function() {
            x("{");
            var e = true, n = [];
            while (!g("punc", "}")) {
                if (e) e = false; else x(",");
                if (!l.strict && g("punc", "}")) break;
                var t = _.token;
                if (g("operator", "*")) {
                    b();
                    var r = ee();
                    var i = _.token;
                    var a = E(rt);
                    a.start = i;
                    a.end = y();
                    n.push(new or({
                        start: t,
                        key: r,
                        value: a,
                        end: y()
                    }));
                    continue;
                }
                if (g("operator", "...")) {
                    b();
                    n.push(new Vt({
                        start: t,
                        expression: S(),
                        end: y()
                    }));
                    continue;
                }
                if ($e(p(), "operator", "=")) {
                    var o = ie(un);
                    b();
                    n.push(new ar({
                        start: t,
                        key: t.value,
                        value: new fn({
                            start: t,
                            left: o,
                            operator: "=",
                            right: S(),
                            end: y()
                        }),
                        end: y()
                    }));
                    continue;
                }
                if ($e(p(), "punc", ",") || $e(p(), "punc", "}")) {
                    n.push(new ar({
                        start: t,
                        key: t.value,
                        value: ie(un),
                        end: y()
                    }));
                    continue;
                }
                var r = ee();
                if (g("punc", "(")) {
                    var s = _.token;
                    var f = E(tt);
                    f.start = s;
                    f.end = y();
                    n.push(new or({
                        start: t,
                        key: r,
                        value: f,
                        end: y()
                    }));
                    continue;
                }
                if (g("punc", ":")) {
                    b();
                    n.push(new ar({
                        start: t,
                        key: r,
                        value: S(),
                        end: y()
                    }));
                    continue;
                }
                if (t.type == "name") switch (r) {
                  case "async":
                    var u = g("operator", "*") && b();
                    r = ee();
                    var s = _.token;
                    var f = E(u ? nt : et);
                    f.start = s;
                    f.end = y();
                    n.push(new or({
                        start: t,
                        key: r,
                        value: f,
                        end: y()
                    }));
                    continue;

                  case "get":
                    n.push(new fr({
                        start: t,
                        key: ee(),
                        value: Q(),
                        end: y()
                    }));
                    continue;

                  case "set":
                    n.push(new sr({
                        start: t,
                        key: ee(),
                        value: Q(),
                        end: y()
                    }));
                    continue;
                }
                w();
            }
            b();
            return new rr({
                properties: n
            });
        });
        function ee() {
            var e = _.token;
            switch (e.type) {
              case "operator":
                if (!Ae[e.value]) w();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                b();
                return "" + e.value;

              case "punc":
                x("[");
                var n = S();
                x("]");
                return n;

              default:
                w();
            }
        }
        function ne() {
            var e = _.token.value;
            u("name");
            return e;
        }
        function te(e, n) {
            var t = n.value;
            switch (t) {
              case "await":
                if (_.in_async) w(n);
                break;

              case "super":
                e = xr;
                break;

              case "this":
                e = kr;
                break;

              case "yield":
                if (_.in_generator) w(n);
                break;
            }
            return new e({
                name: "" + t,
                start: n,
                end: n
            });
        }
        function re(e) {
            if (e.name == "arguments" || e.name == "eval" || e.name == "let") f(e.start, "Unexpected " + e.name + " in strict mode");
        }
        function ie(e, n) {
            if (!g("name")) {
                if (!n) s("Name expected");
                return null;
            }
            var t = te(e, _.token);
            if (_.input.has_directive("use strict") && t instanceof cr) {
                re(t);
            }
            b();
            return t;
        }
        function ae(e) {
            var n = _.token;
            if (g("punc", "[")) {
                b();
                var t = X("]", !l.strict, true, function() {
                    return oe(e);
                });
                return new er({
                    start: n,
                    elements: t,
                    rest: t.rest || null,
                    end: y()
                });
            }
            if (g("punc", "{")) {
                b();
                var r = true, i = [], a = null;
                while (!g("punc", "}")) {
                    if (r) r = false; else x(",");
                    if (!l.strict && g("punc", "}")) break;
                    var o = _.token;
                    if (g("punc", "[") || $e(p(), "punc", ":")) {
                        var s = ee();
                        x(":");
                        i.push(new nr({
                            start: o,
                            key: s,
                            value: oe(e),
                            end: y()
                        }));
                        continue;
                    }
                    if (g("operator", "...")) {
                        b();
                        a = ae(e);
                        break;
                    }
                    var f = ie(e);
                    if (g("operator", "=")) {
                        b();
                        f = new It({
                            start: f.start,
                            name: f,
                            value: S(),
                            end: y()
                        });
                    }
                    i.push(new nr({
                        start: o,
                        key: o.value,
                        value: f,
                        end: y()
                    }));
                }
                x("}");
                return new tr({
                    start: n,
                    properties: i,
                    rest: a,
                    end: y()
                });
            }
            return ie(e);
        }
        function oe(e) {
            var n = _.token;
            var t = ae(e);
            if (!g("operator", "=")) return t;
            b();
            return new It({
                start: n,
                name: t,
                value: S(),
                end: y()
            });
        }
        function se(e) {
            var n = e ? e.start : _.token;
            var t = _.input.context().read_template;
            var r = [];
            var i = [];
            while (t(r)) {
                b();
                i.push(me());
                if (!g("punc", "}")) w();
            }
            b();
            return new Sr({
                start: n,
                expressions: i,
                strings: r,
                tag: e,
                end: y()
            });
        }
        function fe(e, n) {
            var t = e.start;
            var r = null;
            while (true) {
                if (g("operator", "?") && $e(p(), "punc", ".")) {
                    b();
                    b();
                    r = e;
                }
                if (g("punc", "[")) {
                    b();
                    var i = me();
                    x("]");
                    e = new Ut({
                        start: t,
                        optional: r === e,
                        expression: e,
                        property: i,
                        end: y()
                    });
                } else if (n && g("punc", "(")) {
                    b();
                    e = new Ht({
                        start: t,
                        optional: r === e,
                        expression: e,
                        args: X(")", !l.strict),
                        end: y()
                    });
                } else if (r === e || g("punc", ".")) {
                    if (r !== e) b();
                    e = new Bt({
                        start: t,
                        optional: r === e,
                        expression: e,
                        property: ne(),
                        end: y()
                    });
                } else if (g("punc", "`")) {
                    if (r) s("Invalid template on optional chain");
                    e = se(e);
                } else {
                    break;
                }
            }
            if (r) e.terminal = true;
            if (e instanceof Ht && !e.pure) {
                var t = e.start;
                var a = t.comments_before;
                var o = kn(t, "comments_before_length") ? t.comments_before_length : a.length;
                while (--o >= 0) {
                    if (/[@#]__PURE__/.test(a[o].value)) {
                        e.pure = true;
                        break;
                    }
                }
            }
            return e;
        }
        function ue(e) {
            var n = _.token;
            if (_.in_async && g("name", "await")) {
                if (_.in_funarg === _.in_function) s("Invalid use of await in function argument");
                _.input.context().regex_allowed = true;
                b();
                return new Xt({
                    start: n,
                    expression: ue(e),
                    end: y()
                });
            }
            if (_.in_generator && g("name", "yield")) {
                if (_.in_funarg === _.in_function) s("Invalid use of yield in function argument");
                _.input.context().regex_allowed = true;
                b();
                var t = null;
                var r = false;
                if (g("operator", "*")) {
                    b();
                    t = S(e);
                    r = true;
                } else if (g("punc") ? !De[_.token.value] : !c()) {
                    t = S(e);
                }
                return new Kt({
                    start: n,
                    expression: t,
                    nested: r,
                    end: y()
                });
            }
            if (g("operator") && ze[n.value]) {
                b();
                T();
                var i = ce(on, n, ue(e));
                i.start = n;
                i.end = y();
                return i;
            }
            var a = J(true);
            while (g("operator") && Br[_.token.value] && !o(_.token)) {
                a = ce(Gt, _.token, a);
                a.start = n;
                a.end = _.token;
                b();
            }
            return a;
        }
        function ce(e, n, t) {
            var r = n.value;
            switch (r) {
              case "++":
              case "--":
                if (!ve(t)) f(n, "Invalid use of " + r + " operator");
                break;

              case "delete":
                if (t instanceof un && _.input.has_directive("use strict")) f(t.start, "Calling delete on expression not allowed in strict mode");
                break;
            }
            return new e({
                operator: r,
                expression: t
            });
        }
        var le = function(e, n, t) {
            var r = g("operator") ? _.token.value : null;
            if (r == "in" && t) r = null;
            var i = r != null ? Ur[r] : null;
            if (i != null && i > n) {
                b();
                var a = le(ue(t), r == "**" ? i - 1 : i, t);
                return le(new sn({
                    start: e.start,
                    left: e,
                    operator: r,
                    right: a,
                    end: a.end
                }), n, t);
            }
            return e;
        };
        function pe(e) {
            return le(ue(e), 0, e);
        }
        var de = function(e) {
            var n = _.token;
            var t = pe(e);
            if (g("operator", "?")) {
                b();
                var r = S();
                x(":");
                return new Jt({
                    start: n,
                    condition: t,
                    consequent: r,
                    alternative: S(e),
                    end: y()
                });
            }
            return t;
        };
        function ve(e) {
            return e instanceof Lt && !e.optional || e instanceof un;
        }
        function he(e) {
            if (e instanceof Qt) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof Vt) {
                    n = he(e.elements.pop().expression);
                    if (!(n instanceof Zt || ve(n))) return e;
                }
                var t = e.elements.map(he);
                return en(t, function(e) {
                    return e instanceof It || e instanceof Zt || e instanceof Mr || ve(e);
                }) ? new er({
                    start: e.start,
                    elements: t,
                    rest: n,
                    end: e.end
                }) : e;
            }
            if (e instanceof fn) {
                var r = he(e.left);
                return r instanceof Zt || ve(r) ? new It({
                    start: e.start,
                    name: r,
                    value: e.right,
                    end: e.end
                }) : e;
            }
            if (!(e instanceof rr)) return e;
            var n = null;
            if (e.properties[e.properties.length - 1] instanceof Vt) {
                n = he(e.properties.pop().expression);
                if (!(n instanceof Zt || ve(n))) return e;
            }
            var i = [];
            for (var a = 0; a < e.properties.length; a++) {
                var o = e.properties[a];
                if (!(o instanceof ar)) return e;
                var s = he(o.value);
                if (!(s instanceof It || s instanceof Zt || ve(s))) {
                    return e;
                }
                i.push(new nr({
                    start: o.start,
                    key: o.key,
                    value: s,
                    end: o.end
                }));
            }
            return new tr({
                start: e.start,
                properties: i,
                rest: n,
                end: e.end
            });
        }
        function S(e) {
            var n = _.token;
            var t = de(e), r = _.token.value;
            if (g("operator") && Ce[r]) {
                if (ve(t) || r == "=" && (t = he(t)) instanceof Zt) {
                    b();
                    return new fn({
                        start: n,
                        left: t,
                        operator: r,
                        right: S(e),
                        end: y()
                    });
                }
                s("Invalid assignment");
            }
            return t;
        }
        function me(e, n) {
            var t = _.token;
            var r = [];
            while (true) {
                if (n && g("operator", "...")) {
                    b();
                    r.rest = ae(hr);
                    break;
                }
                r.push(S(e));
                if (!g("punc", ",")) break;
                b();
                if (n && g("punc", ")") && $e(p(), "punc", "=>")) break;
            }
            return r.length == 1 && !r.rest ? r[0] : new an({
                start: t,
                expressions: r,
                end: y()
            });
        }
        function _e(e) {
            ++_.in_loop;
            var n = e();
            --_.in_loop;
            return n;
        }
        if (l.expression) {
            T();
            var ge = me();
            u("eof");
            return ge;
        }
        return function() {
            var e = _.token;
            var n = [];
            _.input.push_directives_stack();
            while (!g("eof")) n.push(v());
            _.input.pop_directives_stack();
            var t = y() || e;
            var r = l.toplevel;
            if (r) {
                r.body = r.body.concat(n);
                r.end = t;
            } else {
                r = new Bn({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return r;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function m(e, n, t, r) {
        this._bits = 0;
        this.defun = undefined;
        this.eliminated = 0;
        this.id = e;
        this.init = r;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.safe_ids = undefined;
        this.scope = n;
    }
    m.prototype = {
        forEach: function(e) {
            this.orig.forEach(e);
            this.references.forEach(e);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t = this.redefined();
                if (t) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = x(this, e);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            var e = this;
            var n = e.defun;
            if (!n) return;
            var t = e.name;
            var r = n.variables.get(t) || n instanceof Bn && n.globals.get(t) || e.orig[0] instanceof lr && ln(function(e) {
                return e.name == t;
            }, n.enclosed);
            if (r && r !== e) return r.redefined() || r;
        },
        unmangleable: function(e) {
            if (this.exported) return true;
            if (this.undeclared) return true;
            if (!e.eval && this.scope.pinned()) return true;
            if (e.keep_fargs && Wr(this)) return true;
            if (e.keep_fnames) {
                var n = this.orig[0];
                if (n instanceof gr) return true;
                if (n instanceof Ee) return true;
                if (n instanceof mr) return true;
                if (n instanceof _r) return true;
            }
            if (!e.toplevel && this.global) return true;
            return false;
        }
    };
    r(m, [ "const_redefs", "cross_loop", "direct_access", "exported", "global", "undeclared" ]);
    function Wr(e) {
        return e.orig[0] instanceof hr || e.orig[1] instanceof hr;
    }
    var Gr = wn("delete ++ --");
    function Jr(e, n) {
        if (n instanceof fn) return n.left === e && e;
        if (n instanceof It) return n.name === e && e;
        if (n instanceof Zt) return e;
        if (n instanceof nr) return e;
        if (n instanceof In) return n.init === e && e;
        if (n instanceof Wt) return Gr[n.operator] && n.expression;
    }
    Bn.DEFMETHOD("figure_out_scope", function(c) {
        c = be(c, {
            cache: null,
            ie: false
        });
        var l = this;
        var o = null;
        var s = false;
        var t = 0;
        var f = l.parent_scope = null;
        var p = new Ir(function(r, e) {
            if (r instanceof ct) {
                var n = s;
                s = p.parent() instanceof Ft;
                r.name.walk(p);
                s = n;
                a(function() {
                    if (r.extends) r.extends.walk(p);
                    r.properties.forEach(function(e) {
                        e.walk(p);
                    });
                });
                return true;
            }
            if (r instanceof $t) {
                var n = s;
                s = p.parent() instanceof Ft;
                e();
                s = n;
                return true;
            }
            if (r instanceof it) {
                var n = s;
                s = p.parent() instanceof Ft;
                r.name.walk(p);
                s = n;
                a(function() {
                    r.argnames.forEach(function(e) {
                        e.walk(p);
                    });
                    if (r.rest) r.rest.walk(p);
                    qn(r, p);
                });
                return true;
            }
            if (r instanceof Et) {
                r.init_vars(f);
                e();
                return true;
            }
            if (r instanceof At) {
                a(function() {
                    qn(r, p);
                });
                if (r.bcatch) r.bcatch.walk(p);
                if (r.bfinally) r.bfinally.walk(p);
                return true;
            }
            if (r instanceof Rn) {
                var t = f;
                do {
                    t = t.resolve();
                    if (t.uses_with) break;
                    t.uses_with = true;
                } while (t = t.parent_scope);
                a(e);
                return true;
            }
            if (r instanceof $n) {
                a(e);
                return true;
            }
            if (r instanceof ur) {
                r.scope = f;
            }
            if (r instanceof Se) {
                r.thedef = r;
                r.references = [];
            }
            if (r instanceof br) {
                f.def_variable(r).defun = o;
            } else if (r instanceof lr) {
                var i = f.def_variable(r);
                i.defun = o;
                if (s) i.exported = true;
            } else if (r instanceof mr) {
                var i = o.def_function(r, p.parent());
                if (s) i.exported = true;
            } else if (r instanceof hr) {
                o.def_variable(r);
            } else if (r instanceof _r) {
                var i = o.def_function(r, r.name == "arguments" ? undefined : o);
                if (c.ie) i.defun = o.parent_scope.resolve();
            } else if (r instanceof dr) {
                var i = f.def_variable(r);
                if (s) i.exported = true;
            } else if (r instanceof vr) {
                var i = o.def_variable(r, r instanceof pr ? undefined : null);
                if (s) i.exported = true;
            }
            function a(e) {
                r.init_vars(f);
                var n = o;
                var t = f;
                if (r instanceof Ln) o = r;
                f = r;
                e();
                f = t;
                o = n;
            }
        });
        l.make_def = function(e, n) {
            return new m(++t, this, e, n);
        };
        l.walk(p);
        l.globals = new xn();
        var d = [];
        var p = new Ir(function(e) {
            if (e instanceof Dt) {
                if (!(e.argname instanceof Zt)) return;
                d.push(e);
                e.argname.walk(p);
                d.pop();
                qn(e, p);
                return true;
            }
            if (e instanceof Un) {
                d.push(e);
                if (e.name) e.name.walk(p);
                e.argnames.forEach(function(e) {
                    e.walk(p);
                });
                if (e.rest) e.rest.walk(p);
                d.pop();
                Kn(e, p);
                return true;
            }
            if (e instanceof bt) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof cr) {
                var n = e.definition();
                n.preinit = n.references.length;
                if (e instanceof br) {
                    var t = n.redefined();
                    if (t) for (var r = e.scope; r; r = r.parent_scope) {
                        gn(r.enclosed, t);
                        if (r === t.scope) break;
                    }
                } else if (e instanceof lr) {
                    var t = n.redefined();
                    if (t) t.const_redefs = true;
                } else if (n.scope !== e.scope && (e instanceof mr || e instanceof hr || e instanceof vr)) {
                    e.mark_enclosed(c);
                    var t = e.scope.find_variable(e.name);
                    if (e.thedef !== t) {
                        e.thedef = t;
                        t.orig.push(e);
                        e.mark_enclosed(c);
                    }
                }
                if (e.name != "arguments") return true;
                var i = e instanceof vr && p.parent();
                if (i instanceof Mt && !i.value) return true;
                var a = e.scope.resolve().find_variable("arguments");
                if (a && v(a)) a.scope.uses_arguments = 3;
                return true;
            }
            if (e instanceof un) {
                var o = e.name;
                var a = e.scope.find_variable(o);
                for (var s = d.length; s > 0 && a; ) {
                    s = d.lastIndexOf(a.scope, s - 1);
                    if (s < 0) break;
                    var f = a.orig[0];
                    if (f instanceof br || f instanceof hr || f instanceof _r) {
                        e.in_arg = true;
                        break;
                    }
                    a = a.scope.parent_scope.find_variable(o);
                }
                if (!a) {
                    a = l.def_global(e);
                } else if (o == "arguments" && v(a)) {
                    var i = p.parent();
                    if (Jr(e, i)) {
                        a.scope.uses_arguments = 3;
                    } else if (a.scope.uses_arguments < 2 && !(i instanceof Lt && i.expression === e)) {
                        a.scope.uses_arguments = 2;
                    } else if (!a.scope.uses_arguments) {
                        a.scope.uses_arguments = true;
                    }
                }
                if (o == "eval") {
                    var i = p.parent();
                    if (i.TYPE == "Call" && i.expression === e) {
                        var r = e.scope;
                        do {
                            r = r.resolve();
                            if (r.uses_eval) break;
                            r.uses_eval = true;
                        } while (r = r.parent_scope);
                    } else if (a.undeclared) {
                        l.uses_eval = true;
                    }
                }
                if (a.init instanceof it && a.scope !== a.init.name.scope) {
                    var u = e.scope;
                    do {
                        if (u === a.init.name.scope) break;
                    } while (u = u.parent_scope);
                    if (!u) a.init = undefined;
                }
                e.thedef = a;
                e.reference(c);
                return true;
            }
        });
        l.walk(p);
        if (c.ie) l.walk(new Ir(function(e) {
            if (e instanceof br) {
                var n = e.thedef.defun;
                if (n.name instanceof _r && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                r(e, n);
                return true;
            }
            if (e instanceof _r) {
                var t = e.thedef;
                if (!r(e, e.scope.parent_scope.resolve())) {
                    t.defun = undefined;
                } else if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function v(e) {
            return e.orig[0] instanceof hr && !(e.orig[1] instanceof hr || e.orig[2] instanceof hr) && !Gn(e.scope);
        }
        function r(e, n) {
            var t = e.name;
            var r = e.thedef;
            if (!en(r.orig, function(e) {
                return !(e instanceof lr || e instanceof dr);
            })) return false;
            var i = n.find_variable(t);
            if (i) {
                var a = i.redefined();
                if (a) i = a;
            } else {
                i = l.globals.get(t);
            }
            if (i) {
                i.orig.push(e);
            } else {
                i = n.def_variable(e);
            }
            if (i.undeclared) l.variables.set(t, i);
            if (t == "arguments" && v(r) && e instanceof _r) return true;
            r.defun = i.scope;
            r.forEach(function(e) {
                e.redef = r;
                e.thedef = i;
                e.reference(c);
            });
            return true;
        }
    });
    Bn.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var r = this.make_def(e);
            r.undeclared = true;
            r.global = true;
            n.set(t, r);
            return r;
        }
    });
    function b(e, n) {
        e.enclosed = [];
        e.parent_scope = n;
        e.functions = new xn();
        e.variables = new xn();
        if (n) e.make_def = n.make_def;
    }
    function y(e, n) {
        b(e, n);
        e.uses_eval = false;
        e.uses_with = false;
    }
    $n.DEFMETHOD("init_vars", function(e) {
        b(this, e);
    });
    Ln.DEFMETHOD("init_vars", function(e) {
        y(this, e);
    });
    Qn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
        return this;
    });
    Zn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
    });
    Un.DEFMETHOD("init_vars", function(e) {
        y(this, e);
        this.uses_arguments = false;
        this.def_variable(new hr({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
        return this;
    });
    ur.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            gn(t.enclosed, n);
            if (!e) {
                t._var_names = undefined;
            } else {
                if (e.keep_fargs && t instanceof Un) t.each_argname(function(e) {
                    gn(n.scope.enclosed, e.definition());
                });
                if (e.keep_fnames) t.functions.each(function(e) {
                    gn(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    ur.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    $n.DEFMETHOD("find_variable", function(e) {
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    $n.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof it) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    $n.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init instanceof Wn) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    function w(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.cname = -1;
            e.cname_holes = [];
            e.names_in_use = t = new xn();
            var r = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t.set(e.name, true);
                if (e.global && r && r.has(e.name)) {
                    t.set(r.get(e.name), true);
                }
            });
        }
        return t;
    }
    function x(e, t) {
        var n = e.scope;
        var r = w(n, t);
        var i = n.cname_holes;
        var a = new xn();
        var o = [ n ];
        e.forEach(function(e) {
            var n = e.scope;
            do {
                if (cn(n, o)) break;
                w(n, t).each(function(e, n) {
                    a.set(n, e);
                });
                o.push(n);
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < i.length; f++) {
            s = E(i[f]);
            if (a.has(s)) continue;
            i.splice(f, 1);
            r.set(s, true);
            return s;
        }
        while (true) {
            s = E(++n.cname);
            if (r.has(s) || N[s] || t.reserved.has[s]) continue;
            if (!a.has(s)) break;
            i.push(n.cname);
        }
        r.set(s, true);
        return s;
    }
    ur.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    Se.DEFMETHOD("unmangleable", dn);
    ur.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    function k(e) {
        e = be(e, {
            eval: false,
            ie: false,
            keep_fargs: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false,
            v8: false,
            webkit: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        gn(e.reserved, "arguments");
        e.reserved.has = wn(e.reserved);
        return e;
    }
    Bn.DEFMETHOD("mangle_names", function(s) {
        s = k(s);
        if (s.cache && s.cache.props) {
            var n = w(this, s);
            s.cache.props.each(function(e) {
                n.set(e, true);
            });
        }
        var f = 10;
        var u = -1;
        var a = [];
        var c = new Ir(function(e, n) {
            if (e instanceof Cn) {
                var t = u;
                n();
                if (!s.v8 || !d(c)) u = t;
                return true;
            }
            if (e instanceof $n) {
                if (s.webkit && e instanceof Mn && e.init instanceof zt) {
                    e.init.definitions.forEach(function(e) {
                        e.name.match_symbol(function(e) {
                            if (!(e instanceof dr)) return;
                            var n = e.definition();
                            var t = e.scope.parent_scope;
                            var r = t.def_variable(e);
                            e.thedef = n;
                            t.to_mangle.push(r);
                            n.redefined = function() {
                                return r;
                            };
                        });
                    }, true);
                }
                var r = e.to_mangle = [];
                e.variables.each(function(e) {
                    if (!p(e)) r.push(e);
                });
                n();
                if (s.cache && e instanceof Bn) {
                    e.globals.each(l);
                }
                if (e instanceof st && c.has_directive("use asm")) {
                    var i = new un(e.name);
                    i.scope = e;
                    i.reference(s);
                }
                if (r.length > f) {
                    var a = r.map(function(e, n) {
                        return n;
                    }).sort(function(e, n) {
                        return r[n].references.length - r[e].references.length || e - n;
                    });
                    r = a.slice(0, f).sort(function(e, n) {
                        return e - n;
                    }).map(function(e) {
                        return r[e];
                    }).concat(a.slice(f).sort(function(e, n) {
                        return e - n;
                    }).map(function(e) {
                        return r[e];
                    }));
                }
                r.forEach(l);
                return true;
            }
            if (e instanceof Se) {
                var o;
                do {
                    o = E(++u);
                } while (N[o]);
                e.mangled_name = o;
                return true;
            }
        });
        this.walk(c);
        a.forEach(l);
        function l(e) {
            if (s.reserved.has[e.name]) return;
            e.mangle(s);
        }
        function p(n) {
            var e = n.orig[0];
            var t = n.redefined();
            if (!t) {
                if (!(e instanceof lr)) return false;
                var r = n.scope.resolve();
                if (n.scope === r) return false;
                if (n.scope.parent_scope.find_variable(e.name)) return false;
                t = r.def_variable(e);
                r.to_mangle.push(t);
            }
            a.push(n);
            n.references.forEach(i);
            if (e instanceof br || e instanceof lr) i(e);
            return true;
            function i(e) {
                e.thedef = t;
                e.reference(s);
                e.thedef = n;
            }
        }
        function d(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t instanceof zn) return t instanceof Bn && !s.toplevel;
                if (t instanceof Cn) return true;
            }
        }
    });
    Bn.DEFMETHOD("find_colliding_names", function(t) {
        var r = t.cache && t.cache.props;
        var n = Object.create(N);
        t.reserved.forEach(i);
        this.globals.each(a);
        this.walk(new Ir(function(e) {
            if (e instanceof $n) e.variables.each(a);
        }));
        return n;
        function i(e) {
            n[e] = true;
        }
        function a(e) {
            var n = e.name;
            if (e.global && r && r.has(n)) n = r.get(n); else if (!e.unmangleable(t)) return;
            i(n);
        }
    });
    Bn.DEFMETHOD("expand_names", function(r) {
        E.reset();
        E.sort();
        r = k(r);
        var n = this.find_colliding_names(r);
        var t = 0;
        this.globals.each(a);
        this.walk(new Ir(function(e) {
            if (e instanceof $n) e.variables.each(a);
        }));
        function i() {
            var e;
            do {
                e = E(t++);
            } while (n[e]);
            return e;
        }
        function a(n) {
            if (n.global && r.cache) return;
            if (n.unmangleable(r)) return;
            if (r.reserved.has[n.name]) return;
            var e = n.redefined();
            var t = e ? e.rename || e.name : i();
            n.rename = t;
            n.forEach(function(e) {
                if (e.definition() === n) e.name = t;
            });
        }
    });
    nn.DEFMETHOD("tail_node", hn);
    an.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    Bn.DEFMETHOD("compute_char_frequency", function(e) {
        e = k(e);
        E.reset();
        var n = ur.prototype.add_source_map;
        try {
            ur.prototype.add_source_map = function() {
                if (!this.unmangleable(e)) E.consider(this.name, -1);
            };
            if (e.properties) {
                Bt.prototype.add_source_map = function() {
                    E.consider(this.property, -1);
                };
                Ut.prototype.add_source_map = function() {
                    t(this.property);
                };
            }
            E.consider(this.print_to_string(), 1);
        } finally {
            ur.prototype.add_source_map = n;
            delete Bt.prototype.add_source_map;
            delete Ut.prototype.add_source_map;
        }
        E.sort();
        function t(e) {
            if (e instanceof Ar) {
                E.consider(e.value, -1);
            } else if (e instanceof Jt) {
                t(e.consequent);
                t(e.alternative);
            } else if (e instanceof an) {
                t(e.tail_node());
            }
        }
    });
    var E = function() {
        var i = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var r = e[t];
                n.push(r);
                i[r] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var r, a;
        function o() {
            r = null;
            a = Object.create(i);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                a[e[t]] += n;
            }
        };
        function s(e, n) {
            return a[n] - a[e];
        }
        f.sort = function() {
            r = t.sort(s).concat(n).sort(s);
        };
        f.reset = o;
        o();
        function f(e) {
            var n = t[e % 54];
            for (e = Math.floor(e / 54); --e >= 0; e >>= 6) {
                n += r[e & 63];
            }
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Xr(e, n) {
        if (!(this instanceof Xr)) return new Xr(e, n);
        Hr.call(this, this.before, this.after);
        this.options = be(e, {
            annotations: !n,
            arguments: !n,
            arrows: !n,
            assignments: !n,
            awaits: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            default_values: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_exports: !n,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie: false,
            if_return: !n,
            imports: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n,
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            merge_vars: !n,
            negate_iife: !n,
            objects: !n,
            optional_chains: !n,
            passes: 1,
            properties: !n,
            pure_funcs: null,
            pure_getters: !n && "strict",
            reduce_funcs: !n,
            reduce_vars: !n,
            rests: !n,
            sequences: !n,
            side_effects: !n,
            spreads: !n,
            strings: !n,
            switches: !n,
            templates: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            varify: !n,
            webkit: false,
            yields: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var r = this.options["global_defs"];
        if (typeof r == "object") for (var i in r) {
            if (/^@/.test(i) && kn(r, i)) {
                r[i.slice(1)] = Vr(r[i], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 4;
        this.drop_fargs = this.options["keep_fargs"] ? dn : function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var r = t.definition();
            if (r.direct_access) return false;
            var i = r.escaped;
            return i && i.depth != 1;
        };
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof Ht) {
                    n = e.expression;
                } else if (e instanceof Sr) {
                    n = e.tag;
                }
                return !(n && a === n.print_to_string());
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof Ht) {
                    n = e.expression;
                } else if (e instanceof Sr) {
                    n = e.tag;
                }
                return !(n && cn(n.print_to_string(), a));
            };
        } else {
            this.pure_funcs = vn;
        }
        var o = this.options["sequences"];
        this.sequences_limit = o == 1 ? 800 : o | 0;
        var s = this.options["top_retain"];
        if (s instanceof RegExp) {
            this.top_retain = function(e) {
                return s.test(e.name);
            };
        } else if (typeof s == "function") {
            this.top_retain = s;
        } else if (s) {
            if (typeof s == "string") {
                s = s.split(/,/);
            }
            this.top_retain = function(e) {
                return cn(e.name, s);
            };
        }
        var f = this.options["toplevel"];
        this.toplevel = typeof f == "string" ? {
            funcs: /funcs/.test(f),
            vars: /vars/.test(f)
        } : {
            funcs: f,
            vars: f
        };
    }
    Xr.prototype = new Hr(function(e, n, t) {
        if (e._squeezed) return e;
        var r = e instanceof Ln;
        if (r) {
            e.hoist_properties(this);
            e.hoist_declarations(this);
            e.process_boolean_returns(this);
        }
        n(e, this);
        n(e, this);
        var i = e.optimize(this);
        if (r && i === e && !this.has_directive("use asm") && !i.pinned()) {
            i.drop_unused(this);
            if (i.merge_variables(this)) i.drop_unused(this);
            n(i, this);
        }
        if (i === e) i._squeezed = true;
        return i;
    });
    Xr.prototype.option = function(e) {
        return this.options[e];
    };
    Xr.prototype.exposed = function(e) {
        if (e.exported) return true;
        if (e.undeclared) return true;
        if (!(e.global || e.scope.resolve() instanceof Bn)) return false;
        var n = this.toplevel;
        return !en(e.orig, function(e) {
            return n[e instanceof mr ? "funcs" : "vars"];
        });
    };
    Xr.prototype.compress = function(e) {
        e = e.resolve_defines(this);
        e.hoist_exports(this);
        if (this.option("expression")) {
            e.process_expression(true);
        }
        var n = this.options.merge_vars;
        var t = +this.options.passes || 1;
        var r = 1 / 0;
        var i = false;
        var a = {
            ie: this.option("ie")
        };
        for (var o = 0; o < t; o++) {
            e.figure_out_scope(a);
            if (o > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
            this.options.merge_vars = n && (i || o == t - 1);
            e = e.transform(this);
            if (t > 1) {
                var s = 0;
                e.walk(new Ir(function() {
                    s++;
                }));
                nn.info("pass {pass}: last_count: {min_count}, count: {count}", {
                    pass: o,
                    min_count: r,
                    count: s
                });
                if (s < r) {
                    r = s;
                    i = false;
                } else if (i) {
                    break;
                } else {
                    i = true;
                }
            }
        }
        if (this.option("expression")) {
            e.process_expression(false);
        }
        return e;
    };
    (function(e) {
        e(nn, function(e, n) {
            return e;
        });
        nn.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        Bn.DEFMETHOD("hoist_exports", function(e) {
            if (!e.option("hoist_exports")) return;
            var n = this.body, t = [];
            for (var r = 0; r < n.length; r++) {
                var i = n[r];
                if (i instanceof Ft) {
                    n[r] = i = i.body;
                    if (i instanceof $t) {
                        i.definitions.forEach(function(e) {
                            e.name.match_symbol(a, true);
                        });
                    } else {
                        a(i.name);
                    }
                } else if (i instanceof jt) {
                    n.splice(r--, 1);
                    [].push.apply(t, i.properties);
                }
            }
            if (t.length) n.push(Te(jt, this, {
                properties: t
            }));
            function a(e) {
                if (!(e instanceof cr)) return;
                var n = Te(yr, e, e);
                n.alias = n.name;
                t.push(n);
            }
        });
        Ln.DEFMETHOD("process_expression", function(r, i) {
            var a = this;
            var o = new Hr(function(e) {
                if (r && e instanceof tn) {
                    return i ? i(e) : Te(_t, e, {
                        value: e.body
                    });
                }
                if (!r && e instanceof _t) {
                    return i ? i(e) : Te(tn, e, {
                        body: e.value || Te(on, e, {
                            operator: "void",
                            expression: Te(Dr, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof zn) {
                    if (e instanceof Un) {
                        if (e !== a) return e;
                    } else if (r === "awaits" && e instanceof At) {
                        if (e.bfinally) return e;
                    }
                    for (var n = e.body.length; --n >= 0; ) {
                        var t = e.body[n];
                        if (!P(t, true)) {
                            e.body[n] = t.transform(o);
                            break;
                        }
                    }
                } else if (e instanceof xt) {
                    e.body = e.body.transform(o);
                    if (e.alternative) {
                        e.alternative = e.alternative.transform(o);
                    }
                } else if (e instanceof Rn) {
                    e.body = e.body.transform(o);
                }
                return e;
            });
            a.transform(o);
        });
        function D(e, n) {
            var t = n.get_property();
            if (t instanceof nn) return;
            var r;
            if (e instanceof Qt) {
                var i = e.elements;
                if (t == "length") return ce(i.length, e);
                if (typeof t == "number" && t in i) r = i[t];
            } else if (e instanceof Un) {
                if (t == "length") {
                    e.length_read = true;
                    return ce(e.argnames.length, e);
                }
            } else if (e instanceof rr) {
                t = "" + t;
                var a = e.properties;
                for (var o = a.length; --o >= 0; ) {
                    var s = a[o];
                    if (!Ke(s)) return;
                    if (!r && a[o].key === t) r = a[o].value;
                }
            }
            return r instanceof un && r.fixed_value() || r;
        }
        function l(e, n) {
            if (e instanceof Pr) return b.Boolean[n];
            if (e instanceof Dr) return b.Number[n];
            if (e instanceof Ar) return b.String[n];
            if (n == "valueOf") return false;
            if (e instanceof Qt) return b.Array[n];
            if (e instanceof Un) return b.Function[n];
            if (e instanceof rr) return b.Object[n];
            if (e instanceof $r) return b.RegExp[n] && !e.value.global;
        }
        function qe(e, n, t, r, i, a, o) {
            var s = n.parent(i);
            if (e.option("unsafe") && s instanceof Bt && l(r, s.property)) {
                return;
            }
            var f = Jr(t, s);
            if (f) return f;
            if (i == 0 && r && r.is_constant()) return;
            if (s instanceof Qt) return qe(e, n, s, s, i + 1);
            if (s instanceof fn) switch (s.operator) {
              case "=":
                return qe(e, n, s, r, i + 1, a, o);

              case "&&=":
              case "||=":
              case "??=":
                return qe(e, n, s, s, i + 1);

              default:
                return;
            }
            if (s instanceof sn) {
                if (!$e[s.operator]) return;
                return qe(e, n, s, s, i + 1);
            }
            if (s instanceof Ht) {
                return !a && s.expression === t && !s.is_expr_pure(e) && (!(r instanceof Wn) || !(s instanceof Yt) && r.contains_this());
            }
            if (s instanceof Jt) {
                if (s.condition === t) return;
                return qe(e, n, s, s, i + 1);
            }
            if (s instanceof In) return s.init === t;
            if (s instanceof ar) {
                if (s.value !== t) return;
                var u = n.parent(i + 1);
                return qe(e, n, u, u, i + 2);
            }
            if (s instanceof Lt) {
                if (s.expression !== t) return;
                var c = D(r, s);
                return (!a || o) && qe(e, n, s, c, i + 1);
            }
            if (s instanceof an) {
                if (s.tail_node() !== t) return;
                return qe(e, n, s, r, i + 1, a, o);
            }
        }
        function $(e) {
            return e instanceof ut || e instanceof Un;
        }
        function h(e) {
            return e instanceof ut || e instanceof st || e instanceof tt;
        }
        function ze(e) {
            return e.name == "arguments" && e.scope.uses_arguments;
        }
        function Q(e, n) {
            do {
                if (e === n) return false;
                if (n instanceof Ln) return true;
            } while (n = n.parent_scope);
        }
        function Se(e, n, t) {
            var r = e.redef || e.definition();
            if (e.in_arg && Wr(r)) return false;
            return en(r.orig, function(e) {
                if (e instanceof lr || e instanceof dr) {
                    if (e instanceof pr) return true;
                    return n && X(n, e);
                }
                return !(t && e instanceof _r);
            });
        }
        function Ce(e, n, t, r) {
            if (r instanceof fn) return r.operator == "=" && r.right === t;
            if (r instanceof Ht) return r.expression !== t || r instanceof Yt;
            if (r instanceof mt) return r.value === t && n.resolve() !== e.scope.resolve();
            if (r instanceof Mt) return r.value === t;
        }
        var q = /^(0|[1-9][0-9]*)$/;
        (function(e) {
            e(nn, pn);
            function a(e, n, t) {
                t.assignments = 0;
                t.bool_fn = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.const_redefs && !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof Wn && t.init !== t.scope) && t.init;
                t.reassigned = 0;
                t.recursive_refs = 0;
                t.references = [];
                t.single_use = undefined;
            }
            function s(n, t, e) {
                e.variables.each(function(e) {
                    a(n, t, e);
                });
            }
            function p(t, r, i) {
                i.fn_defs = [];
                i.variables.each(function(e) {
                    a(t, r, e);
                    var n = e.init;
                    if (n instanceof it) {
                        i.fn_defs.push(n);
                        n.safe_ids = null;
                    }
                    if (e.fixed === null) {
                        e.safe_ids = t.safe_ids;
                        _(t, e);
                    } else if (e.fixed) {
                        t.loop_ids[e.id] = t.in_loop;
                        _(t, e);
                    }
                });
                i.may_call_this = function() {
                    i.may_call_this = i.contains_this() ? vn : dn;
                };
                if (i.uses_arguments) i.each_argname(function(e) {
                    e.definition().last_ref = false;
                });
                if (r.option("ie")) i.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function o(e, n) {
                var t = n.safe_ids;
                return t === undefined || t === e.safe_ids;
            }
            function f(e, n) {
                var t = e.fn_scanning;
                e.fn_scanning = n;
                n.walk(e);
                e.fn_scanning = t;
            }
            function u(t, r) {
                r.enclosed.forEach(function(e) {
                    if (r.variables.get(e.name) === e) return;
                    if (b(t, e)) return;
                    e.single_use = false;
                    var n = e.fixed;
                    if (typeof n == "function") n = n();
                    if (n instanceof Un && n.safe_ids !== undefined) return;
                    e.fixed = false;
                });
            }
            function v(e, n, t) {
                var r = t.safe_ids;
                if (r === undefined) return;
                if (r === false) return;
                if (t.parent_scope.resolve().may_call_this === vn) {
                    if (cn(t, e.fn_visited)) u(e, t);
                } else if (r) {
                    var i = cn(t, e.fn_visited);
                    if (r === e.safe_ids) {
                        if (!i) f(e, t);
                    } else if (i) {
                        u(e, t);
                    } else {
                        t.safe_ids = false;
                    }
                } else if (e.fn_scanning && e.fn_scanning !== n.scope.resolve()) {
                    t.safe_ids = false;
                } else {
                    t.safe_ids = e.safe_ids;
                    f(e, t);
                }
            }
            function d(n, e) {
                var t = e.fn_defs;
                var r = e.may_call_this === vn ? t : t.filter(function(e) {
                    if (e.safe_ids === false) return true;
                    e.safe_ids = n.safe_ids;
                    f(n, e);
                    return false;
                });
                m(n);
                r.forEach(function(e) {
                    e.safe_ids = n.safe_ids;
                    f(n, e);
                });
                t.forEach(function(e) {
                    e.safe_ids = undefined;
                });
                e.fn_defs = undefined;
                e.may_call_this = undefined;
            }
            function h(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function m(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function _(e, n) {
                e.safe_ids[n.id] = {};
            }
            function g(e, n) {
                e.references.push(n);
                if (e.last_ref !== false) e.last_ref = n;
            }
            function b(e, n) {
                if (n.single_use == "m") return false;
                var t = e.safe_ids[n.id];
                if (t) {
                    var r = kn(e.safe_ids, n.id);
                    if (!r) t.read = t.read && t.read !== e.safe_ids ? true : e.safe_ids;
                    if (n.fixed == null) {
                        if (ze(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        e.loop_ids[n.id] = null;
                        n.fixed = Te(Cr, n.orig[0]);
                        if (r) n.safe_ids = undefined;
                        return true;
                    }
                    return !t.assign || t.assign === e.safe_ids;
                }
                return n.fixed instanceof it;
            }
            function y(e, n, t) {
                if (!t) {
                    if (Wr(n) && n.scope.uses_arguments && !e.has_directive("use strict")) return false;
                    if (!en(n.orig, function(e) {
                        return !(e instanceof lr);
                    })) return false;
                }
                if (n.fixed === undefined) return t || en(n.orig, function(e) {
                    return !(e instanceof dr);
                });
                if (n.fixed === false || n.fixed === 0) return false;
                var r = e.safe_ids[n.id];
                if (n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    n.safe_ids = undefined;
                    return n.fixed === null || kn(e.safe_ids, n.id) && !r.read;
                }
                if (!kn(e.safe_ids, n.id)) {
                    if (!r) return false;
                    if (r.read) {
                        var i = e.find_parent($n);
                        if (i instanceof ut) return false;
                        if (n.scope.resolve() !== i.resolve()) return false;
                    }
                    r.assign = r.assign && r.assign !== e.safe_ids ? true : e.safe_ids;
                }
                if (n.fixed != null && r.read) {
                    if (r.read !== e.safe_ids) return false;
                    if (e.loop_ids[n.id] !== e.in_loop) return false;
                }
                return b(e, n) && en(n.orig, function(e) {
                    return !(e instanceof _r);
                });
            }
            function x(e, n) {
                var t = Te(un, e, e);
                t.fixed = n || Te(Cr, e);
                return t;
            }
            function k(t, r) {
                return function() {
                    var e = x(t, r);
                    var n = t.definition();
                    n.references.push(e);
                    n.replaced++;
                    return e;
                };
            }
            function c(e, n) {
                return e.option("unused") && !n.scope.pinned() && n.single_use !== false && n.references.length - n.recursive_refs == 1 && !(Wr(n) && n.scope.uses_arguments);
            }
            function E(e) {
                if (!e) return false;
                if (e instanceof fn) {
                    var n = e.operator;
                    return n == "=" ? E(e.right) : !$e[n.slice(0, -1)];
                }
                if (e instanceof an) return E(e.tail_node());
                return e.is_constant() || $(e) || e instanceof wr;
            }
            function l(e, n) {
                if (n instanceof Qt) return true;
                if (n instanceof sn) return $e[n.operator];
                if (n instanceof Jt) return n.condition !== e;
                if (n instanceof an) return n.tail_node() === e;
                if (n instanceof Vt) return true;
            }
            function w(e, n, t, r, i, a, o) {
                var s = e.parent(a);
                if (i && i.is_constant()) return;
                if (Ce(n, t, r, s)) {
                    n.escaped.push(s);
                    if (o > 1 && !(i && i.is_constant_expression(t))) o = 1;
                    if (!n.escaped.depth || n.escaped.depth > o) n.escaped.depth = o;
                    if (n.scope.resolve() !== t.resolve()) n.escaped.cross_scope = true;
                    if (n.fixed) n.fixed.escaped = n.escaped;
                    return;
                } else if (l(r, s)) {
                    w(e, n, t, s, s, a + 1, o);
                } else if (s instanceof ar && s.value === r) {
                    var f = e.parent(a + 1);
                    w(e, n, t, f, f, a + 2, o);
                } else if (s instanceof Lt && s.expression === r) {
                    i = D(i, s);
                    w(e, n, t, s, i, a + 1, o + 1);
                    if (i) return;
                }
                if (a > 0) return;
                if (s instanceof Ht && s.expression === r) return;
                if (s instanceof an && s.tail_node() !== r) return;
                if (s instanceof tn) return;
                if (s instanceof Wt && !Gr[s.operator]) return;
                n.direct_access = true;
                if (n.fixed) n.fixed.direct_access = true;
            }
            function S(e) {
                if (!(e instanceof Ut)) return;
                var n = e.expression;
                if (!(n instanceof un)) return;
                var t = n.definition();
                if (!ze(t)) return;
                var r = e.property;
                if (r.is_constant()) r = r.value;
                if (!(r instanceof nn) && !q.test(r)) return;
                t.reassigned++;
                (r instanceof nn ? t.scope.argnames : [ t.scope.argnames[r] ]).forEach(function(e) {
                    if (e instanceof hr) e.definition().fixed = false;
                });
            }
            function T(o, t, e, s, n) {
                var f = new Ir(function(r) {
                    if (r instanceof It) {
                        z(r);
                        h(o);
                        r.value.walk(o);
                        m(o);
                        var i = s;
                        if (i) s = function() {
                            var e = i();
                            var n;
                            if (Oe(e, t) || (n = U(t, e, true)) === undefined) {
                                return Ae(r, [ e, r.value ]);
                            }
                            return n instanceof nn ? r : e;
                        };
                        r.name.walk(f);
                        s = i;
                        return true;
                    }
                    if (r instanceof er) {
                        z(r);
                        var i = s;
                        r.elements.forEach(function(e, n) {
                            if (e instanceof Mr) return z(e);
                            if (i) s = function() {
                                return Te(Ut, e, {
                                    expression: i(),
                                    property: Te(Dr, e, {
                                        value: n
                                    })
                                });
                            };
                            e.walk(f);
                        });
                        if (r.rest) {
                            var a;
                            if (i) s = t.option("rests") && function() {
                                var e = i();
                                if (!(e instanceof Qt)) return r;
                                for (var n = 0, t = r.elements.length; n < t; n++) {
                                    if (e.elements[n] instanceof Vt) return r;
                                }
                                if (!a) a = Te(Qt, r);
                                a.elements = e.elements.slice(t);
                                return a;
                            };
                            r.rest.walk(f);
                        }
                        s = i;
                        return true;
                    }
                    if (r instanceof tr) {
                        z(r);
                        var i = s;
                        r.properties.forEach(function(t) {
                            z(t);
                            if (t.key instanceof nn) {
                                h(o);
                                t.key.walk(o);
                                m(o);
                            }
                            if (i) s = function() {
                                var e = t.key;
                                var n = Ut;
                                if (typeof e == "string") {
                                    if (Yr(e)) {
                                        n = Bt;
                                    } else {
                                        e = ce(e, t);
                                    }
                                }
                                return Te(n, t, {
                                    expression: i(),
                                    property: e
                                });
                            };
                            t.value.walk(f);
                        });
                        if (r.rest) {
                            s = false;
                            r.rest.walk(f);
                        }
                        s = i;
                        return true;
                    }
                    n(r, s, function() {
                        var e = o.stack.length;
                        for (var n = 0, t = f.stack.length - 1; n < t; n++) {
                            o.stack.push(f.stack[n]);
                        }
                        r.walk(o);
                        o.stack.length = e;
                    });
                    return true;
                });
                e.walk(f);
            }
            function A(i, c, n) {
                var a = this;
                a.inlined = false;
                var o = i.parent();
                var t = Jn(a) || Xn(a);
                var r = false;
                a.walk(new Ir(function(e) {
                    if (t) return r = true;
                    if (e instanceof _t) return t = true;
                    if (e instanceof Ln && e !== a) return true;
                }));
                if (r) h(i);
                p(i, n, a);
                var s = !a.uses_arguments || i.has_directive("use strict");
                a.argnames.forEach(function(t, e) {
                    var r = o.args[e];
                    T(i, n, t, function() {
                        var e = a.argnames.indexOf(t);
                        var n = e < 0 ? r : o.args[e];
                        if (n instanceof an && n.expressions.length < 2) n = n.expressions[0];
                        return n || Te(Cr, o);
                    }, u);
                });
                var e = a.rest, f;
                if (e) T(i, n, e, n.option("rests") && function() {
                    if (a.rest !== e) return e;
                    if (!f) f = Te(Qt, a);
                    f.elements = o.args.slice(a.argnames.length);
                    return f;
                }, u);
                Kn(a, i);
                var l = i.safe_ids;
                d(i, a);
                if (!r) i.safe_ids = l;
                return true;
                function u(e, n) {
                    var t = e.definition();
                    if (n && s && t.fixed === undefined) {
                        _(i, t);
                        i.loop_ids[t.id] = i.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ e ];
                    } else {
                        t.fixed = false;
                    }
                }
            }
            e(fn, function(a, c, n) {
                var o = this;
                var s = o.left;
                var f = o.right;
                var t = s instanceof un && s.definition();
                var e = t || s instanceof Zt;
                switch (o.operator) {
                  case "=":
                    if (s.equivalent_to(f) && !s.has_side_effects(n)) {
                        f.walk(a);
                        u(s);
                        o.redundant = true;
                        return true;
                    }
                    if (t && f instanceof Wn) {
                        p();
                        f.parent_scope.resolve().fn_defs.push(f);
                        f.safe_ids = null;
                        if (!t.fixed || !o.write_only) v(a, t, f);
                        return true;
                    }
                    if (e) {
                        f.walk(a);
                        p();
                        return true;
                    }
                    S(s);
                    return;

                  case "&&=":
                  case "||=":
                  case "??=":
                    var r = true;

                  default:
                    if (!e) {
                        S(s);
                        return d();
                    }
                    t.assignments++;
                    var i = t.fixed;
                    if (qe(n, a, o, o, 0)) {
                        t.fixed = false;
                        return d();
                    }
                    var l = b(a, t);
                    if (r) h(a);
                    f.walk(a);
                    if (r) m(a);
                    if (l && !s.in_arg && y(a, t)) {
                        g(t, s);
                        _(a, t);
                        if (t.single_use) t.single_use = false;
                        s.fixed = t.fixed = function() {
                            return Te(sn, o, {
                                operator: o.operator.slice(0, -1),
                                left: x(s, i),
                                right: o.right
                            });
                        };
                        s.fixed.assigns = !i || !i.assigns ? [] : i.assigns.slice();
                        s.fixed.assigns.push(o);
                        s.fixed.to_binary = k(s, i);
                    } else {
                        s.walk(a);
                        t.fixed = false;
                    }
                    return true;
                }
                function u(e) {
                    if (e instanceof Bt) {
                        u(e.expression);
                    } else if (e instanceof Ut) {
                        u(e.expression);
                        e.property.walk(a);
                    } else if (e instanceof un) {
                        var n = e.definition();
                        g(n, e);
                        if (n.fixed) {
                            e.fixed = n.fixed;
                            if (e.fixed.assigns) {
                                e.fixed.assigns.push(o);
                            } else {
                                e.fixed.assigns = [ o ];
                            }
                        }
                    } else {
                        e.walk(a);
                    }
                }
                function p() {
                    var e = t && Re(a, t);
                    var i = qe(n, a, o, f, 0, E(f), e);
                    T(a, n, s, function() {
                        return o.right;
                    }, function(e, n, t) {
                        if (!(e instanceof un)) {
                            S(e);
                            t();
                            return;
                        }
                        var r = e.definition();
                        r.assignments++;
                        if (!n || e.in_arg || !y(a, r)) {
                            t();
                            r.fixed = false;
                        } else if (i) {
                            t();
                            r.fixed = 0;
                        } else {
                            g(r, e);
                            _(a, r);
                            if (s instanceof Zt || r.orig.length == 1 && r.orig[0] instanceof mr) {
                                r.single_use = false;
                            }
                            a.loop_ids[r.id] = a.in_loop;
                            e.fixed = r.fixed = n;
                            e.fixed.assigns = [ o ];
                            w(a, r, e.scope, o, f, 0, 1);
                        }
                    });
                }
                function d() {
                    if (!r) return;
                    s.walk(a);
                    h(a);
                    f.walk(a);
                    m(a);
                    return true;
                }
            });
            e(sn, function(e) {
                if (!$e[this.operator]) return;
                this.left.walk(e);
                h(e);
                this.right.walk(e);
                m(e);
                return true;
            });
            e($n, function(e, n, t) {
                s(e, t, this);
            });
            e(Ht, function(n, e) {
                var t = this;
                var r = t.expression;
                if (r instanceof Wn) {
                    var i = Pe(t);
                    t.args.forEach(function(e) {
                        e.walk(n);
                        if (e instanceof Vt) i = false;
                    });
                    if (i) r.reduce_vars = A;
                    r.walk(n);
                    if (i) delete r.reduce_vars;
                    return true;
                }
                if (t.TYPE == "Call" && n.in_boolean_context()) {
                    if (r instanceof un) {
                        r.definition().bool_fn++;
                    } else if (r instanceof fn && r.operator == "=" && r.left instanceof un) {
                        r.left.definition().bool_fn++;
                    }
                }
                r.walk(n);
                var a = t.optional;
                if (a) h(n);
                t.args.forEach(function(e) {
                    e.walk(n);
                });
                if (a) m(n);
                var o = r instanceof un && r.fixed_value();
                if (o instanceof Un) {
                    v(n, r.definition(), o);
                } else {
                    n.find_parent(Ln).may_call_this();
                }
                return true;
            });
            e(ut, function(n, e, t) {
                var r = this;
                s(n, t, r);
                if (r.extends) r.extends.walk(n);
                var i = r.properties.filter(function(e) {
                    z(e);
                    if (e.key instanceof nn) e.key.walk(n);
                    return e.value;
                });
                if (r.name) {
                    var a = r.name.definition();
                    var o = n.parent();
                    if (o instanceof Ft || o instanceof Pt) a.single_use = false;
                    if (y(n, a, true)) {
                        _(n, a);
                        n.loop_ids[a.id] = n.in_loop;
                        a.fixed = function() {
                            return r;
                        };
                        a.fixed.assigns = [ r ];
                        if (!ne(a)) a.single_use = false;
                    } else {
                        a.fixed = false;
                    }
                }
                i.forEach(function(e) {
                    if (!e.static || e instanceof dt && e.value.contains_this()) {
                        h(n);
                        e.value.walk(n);
                        m(n);
                    } else {
                        e.value.walk(n);
                    }
                });
                return true;
            });
            e(Jt, function(e) {
                this.condition.walk(e);
                h(e);
                this.consequent.walk(e);
                m(e);
                h(e);
                this.alternative.walk(e);
                m(e);
                return true;
            });
            e(It, function(e) {
                this.name.walk(e);
                h(e);
                this.value.walk(e);
                m(e);
                return true;
            });
            e(Pn, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                h(e);
                this.body.walk(e);
                if (R(this, e.parent())) {
                    m(e);
                    h(e);
                }
                this.condition.walk(e);
                m(e);
                e.in_loop = n;
                return true;
            });
            e(Nn, function(e, n, t) {
                var r = this;
                s(e, t, r);
                if (r.init) r.init.walk(e);
                var i = e.in_loop;
                e.in_loop = r;
                h(e);
                if (r.condition) r.condition.walk(e);
                r.body.walk(e);
                if (r.step) {
                    if (R(r, e.parent())) {
                        m(e);
                        h(e);
                    }
                    r.step.walk(e);
                }
                m(e);
                e.in_loop = i;
                return true;
            });
            e(In, function(e, n, t) {
                var r = this;
                s(e, t, r);
                r.object.walk(e);
                var i = e.in_loop;
                e.in_loop = r;
                h(e);
                var a = r.init;
                if (a instanceof $t) {
                    a.definitions[0].name.mark_symbol(function(e) {
                        if (e instanceof cr) {
                            var n = e.definition();
                            n.assignments++;
                            n.fixed = false;
                        }
                    }, e);
                } else if (a instanceof Zt || a instanceof un) {
                    a.mark_symbol(function(e) {
                        if (e instanceof un) {
                            var n = e.definition();
                            g(n, e);
                            n.assignments++;
                            if (!e.is_immutable()) n.fixed = false;
                        }
                    }, e);
                } else {
                    a.walk(e);
                }
                r.body.walk(e);
                m(e);
                e.in_loop = i;
                return true;
            });
            e(xt, function(e) {
                this.condition.walk(e);
                h(e);
                this.body.walk(e);
                m(e);
                if (this.alternative) {
                    h(e);
                    this.alternative.walk(e);
                    m(e);
                }
                return true;
            });
            e(Cn, function(e) {
                h(e);
                this.body.walk(e);
                m(e);
                return true;
            });
            e(Un, function(e, n, t) {
                var r = this;
                if (!o(e, r)) return true;
                if (!gn(e.fn_visited, r)) return true;
                r.inlined = false;
                h(e);
                p(e, t, r);
                n();
                d(e, r);
                if (r.name) w(e, r.name.definition(), r, r.name, r, 0, 1);
                return true;
            });
            e(it, function(e, n, t) {
                var r = this;
                var i = r.name.definition();
                var a = e.parent();
                if (a instanceof Ft || a instanceof Pt) i.single_use = false;
                if (!o(e, r)) return true;
                if (!gn(e.fn_visited, r)) return true;
                r.inlined = false;
                h(e);
                p(e, t, r);
                n();
                d(e, r);
                return true;
            });
            e(Ut, function(e) {
                if (!this.optional) return;
                this.expression.walk(e);
                h(e);
                this.property.walk(e);
                m(e);
                return true;
            });
            e(kt, function(n, e, t) {
                var r = this;
                s(n, t, r);
                r.expression.walk(n);
                var i = true;
                r.body.forEach(function(e) {
                    if (e instanceof St) return;
                    e.expression.walk(n);
                    if (i) {
                        i = false;
                        h(n);
                    }
                });
                if (!i) m(n);
                qn(r, n);
                return true;
            });
            e(Et, function(e) {
                h(e);
                qn(this, e);
                m(e);
                return true;
            });
            e(br, function() {
                this.definition().fixed = false;
            });
            e(pr, function() {
                this.definition().fixed = false;
            });
            e(un, function(r, e, n) {
                var i = this.definition();
                g(i, this);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof mr) {
                    r.loop_ids[i.id] = r.in_loop;
                }
                var a = Re(r, i);
                if (a) a.enclosed.forEach(function(e) {
                    if (i === e) return;
                    if (e.scope.resolve() === a) return;
                    var n = e.fixed && e.fixed.assigns;
                    if (!n) return;
                    if (n[n.length - 1] instanceof Mt) return;
                    var t = r.safe_ids[e.id];
                    if (!t) return;
                    t.assign = true;
                });
                if (i.fixed === false || i.fixed === 0) {
                    var t = i.redefined();
                    if (t && Q(i.scope, this.scope)) t.single_use = false;
                } else if (i.fixed === undefined || !b(r, i)) {
                    i.fixed = false;
                } else if (i.fixed) {
                    if (this.in_arg && i.orig[0] instanceof _r) this.fixed = i.scope;
                    var o = this.fixed_value();
                    if (a) {
                        i.recursive_refs++;
                    } else if (o && c(n, i)) {
                        i.in_loop = r.loop_ids[i.id] !== r.in_loop;
                        i.single_use = $(o) && !o.pinned() && (!i.in_loop || r.parent() instanceof Ht) || !i.in_loop && i.scope === this.scope.resolve() && o.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if (qe(n, r, this, o, 0, E(o), a)) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = 0;
                        }
                    }
                    if (i.fixed && r.loop_ids[i.id] !== r.in_loop) i.cross_loop = true;
                    w(r, i, this.scope, this, o, 0, 1);
                }
                if (!this.fixed) this.fixed = i.fixed;
                var s;
                if (o instanceof Un && !((s = r.parent()) instanceof Ht && s.expression === this)) {
                    v(r, i, o);
                }
            });
            e(Sr, function(n, e) {
                var t = this;
                var r = t.tag;
                if (!r) return;
                if (r instanceof Wn) {
                    t.expressions.forEach(function(e) {
                        e.walk(n);
                    });
                    r.walk(n);
                    return true;
                }
                r.walk(n);
                t.expressions.forEach(function(e) {
                    e.walk(n);
                });
                var i = r instanceof un && r.fixed_value();
                if (i instanceof Un) {
                    v(n, r.definition(), i);
                } else {
                    n.find_parent(Ln).may_call_this();
                }
                return true;
            });
            e(Bn, function(n, e, t) {
                var r = this;
                r.globals.each(function(e) {
                    a(n, t, e);
                });
                h(n);
                p(n, t, r);
                e();
                d(n, r);
                return true;
            });
            e(At, function(e, n, t) {
                var r = this;
                s(e, t, r);
                h(e);
                qn(r, e);
                m(e);
                if (r.bcatch) {
                    h(e);
                    r.bcatch.walk(e);
                    m(e);
                }
                if (r.bfinally) r.bfinally.walk(e);
                return true;
            });
            e(Wt, function(e, n) {
                var t = this;
                if (!Br[t.operator]) return;
                var r = t.expression;
                if (!(r instanceof un)) {
                    S(r);
                    return;
                }
                var i = r.definition();
                i.assignments++;
                var a = i.fixed;
                if (b(e, i) && !r.in_arg && y(e, i)) {
                    g(i, r);
                    _(e, i);
                    if (i.single_use) i.single_use = false;
                    i.fixed = function() {
                        return Te(sn, t, {
                            operator: t.operator.slice(0, -1),
                            left: Te(on, t, {
                                operator: "+",
                                expression: x(r, a)
                            }),
                            right: Te(Dr, t, {
                                value: 1
                            })
                        });
                    };
                    i.fixed.assigns = a && a.assigns ? a.assigns.slice() : [];
                    i.fixed.assigns.push(t);
                    if (t instanceof on) {
                        r.fixed = i.fixed;
                    } else {
                        r.fixed = function() {
                            return Te(on, t, {
                                operator: "+",
                                expression: x(r, a)
                            });
                        };
                        r.fixed.assigns = a && a.assigns;
                        r.fixed.to_prefix = k(r, i.fixed);
                    }
                } else {
                    r.walk(e);
                    i.fixed = false;
                }
                return true;
            });
            e(Mt, function(r, e, n) {
                var i = this;
                var t = i.value;
                if (t instanceof Wn && i.name instanceof cr) {
                    o();
                    t.parent_scope.resolve().fn_defs.push(t);
                    t.safe_ids = null;
                    var a = i.name.definition();
                    if (!a.fixed) v(r, a, t);
                } else if (t) {
                    t.walk(r);
                    o();
                } else if (r.parent() instanceof zt) {
                    o();
                }
                return true;
                function o() {
                    T(r, n, i.name, function() {
                        return i.value || Te(Cr, i);
                    }, function(e, n) {
                        var t = e.definition();
                        if (n && y(r, t, true)) {
                            _(r, t);
                            r.loop_ids[t.id] = r.in_loop;
                            t.fixed = n;
                            t.fixed.assigns = [ i ];
                            if (e instanceof lr && t.redefined() || !(Se(e) || ne(t))) {
                                t.single_use = false;
                            }
                        } else {
                            t.fixed = false;
                        }
                    });
                }
            });
            e(jn, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                h(e);
                n();
                m(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        function z(e) {
            e._squeezed = false;
            e._optimized = false;
            if (e instanceof $n) e._var_names = undefined;
            if (e instanceof un) e.fixed = undefined;
        }
        Bn.DEFMETHOD("reset_opt_flags", function(t) {
            var r = new Ir(t.option("reduce_vars") ? function(e, n) {
                z(e);
                return e.reduce_vars(r, n, t);
            } : z);
            r.fn_scanning = null;
            r.fn_visited = [];
            r.in_loop = null;
            r.loop_ids = Object.create(null);
            r.safe_ids = Object.create(null);
            this.walk(r);
        });
        ur.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (e) {
                if (this.fixed) e = this.fixed;
                return (e instanceof nn ? e : e()).tail_node();
            }
            e = e === 0 && this.fixed;
            if (!e) return e;
            var n = (e instanceof nn ? e : e()).tail_node();
            return n.is_constant() && n;
        });
        un.DEFMETHOD("is_immutable", function() {
            var e = this.redef || this.definition();
            return (this.in_arg || e.orig.length == 1) && e.orig[0] instanceof _r;
        });
        nn.DEFMETHOD("convert_symbol", pn);
        function n(t, r) {
            return this.transform(new Hr(function(e, n) {
                if (e instanceof It) {
                    e = e.clone();
                    e.name = e.name.transform(this);
                    return e;
                }
                if (e instanceof Zt) {
                    e = e.clone();
                    n(e, this);
                    return e;
                }
                if (e instanceof nr) {
                    e = e.clone();
                    e.value = e.value.transform(this);
                    return e;
                }
                return e.convert_symbol(t, r);
            }));
        }
        It.DEFMETHOD("convert_symbol", n);
        Zt.DEFMETHOD("convert_symbol", n);
        function t(e, n) {
            var t = Te(e, this, this);
            n(t, this);
            return t;
        }
        cr.DEFMETHOD("convert_symbol", t);
        un.DEFMETHOD("convert_symbol", t);
        function r(n, t) {
            var r = new Ir(function(e) {
                if (e instanceof It) {
                    e.value.walk(t);
                    e.name.walk(r);
                    return true;
                }
                if (e instanceof nr) {
                    if (e.key instanceof nn) e.key.walk(t);
                    e.value.walk(r);
                    return true;
                }
                return n(e);
            });
            this.walk(r);
        }
        It.DEFMETHOD("mark_symbol", r);
        Zt.DEFMETHOD("mark_symbol", r);
        function i(e) {
            return e(this);
        }
        cr.DEFMETHOD("mark_symbol", i);
        un.DEFMETHOD("mark_symbol", i);
        nn.DEFMETHOD("match_symbol", function(e) {
            return e(this);
        });
        function a(n, t) {
            var r = false;
            var i = new Ir(function(e) {
                if (r) return true;
                if (e instanceof It) {
                    if (!t) return r = true;
                    e.name.walk(i);
                    return true;
                }
                if (e instanceof nr) {
                    if (!t && e.key instanceof nn) return r = true;
                    e.value.walk(i);
                    return true;
                }
                if (n(e)) return r = true;
            });
            this.walk(i);
            return r;
        }
        It.DEFMETHOD("match_symbol", a);
        Zt.DEFMETHOD("match_symbol", a);
        function E(e) {
            return e instanceof ot || e instanceof nt;
        }
        function fe(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t.variables) return t;
            }
        }
        var ue = wn("Infinity NaN undefined");
        function Me(e, n) {
            if (e instanceof wr) return true;
            if (e instanceof Lt) {
                if (e.property === "__proto__") return true;
                e = e.expression;
                if (e instanceof un) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.tail_node().is_constant()) return true;
                return Me(e, n);
            }
            if (e instanceof un) {
                if (e.is_immutable()) return true;
                var t = e.definition();
                return n.exposed(t) && ue[t.name];
            }
            return false;
        }
        function Te(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function Ae(e, n) {
            if (n.length == 1) return n[0];
            return Te(an, e, {
                expressions: n.reduce(S, [])
            });
        }
        function ce(e, n) {
            switch (typeof e) {
              case "string":
                return Te(Ar, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return Te(zr, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? Te(on, n, {
                        operator: "-",
                        expression: Te(Dr, n, {
                            value: -e
                        })
                    }) : Te(Dr, n, {
                        value: e
                    });
                }
                return e < 0 ? Te(on, n, {
                    operator: "-",
                    expression: Te(Fr, n)
                }) : Te(Fr, n);

              case "boolean":
                return Te(e ? Nr : jr, n);

              case "undefined":
                return Te(Cr, n);

              default:
                if (e === null) {
                    return Te(qr, n);
                }
                if (e instanceof RegExp) {
                    return Te($r, n, {
                        value: e
                    });
                }
                throw new Error(bn("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function le(e, n) {
            return n instanceof Lt || De(n) && n.name == "eval";
        }
        function Fe(e, n, t, r) {
            var i = false;
            if (n.TYPE == "Call") {
                i = n.expression === t && le(e, r);
            } else if (n instanceof Sr) {
                i = n.tag === t && le(e, r);
            } else if (n instanceof on) {
                i = n.operator == "delete" || n.operator == "typeof" && De(r);
            }
            return i ? Ae(t, [ Te(Dr, t, {
                value: 0
            }), r ]) : r;
        }
        function S(e, n) {
            if (n instanceof an) {
                [].push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function C(e) {
            return e instanceof qt || e instanceof ct || e instanceof zt;
        }
        function T(e) {
            if (e instanceof it) {
                var n = e.name.definition();
                var t = e.name.scope;
                return n.scope === t || en(n.references, function(e) {
                    var n = e.scope;
                    do {
                        if (n === t) return true;
                    } while (n = n.parent_scope);
                });
            }
            return !C(e);
        }
        function M(e) {
            if (e === null) return [];
            if (e instanceof rn) return en(e.body, T) ? e.body : [ e ];
            if (e instanceof Dn) return [];
            if (On(e)) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function pe(e) {
            if (e === null) return true;
            if (e instanceof Dn) return true;
            if (e instanceof rn) return e.body.length == 0;
            return false;
        }
        function A(e) {
            return en(e.body, function(e) {
                return pe(e) || e instanceof st || e instanceof Ct && ve(e);
            });
        }
        function F(e) {
            if (e instanceof Mn) {
                return e.body instanceof rn ? e.body : e;
            }
            return e;
        }
        function de(e) {
            if (e.TYPE != "Call") return false;
            do {
                e = e.expression;
            } while (e instanceof Lt);
            return e instanceof Wn ? !Gn(e) : de(e);
        }
        function Pe(e) {
            var n = e.expression;
            if (n.name) return false;
            if (!(e instanceof Yt)) return true;
            var t = false;
            n.walk(new Ir(function(e) {
                if (t) return true;
                if (e instanceof Er) return t = true;
                if (e instanceof Ln && e !== n) return true;
            }));
            return !t;
        }
        function De(e) {
            return e instanceof un && e.definition().undeclared;
        }
        var je = wn("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Map Math Number parseFloat parseInt RangeError ReferenceError RegExp Object Set setInterval setTimeout String SyntaxError TypeError unescape URIError WeakMap WeakSet");
        un.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && je[this.name];
        });
        function ve(e) {
            return en(e.definitions, function(e) {
                return !e.value;
            });
        }
        function P(e, n) {
            if (e instanceof ct) return n && !e.extends && en(e.properties, function(e) {
                if (e.key instanceof nn) return false;
                if (e instanceof dt && e.static && e.value) return false;
                return true;
            });
            if (e instanceof $t) return (n || e instanceof Ct) && ve(e);
            if (e instanceof Ft) return P(e.body, n);
            if (e instanceof Pt) return P(e.body, n);
            return e instanceof it;
        }
        function j(e, n) {
            var t = e.lastIndexOf(n);
            if (t < 0) return false;
            while (++t < e.length) {
                if (!P(e[t], true)) return false;
            }
            return true;
        }
        function Ne(e, n) {
            var t;
            if (e.init instanceof rn) {
                t = e.init;
                e.init = t.body.pop();
                t.body.push(e);
            }
            if (e.init instanceof st) {
                if (!t) t = Te(rn, e, {
                    body: [ e ]
                });
                t.body.splice(-1, 0, e.init);
                e.init = null;
            } else if (e.init instanceof tn) {
                e.init = e.init.body;
            } else if (pe(e.init)) {
                e.init = null;
            }
            if (!t) return;
            return n ? _n.splice(t.body) : t;
        }
        function c(e, s) {
            var A = D(s, function(e) {
                return e instanceof Un;
            });
            var o, xe, ke, Ee;
            i();
            var n, t, r = 10;
            do {
                t = n;
                n = 0;
                if (f(e)) n = 1;
                if (!n && t == 1) break;
                if (s.option("dead_code")) {
                    if (c(e, s)) n = 2;
                    if (!n && t == 2) break;
                }
                if (s.option("if_return")) {
                    if (u(e, s)) n = 3;
                    if (!n && t == 3) break;
                }
                if (s.option("awaits") && s.option("side_effects")) {
                    if (l(e, s)) n = 4;
                    if (!n && t == 4) break;
                }
                if (s.option("inline") >= 4) {
                    if (d(e, s)) n = 5;
                    if (!n && t == 5) break;
                }
                if (s.sequences_limit > 0) {
                    if (v(e, s)) n = 6;
                    if (!n && t == 6) break;
                    if (m(e, s)) n = 7;
                    if (!n && t == 7) break;
                }
                if (s.option("join_vars")) {
                    if (x(e)) n = 8;
                    if (!n && t == 8) break;
                }
                if (s.option("collapse_vars")) {
                    if (a(e, s)) n = 9;
                }
            } while (n && r-- > 0);
            return e;
            function D(e, n) {
                var t = e.self(), r, i = 0;
                do {
                    do {
                        if (n(t)) return true;
                        t = e.parent(i++);
                    } while (t instanceof xt && (r = t));
                } while ((t instanceof rn || t instanceof Ln) && j(t.body, r));
            }
            function i() {
                var e = s.self(), n = 0;
                do {
                    if (!o && e.variables) o = e;
                    if (e instanceof Dt) {
                        if (s.parent(n).bfinally) {
                            if (!ke) ke = {};
                            ke.bfinally = true;
                        }
                        n++;
                    } else if (e instanceof Ot) {
                        n++;
                    } else if (e instanceof Mn) {
                        xe = true;
                    } else if (e instanceof Ln) {
                        Ee = e;
                        break;
                    } else if (e instanceof At) {
                        if (!ke) ke = {};
                        if (e.bcatch) ke.bcatch = true;
                        if (e.bfinally) ke.bfinally = true;
                    }
                } while (e = s.parent(n++));
            }
            function a(m, d) {
                if (Ee.pinned()) return;
                var _;
                var g = new xn();
                var b = [];
                var y = false;
                var w = new xn();
                var a;
                var x = m.length;
                var l = new Hr(function(e, n) {
                    if (p) return e;
                    if (!U) {
                        if (e !== f[k]) return e;
                        k++;
                        if (k < f.length) return G(e, l);
                        U = true;
                        D = (A ? c : ne)(e, 0);
                        if (D === e) p = true;
                        return e;
                    }
                    var t = l.parent();
                    if (!O && K(e, t)) {
                        O = t;
                    }
                    if (C && q && h && !O && e instanceof fn && e.operator != "=" && e.left.equivalent_to(v)) {
                        V++;
                        y = true;
                        nn.info("Cascading {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        h = false;
                        I = de(v);
                        e.right.transform(l);
                        le(u);
                        var r;
                        if (p) {
                            r = u;
                        } else {
                            p = true;
                            r = Te(sn, u, {
                                operator: C,
                                left: v.fixed && v.definition().fixed ? v.fixed.to_binary() : v,
                                right: R
                            });
                        }
                        return Te(fn, e, {
                            operator: "=",
                            left: e.left,
                            right: Te(sn, e, {
                                operator: e.operator.slice(0, -1),
                                left: r,
                                right: e.right
                            })
                        });
                    }
                    if (X(e, t)) {
                        p = true;
                        return e;
                    }
                    if (e.single_use && t instanceof Mt && t.value === e) return e;
                    var i;
                    if (!(e instanceof cr) && (q && v.equivalent_to(e) || z && (i = z(e, this)))) {
                        if (!h || O && (i || !H || !B)) {
                            if (!i && !A) p = true;
                            return e;
                        }
                        if (Jr(e, t)) {
                            if (A && !i) S = true;
                            return e;
                        } else if (A) {
                            if (O && E == 0) E = T - V;
                            if (!i) V++;
                            return e;
                        } else {
                            V++;
                        }
                        y = p = true;
                        nn.info("Collapsing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (u.TYPE == "Binary") return Te(fn, u, {
                            operator: "=",
                            left: u.right.left,
                            right: Te(Jt, u, {
                                condition: u.operator == "&&" ? u.left : u.left.negate(d),
                                consequent: u.right.right,
                                alternative: e
                            })
                        });
                        if (u instanceof Gt) return Te(on, u, {
                            operator: u.operator,
                            expression: v.fixed && v.definition().fixed ? v.fixed.to_prefix() : v
                        });
                        if (u instanceof Mt) {
                            var a = u.name.definition();
                            if (a.references.length - a.replaced == 1 && !d.exposed(a)) {
                                a.replaced++;
                                return Fe(d, t, e, R);
                            }
                            return Te(fn, u, {
                                operator: "=",
                                left: e,
                                right: R
                            });
                        }
                        le(u);
                        var o = u.clone();
                        o.right = R;
                        return o;
                    }
                    if (Q(e, t) || M(e)) {
                        D = e;
                        if (e instanceof Ln) p = true;
                    }
                    if (e instanceof Vn) {
                        var s = h;
                        h = false;
                        n(e, l);
                        h = s;
                        return W(e);
                    }
                    if (e instanceof Zt) {
                        var s = h;
                        h = false;
                        n(e, l);
                        h = s;
                        return W(e);
                    }
                    if (e instanceof It) {
                        e.name = e.name.transform(l);
                        var s = h;
                        h = false;
                        e.value = e.value.transform(l);
                        h = s;
                        return W(e);
                    }
                    if (e instanceof $n && !(e instanceof Ln) && !(e.variables && e.variables.all(function(e) {
                        return !j.has(e.name) && !I.has(e.name);
                    }))) {
                        var s = h;
                        h = false;
                        if (!G(e, l)) n(e, l);
                        h = s;
                        return W(e);
                    }
                    return G(e, l);
                }, W);
                var r = new Hr(function(e) {
                    if (p) return e;
                    if (!U) {
                        if (e !== f[k]) return e;
                        k++;
                        switch (f.length - k) {
                          case 0:
                            U = true;
                            if (S) return e;
                            if (e !== u) return e;
                            if (e instanceof Mt) return e;
                            i.replaced++;
                            var n = r.parent();
                            if (n instanceof an && n.tail_node() !== e) {
                                A.replaced++;
                                if (R === Y) return _n.skip;
                                return Ae(Y, Y.expressions.slice(0, -1));
                            }
                            return R;

                          case 1:
                            if (!S && e.body === u) {
                                U = true;
                                i.replaced++;
                                A.replaced++;
                                return null;
                            }

                          default:
                            return G(e, r);
                        }
                    }
                    if (e instanceof un && e.definition() === i) {
                        if (Jr(e, r.parent())) return e;
                        if (!--V) p = true;
                        nn.info("Replacing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        var t = R.clone();
                        t.scope = e.scope;
                        t.reference();
                        if (V == E) {
                            p = true;
                            return Te(fn, u, {
                                operator: "=",
                                left: e,
                                right: t
                            });
                        }
                        i.replaced++;
                        return t;
                    }
                    if (e instanceof St || e instanceof Ln) return e;
                }, function(e) {
                    return he(e, r);
                });
                while (--x >= 0) {
                    if (x == 0 && d.option("unused")) ee();
                    var f = [];
                    o(m[x]);
                    while (b.length > 0) {
                        f = b.pop();
                        var k = 0;
                        var u = f[f.length - 1];
                        var E = -1;
                        var S = false;
                        var T;
                        var A = null;
                        var D = null;
                        var O = null;
                        var v = oe(u);
                        var $ = v && v.has_side_effects(d);
                        var q = v && !$ && !Me(v, d);
                        var z = ue(u);
                        if (!q && !z) continue;
                        var C = u instanceof fn && u.operator.slice(0, -1);
                        var t = u.name instanceof hr;
                        var M = dn;
                        if (u.may_throw(d)) {
                            if (t && Jn(Ee)) continue;
                            M = ke ? function(e) {
                                return e.has_side_effects(d);
                            } : we;
                        }
                        var F = false;
                        var P = false;
                        var j = new xn();
                        var N = true;
                        var I = de(u);
                        var H = me(v);
                        var Y = se(u);
                        var R = !C && Y instanceof an ? Y.tail_node() : Y;
                        if (!$) $ = _e();
                        var L = ke || !H ? function(e) {
                            return e instanceof Zt;
                        } : dn;
                        var B = ge(u);
                        var U = t;
                        var p = false;
                        var V = 0;
                        var h = !_ || !U;
                        if (!h) {
                            for (var e = u.arg_index + 1; !p && e < _.length; e++) {
                                if (_[e]) _[e].transform(l);
                            }
                            h = true;
                        }
                        for (var n = x; !p && n < m.length; n++) {
                            m[n].transform(l);
                        }
                        if (A) {
                            if (!V || T > V + S) {
                                b.push(f);
                                a = true;
                                continue;
                            }
                            if (V == E) S = true;
                            var i = v.definition();
                            p = false;
                            k = 0;
                            U = t;
                            for (var n = x; !p && n < m.length; n++) {
                                if (!m[n].transform(r)) m.splice(n--, 1);
                            }
                            V = u instanceof Mt && u === f[f.length - 1] && i.references.length == i.replaced && !d.exposed(i);
                            A.last_ref = false;
                            A.single_use = false;
                            y = true;
                        }
                        if (V) ve(u);
                    }
                }
                return y;
                function W(e) {
                    if (p) return e;
                    if (D === e) p = true;
                    if (O === e) O = null;
                    return e;
                }
                function G(e, n) {
                    if (!(e instanceof $n)) {
                        if (!(e instanceof pt && !e.static)) return;
                        if (e.key instanceof nn) e.key = e.key.transform(n);
                        return e;
                    }
                    if (e instanceof Ln) return e;
                    if (e instanceof In) {
                        e.object = e.object.transform(n);
                        p = true;
                        return e;
                    }
                    if (e instanceof kt) {
                        e.expression = e.expression.transform(n);
                        for (var t = 0; !p && t < e.body.length; t++) {
                            var r = e.body[t];
                            if (r instanceof Tt) {
                                if (!U) {
                                    if (r !== f[k]) continue;
                                    k++;
                                }
                                r.expression = r.expression.transform(n);
                                if (!B) break;
                                z = false;
                            }
                        }
                        p = true;
                        return e;
                    }
                }
                function J(e, n) {
                    if (n instanceof fn) return n.operator == "=" && n.left === e;
                    if (n instanceof It) return n.name === e;
                    if (n instanceof er) return true;
                    if (n instanceof nr) return n.value === e;
                }
                function X(e, n) {
                    if (e === R) return true;
                    if (n instanceof Nn) {
                        if (e !== n.init) return true;
                    }
                    if (e instanceof fn) {
                        return e.operator != "=" && v.equivalent_to(e.left);
                    }
                    if (e instanceof Ht) {
                        if (!(v instanceof Lt)) return false;
                        if (!v.equivalent_to(e.expression)) return false;
                        return !(R instanceof Wn && !R.contains_this());
                    }
                    if (e instanceof ut) return !d.has_directive("use strict");
                    if (e instanceof Tn) return true;
                    if (e instanceof st) return t && v.name === e.name.name;
                    if (e instanceof nr) return e.key instanceof nn;
                    if (e instanceof Fn) return true;
                    if (e instanceof bt) return true;
                    if (e instanceof un) {
                        if (e.is_declared(d)) {
                            if (e.fixed_value()) return false;
                            if (Se(e)) {
                                return !(n instanceof Lt && n.expression === e) && ze(e.definition());
                            }
                        } else if (J(e, n)) {
                            return false;
                        }
                        if (!B) return true;
                        z = false;
                        return false;
                    }
                    if (e instanceof At) return true;
                    if (e instanceof Rn) return true;
                    return false;
                }
                function K(e, n) {
                    if (n instanceof fn) return n.left !== e && $e[n.operator.slice(0, -1)];
                    if (n instanceof sn) return n.left !== e && $e[n.operator];
                    if (n instanceof Ht) return n.optional && n.expression !== e;
                    if (n instanceof Tt) return n.expression !== e;
                    if (n instanceof Jt) return n.condition !== e;
                    if (n instanceof xt) return n.condition !== e;
                    if (n instanceof Ut) return n.optional && n.expression !== e;
                }
                function Q(e, n) {
                    if (e instanceof Xt) return true;
                    if (e.TYPE == "Binary") return e.operator == "in" && !Ye(e.right);
                    if (e instanceof Ht) {
                        var t, r = e.expression;
                        if (r instanceof un) {
                            t = r.definition();
                            r = r.fixed_value();
                        }
                        if (!(r instanceof Un)) return !e.is_expr_pure(d);
                        if (t && Re(d, t, r)) return true;
                        if (r.collapse_scanning) return false;
                        r.collapse_scanning = true;
                        var i = h;
                        h = false;
                        var a = D;
                        var c = O;
                        if (!en(r.argnames, function(e) {
                            if (e instanceof It) {
                                e.value.transform(l);
                                if (p) return false;
                                e = e.name;
                            }
                            return !(e instanceof Zt);
                        })) {
                            p = true;
                        } else if (Gn(r) && r.value) {
                            r.value.transform(l);
                        } else for (var o = 0; !p && o < r.body.length; o++) {
                            var s = r.body[o];
                            if (s instanceof _t) {
                                if (s.value) s.value.transform(l);
                                break;
                            }
                            s.transform(l);
                        }
                        O = c;
                        D = a;
                        h = i;
                        r.collapse_scanning = false;
                        if (!p) return false;
                        p = false;
                        return true;
                    }
                    if (e instanceof mt) {
                        if (ke) {
                            if (ke.bfinally) return true;
                            if (ke.bcatch && e instanceof gt) return true;
                        }
                        return $ || v instanceof Lt || ye(v);
                    }
                    if (e instanceof tt) {
                        return d.option("ie") && e.name && I.has(e.name.name);
                    }
                    if (e instanceof wr) return be(e, n);
                    if (e instanceof Lt) {
                        if ($) return true;
                        var f = e.expression;
                        if (f instanceof un && ze(f.definition())) return true;
                        if (d.option("unsafe")) {
                            if (De(f) && je[f.name]) return false;
                            if (Ie(f)) return false;
                        }
                        if (!N) return true;
                        if (A) return false;
                        if (!ke && H) return false;
                        if (e.optional) return false;
                        return f.may_throw_on_access(d);
                    }
                    if (e instanceof Vt) return true;
                    if (e instanceof un) {
                        if (be(e, n)) return !J(e, n);
                        if ($ && ye(e)) return true;
                        var t = e.definition();
                        return (ke || t.scope.resolve() !== Ee) && !Se(e);
                    }
                    if (e instanceof Sr) return !e.is_expr_pure(d);
                    if (e instanceof Mt) {
                        if (L(e.name)) return true;
                        return (e.value || n instanceof zt) && e.name.match_symbol(function(e) {
                            return e instanceof cr && (I.has(e.name) || $ && ye(e));
                        }, true);
                    }
                    if (e instanceof Kt) return true;
                    var u = Jr(e.left, e);
                    if (!u) return false;
                    if (u instanceof Lt) return true;
                    if (L(u)) return true;
                    return u.match_symbol(function(e) {
                        return e instanceof un && (I.has(e.name) || F && d.exposed(e.definition()));
                    }, true);
                }
                function Z(e, n) {
                    if (!n) return !(e instanceof ur);
                    if (e instanceof It) {
                        return n.has_side_effects(d) || e.value.has_side_effects(d) || Z(e.name, Oe(n) && e.value);
                    }
                    if (e instanceof Zt) {
                        if (e.rest && Z(e.rest)) return true;
                        if (e instanceof er) {
                            if (!(n instanceof Qt || n.is_string(d))) return true;
                            return !en(e.elements, function(e) {
                                return !Z(e);
                            });
                        }
                        if (e instanceof tr) {
                            if (!n.is_defined(d)) return true;
                            return !en(e.properties, function(e) {
                                if (e instanceof nn && e.has_side_effects(d)) return false;
                                return !Z(e.value);
                            });
                        }
                    }
                }
                function ee() {
                    var e, i = d.self();
                    if (i instanceof Wn && !Xn(i) && !i.uses_arguments && !i.pinned() && (e = d.parent()) instanceof Ht && e.expression === i && Pe(e) && en(e.args, function(e) {
                        return !(e instanceof Vt);
                    })) {
                        var a = d.has_directive("use strict");
                        if (a && !cn(a, i.body)) a = false;
                        var c = Jn(i) ? function(e) {
                            return e instanceof ur && e.name == "await";
                        } : function(e) {
                            return e instanceof Xt && !n.find_parent(Ln);
                        };
                        var o = null;
                        var n = new Ir(function(e, n) {
                            if (!s) return true;
                            if (c(e) || e instanceof Kt) {
                                s = null;
                                return true;
                            }
                            if (e instanceof wr && (a || !o)) {
                                s = null;
                                return true;
                            }
                            if (e instanceof un && i.variables.has(e.name)) {
                                var t = e.definition().scope;
                                if (t !== Ee) while (t = t.parent_scope) {
                                    if (t === Ee) return true;
                                }
                                s = null;
                            }
                            if (e instanceof Ln && !Gn(e)) {
                                var r = o;
                                o = e;
                                n();
                                o = r;
                                return true;
                            }
                        });
                        _ = e.args.slice();
                        var l = _.length;
                        var p = new xn();
                        for (var t = i.argnames.length; --t >= 0; ) {
                            var r = i.argnames[t];
                            var s = _[t];
                            var f;
                            if (r instanceof It) {
                                f = r.value;
                                r = r.name;
                                _[l + t] = f;
                            }
                            if (r instanceof Zt) {
                                if (!Z(r, s)) continue;
                                b.length = 0;
                                break;
                            }
                            if (p.has(r.name)) continue;
                            p.set(r.name, true);
                            if (f) s = Oe(s) ? f : null;
                            if (!s && !f) {
                                s = Te(Cr, r).transform(d);
                            } else if (s instanceof Un && s.pinned()) {
                                s = null;
                            } else if (s) {
                                s.walk(n);
                            }
                            if (!s) continue;
                            var u = Te(Mt, r, {
                                name: r,
                                value: s
                            });
                            u.name_index = t;
                            u.arg_index = f ? l + t : t;
                            b.unshift([ u ]);
                        }
                    }
                }
                function o(e, n) {
                    f.push(e);
                    if (e instanceof Qt) {
                        e.elements.forEach(function(e) {
                            o(e, n);
                        });
                    } else if (e instanceof fn) {
                        var t = e.left;
                        if (!(t instanceof Zt)) b.push(f.slice());
                        o(t);
                        o(e.right);
                        if (t instanceof un && e.operator == "=") {
                            g.set(t.name, (g.get(t.name) || 0) + 1);
                        }
                    } else if (e instanceof Xt) {
                        o(e.expression, n);
                    } else if (e instanceof sn) {
                        var r = $e[e.operator];
                        if (n && r && e.operator != "??" && e.right instanceof fn && e.right.operator == "=" && !(e.right.left instanceof Zt)) {
                            b.push(f.slice());
                        }
                        o(e.left, !r && n);
                        o(e.right, n);
                    } else if (e instanceof Ht) {
                        o(e.expression);
                        e.args.forEach(o);
                    } else if (e instanceof Tt) {
                        o(e.expression);
                    } else if (e instanceof Jt) {
                        o(e.condition);
                        o(e.consequent, n);
                        o(e.alternative, n);
                    } else if (e instanceof $t) {
                        e.definitions.forEach(o);
                    } else if (e instanceof Bt) {
                        o(e.expression);
                    } else if (e instanceof Fn) {
                        o(e.condition);
                        if (!(e.body instanceof zn)) {
                            o(e.body);
                        }
                    } else if (e instanceof mt) {
                        if (e.value) o(e.value);
                    } else if (e instanceof Nn) {
                        if (e.init) o(e.init, true);
                        if (e.condition) o(e.condition);
                        if (e.step) o(e.step, true);
                        if (!(e.body instanceof zn)) {
                            o(e.body);
                        }
                    } else if (e instanceof In) {
                        o(e.object);
                        if (!(e.body instanceof zn)) {
                            o(e.body);
                        }
                    } else if (e instanceof xt) {
                        o(e.condition);
                        if (!(e.body instanceof zn)) {
                            o(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof zn)) {
                            o(e.alternative);
                        }
                    } else if (e instanceof rr) {
                        e.properties.forEach(function(e) {
                            f.push(e);
                            if (e.key instanceof nn) o(e.key);
                            if (e instanceof ar) o(e.value, n);
                            f.pop();
                        });
                    } else if (e instanceof an) {
                        var i = e.expressions.length - (n ? 0 : 1);
                        e.expressions.forEach(function(e, n) {
                            o(e, n < i);
                        });
                    } else if (e instanceof tn) {
                        o(e.body, true);
                    } else if (e instanceof Vt) {
                        o(e.expression);
                    } else if (e instanceof Ut) {
                        o(e.expression);
                        o(e.property);
                    } else if (e instanceof kt) {
                        o(e.expression);
                        e.body.forEach(o);
                    } else if (e instanceof Wt) {
                        if (Br[e.operator]) {
                            b.push(f.slice());
                        } else {
                            o(e.expression);
                        }
                    } else if (e instanceof Mt) {
                        if (e.name instanceof vr) {
                            if (e.value) {
                                var a = e.name.definition();
                                if (a.references.length > a.replaced) {
                                    b.push(f.slice());
                                }
                            } else {
                                w.set(e.name.name, (w.get(e.name.name) || 0) + 1);
                            }
                        }
                        if (e.value) o(e.value);
                    } else if (e instanceof Kt) {
                        if (e.expression) o(e.expression);
                    }
                    f.pop();
                }
                function ne(e, n) {
                    var t = l.parent(n);
                    if (t instanceof Qt) return e;
                    if (t instanceof fn) return e;
                    if (t instanceof Xt) return e;
                    if (t instanceof sn) return e;
                    if (t instanceof Ht) return e;
                    if (t instanceof Tt) return e;
                    if (t instanceof Jt) return e;
                    if (t instanceof $t) return s(t, n + 1);
                    if (t instanceof mt) return e;
                    if (t instanceof xt) return e;
                    if (t instanceof Mn) return e;
                    if (t instanceof ir) return e;
                    if (t instanceof Lt) return e;
                    if (t instanceof an) {
                        return (t.tail_node() === e ? ne : s)(t, n + 1);
                    }
                    if (t instanceof tn) return s(t, n + 1);
                    if (t instanceof Vt) return e;
                    if (t instanceof kt) return e;
                    if (t instanceof Wt) return e;
                    if (t instanceof Mt) return e;
                    if (t instanceof Kt) return e;
                    return null;
                }
                function te(e, n, t) {
                    var r;
                    do {
                        r = e;
                        e = l.parent(++t);
                    } while (e instanceof fn && e.operator.slice(0, -1) == n || e instanceof sn && e.operator == n);
                    return r;
                }
                function re(e, n, t, r, i) {
                    var a = h;
                    h = false;
                    var o = D;
                    var s = O;
                    var f = l.stack;
                    l.stack = [ r ];
                    e.transform(l);
                    l.stack = f;
                    O = s;
                    D = o;
                    h = a;
                    if (p) {
                        p = false;
                        return t;
                    }
                    return n(r, i + 1);
                }
                function c(e, n) {
                    var t = l.parent(n);
                    if (t instanceof Qt) return c(t, n + 1);
                    if (t instanceof fn) {
                        if (M(t)) return e;
                        if (t.left.match_symbol(function(e) {
                            return e instanceof un && (v.name == e.name || A.name == e.name);
                        })) return e;
                        var r;
                        if (t.left === e || !$e[r = t.operator.slice(0, -1)]) {
                            return c(t, n + 1);
                        }
                        return te(t, r, n);
                    }
                    if (t instanceof sn) {
                        var r;
                        if (t.left === e || !$e[r = t.operator]) {
                            return c(t, n + 1);
                        }
                        return te(t, r, n);
                    }
                    if (t instanceof Ht) return t;
                    if (t instanceof Tt) {
                        if (t.expression !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof Jt) {
                        if (t.condition !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof $t) return s(t, n + 1);
                    if (t instanceof Pn) return e;
                    if (t instanceof mt) return s(t, n + 1);
                    if (t instanceof Nn) {
                        if (t.init !== e && t.condition !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof In) {
                        if (t.init !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof xt) {
                        if (t.condition !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof ir) {
                        var i = l.parent(n + 1);
                        return en(i.properties, function(e) {
                            return e instanceof ar;
                        }) ? c(i, n + 2) : i;
                    }
                    if (t instanceof Lt) {
                        var a = t.expression;
                        return a === e ? c(t, n + 1) : e;
                    }
                    if (t instanceof an) {
                        return (t.tail_node() === e ? c : s)(t, n + 1);
                    }
                    if (t instanceof tn) return s(t, n + 1);
                    if (t instanceof Vt) return c(t, n + 1);
                    if (t instanceof kt) {
                        if (t.expression !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof Wt) {
                        if (t.operator == "delete") return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof Mt) return t.name.match_symbol(function(e) {
                        return e instanceof cr && (v.name == e.name || A.name == e.name);
                    }) ? e : c(t, n + 1);
                    if (t instanceof jn) {
                        if (t.condition !== e) return e;
                        return c(t, n + 1);
                    }
                    if (t instanceof Kt) return c(t, n + 1);
                    return null;
                }
                function s(n, t) {
                    var r = l.parent(t);
                    if (Q(n, r)) return n;
                    if (K(n, r)) return n;
                    if (r instanceof Qt) return s(r, t + 1);
                    if (r instanceof fn) return a(r.left);
                    if (r instanceof Xt) return n;
                    if (r instanceof sn) return s(r, t + 1);
                    if (r instanceof Ht) return s(r, t + 1);
                    if (r instanceof Tt) return s(r, t + 1);
                    if (r instanceof Jt) return s(r, t + 1);
                    if (r instanceof $t) return s(r, t + 1);
                    if (r instanceof mt) return s(r, t + 1);
                    if (r instanceof xt) return s(r, t + 1);
                    if (r instanceof Mn) return n;
                    if (r instanceof ir) {
                        var e = l.parent(t + 1);
                        return en(e.properties, function(e) {
                            return e instanceof ar;
                        }) ? s(e, t + 2) : e;
                    }
                    if (r instanceof Lt) {
                        var i = r.expression;
                        if (i === n) return s(r, t + 1);
                        return re(i, s, n, r, t);
                    }
                    if (r instanceof an) return s(r, t + 1);
                    if (r instanceof tn) return s(r, t + 1);
                    if (r instanceof Vt) return n;
                    if (r instanceof kt) return s(r, t + 1);
                    if (r instanceof Wt) return s(r, t + 1);
                    if (r instanceof Mt) return a(r.name);
                    if (r instanceof Kt) return n;
                    return null;
                    function a(e) {
                        if (M(r)) return n;
                        if (e !== n && e instanceof Zt) {
                            return re(e, s, n, r, t);
                        }
                        return s(r, t + 1);
                    }
                }
                function ie(e) {
                    if (a) {
                        a = false;
                        return;
                    }
                    if (T < 1) return;
                    e = e.tail_node();
                    var n = e instanceof fn && e.operator == "=" ? e.left : e;
                    if (!(n instanceof un)) return;
                    var t = n.definition();
                    if (t.undeclared) return;
                    if (ze(t)) return;
                    if (n !== e) {
                        if (Me(n, d)) return;
                        var r = t.references.length - t.replaced;
                        if (r < 2) return;
                        var i = u.clone();
                        i[i instanceof fn ? "right" : "value"] = n;
                        if (u.name_index >= 0) {
                            i.name_index = u.name_index;
                            i.arg_index = u.arg_index;
                        }
                        u = i;
                    }
                    return A = t;
                }
                function ae(e) {
                    return e.references.length - e.replaced - (g.get(e.name) || 0);
                }
                function oe(t) {
                    if (t instanceof fn) {
                        var r = t.left;
                        if (!(r instanceof un)) return r;
                        var e = r.definition();
                        if (Ee.uses_arguments && Wr(e)) return r;
                        if (d.exposed(e)) return r;
                        T = ae(e);
                        if (e.fixed && r.fixed) {
                            var n = e.references.filter(function(e) {
                                return e.fixed === r.fixed;
                            }).length - 1;
                            if (n < T) {
                                T = n;
                                E = 0;
                            }
                        }
                        if (t.operator == "=") ie(t.right);
                        return r;
                    }
                    if (t instanceof sn) return t.right.left;
                    if (t instanceof Wt) return t.expression;
                    if (t instanceof Mt) {
                        var r = t.name;
                        var e = r.definition();
                        if (e.const_redefs) return;
                        if (!cn(r, e.orig)) return;
                        if (Ee.uses_arguments && Wr(e)) return;
                        var i = e.orig.length - e.eliminated - (w.get(e.name) || 0);
                        T = ae(e);
                        if (e.fixed) T = Math.min(T, e.references.filter(function(e) {
                            if (!e.fixed) return true;
                            if (!e.fixed.assigns) return true;
                            var n = e.fixed.assigns[0];
                            return n === r || se(n) === t.value;
                        }).length);
                        if (i > 1 && !(r instanceof hr)) {
                            ie(t.value);
                            return Te(un, r, r);
                        }
                        if (ie(t.value) || T == 1 && !d.exposed(e)) {
                            return Te(un, r, r);
                        }
                        return;
                    }
                }
                function se(e) {
                    if (e instanceof fn) return e.right;
                    if (e instanceof sn) {
                        var n = e.clone();
                        n.right = e.right.right;
                        return n;
                    }
                    if (e instanceof Mt) return e.value;
                }
                function fe(e) {
                    if (e instanceof Qt) return false;
                    if (e instanceof sn && $e[e.operator]) {
                        return fe(e.left) && fe(e.right);
                    }
                    if (e instanceof Ht) return false;
                    if (e instanceof Jt) {
                        return fe(e.consequent) && fe(e.alternative);
                    }
                    if (e instanceof rr) return false;
                    return !e.has_side_effects(d);
                }
                function ue(n) {
                    if (n instanceof fn && n.right.single_use) return;
                    var t = Object.create(null);
                    var e = new Ir(function(e) {
                        if (e instanceof un) t[e.definition().id] = true;
                    });
                    while (n instanceof fn && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof wr) return o;
                    if (n instanceof un) {
                        var r = n.evaluate(d);
                        if (r === n) return o;
                        return ce(r, o);
                    }
                    if (n.is_truthy()) return ce(true, dn);
                    if (n.is_constant()) {
                        var i = n.evaluate(d);
                        if (!(i instanceof nn)) return ce(i, o);
                    }
                    if (!(v instanceof un)) return false;
                    if (!fe(n)) return false;
                    var a;
                    n.walk(new Ir(function(e) {
                        if (a) return true;
                        if (e instanceof un && t[e.definition().id]) a = true;
                    }));
                    return !a && o;
                    function o(e) {
                        return n.equivalent_to(e);
                    }
                }
                function ce(r, i) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (r && e.is_truthy() && !e.has_side_effects(d)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                var t = e.evaluate(d);
                                if (!(t instanceof nn)) return !t == !r;
                            }
                        }
                        return i(e);
                    };
                }
                function le(e) {
                    while (e.write_only) {
                        e.write_only = false;
                        if (!(e instanceof fn)) break;
                        e = e.right;
                    }
                }
                function pe(e) {
                    if (e instanceof un) {
                        e = e.fixed_value();
                        if (!e) return true;
                    }
                    if (e instanceof fn) return e.operator == "=" && pe(e.right);
                    return e instanceof Lt || e instanceof wr;
                }
                function de(f) {
                    var u = new xn();
                    if (f instanceof Mt) {
                        if (!f.name.definition().fixed) N = false;
                        u.add(f.name.name, v);
                    }
                    var c = Ee.uses_arguments && !d.has_directive("use strict");
                    var l = Ee instanceof Bn;
                    var p = new Ir(function(n) {
                        var e;
                        if (n instanceof un) {
                            e = n.fixed_value();
                            if (!e) {
                                e = n;
                                var t = n.definition();
                                var r = n.fixed && n.fixed.escaped || t.escaped;
                                if (!t.undeclared && (t.assignments || !r || r.cross_scope) && (Ce(t, n.scope, n, p.parent()) || !Le(t))) {
                                    N = false;
                                }
                            }
                        } else if (n instanceof wr) {
                            e = n;
                        }
                        if (e) {
                            u.add(n.name, qe(d, p, n, e, 0));
                        } else if (n instanceof Un) {
                            for (var i = 0, a, o = n; a = p.parent(i++); o = a) {
                                if (a instanceof fn) {
                                    if (a.left === o) break;
                                    if (a.operator == "=") continue;
                                    if ($e[a.operator.slice(0, -1)]) continue;
                                    break;
                                }
                                if (a instanceof sn) {
                                    if ($e[a.operator]) continue;
                                    break;
                                }
                                if (a instanceof Ht) return;
                                if (a instanceof Ln) return;
                                if (a instanceof an) {
                                    if (a.tail_node() === o) continue;
                                    break;
                                }
                                if (a instanceof Sr) {
                                    if (a.tag) return;
                                    break;
                                }
                            }
                            n.enclosed.forEach(function(e) {
                                if (e.scope !== n) j.set(e.name, true);
                            });
                            return true;
                        } else if (c && n instanceof Ut) {
                            Ee.each_argname(function(e) {
                                if (!d.option("reduce_vars") || e.definition().assignments) {
                                    if (!e.definition().fixed) N = false;
                                    u.add(e.name, true);
                                }
                            });
                            c = false;
                        }
                        if (!l) return;
                        if (n.TYPE == "Call") {
                            if (P) return;
                            var s = n.expression;
                            if (s instanceof Lt) return;
                            if (s instanceof Wn && !s.contains_this()) return;
                            P = true;
                        } else if (n instanceof Lt && pe(n.expression)) {
                            if (n === v && !(f instanceof Wt)) {
                                P = true;
                            } else {
                                F = true;
                            }
                        }
                    });
                    f.walk(p);
                    return u;
                }
                function ve(e) {
                    var r = R === Y ? null : Ae(Y, Y.expressions.slice(0, -1));
                    var n = e.name_index;
                    if (n >= 0) {
                        var t, i = Ee.argnames[n];
                        if (i instanceof It) {
                            Ee.argnames[n] = i = i.clone();
                            i.value = r || Te(Dr, i, {
                                value: 0
                            });
                        } else if ((t = d.parent().args)[n]) {
                            Ee.argnames[n] = i.clone();
                            t[n] = r || Te(Dr, t[n], {
                                value: 0
                            });
                        }
                        return;
                    }
                    var a = f.length - 1;
                    if (f[a - 1].body === f[a]) a--;
                    var o = new Hr(function(e, n, t) {
                        if (U) return e;
                        if (e !== f[k]) return e;
                        k++;
                        if (k <= a) return G(e, o);
                        U = true;
                        if (e instanceof Mt) {
                            w.set(e.name.name, (w.get(e.name.name) || 0) + 1);
                            if (A) A.replaced++;
                            e = e.clone();
                            e.value = null;
                            return r ? _n.splice([ r, e ]) : e;
                        }
                        if (!r) return t ? _n.skip : null;
                        return On(e) ? Te(tn, r, {
                            body: r
                        }) : r;
                    }, function(n, e) {
                        if (n instanceof $t) {
                            var t = [], r = n.definitions;
                            for (var i = 0, a = 0; i < r.length; i++) {
                                var o = r[i];
                                if (o instanceof Mt) continue;
                                s();
                                a = i + 1;
                                t.push(Te(tn, o, {
                                    body: o
                                }));
                            }
                            if (a == 0) return;
                            s();
                            if (t.length == 1) return t[0];
                            return e ? _n.splice(t) : Te(rn, n, {
                                body: t
                            });
                        }
                        if (n instanceof Nn) return Ne(n, e);
                        return he(n, this);
                        function s() {
                            if (a < i) {
                                var e = n.clone();
                                e.definitions = r.slice(a, i);
                                t.push(e);
                            }
                        }
                    });
                    p = false;
                    U = false;
                    k = 0;
                    if (!(m[x] = m[x].transform(o))) m.splice(x, 1);
                }
                function he(e, n) {
                    if (e instanceof an) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return Fe(d, n.parent(), e, e.expressions[0]);
                    }
                }
                function me(e) {
                    var n = Rt(e);
                    if (!(n instanceof un)) return false;
                    if (n.definition().scope.resolve() !== Ee) return false;
                    if (!xe) return true;
                    if (C) return false;
                    if (u instanceof Wt) return false;
                    var t = I.get(n.name);
                    return !t || t[0] === e;
                }
                function _e() {
                    if (u instanceof Wt) return false;
                    return R.has_side_effects(d);
                }
                function ge(e) {
                    if (e instanceof Wt) return false;
                    if ($) return false;
                    if (A) return true;
                    if (!(v instanceof un)) return false;
                    var n;
                    if (e instanceof Mt) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = v.definition();
                    if (t.references.length - t.replaced == n) return true;
                    return t.fixed && v.fixed && t.references.filter(function(e) {
                        return e.fixed === v.fixed;
                    }).length == n;
                }
                function be(e, n) {
                    var t = I.get(e.name);
                    if (!t || en(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== v) return true;
                    z = false;
                }
                function ye(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof mr) return false;
                    if (n.scope.resolve() !== Ee) return true;
                    if (P && d.exposed(n)) return true;
                    return !en(n.references, function(e) {
                        return e.scope.resolve() === Ee;
                    });
                }
                function we(e, n) {
                    if (e instanceof fn) return we(e.left, true);
                    if (e instanceof Wt) return we(e.expression, true);
                    if (e instanceof Mt) return e.value && we(e.value);
                    if (n) {
                        if (e instanceof Bt) return we(e.expression, true);
                        if (e instanceof Ut) return we(e.expression, true);
                        if (e instanceof un) return e.definition().scope.resolve() !== Ee;
                    }
                    return false;
                }
            }
            function f(e) {
                var n = false, t = [];
                for (var r = 0; r < e.length; ) {
                    var i = e[r];
                    if (i instanceof rn) {
                        if (en(i.body, T)) {
                            n = true;
                            f(i.body);
                            [].splice.apply(e, [ r, 1 ].concat(i.body));
                            r += i.body.length;
                            continue;
                        }
                    }
                    if (i instanceof An) {
                        if (cn(i.value, t)) {
                            n = true;
                            e.splice(r, 1);
                            continue;
                        }
                        t.push(i.value);
                    }
                    if (i instanceof Dn) {
                        n = true;
                        e.splice(r, 1);
                        continue;
                    }
                    r++;
                }
                return n;
            }
            function u(r, t) {
                var e = false;
                var c = t.parent();
                var l = A && c && c.TYPE == "Call";
                var p = b(r);
                for (var i = r.length; --i >= 0; ) {
                    var n = r[i];
                    var a = S(i);
                    var o = r[a];
                    if (A && !o && n instanceof _t) {
                        if (!n.value) {
                            e = true;
                            r.splice(i, 1);
                            continue;
                        }
                        var d = n.value.tail_node();
                        if (d instanceof on && d.operator == "void") {
                            e = true;
                            var s;
                            if (d === n.value) {
                                s = d.expression;
                            } else {
                                s = n.value.clone();
                                s.expressions[s.length - 1] = d.expression;
                            }
                            r[i] = Te(tn, n, {
                                body: s
                            });
                            continue;
                        }
                    }
                    if (n instanceof xt) {
                        var f = O(n.body);
                        if (x(f)) {
                            if (f.label) yn(f.label.thedef.references, f);
                            e = true;
                            n = n.clone();
                            n.condition = n.condition.negate(t);
                            var s = E(n.body, f);
                            n.body = Te(rn, n, {
                                body: M(n.alternative).concat(k())
                            });
                            n.alternative = Te(rn, n, {
                                body: s
                            });
                            r[i] = n;
                            r[i] = n.transform(t);
                            continue;
                        }
                        if (f && !n.alternative && n.body instanceof rn && o instanceof ht) {
                            var v = n.condition.negate(t);
                            if (v.print_to_string().length <= n.condition.print_to_string().length) {
                                e = true;
                                n = n.clone();
                                n.condition = v;
                                r[a] = n.body;
                                n.body = o;
                                r[i] = n;
                                r[i] = n.transform(t);
                                continue;
                            }
                        }
                        var u = O(n.alternative);
                        if (x(u)) {
                            if (u.label) yn(u.label.thedef.references, u);
                            e = true;
                            n = n.clone();
                            n.body = Te(rn, n.body, {
                                body: M(n.body).concat(k())
                            });
                            var s = E(n.alternative, u);
                            n.alternative = Te(rn, n.alternative, {
                                body: s
                            });
                            r[i] = n;
                            r[i] = n.transform(t);
                            continue;
                        }
                        if (t.option("typeofs")) {
                            if (f && !u) {
                                var h = Te(rn, t.self(), {
                                    body: r.slice(i + 1)
                                });
                                B(n.condition, null, h);
                            }
                            if (!f && u) {
                                var h = Te(rn, t.self(), {
                                    body: r.slice(i + 1)
                                });
                                B(n.condition, h);
                            }
                        }
                    }
                    if (n instanceof xt && n.body instanceof _t) {
                        var m = n.body.value;
                        var _ = n.body.in_bool || o instanceof _t && o.in_bool;
                        if (!m && !n.alternative && (A && !o || o instanceof _t && !o.value)) {
                            e = true;
                            r[i] = Te(tn, n.condition, {
                                body: n.condition
                            });
                            continue;
                        }
                        if (!n.alternative && o instanceof _t) {
                            e = true;
                            n = n.clone();
                            n.alternative = o;
                            r.splice(i, 1, n.transform(t));
                            r.splice(a, 1);
                            continue;
                        }
                        if (!n.alternative && !o && A && (_ || m && p)) {
                            e = true;
                            n = n.clone();
                            n.alternative = Te(_t, n, {
                                value: null
                            });
                            r.splice(i, 1, n.transform(t));
                            continue;
                        }
                        var g = r[T(i)];
                        if (t.option("sequences") && A && !n.alternative && (!g && l || g instanceof xt && g.body instanceof _t) && S(a) == r.length && o instanceof tn) {
                            e = true;
                            n = n.clone();
                            n.alternative = Te(rn, o, {
                                body: [ o, Te(_t, o, {
                                    value: null
                                }) ]
                            });
                            r.splice(i, 1, n.transform(t));
                            r.splice(a, 1);
                            continue;
                        }
                    }
                }
                return e;
                function b(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var r = e[t];
                        if (r instanceof xt && r.body instanceof _t) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function y(n) {
                    return D(t, function(e) {
                        return e === n;
                    });
                }
                function w(e) {
                    if (e instanceof _t) return A && Oe(e.value);
                    if (!(e instanceof bt)) return false;
                    var n = t.loopcontrol_target(e);
                    if (e instanceof wt) return y(F(n));
                    if (n instanceof Mn) return false;
                    return y(n);
                }
                function x(e) {
                    if (!w(e)) return false;
                    for (var n = r.length; --n > i; ) {
                        var t = r[n];
                        if (t instanceof ct) {
                            if (t.name.definition().preinit) return false;
                        } else if (t instanceof qt || t instanceof zt) {
                            if (!en(t.definitions, function(e) {
                                return !e.name.match_symbol(function(e) {
                                    return e instanceof cr && e.definition().preinit;
                                });
                            })) return false;
                        }
                    }
                    return true;
                }
                function k() {
                    var n = [];
                    var t = false;
                    var e = r.splice(i + 1).filter(function(e) {
                        if (e instanceof it) {
                            n.push(e);
                            return false;
                        }
                        if (C(e)) t = true;
                        return true;
                    });
                    [].push.apply(t ? e : r, n);
                    return e;
                }
                function E(e, n) {
                    var t = M(e);
                    var r = t, i;
                    while ((i = r[r.length - 1]) !== n) {
                        r = i.body;
                    }
                    r.pop();
                    if (n.value) r.push(Te(tn, n.value, {
                        body: n.value
                    }));
                    return t;
                }
                function S(e) {
                    for (var n = e + 1; n < r.length; n++) {
                        if (!P(r[n])) break;
                    }
                    return n;
                }
                function T(e) {
                    for (var n = e; --n >= 0; ) {
                        if (!P(r[n])) break;
                    }
                    return n;
                }
            }
            function c(n, t) {
                var e;
                var r = t.self();
                for (var i = 0, a = 0, o = n.length; i < o; i++) {
                    var s = n[i];
                    if (s instanceof bt) {
                        var f = t.loopcontrol_target(s);
                        if (F(f) !== r || s instanceof yt && f instanceof Mn) {
                            n[a++] = s;
                        } else if (s.label) {
                            yn(s.label.thedef.references, s);
                        }
                    } else {
                        n[a++] = s;
                    }
                    if (O(s)) {
                        e = n.slice(i + 1);
                        break;
                    }
                }
                n.length = a;
                if (e) e.forEach(function(e) {
                    N(t, e, n);
                });
                return n.length != o;
            }
            function l(e, n) {
                if (!A || ke && ke.bfinally) return;
                var t = false;
                for (var r = e.length; --r >= 0; ) {
                    var i = e[r];
                    if (!(i instanceof tn)) break;
                    var a = i.body;
                    if (!(a instanceof Xt)) break;
                    var o = a.expression;
                    if (!k(n, o)) break;
                    t = true;
                    o = o.drop_side_effect_free(n, true);
                    if (o) {
                        i.body = o;
                        break;
                    }
                }
                e.length = r + 1;
                return t;
            }
            function d(e, n) {
                var t = false;
                var r = e.length - 1;
                if (A && r >= 0) {
                    var i = e[r].try_inline(n, o);
                    if (i) {
                        e[r--] = i;
                        t = true;
                    }
                }
                var a = xe && ke && ke.bfinally ? "try" : xe;
                for (;r >= 0; r--) {
                    var i = e[r].try_inline(n, o, true, a);
                    if (!i) continue;
                    e[r] = i;
                    t = true;
                }
                return t;
            }
            function v(n, e) {
                if (n.length < 2) return;
                var t = [], r = 0;
                function i() {
                    if (!t.length) return;
                    var e = Ae(t[0], t);
                    n[r++] = Te(tn, e, {
                        body: e
                    });
                    t = [];
                }
                for (var a = 0, o = n.length; a < o; a++) {
                    var s = n[a];
                    if (s instanceof tn) {
                        if (t.length >= e.sequences_limit) i();
                        var f = s.body;
                        if (t.length > 0) f = f.drop_side_effect_free(e);
                        if (f) S(t, f);
                    } else if (P(s)) {
                        n[r++] = s;
                    } else {
                        i();
                        n[r++] = s;
                    }
                }
                i();
                n.length = r;
                return r != o;
            }
            function h(e, n) {
                if (!(e instanceof rn)) return e;
                var t = null;
                for (var r = 0; r < e.body.length; r++) {
                    var i = e.body[r];
                    if (i instanceof Ct && ve(i)) {
                        n.push(i);
                    } else if (t || C(i)) {
                        return false;
                    } else {
                        t = i;
                    }
                }
                return t;
            }
            function m(e, n) {
                var t = false, r = 0, i;
                for (var a = 0; a < e.length; a++) {
                    var o = e[a];
                    if (i) {
                        if (o instanceof mt) {
                            if (o.value || !E(Ee)) {
                                o.value = u(o.value || Te(Cr, o)).optimize(n);
                            }
                        } else if (o instanceof Nn) {
                            if (!(o.init instanceof $t)) {
                                var s = false;
                                i.body.walk(new Ir(function(e) {
                                    if (s || e instanceof Ln) return true;
                                    if (e instanceof sn && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (o.init) o.init = u(o.init); else {
                                        o.init = i.body;
                                        r--;
                                        t = true;
                                    }
                                }
                            }
                        } else if (o instanceof Hn) {
                            if (!C(o.init)) o.object = u(o.object);
                        } else if (o instanceof xt) {
                            o.condition = u(o.condition);
                        } else if (o instanceof kt) {
                            o.expression = u(o.expression);
                        } else if (o instanceof Rn) {
                            o.expression = u(o.expression);
                        }
                    }
                    if (n.option("conditionals") && o instanceof xt) {
                        var f = [];
                        var c = h(o.body, f);
                        var l = h(o.alternative, f);
                        if (c !== false && l !== false && f.length > 0) {
                            var p = f.length;
                            f.push(Te(xt, o, {
                                condition: o.condition,
                                body: c || Te(Dn, o.body),
                                alternative: l
                            }));
                            f.unshift(r, 1);
                            [].splice.apply(e, f);
                            a += p;
                            r += p + 1;
                            i = null;
                            t = true;
                            continue;
                        }
                    }
                    e[r++] = o;
                    i = o instanceof tn ? o : null;
                }
                e.length = r;
                return t;
                function u(e) {
                    r--;
                    t = true;
                    var n = i.body;
                    return Ae(n, [ n, e ]);
                }
            }
            function _(e) {
                if (e instanceof fn) return [ e ];
                if (e instanceof an) return e.expressions.slice();
            }
            function p(e, c, n) {
                var t = _(c);
                if (!t) return;
                var r = false;
                for (var i = t.length - (n || 0); --i >= 0; ) {
                    var a = t[i];
                    if (!u(a)) continue;
                    var o;
                    if (a.left instanceof un) {
                        o = t.slice(i + 1);
                    } else if (a.left instanceof Lt && u(a.left.expression)) {
                        o = t.slice(i + 1);
                        var s = a.clone();
                        a = a.left.expression;
                        s.left = s.left.clone();
                        s.left.expression = a.left.clone();
                        o.unshift(s);
                    } else {
                        continue;
                    }
                    if (o.length == 0) continue;
                    if (!w(a.left, a.right, o)) continue;
                    r = true;
                    t = t.slice(0, i).concat(a, o);
                }
                if (e instanceof $t) {
                    n = n || 0;
                    for (var i = e.definitions.length; --i >= 0; ) {
                        var f = e.definitions[i];
                        if (!f.value) continue;
                        if (w(f.name, f.value, t)) r = true;
                        if (b(f, t, n)) r = true;
                        break;
                    }
                    if (e instanceof Ct && y(e.definitions, t, n)) r = true;
                }
                return r && t;
                function u(e) {
                    return e instanceof fn && e.operator == "=";
                }
            }
            function g(e, n) {
                if (!(e instanceof tn)) return;
                if (ve(n)) return;
                var t = _(e.body);
                if (!t) return;
                var r = [];
                if (!y(r, t.reverse(), 0)) return;
                n.definitions = r.reverse().concat(n.definitions);
                return t.reverse();
            }
            function b(e, n, t) {
                if (!s.option("conditionals")) return;
                if (e.name instanceof Zt) return;
                var r = false;
                var i = e.name.definition();
                while (n.length > t) {
                    var a = te(s, i, e.value, n[0]);
                    if (!a) break;
                    e.value = a;
                    n.shift();
                    r = true;
                }
                return r;
            }
            function y(e, n, t) {
                var r = false;
                while (n.length > t) {
                    var i = n[0];
                    if (!(i instanceof fn)) break;
                    if (i.operator != "=") break;
                    var a = i.left;
                    if (!(a instanceof un)) break;
                    if (De(a)) break;
                    if (a.scope.resolve() !== Ee) break;
                    var o = a.definition();
                    if (o.scope !== Ee) break;
                    if (o.orig.length > o.eliminated + 1) break;
                    if (o.orig[0].TYPE != "SymbolVar") break;
                    var s = Te(vr, a, a);
                    e.push(Te(Mt, i, {
                        name: s,
                        value: i.right
                    }));
                    o.orig.push(s);
                    o.replaced++;
                    n.shift();
                    r = true;
                }
                return r;
            }
            function w(e, i, n) {
                var a = new xn();
                a.set(e.name, true);
                while (i instanceof fn && i.operator == "=") {
                    if (i.left instanceof un) a.set(i.left.name, true);
                    i = i.right;
                }
                if (!(i instanceof rr)) return;
                var t = false;
                do {
                    if (!o(n[0])) break;
                    n.shift();
                    t = true;
                } while (n.length);
                return t;
                function o(e) {
                    if (!(e instanceof fn)) return;
                    if (e.operator != "=") return;
                    if (!(e.left instanceof Lt)) return;
                    var n = e.left.expression;
                    if (!(n instanceof un)) return;
                    if (!a.has(n.name)) return;
                    if (!e.right.is_constant_expression(Ee)) return;
                    var t = e.left.property;
                    if (t instanceof nn) {
                        if (o(t)) t = e.left.property = t.right.clone();
                        t = t.evaluate(s);
                    }
                    if (t instanceof nn) return;
                    t = "" + t;
                    var r = t == "__proto__" || s.has_directive("use strict") ? function(e) {
                        var n = e.key;
                        return typeof n == "string" && n != t && n != "__proto__";
                    } : function(e) {
                        var n = e.key;
                        if (e instanceof fr || e instanceof sr) {
                            return typeof n == "string" && n != t;
                        }
                        return n !== "__proto__";
                    };
                    if (!en(i.properties, r)) return;
                    i.properties.push(Te(ar, e, {
                        key: t,
                        value: e.right
                    }));
                    return true;
                }
            }
            function x(e) {
                var i = false, a;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var r = e[n];
                    var o = e[t];
                    if (r instanceof $t) {
                        if (o && o.TYPE == r.TYPE) {
                            o.definitions = o.definitions.concat(r.definitions);
                            i = true;
                        } else if (a && a.TYPE == r.TYPE && ve(r)) {
                            a.definitions = a.definitions.concat(r.definitions);
                            i = true;
                        } else if (r instanceof Ct) {
                            var s = g(o, r);
                            if (s) {
                                if (s.length) {
                                    o.body = Ae(o, s);
                                    t++;
                                }
                                i = true;
                            } else {
                                t++;
                            }
                            e[t] = a = r;
                        } else {
                            e[++t] = r;
                        }
                        continue;
                    } else if (r instanceof mt) {
                        r.value = u(r.value);
                    } else if (r instanceof Nn) {
                        var s = p(o, r.init);
                        if (s) {
                            i = true;
                            r.init = s.length ? Ae(r.init, s) : null;
                        } else if (o instanceof Ct && (!r.init || r.init.TYPE == o.TYPE)) {
                            if (r.init) {
                                o.definitions = o.definitions.concat(r.init.definitions);
                            }
                            r = r.clone();
                            a = r.init = o;
                            e[t] = l(r);
                            i = true;
                            continue;
                        } else if (a && r.init && a.TYPE == r.init.TYPE && ve(r.init)) {
                            a.definitions = a.definitions.concat(r.init.definitions);
                            r.init = null;
                            i = true;
                        } else if (r.init instanceof Ct) {
                            a = r.init;
                            s = g(o, r.init);
                            if (s) {
                                i = true;
                                if (s.length == 0) {
                                    e[t] = l(r);
                                    continue;
                                }
                                o.body = Ae(o, s);
                            }
                        }
                    } else if (r instanceof In) {
                        if (a && a.TYPE == r.init.TYPE) {
                            var c = a.definitions.slice();
                            r.init = r.init.definitions[0].name.convert_symbol(un, function(e, n) {
                                c.push(Te(Mt, n, {
                                    name: n,
                                    value: null
                                }));
                                n.definition().references.push(e);
                            });
                            a.definitions = c;
                            i = true;
                        }
                        r.object = u(r.object);
                    } else if (r instanceof xt) {
                        r.condition = u(r.condition);
                    } else if (r instanceof tn) {
                        var s = p(o, r.body), f;
                        if (s) {
                            i = true;
                            if (!s.length) continue;
                            r.body = Ae(r.body, s);
                        } else if (o instanceof $t && (f = e[n + 1]) && o.TYPE == f.TYPE && (f = f.definitions[0]).value) {
                            i = true;
                            f.value = Ae(r, [ r.body, f.value ]);
                            continue;
                        }
                    } else if (r instanceof kt) {
                        r.expression = u(r.expression);
                    } else if (r instanceof Rn) {
                        r.expression = u(r.expression);
                    }
                    e[++t] = a ? l(r) : r;
                }
                e.length = t + 1;
                return i;
                function u(e) {
                    var n = p(o, e, 1);
                    if (!n) return e;
                    i = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return Ae(e, n);
                }
                function l(e) {
                    return e.transform(new Hr(function(e, n, t) {
                        if (e instanceof $t) {
                            if (a === e) return e;
                            if (a.TYPE != e.TYPE) return e;
                            var r = this.parent();
                            if (r instanceof In && r.init === e) return e;
                            if (!ve(e)) return e;
                            a.definitions = a.definitions.concat(e.definitions);
                            i = true;
                            if (r instanceof Nn && r.init === e) return null;
                            return t ? _n.skip : Te(Dn, e);
                        }
                        if (e instanceof Ft) return e;
                        if (e instanceof Ln) return e;
                        if (!On(e)) return e;
                    }));
                }
            }
        }
        function N(i, a, o) {
            var s;
            var f = false;
            a.walk(new Ir(function(e, n) {
                if (e instanceof ct) {
                    e.extends = null;
                    e.properties = [];
                    u(e);
                    return true;
                }
                if (e instanceof $t) {
                    var t = [];
                    if (e.remove_initializers(i, t)) {
                        nn.warn("Dropping initialization in unreachable code [{file}:{line},{col}]", e.start);
                    }
                    if (t.length > 0) {
                        e.definitions = t;
                        u(e);
                    }
                    return true;
                }
                if (e instanceof it) {
                    u(e);
                    return true;
                }
                if (e instanceof Ln) return true;
                if (e instanceof $n) {
                    var r = s;
                    s = [];
                    n();
                    if (s.required) {
                        o.push(Te(rn, a, {
                            body: s
                        }));
                    } else if (s.length) {
                        [].push.apply(o, s);
                    }
                    s = r;
                    return true;
                }
                if (!(e instanceof bt)) f = true;
            }));
            if (f) nn.warn("Dropping unreachable code [{file}:{line},{col}]", a.start);
            function u(e) {
                if (s) {
                    s.push(e);
                    if (!T(e)) s.required = true;
                } else {
                    o.push(e);
                }
            }
        }
        function Oe(e, n) {
            return e == null || e.is_undefined || e instanceof Cr || e instanceof on && e.operator == "void" && !(n && e.expression.has_side_effects(n));
        }
        (function(e) {
            e(nn, dn);
            e(Qt, vn);
            e(fn, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(Un, vn);
            e(rr, vn);
            e($r, vn);
            e(an, function() {
                return this.tail_node().is_truthy();
            });
            e(un, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = dn;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(nn, vn);
            e(Qt, dn);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof Tr) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                  case "**":
                    return true;

                  default:
                    return false;
                }
            }
            e(fn, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(sn, function() {
                return n(this.operator, this.left, this.right);
            });
            e(Tr, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(Un, dn);
            e(rr, dn);
            e($r, dn);
            e(an, function() {
                return this.tail_node().is_negative_zero();
            });
            e(un, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = vn;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e(on, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            nn.DEFMETHOD("may_throw_on_access", function(e, n) {
                return !e.option("pure_getters") || this._dot_throw(e, n);
            });
            function i(e, n) {
                return n || /strict/.test(e.option("pure_getters"));
            }
            e(nn, i);
            e(Qt, dn);
            e(fn, function(e) {
                var n = this.operator;
                var t = this.left;
                var r = this.right;
                if (n != "=") {
                    return $e[n.slice(0, -1)] && (t._dot_throw(e) || r._dot_throw(e));
                }
                if (!r._dot_throw(e)) return false;
                if (!(t instanceof un)) return true;
                if (r instanceof sn && r.operator == "||" && t.name == r.left.name) {
                    return r.right._dot_throw(e);
                }
                return true;
            });
            e(sn, function(e) {
                return $e[this.operator] && (this.left._dot_throw(e) || this.right._dot_throw(e));
            });
            e(ut, dn);
            e(Jt, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(Tr, dn);
            e(Bt, function(e, n) {
                if (!i(e, n)) return false;
                var t = this.expression;
                if (t instanceof un) t = t.fixed_value();
                return !(this.property == "prototype" && $(t));
            });
            e(Un, dn);
            e(qr, vn);
            e(rr, function(n, t) {
                return i(n, t) && !en(this.properties, function(e) {
                    if (!(e instanceof ar)) return false;
                    return !(e.key === "__proto__" && e.value._dot_throw(n, t));
                });
            });
            e(wr, function(e, n) {
                return i(e, n) && !this.scope.resolve().new;
            });
            e(an, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(un, function(e, n) {
                if (this.is_undefined) return true;
                if (!i(e, n)) return false;
                if (De(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                var t = this.definition();
                if (ze(t) && !t.scope.rest && en(t.scope.argnames, function(e) {
                    return e instanceof hr;
                })) return t.scope.uses_arguments > 2;
                var r = this.fixed_value();
                if (!r) return true;
                this._dot_throw = vn;
                if (r._dot_throw(e)) {
                    delete this._dot_throw;
                    return true;
                }
                this._dot_throw = dn;
                return false;
            });
            e(on, function() {
                return this.operator == "void";
            });
            e(Gt, dn);
            e(Cr, vn);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(nn, dn);
            e(Qt, vn);
            function t(e, n, t) {
                switch (n) {
                  case "&&":
                    return t.left.is_defined(e) && t.right.is_defined(e);

                  case "||":
                    return t.left.is_truthy() || t.right.is_defined(e);

                  case "??":
                    return t.left.is_defined(e) || t.right.is_defined(e);

                  default:
                    return true;
                }
            }
            e(fn, function(e) {
                var n = this.operator;
                if (n == "=") return this.right.is_defined(e);
                return t(e, n.slice(0, -1), this);
            });
            e(sn, function(e) {
                return t(e, this.operator, this);
            });
            e(Jt, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(Tr, vn);
            e(Mr, dn);
            e(Un, vn);
            e(rr, vn);
            e(an, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(un, function(e) {
                if (this.is_undefined) return false;
                if (De(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = dn;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(on, function() {
                return this.operator != "void";
            });
            e(Gt, vn);
            e(Cr, dn);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(nn, dn);
            e(fn, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = wn("in instanceof == != === !== < <= >= >");
            e(sn, function(e) {
                return n[this.operator] || $e[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(Pr, vn);
            var t = wn("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(Ht, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Bt && (t[n.property] || n.property == "test" && n.expression instanceof $r);
            });
            e(Jt, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(Yt, dn);
            e(an, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(un, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = dn;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var r = wn("! delete");
            e(on, function() {
                return r[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(nn, dn);
            var n = wn("- * / % ** & | ^ << >> >>>");
            e(fn, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(sn, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = wn([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear", "toExponential", "toFixed", "toPrecision" ]);
            e(Ht, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Bt && (t[n.property] || De(n.expression) && n.expression.name == "Math");
            });
            e(Jt, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(Yt, dn);
            e(Dr, vn);
            e(an, function(e) {
                return this.tail_node().is_number(e);
            });
            e(un, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_number = dn;
                var t = n.is_number(e);
                delete this.is_number;
                return t;
            });
            var r = wn("+ - ~ ++ --");
            e(Wt, function() {
                return r[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(nn, dn);
            e(fn, function(e) {
                switch (this.operator) {
                  case "+=":
                    if (this.left.is_string(e)) return true;

                  case "=":
                    return this.right.is_string(e);
                }
            });
            e(sn, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = wn([ "charAt", "substr", "substring", "toLowerCase", "toString", "toUpperCase", "trim" ]);
            e(Ht, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Bt && t[n.property];
            });
            e(Jt, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(an, function(e) {
                return this.tail_node().is_string(e);
            });
            e(Ar, vn);
            e(un, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = dn;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(Sr, function(e) {
                return !this.tag || Be(e, this.tag);
            });
            e(on, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var $e = wn("&& || ??");
        (function(e) {
            function i(e, n) {
                if (e instanceof nn) return e.clone(true);
                if (Array.isArray(e)) return Te(Qt, n, {
                    elements: e.map(function(e) {
                        return i(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var r in e) if (kn(e, r)) {
                        t.push(Te(ar, n, {
                            key: r,
                            value: i(e[r], n)
                        }));
                    }
                    return Te(rr, n, {
                        properties: t
                    });
                }
                return ce(e, n);
            }
            function o(e) {
                nn.warn("global_defs {node} redefined [{file}:{line},{col}]", {
                    node: e,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            Bn.DEFMETHOD("resolve_defines", function(a) {
                if (!a.option("global_defs")) return this;
                this.figure_out_scope({
                    ie: a.option("ie")
                });
                return this.transform(new Hr(function(e) {
                    var n = e._find_defs(a, "");
                    if (!n) return;
                    var t = 0, r = e, i;
                    while (i = this.parent(t++)) {
                        if (!(i instanceof Lt)) break;
                        if (i.expression !== r) break;
                        r = i;
                    }
                    if (Jr(r, i)) {
                        o(e);
                        return;
                    }
                    return n;
                }));
            });
            e(nn, pn);
            e(Bt, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(cr, function(e) {
                if (!this.definition().global) return;
                if (kn(e.option("global_defs"), this.name)) o(this);
            });
            e(un, function(e, n) {
                if (!this.definition().global) return;
                var t = e.option("global_defs");
                var r = this.name + n;
                if (kn(t, r)) return i(t[r], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function he(e, n, t) {
            var r = n.print_to_string().length - e.print_to_string().length;
            return r < (t || 0) ? n : e;
        }
        function u(e, n, t) {
            return he(Te(tn, e, {
                body: e
            }), Te(tn, n, {
                body: n
            }), t).body;
        }
        function me(e, n, t, r) {
            return (En(e) ? u : he)(n, t, r);
        }
        function s(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = wn(n[e]);
            });
            return t;
        }
        function o(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof An)) return t;
            }
        }
        function f() {
            if (this.value) return Te(_t, this.value, {
                value: this.value
            });
            return o(this.body);
        }
        Qn.DEFMETHOD("first_statement", f);
        Zn.DEFMETHOD("first_statement", f);
        Un.DEFMETHOD("first_statement", function() {
            return o(this.body);
        });
        Un.DEFMETHOD("length", function() {
            var e = this.argnames;
            for (var n = 0; n < e.length; n++) {
                if (e[n] instanceof It) break;
            }
            return n;
        });
        function _e(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = ce(t, n).optimize(e);
            return me(e, n, t, e.eval_threshold);
        }
        var p = [ "constructor", "toString", "valueOf" ];
        var b = s({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(p),
            Boolean: p,
            Function: p,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(p),
            Object: p,
            RegExp: [ "exec", "test" ].concat(p),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(p)
        });
        var y = s({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode", "raw" ]
        });
        function Ie(e) {
            if (!(e instanceof Bt)) return false;
            var n = e.expression;
            if (!De(n)) return false;
            var t = y[n.name];
            return t && (t[e.property] || n.name == "Math" && e.property == "random");
        }
        (function(e) {
            e(nn, dn);
            e(Tr, vn);
            e($r, dn);
            var n = wn("! ~ - + void");
            e(on, function() {
                return n[this.operator] && this.expression instanceof Tr;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant", n);
        });
        (function(e) {
            nn.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var r = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return r;
                if (!r || r instanceof RegExp) return r;
                if (typeof r == "function" || typeof r == "object") return this;
                return r;
            });
            var m = new Ir(function(e) {
                if (e instanceof fn) u(e.left);
                if (e instanceof Wt && Br[e.operator]) u(e.expression);
            });
            function u(e) {
                if (e instanceof er) {
                    e.elements.forEach(u);
                } else if (e instanceof tr) {
                    e.properties.forEach(function(e) {
                        u(e.value);
                    });
                } else if (e instanceof Lt) {
                    u(e.expression);
                } else if (e instanceof un) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(Sn, function() {
                throw new Error(bn("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(Vn, hn);
            e(Or, hn);
            e(ut, hn);
            e(nn, hn);
            e(Tr, function() {
                return this.value;
            });
            e(fn, function(e, n, t, r) {
                var i = this.left;
                if (!n) {
                    if (!(i instanceof un)) return this;
                    if (!kn(i, "_eval")) {
                        if (!i.fixed) return this;
                        var a = i.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== i) return this;
                        if (a.single_use == "m") return this;
                    }
                }
                var o = this.operator;
                var s;
                if (!kn(i, "_eval") && i instanceof un && i.fixed && i.definition().fixed) {
                    s = i;
                } else if (o == "=") {
                    s = this.right;
                } else {
                    s = Te(sn, this, {
                        operator: o.slice(0, -1),
                        left: i,
                        right: this.right
                    });
                }
                i.walk(m);
                var f = s._eval(e, n, t, r);
                if (typeof f == "object") return this;
                u(i);
                return f;
            });
            e(an, function(e, n, t, r) {
                if (!n) return this;
                var i = this.expressions;
                for (var a = 0, o = i.length - 1; a < o; a++) {
                    i[a].walk(m);
                }
                var s = i[o];
                var f = s._eval(e, n, t, r);
                return f === s ? this : f;
            });
            e(Un, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(Qt, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i = [];
                    for (var a = 0; a < this.elements.length; a++) {
                        var o = this.elements[a];
                        if (o instanceof Mr) return this;
                        var s = o._eval(e, n, t, r);
                        if (o === s) return this;
                        i.push(s);
                    }
                    return i;
                }
                return this;
            });
            e(rr, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i = {};
                    for (var a = 0; a < this.properties.length; a++) {
                        var o = this.properties[a];
                        if (!(o instanceof ar)) return this;
                        var s = o.key;
                        if (s instanceof nn) {
                            s = s._eval(e, n, t, r);
                            if (s === o.key) return this;
                        }
                        switch (s) {
                          case "__proto__":
                          case "toString":
                          case "valueOf":
                            return this;
                        }
                        i[s] = o.value._eval(e, n, t, r);
                        if (i[s] === o.value) return this;
                    }
                    return i;
                }
                return this;
            });
            var f = wn("! typeof void");
            e(on, function(e, n, t, r) {
                var i = this.expression;
                var a = this.operator;
                if (e.option("typeofs") && a == "typeof" && (i instanceof Un || i instanceof un && i.fixed_value() instanceof Un)) {
                    return typeof function() {};
                }
                var o = i instanceof un && i.definition();
                if (!f[a] && !(o && o.fixed)) r++;
                i.walk(m);
                var s = i._eval(e, n, t, r);
                if (s === i) {
                    if (n && a == "void") return;
                    return this;
                }
                switch (a) {
                  case "!":
                    return !s;

                  case "typeof":
                    if (s instanceof RegExp) return this;
                    return typeof s;

                  case "void":
                    return;

                  case "~":
                    return ~s;

                  case "-":
                    return -s;

                  case "+":
                    return +s;

                  case "++":
                  case "--":
                    if (!o) return this;
                    if (!n) {
                        if (o.undeclared) return this;
                        if (o.last_ref !== i) return this;
                    }
                    if (kn(i, "_eval")) s = +(a[0] + 1) + +s;
                    u(i);
                    return s;
                }
                return this;
            });
            e(Gt, function(e, n, t, r) {
                var i = this.expression;
                if (!(i instanceof un)) {
                    if (!n) return this;
                } else if (!kn(i, "_eval")) {
                    if (!i.fixed) return this;
                    if (!n) {
                        var a = i.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== i) return this;
                    }
                }
                if (!(i instanceof un && i.definition().fixed)) r++;
                i.walk(m);
                var o = i._eval(e, n, t, r);
                if (o === i) return this;
                u(i);
                return +o;
            });
            var c = wn("&& || === !==");
            e(sn, function(e, n, t, r) {
                if (!c[this.operator]) r++;
                var i = this.left._eval(e, n, t, r);
                if (i === this.left) return this;
                if (this.operator == (i ? "||" : "&&")) return i;
                var a = n && !(i && typeof i == "object");
                var o = this.right._eval(e, a, t, r);
                if (o === this.right) return this;
                var s;
                switch (this.operator) {
                  case "&&":
                    s = i && o;
                    break;

                  case "||":
                    s = i || o;
                    break;

                  case "??":
                    s = i == null ? o : i;
                    break;

                  case "|":
                    s = i | o;
                    break;

                  case "&":
                    s = i & o;
                    break;

                  case "^":
                    s = i ^ o;
                    break;

                  case "+":
                    s = i + o;
                    break;

                  case "-":
                    s = i - o;
                    break;

                  case "*":
                    s = i * o;
                    break;

                  case "/":
                    s = i / o;
                    break;

                  case "%":
                    s = i % o;
                    break;

                  case "<<":
                    s = i << o;
                    break;

                  case ">>":
                    s = i >> o;
                    break;

                  case ">>>":
                    s = i >>> o;
                    break;

                  case "==":
                    s = i == o;
                    break;

                  case "===":
                    s = i === o;
                    break;

                  case "!=":
                    s = i != o;
                    break;

                  case "!==":
                    s = i !== o;
                    break;

                  case "<":
                    s = i < o;
                    break;

                  case "<=":
                    s = i <= o;
                    break;

                  case ">":
                    s = i > o;
                    break;

                  case ">=":
                    s = i >= o;
                    break;

                  case "**":
                    s = Math.pow(i, o);
                    break;

                  case "in":
                    if (o && typeof o == "object" && kn(o, i)) {
                        s = true;
                        break;
                    }

                  default:
                    return this;
                }
                if (isNaN(s)) return e.find_parent(Rn) ? this : s;
                if (e.option("unsafe_math") && !n && s && typeof s == "number" && (this.operator == "+" || this.operator == "-")) {
                    var f = Math.max(0, u(i), u(o));
                    if (f < 16) return +s.toFixed(f);
                }
                return s;
                function u(e) {
                    var n = /(\.[0-9]*)?(e[^e]+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(Jt, function(e, n, t, r) {
                var i = this.condition._eval(e, n, t, r);
                if (i === this.condition) return this;
                var a = i ? this.consequent : this.alternative;
                var o = a._eval(e, n, t, r);
                return o === a ? this : o;
            });
            function o(n, e) {
                var t = n.definition().escaped;
                switch (t.length) {
                  case 0:
                    return true;

                  case 1:
                    var r = false;
                    t[0].walk(new Ir(function(e) {
                        if (r) return true;
                        if (e === n) return r = true;
                        if (e instanceof Ln) return true;
                    }));
                    return r;

                  default:
                    return e <= t.depth;
                }
            }
            e(un, function(e, n, t, r) {
                var i = this.fixed_value();
                if (!i) return this;
                var a;
                if (kn(i, "_eval")) {
                    a = i._eval();
                } else {
                    this._eval = hn;
                    a = i._eval(e, n, t, r);
                    delete this._eval;
                    if (a === i) return this;
                    i._eval = function() {
                        return a;
                    };
                    t.push(i);
                }
                return a && typeof a == "object" && !o(this, r) ? this : a;
            });
            var _ = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var l = s({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var p = wn("global ignoreCase multiline source");
            e(Lt, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i;
                    var a = this.expression;
                    if (!De(a)) {
                        i = a._eval(e, n, t, r + 1);
                        if (i == null || i === a) return this;
                    }
                    var o = this.property;
                    if (o instanceof nn) {
                        o = o._eval(e, n, t, r);
                        if (o === this.property) return this;
                    }
                    if (i === undefined) {
                        var s = l[a.name];
                        if (!s || !s[o]) return this;
                        i = _[a.name];
                    } else if (i instanceof RegExp) {
                        if (!p[o]) return this;
                    } else if (typeof i == "object") {
                        if (!kn(i, o)) return this;
                    } else if (typeof i == "function") switch (o) {
                      case "name":
                        return i.node.name ? i.node.name.name : "";

                      case "length":
                        return i.node.length();

                      default:
                        return this;
                    }
                    return i[o];
                }
                return this;
            });
            function g(e, n, t, r, i) {
                var a = [];
                for (var o = 0; o < e.length; o++) {
                    var s = e[o];
                    var f = s._eval(n, t, r, i);
                    if (s === f) return;
                    a.push(f);
                }
                return a;
            }
            e(Ht, function(r, i, a, o) {
                var e = this.expression;
                var n = e instanceof un ? e.fixed_value() : e;
                if (n instanceof Qn || n instanceof st || n instanceof tt) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(r)) return this;
                    var s = g(this.args, r, i, a, o);
                    if (!en(n.argnames, function(e, n) {
                        if (e instanceof It) {
                            if (!s) return false;
                            if (s[n] === undefined) {
                                var t = e.value._eval(r, i, a, o);
                                if (t === e.value) return false;
                                s[n] = t;
                            }
                            e = e.name;
                        }
                        return !(e instanceof Zt);
                    })) return this;
                    if (n.rest instanceof Zt) return this;
                    if (!s && !i) return this;
                    var c = n.first_statement();
                    if (!(c instanceof _t)) {
                        if (i) {
                            n.walk(m);
                            var l = false;
                            n.evaluating = true;
                            qn(n, new Ir(function(e) {
                                if (l) return true;
                                if (e instanceof _t) {
                                    if (e.value && e.value._eval(r, true, a, o) !== undefined) {
                                        l = true;
                                    }
                                    return true;
                                }
                                if (e instanceof Ln && e !== n) return true;
                            }));
                            n.evaluating = false;
                            if (!l) return;
                        }
                        return this;
                    }
                    var t = c.value;
                    if (!t) return;
                    var p = [];
                    if (!s || en(n.argnames, function(e, n) {
                        return h(e, s[n]);
                    }) && !(n.rest && !h(n.rest, s.slice(n.argnames.length))) || i) {
                        if (i) n.argnames.forEach(function(e) {
                            if (e instanceof It) e.value.walk(m);
                        });
                        n.evaluating = true;
                        t = t._eval(r, i, a, o);
                        n.evaluating = false;
                    }
                    p.forEach(function(e) {
                        delete e._eval;
                    });
                    return t === c.value ? this : t;
                } else if (r.option("unsafe") && e instanceof Lt) {
                    var f = e.property;
                    if (f instanceof nn) {
                        f = f._eval(r, i, a, o);
                        if (f === e.property) return this;
                    }
                    var t;
                    var u = e.expression;
                    if (De(u)) {
                        var d = y[u.name];
                        if (!d || !d[f]) return this;
                        t = _[u.name];
                    } else {
                        t = u._eval(r, i, a, o + 1);
                        if (t == null || t === u) return this;
                        var v = b[t.constructor.name];
                        if (!v || !v[f]) return this;
                        if (t instanceof RegExp && t.global && !(u instanceof $r)) return this;
                    }
                    var s = g(this.args, r, i, a, o);
                    if (!s) return this;
                    if (f == "replace" && typeof s[1] == "function") return this;
                    try {
                        return t[f].apply(t, s);
                    } catch (e) {
                        nn.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this,
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    } finally {
                        if (t instanceof RegExp) t.lastIndex = 0;
                    }
                }
                return this;
                function h(e, n) {
                    if (e instanceof It) e = e.name;
                    var t = e.definition();
                    if (t.orig[t.orig.length - 1] !== e) return false;
                    var r = n;
                    t.references.forEach(function(e) {
                        e._eval = function() {
                            return r;
                        };
                        p.push(e);
                    });
                    return true;
                }
            });
            e(Yt, hn);
            e(Sr, function(e, n, t, r) {
                if (!e.option("templates")) return this;
                if (this.tag) {
                    if (!Be(e, this.tag)) return this;
                    f = function(e) {
                        return e;
                    };
                }
                var i = g(this.expressions, e, n, t, r);
                if (!i) return this;
                var a = false;
                var o = f(this.strings[0]);
                for (var s = 0; s < i.length; s++) {
                    o += i[s] + f(this.strings[s + 1]);
                }
                if (!a) return o;
                this._eval = hn;
                return this;
                function f(e) {
                    e = Ue(e);
                    if (typeof e != "string") a = true;
                    return e;
                }
            });
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function a(e) {
                return Te(on, e, {
                    operator: "!",
                    expression: e
                });
            }
            function i(e, n, t) {
                var r = a(e);
                if (t) {
                    var i = Te(tn, n, {
                        body: n
                    });
                    return he(r, i) === i ? n : r;
                }
                return he(r, n);
            }
            e(nn, function() {
                return a(this);
            });
            e(Sn, function() {
                throw new Error("Cannot negate a statement");
            });
            e(sn, function(e, n) {
                var t = this.clone(), r = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (r) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (r) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return i(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return i(this, t, n);
                }
                return a(this);
            });
            e(lt, function() {
                return a(this);
            });
            e(Jt, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return i(this, t, n);
            });
            e(Wn, function() {
                return a(this);
            });
            e(an, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return Ae(this, n);
            });
            e(on, function() {
                if (this.operator == "!") return this.expression;
                return a(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var d = wn("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        var v = wn("Map Set WeakMap WeakSet");
        Ht.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (De(n)) {
                    if (d[n.name]) return true;
                    if (this instanceof Yt && v[n.name]) return true;
                }
                if (Ie(n)) return true;
            }
            return e.option("annotations") && this.pure || !e.pure_funcs(this);
        });
        Sr.DEFMETHOD("is_expr_pure", function(e) {
            var n = this.tag;
            if (!n) return true;
            if (e.option("unsafe")) {
                if (De(n) && d[n.name]) return true;
                if (n instanceof Bt && De(n.expression)) {
                    var t = y[n.expression.name];
                    return t && (t[n.property] || n.expression.name == "Math" && n.property == "random");
                }
            }
            return !e.pure_funcs(this);
        });
        nn.DEFMETHOD("is_call_pure", dn);
        Ht.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof Bt)) return false;
            var t = n.expression;
            var r;
            var i = n.property;
            if (t instanceof Qt) {
                r = b.Array;
            } else if (t.is_boolean(e)) {
                r = b.Boolean;
            } else if (t.is_number(e)) {
                r = b.Number;
            } else if (t instanceof $r) {
                r = b.RegExp;
            } else if (t.is_string(e)) {
                r = b.String;
                if (i == "replace") {
                    var a = this.args[1];
                    if (a && !a.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                r = b.Object;
            }
            return r && r[i];
        });
        (function(e) {
            e(nn, dn);
            e(Qt, vn);
            e(fn, function() {
                switch (this.operator) {
                  case "=":
                    return this.right.safe_to_spread();

                  case "&&=":
                  case "||=":
                  case "??=":
                    return this.left.safe_to_spread() && this.right.safe_to_spread();
                }
                return true;
            });
            e(sn, function() {
                return !$e[this.operator] || this.left.safe_to_spread() && this.right.safe_to_spread();
            });
            e(Tr, vn);
            e(Un, vn);
            e(rr, function() {
                return en(this.properties, function(e) {
                    return !(e instanceof fr || e instanceof Vt);
                });
            });
            e(wr, vn);
            e(an, function() {
                return this.tail_node().safe_to_spread();
            });
            e(un, function() {
                var e = this.fixed_value();
                return e && e.safe_to_spread();
            });
            e(Wt, vn);
        })(function(e, n) {
            e.DEFMETHOD("safe_to_spread", n);
        });
        (function(e) {
            function t(e, n, t) {
                return !en(e, t ? function(e) {
                    return e instanceof Vt ? !t(e, n) : !e.has_side_effects(n);
                } : function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function n(e, n) {
                var t = e.expression;
                return !t.is_string(n) || t.has_side_effects(n);
            }
            e(nn, vn);
            e(Qt, function(e) {
                return t(this.elements, e, n);
            });
            e(fn, function(e) {
                var n = this.left;
                if (!(n instanceof Lt)) return true;
                var t = n.expression;
                return !(t instanceof wr) || !t.scope.resolve().new || n instanceof Ut && n.property.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(sn, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e) || this.operator == "in" && !Ye(this.right);
            });
            e(zn, function(e) {
                return t(this.body, e);
            });
            e(Ht, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return t(this.args, e, n);
            });
            e(Tt, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(ut, function(e) {
                var n = this.extends;
                if (n) {
                    if (n instanceof un) n = n.fixed_value();
                    if (!h(n)) return true;
                }
                return t(this.properties, e);
            });
            e(pt, function(e) {
                return this.key instanceof nn && this.key.has_side_effects(e) || this.static && this.value && this.value.has_side_effects(e);
            });
            e(Jt, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(Tr, dn);
            e($t, function(e) {
                return t(this.definitions, e);
            });
            e(er, function(e) {
                return t(this.elements, e);
            });
            e(nr, function(e) {
                return this.key instanceof nn && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(tr, function(e) {
                return t(this.properties, e);
            });
            e(Bt, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(Dn, dn);
            e(xt, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(Cn, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Un, dn);
            e(rr, function(e) {
                return t(this.properties, e, function(e, n) {
                    var t = e.expression;
                    return !t.safe_to_spread() || t.has_side_effects(n);
                });
            });
            e(wr, dn);
            e(ir, function(e) {
                return this.key instanceof nn && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(an, function(e) {
                return t(this.expressions, e);
            });
            e(tn, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Ut, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(kt, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(cr, dn);
            e(un, function(e) {
                return !this.is_declared(e) || !Se(this, e);
            });
            e(Sr, function(e) {
                return !this.is_expr_pure(e) || t(this.expressions, e);
            });
            e(At, function(e) {
                return t(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(Wt, function(e) {
                return Gr[this.operator] || this.expression.has_side_effects(e);
            });
            e(Mt, function() {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(nn, vn);
            e(Tr, dn);
            e(Dn, dn);
            e(Un, dn);
            e(wr, dn);
            e(cr, dn);
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            function r(e, n) {
                if (e.may_throw(n)) return true;
                if (e instanceof un) e = e.fixed_value();
                if (!(e instanceof Un)) return true;
                if (t(e.argnames, n)) return true;
                if (t(e.body, n)) return true;
                return Gn(e) && e.value && e.value.may_throw(n);
            }
            e(Qt, function(e) {
                return t(this.elements, e);
            });
            e(fn, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof un) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(Xt, function(e) {
                return this.expression.may_throw(e);
            });
            e(sn, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e) || this.operator == "in" && !Ye(this.right);
            });
            e(zn, function(e) {
                return t(this.body, e);
            });
            e(Ht, function(e) {
                if (t(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                this.may_throw = vn;
                var n = r(this.expression, e);
                delete this.may_throw;
                return n;
            });
            e(Tt, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(Jt, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(It, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
            e($t, function(e) {
                return t(this.definitions, e);
            });
            e(Bt, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(In, function(e) {
                if (this.init.may_throw(e)) return true;
                var n = this.object;
                if (n.may_throw(e)) return true;
                n = n.tail_node();
                if (!(n instanceof Qt || n.is_string(e))) return true;
                return this.body.may_throw(e);
            });
            e(xt, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(Cn, function(e) {
                return this.body.may_throw(e);
            });
            e(rr, function(e) {
                return t(this.properties, e);
            });
            e(ir, function(e) {
                return this.value.may_throw(e) || this.key instanceof nn && this.key.may_throw(e);
            });
            e(_t, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(an, function(e) {
                return t(this.expressions, e);
            });
            e(tn, function(e) {
                return this.body.may_throw(e);
            });
            e(Ut, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(kt, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(un, function(e) {
                return !this.is_declared(e) || !Se(this, e);
            });
            e(Sr, function(e) {
                if (t(this.expressions, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (!this.tag) return false;
                this.may_throw = vn;
                var n = r(this.tag, e);
                delete this.may_throw;
                return n;
            });
            e(At, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : t(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(Wt, function(e) {
                return this.expression.may_throw(e) && !(this.operator == "typeof" && this.expression instanceof un);
            });
            e(Mt, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (!e[t].is_constant_expression(n)) return false;
                return true;
            }
            e(nn, dn);
            e(Qt, function(e) {
                return t(this.elements, e);
            });
            e(sn, function(e) {
                return this.left.is_constant_expression(e) && this.right.is_constant_expression(e) && (this.operator != "in" || Ye(this.right));
            });
            e(ut, function(e) {
                var n = this.extends;
                if (n && !h(n)) return false;
                return t(this.properties, e);
            });
            e(pt, function(e) {
                return typeof this.key == "string" && (!this.value || this.value.is_constant_expression(e));
            });
            e(Tr, vn);
            e(Un, function(i) {
                var a = this;
                var o = true;
                var s = [];
                a.walk(new Ir(function(e, n) {
                    if (!o) return true;
                    if (e instanceof $n) {
                        if (e === a) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof un) {
                        if (a.inlined || e.redef) {
                            o = false;
                            return true;
                        }
                        if (a.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (cn(t.scope, s)) return true;
                        if (i && !t.redefined()) {
                            var r = i.find_variable(e.name);
                            if (r ? r === t : t.undeclared) {
                                o = "f";
                                return true;
                            }
                        }
                        o = false;
                        return true;
                    }
                    if (e instanceof wr) {
                        if (Gn(a) && en(s, function(e) {
                            return !(e instanceof Ln) || Gn(e);
                        })) o = false;
                        return true;
                    }
                }));
                return o;
            });
            e(rr, function(e) {
                return t(this.properties, e);
            });
            e(ir, function(e) {
                return typeof this.key == "string" && this.value.is_constant_expression(e);
            });
            e(Wt, function(e) {
                return this.expression.is_constant_expression(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function O(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(Sn, mn);
            e(ht, hn);
            function n() {
                var e = this.body.length;
                return e > 0 && O(this.body[e - 1]);
            }
            e(rn, n);
            e(Et, n);
            e(xt, function() {
                return this.alternative && O(this.body) && O(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var m = wn([ "use asm", "use strict" ]);
        e(An, function(e, n) {
            if (n.option("directives") && (!m[e.value] || n.has_directive(e.value) !== e)) {
                return Te(Dn, e);
            }
            return e;
        });
        e(Tn, function(e, n) {
            if (n.option("drop_debugger")) return Te(Dn, e);
            return e;
        });
        e(Cn, function(e, n) {
            if (n.option("dead_code") && e.body instanceof yt && n.loopcontrol_target(e.body) === e.body) {
                return Te(Dn, e);
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(bt, function(e, n) {
            if (!n.option("dead_code")) return e;
            var t = e.label;
            if (t) {
                var r = n.loopcontrol_target(e);
                e.label = null;
                if (n.loopcontrol_target(e) === r) {
                    yn(t.thedef.references, e);
                } else {
                    e.label = t;
                }
            }
            return e;
        });
        e(zn, function(e, n) {
            e.body = c(e.body, n);
            return e;
        });
        function Z(e, n, t) {
            switch (e.body.length) {
              case 0:
                return t ? _n.skip : Te(Dn, e);

              case 1:
                var r = e.body[0];
                if (!T(r)) return e;
                if (n instanceof Mn && r instanceof it) return e;
                return r;
            }
            return e;
        }
        e(rn, function(e, n) {
            e.body = c(e.body, n);
            return Z(e, n.parent());
        });
        function _(e, n) {
            if (!n.option("rests")) return;
            if (e.uses_arguments) return;
            if (!(e.rest instanceof er)) return;
            if (!n.drop_fargs(e, n.parent())) return;
            e.argnames = e.argnames.concat(e.rest.elements);
            e.rest = e.rest.rest;
        }
        e(Un, function(e, n) {
            _(e, n);
            e.body = c(e.body, n);
            return e;
        });
        function g(e, n) {
            if (!n.option("arrows")) return e;
            _(e, n);
            var t = c(e.value ? [ e.first_statement() ] : e.body, n);
            switch (t.length) {
              case 1:
                var r = t[0];
                if (r instanceof _t) {
                    e.body.length = 0;
                    e.value = r.value;
                    break;
                }

              default:
                e.body = t;
                e.value = null;
                break;
            }
            return e;
        }
        e(Qn, g);
        e(Zn, g);
        e(tt, function(n, e) {
            _(n, e);
            n.body = c(n.body, e);
            var t = e.parent();
            if (e.option("inline")) for (var r = 0; r < n.body.length; r++) {
                var i = n.body[r];
                if (i instanceof An) continue;
                if (i instanceof _t) {
                    if (r != n.body.length - 1) break;
                    var a = i.value;
                    if (!a || a.TYPE != "Call") break;
                    if (a.is_expr_pure(e)) break;
                    var o = a.expression;
                    if (o instanceof un) {
                        if (n.name && n.name.definition() === o.definition()) break;
                        o = o.fixed_value();
                    }
                    if (!(o instanceof st || o instanceof tt)) break;
                    if (o.rest) break;
                    if (o.uses_arguments) break;
                    if (o === a.expression) {
                        if (o.parent_scope !== n) break;
                        if (!en(o.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if (o.name && (t instanceof vt || t instanceof or) && t.value === e.self()) break;
                    if (o.contains_this()) break;
                    var s = o.argnames.length;
                    if (s > 0 && e.option("inline") < 2) break;
                    if (s > n.argnames.length) break;
                    if (!en(n.argnames, function(e) {
                        return e instanceof hr;
                    })) break;
                    if (!en(a.args, function(e) {
                        return !(e instanceof Vt);
                    })) break;
                    for (var f = 0; f < s; f++) {
                        var u = a.args[f];
                        if (!(u instanceof un)) break;
                        if (u.definition() !== n.argnames[f].definition()) break;
                    }
                    if (f < s) break;
                    for (;f < a.args.length; f++) {
                        if (a.args[f].has_side_effects(e)) break;
                    }
                    if (f < a.args.length) break;
                    if (s < n.argnames.length && !e.drop_fargs(n, t)) {
                        if (!e.drop_fargs(o, a)) break;
                        do {
                            o.argnames.push(o.make_var(hr, o, "argument_" + s));
                        } while (++s < n.argnames.length);
                    }
                    return a.expression;
                }
                break;
            }
            return n;
        });
        var I = wn("arguments await yield");
        Ln.DEFMETHOD("merge_variables", function(y) {
            if (!y.option("merge_vars")) return;
            var w, x, v = {}, k = this;
            var o = [], s = [], f = 0;
            var E = new xn();
            var h = Object.create(null);
            var u = Object.create(null);
            var m = new Ir(function(i, e) {
                if (i instanceof fn) {
                    var n = i.left;
                    var t = i.right;
                    if (n instanceof Zt) {
                        t.walk(m);
                        var r = new Ir(function(e) {
                            if (e instanceof Zt) return;
                            if (e instanceof It) {
                                _();
                                e.value.walk(m);
                                g();
                                e.name.walk(r);
                            } else if (e instanceof nr) {
                                if (e.key instanceof nn) {
                                    _();
                                    v.block = e;
                                    e.key.walk(m);
                                    e.value.walk(r);
                                    g();
                                } else {
                                    e.value.walk(r);
                                }
                            } else if (e instanceof un) {
                                b(e);
                            } else {
                                e.walk(m);
                            }
                            return true;
                        });
                        n.walk(r);
                        return true;
                    }
                    if ($e[i.operator.slice(0, -1)]) {
                        n.walk(m);
                        _();
                        t.walk(m);
                        if (n instanceof un) b(n);
                        g();
                        return true;
                    }
                    if (n instanceof un) {
                        if (i.operator != "=") b(n, true);
                        t.walk(m);
                        b(n);
                        return true;
                    }
                    return;
                }
                if (i instanceof sn) {
                    if (!$e[i.operator]) return;
                    i.left.walk(m);
                    _();
                    i.right.walk(m);
                    g();
                    return true;
                }
                if (i instanceof yt) {
                    var a = m.loopcontrol_target(i);
                    if (!(a instanceof Mn)) S(a);
                    return true;
                }
                if (i instanceof Ht) {
                    var o = i.expression;
                    var s = o.tail_node();
                    if (!$(s)) {
                        e();
                        return d(o);
                    }
                    if (o !== s) o.expressions.slice(0, -1).forEach(function(e) {
                        e.walk(m);
                    });
                    i.args.forEach(function(e) {
                        e.walk(m);
                    });
                    s.walk(m);
                    return true;
                }
                if (i instanceof Jt) {
                    i.condition.walk(m);
                    _();
                    i.consequent.walk(m);
                    g();
                    _();
                    i.alternative.walk(m);
                    g();
                    return true;
                }
                if (i instanceof wt) {
                    var a = m.loopcontrol_target(i);
                    if (a instanceof Pn) S(a);
                    return true;
                }
                if (i instanceof Pn) {
                    _();
                    v.block = i;
                    v.loop = true;
                    var f = v;
                    i.body.walk(m);
                    if (v.inserted === i) v = f;
                    i.condition.walk(m);
                    g();
                    return true;
                }
                if (i instanceof Nn) {
                    if (i.init) i.init.walk(m);
                    _();
                    v.block = i;
                    v.loop = true;
                    if (i.condition) i.condition.walk(m);
                    i.body.walk(m);
                    if (i.step) i.step.walk(m);
                    g();
                    return true;
                }
                if (i instanceof In) {
                    i.object.walk(m);
                    _();
                    v.block = i;
                    v.loop = true;
                    i.init.walk(m);
                    i.body.walk(m);
                    g();
                    return true;
                }
                if (i instanceof xt) {
                    i.condition.walk(m);
                    _();
                    i.body.walk(m);
                    g();
                    if (i.alternative) {
                        _();
                        i.alternative.walk(m);
                        g();
                    }
                    return true;
                }
                if (i instanceof Cn) {
                    _();
                    v.block = i;
                    var f = v;
                    i.body.walk(m);
                    if (v.inserted === i) v = f;
                    g();
                    return true;
                }
                if (i instanceof Ln) {
                    _();
                    v.block = i;
                    if (i === k) x = v;
                    if (i instanceof Un) {
                        if (i.name) h[i.name.definition().id] = false;
                        var r = i.uses_arguments && !m.has_directive("use strict") ? function(e) {
                            if (e instanceof hr) h[e.definition().id] = false;
                        } : function(e) {
                            if (e instanceof hr) b(e);
                        };
                        var c = new Ir(function(e) {
                            if (e instanceof cr) h[e.definition().id] = false;
                            if (!(e instanceof un)) return;
                            var n = e.definition();
                            var t = i.variables.get(e.name);
                            if (t && (t === n || n.undeclared || i.parent_scope.find_variable(e.name) === n)) {
                                h[n.id] = false;
                                h[t.id] = false;
                            } else {
                                var r = v;
                                g();
                                b(e, true);
                                v = r;
                            }
                            return true;
                        });
                        i.argnames.forEach(function(e) {
                            e.mark_symbol(r, c);
                        });
                        if (i.rest) i.rest.mark_symbol(r, c);
                    }
                    Kn(i, m);
                    g();
                    return true;
                }
                if (i instanceof Ut) {
                    var o = i.expression;
                    if (i.optional) {
                        o.walk(m);
                        _();
                        i.property.walk(m);
                        g();
                    } else {
                        e();
                    }
                    return d(o);
                }
                if (i instanceof kt) {
                    i.expression.walk(m);
                    var f = v;
                    i.body.forEach(function(e) {
                        if (e instanceof St) return;
                        e.expression.walk(m);
                        if (f === v) _();
                    });
                    v = f;
                    i.body.forEach(function(e) {
                        _();
                        v.block = i;
                        var n = v;
                        qn(e, m);
                        if (v.inserted === i) v = n;
                        g();
                    });
                    return true;
                }
                if (i instanceof lr || i instanceof dr) {
                    h[i.definition().id] = false;
                    return true;
                }
                if (i instanceof un) {
                    b(i, true);
                    return true;
                }
                if (i instanceof At) {
                    var l = w;
                    w = i;
                    var f = v;
                    qn(i, m);
                    v = f;
                    if (i.bcatch) {
                        if (i.bcatch.argname) i.bcatch.argname.mark_symbol(function(e) {
                            if (e instanceof br) {
                                var n = e.definition();
                                h[n.id] = false;
                                if (n = n.redefined()) h[n.id] = false;
                            }
                        }, m);
                        if (i.bfinally || (w = l)) {
                            qn(i.bcatch, m);
                        } else {
                            _();
                            qn(i.bcatch, m);
                            g();
                        }
                    }
                    w = l;
                    v = f;
                    if (i.bfinally) i.bfinally.walk(m);
                    return true;
                }
                if (i instanceof Wt) {
                    if (!Br[i.operator]) return;
                    var p = i.expression;
                    if (!(p instanceof un)) return;
                    b(p, true);
                    return true;
                }
                if (i instanceof Mt) {
                    var u = i.value;
                    if (u) {
                        u.walk(m);
                    } else {
                        u = v.block instanceof In && v.block.init === m.parent();
                    }
                    i.name.mark_symbol(u ? function(e) {
                        if (!(e instanceof cr)) return;
                        if (e instanceof vr) {
                            b(e);
                        } else {
                            h[e.definition().id] = false;
                        }
                        return true;
                    } : function(e) {
                        if (!(e instanceof cr)) return;
                        var n = e.definition().id;
                        if (!(e instanceof vr)) {
                            h[n] = false;
                        } else if (!(n in h)) {
                            E.add(n, e);
                        } else if (h[n]) {
                            h[n].push(e);
                        }
                        return true;
                    }, m);
                    return true;
                }
                if (i instanceof jn) {
                    _();
                    v.block = i;
                    v.loop = true;
                    e();
                    g();
                    return true;
                }
                function d(e) {
                    if (y.option("ie")) {
                        var n = Rt(e);
                        if (n instanceof un) n.walk(m);
                    }
                    return true;
                }
            });
            m.directives = Object.create(y.directives);
            k.walk(m);
            var r = false;
            var i = Object.create(null);
            while (o.length && s.length) {
                var a = s.shift();
                if (!a) continue;
                var n = a.definition;
                var e = h[n.id];
                if (!e) continue;
                e = {
                    end: e.end
                };
                while (n.id in i) n = i[n.id];
                e.start = h[n.id].start;
                var c = [];
                do {
                    var l = o.shift();
                    if (a.index > l.index) continue;
                    var p = l.definition.id;
                    if (!(p in u)) continue;
                    var t = h[p];
                    if (!t) continue;
                    if (t.start.block !== e.start.block || !T(t, e) || (t.start.loop || !Le(n)) && !T(e, t) || y.option("webkit") && Wr(n) !== Wr(l.definition) || l.definition.const_redefs || !en(t, function(e) {
                        return e.scope.find_variable(n.name) === n;
                    })) {
                        c.push(l);
                        continue;
                    }
                    t.forEach(function(e) {
                        e.thedef = n;
                        e.name = n.name;
                        if (e instanceof un) {
                            n.references.push(e);
                        } else {
                            n.orig.push(e);
                        }
                    });
                    if (!l.definition.fixed) n.fixed = false;
                    i[p] = n;
                    r = true;
                    break;
                } while (o.length);
                if (c.length) o = c.concat(o);
            }
            return r;
            function _() {
                v = Object.create(v);
            }
            function g() {
                v = Object.getPrototypeOf(v);
            }
            function b(e, n) {
                var t = e.definition(), r, i = v;
                if (w) {
                    _();
                    i = v;
                    g();
                }
                if (t.id in h) {
                    var a = h[t.id];
                    if (!a) return;
                    if (a.start.block !== i.block) return h[t.id] = false;
                    a.push(e);
                    a.end = i;
                    if (t.id in u) {
                        s[u[t.id]] = null;
                    } else if (!n) {
                        return;
                    }
                } else if ((r = k.variables.get(t.name)) !== t) {
                    if (r && x === i) h[r.id] = false;
                    return h[t.id] = false;
                } else if (y.exposed(t) || I[e.name]) {
                    return h[t.id] = false;
                } else {
                    var a = E.get(t.id) || [];
                    a.push(e);
                    h[t.id] = a;
                    if (!n) {
                        a.start = i;
                        return o.push({
                            index: f++,
                            definition: t
                        });
                    }
                    if (i.block !== k) return h[t.id] = false;
                    a.start = x;
                }
                u[t.id] = s.length;
                s.push({
                    index: f++,
                    definition: t
                });
            }
            function S(e) {
                var n = [];
                while (true) {
                    if (kn(v, "block")) {
                        var t = v.block;
                        if (t instanceof Cn) t = t.body;
                        if (t === e) break;
                    }
                    n.push(v);
                    g();
                }
                v.inserted = v.block;
                _();
                while (n.length) {
                    var r = n.pop();
                    _();
                    if (kn(r, "block")) v.block = r.block;
                    if (kn(r, "loop")) v.loop = r.loop;
                }
            }
            function d(e, n) {
                return e === n || e.isPrototypeOf(n);
            }
            function T(e, n) {
                return d(e.start, e.end) || d(e.start, n.start);
            }
        });
        function ge(e, n) {
            for (var t = n.length; --t >= 0; ) {
                if (!n[t]) n[t] = Te(Mr, e);
            }
        }
        function ee(e, n) {
            var t = Te(lt, e, e);
            if (t.name) t.name = n ? null : Te(gr, t.name, t.name);
            return t;
        }
        function be(e, n) {
            var t;
            switch (e.CTOR) {
              case at:
                t = et;
                break;

              case ot:
                t = nt;
                break;

              case st:
                t = tt;
                break;

              case ft:
                t = rt;
                break;
            }
            var r = Te(t, e, e);
            r.name = n ? null : Te(_r, e.name, e.name);
            return r;
        }
        Ln.DEFMETHOD("drop_unused", function(D) {
            if (!D.option("unused")) return;
            var O = this;
            var P = !(O instanceof Bn) || D.toplevel.funcs;
            var $ = !(O instanceof Bn) || D.toplevel.vars;
            var j = /keep_assign/.test(D.option("unused")) ? dn : function(e, n) {
                var t, i = false;
                if (e instanceof fn) {
                    if (e.write_only || e.operator == "=") t = a(e.left, n);
                } else if (e instanceof Wt) {
                    if (e.write_only) t = a(e.expression, n);
                }
                if (!(t instanceof un)) return;
                var r = t.definition();
                if (o[r.id]) return;
                if (D.exposed(r)) return;
                if (!Se(t, D, i)) return;
                return t;
                function a(e, n) {
                    if (e instanceof Lt) {
                        var t = e.expression;
                        if (!t.may_throw_on_access(D, true)) {
                            i = true;
                            if (n && e instanceof Ut) n.unshift(e.property);
                            return a(t, n);
                        }
                    } else if (e instanceof fn && e.operator == "=") {
                        e.write_only = "p";
                        var r = a(e.right);
                        if (!n) return r;
                        n.assign = e;
                        return r instanceof un ? r : e.left;
                    }
                    return e;
                }
            };
            var q = Object.create(null);
            var o = Object.create(null);
            var _ = function(e) {
                _ = a(O, 0, pn);
                return _(e);
                function a(e, n, r) {
                    var i = D.parent(n);
                    if (!i) return r;
                    var t = i instanceof Un && cn(e, i.argnames);
                    return a(i, n + 1, t ? function(e) {
                        var n = r(e);
                        if (n) return n;
                        n = i.variables.get(e);
                        if (n) {
                            var t = n.orig[0];
                            if (t instanceof hr || t instanceof _r) return n;
                        }
                    } : i.variables ? function(e) {
                        return r(e) || i.variables.get(e);
                    } : r);
                }
            };
            var N = Object.create(null);
            var h = [];
            var z = Object.create(null);
            var g = Object.create(null);
            var b = Object.create(null);
            var C = Object.create(null);
            if (O instanceof Bn && D.top_retain) {
                O.variables.each(function(e) {
                    if (D.top_retain(e) && !(e.id in z)) {
                        z[e.id] = true;
                        h.push(e);
                    }
                });
            }
            var y = new xn();
            var w = new xn();
            var M = this;
            var m = new Ir(function(s, e) {
                if (s instanceof Un && s.uses_arguments && !m.has_directive("use strict")) {
                    s.each_argname(function(e) {
                        var n = e.definition();
                        if (!(n.id in z)) {
                            z[n.id] = true;
                            h.push(n);
                        }
                    });
                }
                if (s === O) return;
                if (M === O) {
                    if (s instanceof ct) {
                        var t = s.name.definition();
                        if ((!P || t.exported) && !(t.id in z)) {
                            z[t.id] = true;
                            h.push(t);
                        }
                        if (s.extends) s.extends.walk(m);
                        var r = false;
                        if (m.parent() instanceof Pt) {
                            r = true;
                            o[t.id] = true;
                        }
                        s.properties.forEach(function(e) {
                            if (e.key instanceof nn) e.key.walk(m);
                            if (!e.value) return;
                            if (r || e instanceof dt && e.static) {
                                var n = M;
                                M = s;
                                e.value.walk(m);
                                M = n;
                            } else {
                                w.add(t.id, e.value);
                            }
                        });
                        return true;
                    }
                    if (s instanceof it) {
                        var t = s.name.definition();
                        if ((!P || t.exported) && !(t.id in z)) {
                            z[t.id] = true;
                            h.push(t);
                        }
                        w.add(t.id, s);
                        if (m.parent() instanceof Pt) {
                            o[t.id] = true;
                        } else {
                            return true;
                        }
                    }
                    if (s instanceof $t) {
                        s.definitions.forEach(function(r) {
                            var i = r.value;
                            var a = i && (r.name instanceof Zt || i.has_side_effects(D));
                            var o = a && i.tail_node().operator == "=";
                            r.name.mark_symbol(function(e) {
                                if (!(e instanceof cr)) return;
                                var n = e.definition();
                                C[n.id] = (C[n.id] || 0) + 1;
                                if (s instanceof Ct && n.orig[0] instanceof br) {
                                    var t = n.redefined();
                                    if (t) C[t.id] = (C[t.id] || 0) + 1;
                                }
                                if (!(n.id in z) && (!$ || n.exported || (s instanceof qt ? n.redefined() : n.const_redefs) || !(s instanceof Ct || ne(n)))) {
                                    z[n.id] = true;
                                    h.push(n);
                                }
                                if (i) {
                                    if (!a) {
                                        w.add(n.id, i);
                                    } else if (o) {
                                        E(n, e, b[n.id]);
                                    }
                                    y.add(n.id, r);
                                }
                                return true;
                            }, m);
                            if (a) i.walk(m);
                        });
                        return true;
                    }
                    if (s instanceof hr) {
                        var t = s.definition();
                        C[t.id] = (C[t.id] || 0) + 1;
                        y.add(t.id, s);
                        return true;
                    }
                    if (s instanceof pr) {
                        var t = s.definition();
                        if (!(t.id in z) && (!$ || !ne(t))) {
                            z[t.id] = true;
                            h.push(t);
                        }
                        return true;
                    }
                }
                return i(s, e, true);
            });
            m.directives = Object.create(D.directives);
            O.walk(m);
            var I = D.option("keep_fnames") ? dn : D.option("ie") ? function(e) {
                return !D.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                if (!(e.id in z)) return true;
                if (e.orig.length - e.eliminated < 2) return false;
                if (e.orig[1] instanceof hr) return true;
                return en(e.references, function(e) {
                    return !e.in_arg;
                });
            };
            if (D.option("ie")) w.each(function(e, n) {
                if (n in z) return;
                e.forEach(function(e) {
                    e.walk(new Ir(function(e) {
                        if (e instanceof tt && e.name && !I(e.name.definition())) {
                            e.walk(m);
                            return true;
                        }
                        if (e instanceof Ln) return true;
                    }));
                });
            });
            m = new Ir(i);
            for (var e = 0; e < h.length; e++) {
                var n = w.get(h[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(m);
                });
            }
            Object.keys(q).forEach(function(e) {
                var t = q[e];
                if (!t) {
                    delete q[e];
                    return;
                }
                t = t.reduce(function(n, e) {
                    e.forEach(function(e) {
                        gn(n, e);
                    });
                    return n;
                }, []);
                var n = (y.get(e) || []).filter(function(n) {
                    return ln(n instanceof Wt ? function(e) {
                        return e === n;
                    } : function(e) {
                        if (e === n) return true;
                        if (e instanceof Wt) return false;
                        return r(e) === r(n);
                    }, t);
                });
                if (t.length == n.length) {
                    q[e] = n;
                } else {
                    delete q[e];
                }
            });
            var H = [];
            var Y = [];
            var R = [];
            var L = new Hr(function(r) {
                if (r instanceof It) return T(L, r);
                if (r instanceof Zt && r.rest) r.rest = r.rest.transform(L);
                if (r instanceof er) {
                    var e = !r.rest;
                    for (var n = r.elements.length; --n >= 0; ) {
                        var t = r.elements[n].transform(L);
                        if (t) {
                            r.elements[n] = t;
                            e = false;
                        } else if (e) {
                            r.elements.pop();
                        } else {
                            r.elements[n] = Te(Mr, r.elements[n]);
                        }
                    }
                    return r;
                }
                if (r instanceof tr) {
                    var i = [];
                    r.properties.forEach(function(e) {
                        var n = false;
                        if (e.key instanceof nn) {
                            e.key = e.key.transform(F);
                            n = e.key.has_side_effects(D);
                        }
                        if ((n || r.rest) && a(e.value)) {
                            e.value = e.value.transform(F);
                            i.push(e);
                        } else {
                            var t = e.value.transform(L);
                            if (!t && r.rest) {
                                if (e.value instanceof er) {
                                    t = Te(er, e.value, {
                                        elements: []
                                    });
                                } else {
                                    t = Te(tr, e.value, {
                                        properties: []
                                    });
                                }
                            }
                            if (t) {
                                e.value = t;
                                i.push(e);
                            }
                        }
                    });
                    r.properties = i;
                    return r;
                }
                if (r instanceof cr) return r.definition().id in z ? r : null;
            });
            var F = new Hr(function(_, o, s) {
                var g = F.parent();
                if ($) {
                    var e = [], n = j(_, e);
                    if (n) {
                        var t;
                        if (J(n, _)) {
                            if (_ instanceof fn) {
                                t = X(_);
                                if (_.write_only === true) t = t.drop_side_effect_free(D);
                            }
                            if (!t) t = Te(Dr, _, {
                                value: 0
                            });
                        }
                        if (t) {
                            if (e.assign) {
                                var f = e.assign.drop_side_effect_free(D);
                                if (f) {
                                    f.write_only = true;
                                    e.unshift(f);
                                }
                            }
                            if (!(g instanceof an) || g.tail_node() === _ || t.has_side_effects(D)) {
                                e.push(t);
                            }
                            switch (e.length) {
                              case 0:
                                return _n.skip;

                              case 1:
                                return Fe(D, g, _, e[0].transform(F));

                              default:
                                return Ae(_, e.map(function(e) {
                                    return e.transform(F);
                                }));
                            }
                        }
                    } else if (_ instanceof Gt && _.expression instanceof un && G(_.expression.definition(), _) < 0) {
                        return Te(on, _, {
                            operator: "+",
                            expression: _.expression
                        });
                    }
                }
                if (_ instanceof Ht) Y.push(_);
                if (M !== O) return;
                if (P && _ !== O && _ instanceof ct) {
                    var u = _.name.definition();
                    if (!(u.id in z)) {
                        B(_.name, "Dropping unused class {name}");
                        u.eliminated++;
                        o(_, F);
                        var r = ee(_, true);
                        if (g instanceof Pt) return r;
                        r = r.drop_side_effect_free(D, true);
                        if (r) return Te(tn, _, {
                            body: r
                        });
                        return s ? _n.skip : Te(Dn, _);
                    }
                }
                if (_ instanceof lt && _.name && I(_.name.definition())) {
                    H.push(_);
                }
                if (_ instanceof Un) {
                    if (P && _ !== O && _ instanceof it) {
                        var u = _.name.definition();
                        if (!(u.id in z)) {
                            B(_.name, "Dropping unused function {name}");
                            u.eliminated++;
                            if (g instanceof Pt) {
                                A();
                                return be(_, true);
                            }
                            return s ? _n.skip : Te(Dn, _);
                        }
                    }
                    if (_ instanceof Wn && _.name && I(_.name.definition())) {
                        H.push(_);
                    }
                    if (!(_ instanceof Vn)) {
                        var i, c;
                        if (g instanceof Ht && g.expression === _) {
                            i = g.args;
                            for (c = 0; c < i.length; c++) {
                                if (i[c] instanceof Vt) break;
                            }
                        }
                        var l = _.argnames;
                        var a = _.rest;
                        if (a) {
                            if (!i || c < l.length || a instanceof hr) {
                                a = a.transform(L);
                            } else {
                                var r = K(a, Te(Qt, g, {
                                    elements: i.slice(l.length)
                                }), function(e) {
                                    return e.definition().id in z ? e : null;
                                }, !_.uses_arguments, a);
                                a = r.name;
                                i.length = l.length;
                                if (r.value.elements.length) [].push.apply(i, r.value.elements);
                            }
                            if (a instanceof Zt && !a.rest && (!_.uses_arguments || F.has_directive("use strict"))) {
                                if (a instanceof er) {
                                    if (a.elements.length == 0) a = null;
                                } else if (a.properties.length == 0) {
                                    a = null;
                                }
                            }
                            _.rest = a;
                        }
                        var p = D.drop_fargs(_, g) && !_.rest;
                        var d = p ? -1 : _.length();
                        for (var v = l.length; --v >= 0; ) {
                            var n = l[v];
                            if (n instanceof hr) {
                                var u = n.definition();
                                if (u.id in z) {
                                    p = false;
                                    if (G(u, n) < 0) n.unused = null;
                                } else if (p) {
                                    B(n, "Dropping unused function argument {name}");
                                    l.pop();
                                } else {
                                    n.unused = true;
                                }
                            } else {
                                var h;
                                if (!i || c < v) {
                                    h = n.transform(L);
                                } else {
                                    h = K(n, i[v], function(e) {
                                        return e.definition().id in z ? e : null;
                                    }, !_.uses_arguments, n).name;
                                }
                                if (h) {
                                    p = false;
                                } else if (p) {
                                    U(n, "Dropping unused default argument {name}");
                                    l.pop();
                                } else if (v > d) {
                                    U(n, "Dropping unused default argument assignment {name}");
                                    if (n.name instanceof hr) n.name.unused = true;
                                    l[v] = n.name;
                                } else {
                                    U(n, "Dropping unused default argument value {name}");
                                    n.value = Te(Dr, n, {
                                        value: 0
                                    });
                                }
                            }
                        }
                        R.push(_);
                    }
                }
                if (_ instanceof Dt && _.argname instanceof Zt) {
                    _.argname.transform(L);
                }
                if (_ instanceof $t && !(g instanceof In && g.init === _)) {
                    var w = [], x = [], b = [];
                    var y = [];
                    var k = 0;
                    var E = _ instanceof Ct;
                    _.definitions.forEach(function(t) {
                        if (t.value) t.value = t.value.transform(F);
                        var e = t.value;
                        if (t.name instanceof Zt) {
                            var n = K(t.name, e, function(e) {
                                if (!$) return e;
                                if (e.definition().id in z) return e;
                                if (h(e)) return e;
                                if (E && !Se(e)) return e;
                                return null;
                            }, true);
                            if (n.name) {
                                t = Te(Mt, t, {
                                    name: n.name,
                                    value: e = n.value
                                });
                                m();
                            } else if (n.value) {
                                y.push(n.value);
                            }
                            return;
                        }
                        var a = t.name.definition();
                        var r = E ? Se(t.name) : ne(a);
                        if (!r || !$ || a.id in z) {
                            var i;
                            if (e && ((i = G(a, t)) < 0 || l(e.tail_node()))) {
                                e = e.drop_side_effect_free(D);
                                if (e) {
                                    nn.warn("Side effects in definition of variable {name} [{file}:{line},{col}]", V(t.name));
                                    y.push(e);
                                }
                                t = t.clone();
                                t.value = e = null;
                                if (i >= 0) q[a.id][i] = t;
                            }
                            var o, s;
                            if (!e && !(_ instanceof zt)) {
                                if (g instanceof Ft) {
                                    m();
                                } else if (r && C[a.id] > 1) {
                                    nn.info("Dropping declaration of variable {name} [{file}:{line},{col}]", V(t.name));
                                    C[a.id]--;
                                    a.eliminated++;
                                } else {
                                    x.push(t);
                                }
                            } else if (D.option("functions") && !D.option("ie") && r && e && C[a.id] == 1 && a.assignments == 0 && (s = e.tail_node()) instanceof Wn && !ze(a) && !Gn(s) && p(s, a.references) && d(s) && (o = v(s, t.name.name)) !== false) {
                                nn.warn("Declaring {name} as function [{file}:{line},{col}]", V(t.name));
                                var f;
                                switch (s.CTOR) {
                                  case et:
                                    f = at;
                                    break;

                                  case nt:
                                    f = ot;
                                    break;

                                  case tt:
                                    f = st;
                                    break;

                                  case rt:
                                    f = ft;
                                    break;
                                }
                                var u = Te(f, t, s);
                                u.name = Te(mr, t.name, t.name);
                                var c = t.name.scope.resolve().def_function(u.name);
                                if (o) o.forEach(function(e) {
                                    e.name = c.name;
                                    e.thedef = c;
                                    e.reference();
                                });
                                w.push(u);
                                if (e !== s) [].push.apply(y, e.expressions.slice(0, -1));
                            } else {
                                if (r && C[a.id] > 1 && !(g instanceof Ft) && a.orig.indexOf(t.name) > a.eliminated) {
                                    C[a.id]--;
                                    k++;
                                }
                                m();
                            }
                        } else if (h(t.name)) {
                            e = e && e.drop_side_effect_free(D);
                            if (e) y.push(e);
                            if (C[a.id] > 1) {
                                nn.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", V(t.name));
                                C[a.id]--;
                                a.eliminated++;
                            } else {
                                t.value = null;
                                x.push(t);
                            }
                        } else {
                            e = e && e.drop_side_effect_free(D);
                            if (e) {
                                nn.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", V(t.name));
                                y.push(e);
                            } else {
                                B(t.name, "Dropping unused variable {name}");
                            }
                            a.eliminated++;
                        }
                        function l(e) {
                            return e instanceof un && e.definition() === a;
                        }
                        function p(n, e) {
                            if (e.length == 0) return n === t.name.fixed_value();
                            return en(e, function(e) {
                                return n === e.fixed_value();
                            });
                        }
                        function d(e) {
                            if (!E || D.has_directive("use strict") || !(e instanceof tt)) {
                                return g instanceof Ln;
                            }
                            return g instanceof zn || g instanceof Nn && g.init === _ || g instanceof xt;
                        }
                        function v(t, r) {
                            if (!t.name) return null;
                            var e = t.name.definition();
                            if (e.orig.length > 1) return null;
                            if (e.assignments > 0) return false;
                            if (e.name == r) return e;
                            var i;
                            switch (r) {
                              case "await":
                                i = Jn;
                                break;

                              case "yield":
                                i = Xn;
                                break;
                            }
                            return en(e.references, function(e) {
                                var n = e.scope;
                                if (n.find_variable(r) !== a) return false;
                                if (i) do {
                                    n = n.resolve();
                                    if (i(n)) return false;
                                } while (n !== t && (n = n.parent_scope));
                                return true;
                            }) && e;
                        }
                        function h(e) {
                            var n = e.definition();
                            return n.orig[0] instanceof br && n.scope.resolve() === e.scope.resolve();
                        }
                        function m() {
                            if (y.length > 0) {
                                if (b.length == 0) {
                                    w.push(Te(tn, _, {
                                        body: Ae(_, y)
                                    }));
                                } else if (e) {
                                    y.push(e);
                                    t.value = Ae(e, y);
                                } else {
                                    t.value = Te(on, t, {
                                        operator: "void",
                                        expression: Ae(t, y)
                                    });
                                }
                                y = [];
                            }
                            b.push(t);
                        }
                    });
                    switch (x.length) {
                      case 0:
                        if (b.length == 0) break;
                        if (b.length == k) {
                            [].unshift.apply(y, b.map(function(e) {
                                nn.info("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", V(e.name));
                                var n = e.name.definition();
                                var t = Te(un, e.name, e.name);
                                n.references.push(t);
                                var r = Te(fn, e, {
                                    operator: "=",
                                    left: t,
                                    right: e.value
                                });
                                var i = G(n, e);
                                if (i >= 0) q[n.id][i] = r;
                                n.eliminated++;
                                return r;
                            }));
                            break;
                        }

                      case 1:
                        if (b.length == 0) {
                            var m = x[0].name.definition().id;
                            if (m in N) {
                                _.definitions = x;
                                N[m].init = _;
                                break;
                            }
                        }

                      default:
                        var S;
                        if (b.length > 0 && (S = b[0].value) instanceof an) {
                            b[0].value = S.tail_node();
                            w.push(Te(tn, _, {
                                body: Ae(S, S.expressions.slice(0, -1))
                            }));
                        }
                        _.definitions = x.concat(b);
                        w.push(_);
                    }
                    if (y.length > 0) {
                        w.push(Te(tn, _, {
                            body: Ae(_, y)
                        }));
                    }
                    return W(w, _, s);
                }
                if (_ instanceof fn) {
                    o(_, F);
                    if (!(_.left instanceof Zt)) return _;
                    var r = K(_.left, _.right, function(e) {
                        return e;
                    }, _.write_only === true);
                    if (r.name) return Te(fn, _, {
                        operator: _.operator,
                        left: r.name,
                        right: r.value
                    });
                    if (r.value) return r.value;
                    if (g instanceof an && g.tail_node() !== _) return _n.skip;
                    return Te(Dr, _, {
                        value: 0
                    });
                }
                if (_ instanceof Cn && _.body instanceof Nn) {
                    o(_, F);
                    if (_.body instanceof rn) {
                        var T = _.body;
                        _.body = T.body.pop();
                        T.body.push(_);
                        return s ? _n.splice(T.body) : T;
                    }
                    return _;
                }
                if (_ instanceof Ln) {
                    A();
                    return _;
                }
                if (_ instanceof pr) {
                    if (!D.option("imports") || _.definition().id in z) return _;
                    return s ? _n.skip : null;
                }
                function A() {
                    var e = M;
                    M = _;
                    o(_, F);
                    M = e;
                }
            }, function(e, n) {
                if (e instanceof rn) return Z(e, F.parent(), n);
                if (e instanceof Nn) return Ne(e, n);
                if (e instanceof Hn) {
                    if (!$ || !D.option("loops")) return;
                    if (!pe(e.body)) return;
                    var t = S(e);
                    if (!t) return;
                    var r = t.definition();
                    if (r.id in z) return;
                    B(t, "Dropping unused loop variable {name}");
                    if (N[r.id] === e) delete N[r.id];
                    var i = [];
                    var a = e.object.drop_side_effect_free(D);
                    if (a) {
                        nn.warn("Side effects in object of for-in loop [{file}:{line},{col}]", a.start);
                        i.push(Te(tn, e, {
                            body: a
                        }));
                    }
                    if (e.init instanceof $t && r.orig[0] instanceof br) {
                        i.push(e.init);
                    }
                    return W(i, e, n);
                }
                if (e instanceof Nt) {
                    if (e.properties && e.properties.length == 0) e.properties = null;
                    return e;
                }
                if (e instanceof an) {
                    if (e.expressions.length > 1) return;
                    return Fe(D, F.parent(), e, e.expressions[0]);
                }
            });
            F.push(D.parent());
            O.transform(F);
            if (O instanceof Un && O.body.length == 1 && O.body[0] instanceof An && O.body[0].value == "use strict") {
                O.body.length = 0;
            }
            H.forEach(function(e) {
                e.name = null;
            });
            Y.forEach(function(e) {
                ke(e, D, R);
            });
            function B(e, n) {
                nn[e.definition().references.length > 0 ? "info" : "warn"](n + " [{file}:{line},{col}]", V(e));
            }
            function U(e, n) {
                if (e.name instanceof hr) {
                    B(e.name, n);
                } else {
                    nn.info(n + " [{file}:{line},{col}]", {
                        name: e,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    });
                }
            }
            function V(e) {
                return {
                    name: e.name,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                };
            }
            function r(e) {
                return e[e instanceof fn ? "right" : "value"];
            }
            function W(e, n, t) {
                switch (e.length) {
                  case 0:
                    return t ? _n.skip : Te(Dn, n);

                  case 1:
                    return e[0];

                  default:
                    return t ? _n.splice(e) : Te(rn, n, {
                        body: e
                    });
                }
            }
            function x(e, n) {
                if (e.scope.resolve() !== O) return false;
                if (!e.fixed || !n.fixed) q[e.id] = false;
                return q[e.id] !== false;
            }
            function k(e, n) {
                if (!q[e.id]) q[e.id] = [];
                if (n.fixed.assigns) gn(q[e.id], n.fixed.assigns);
            }
            function G(e, n) {
                var t = q[e.id];
                return t && t.indexOf(n);
            }
            function E(e, n, t) {
                if (e.id in z) return;
                if (n && t) {
                    z[e.id] = n;
                    h.push(e);
                } else {
                    g[e.id] = n;
                    b[e.id] = t;
                }
            }
            function J(e, n) {
                var t = e.definition();
                var r = z[t.id];
                if (!r) return true;
                if (n[n instanceof fn ? "left" : "expression"] !== e) return false;
                return r === e && t.references.length - t.replaced == 1 || G(t, n) < 0;
            }
            function X(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof sn && $e[n.operator])) return n;
                if (!(n.left instanceof un)) return n;
                if (!(e.left instanceof un)) return n;
                var t = e.left.definition();
                if (n.left.definition() !== t) return n;
                if (n.right.has_side_effects(D)) return n;
                if (x(t, n.left)) k(t, n.left);
                return n.right;
            }
            function S(e) {
                var n = e.init;
                if (n instanceof $t) {
                    n = n.definitions[0].name;
                    return n instanceof cr && n;
                }
                while (n instanceof Lt) n = n.expression.tail_node();
                if (n instanceof un) return n;
            }
            function i(e, c, l) {
                if (e instanceof fn && e.left instanceof un) {
                    var n = e.left.definition();
                    if (n.scope.resolve() === O) y.add(n.id, e);
                }
                if (e instanceof Wt && e.expression instanceof un) {
                    var n = e.expression.definition();
                    if (n.scope.resolve() === O) y.add(n.id, e);
                }
                var t, r = [], i = j(e, r);
                if (i && ((t = i.definition()).scope.resolve() === O || O.variables.get(i.name) === t) && !(ze(t) && !en(O.argnames, function(e) {
                    return !e.match_symbol(function(e) {
                        if (e instanceof hr) {
                            var n = e.definition();
                            return n.references.length > n.replaced;
                        }
                    }, true);
                }))) {
                    if (e.write_only === "p" && e.right.may_throw_on_access(D, true)) return;
                    var a = r.assign;
                    if (a) {
                        a.write_only = true;
                        a.walk(m);
                    }
                    r.forEach(function(e) {
                        e.walk(m);
                    });
                    if (e instanceof fn) {
                        var o = X(e), s = false;
                        if (l && e.write_only === true && !o.has_side_effects(D)) {
                            w.add(t.id, o);
                        } else {
                            o.walk(m);
                            s = o.tail_node().operator == "=";
                        }
                        if (e.left === i) {
                            if (!e.write_only || s) {
                                E(t, i, b[t.id]);
                            }
                        } else {
                            var p = i.fixed_value();
                            if (!p || !p.is_constant()) {
                                E(t, g[t.id], true);
                            }
                        }
                    }
                    if (x(t, i) && Jr(i, e) !== i) k(t, i);
                    return true;
                }
                if (e instanceof Hn) {
                    if (e.init instanceof un && M === O) {
                        var d = e.init.definition().id;
                        if (!(d in N)) N[d] = e;
                    }
                    if (!$ || !D.option("loops")) return;
                    if (!pe(e.body)) return;
                    if (e.init.has_side_effects(D)) return;
                    var i = S(e);
                    if (!i) return;
                    var n = i.definition();
                    if (n.scope.resolve() !== O) {
                        var f = _(i.name);
                        if (f === n || f && f.redefined() === n) return;
                    }
                    e.object.walk(m);
                    return true;
                }
                if (e instanceof un) {
                    t = e.definition();
                    if (!(t.id in z)) {
                        z[t.id] = true;
                        h.push(t);
                    }
                    if (Q(t.scope, e.scope)) {
                        var u = t.redefined();
                        if (u && !(u.id in z)) {
                            z[u.id] = true;
                            h.push(u);
                        }
                    }
                    if (x(t, e)) k(t, e);
                    return true;
                }
                if (e instanceof Ln) {
                    var v = M;
                    M = e;
                    c();
                    M = v;
                    return true;
                }
            }
            function a(e) {
                return (e instanceof It ? e.name : e) instanceof cr;
            }
            function T(e, n) {
                n.value = n.value.transform(F);
                var t = n.name.transform(e);
                if (!t) {
                    if (n.name instanceof Zt) return null;
                    var r = n.value.drop_side_effect_free(D);
                    if (!r) return null;
                    B(n.name, "Side effects in default value of unused variable {name}");
                    n.name.unused = null;
                    n.value = r;
                }
                return n;
            }
            function K(e, m, _, g, b) {
                var y = new Hr(function(a) {
                    if (a instanceof It) {
                        if (!(D.option("default_values") && m && m.is_defined(D))) {
                            var n = g;
                            g = false;
                            var l = T(y, a);
                            g = n;
                            if (!l && g && m) m = m.drop_side_effect_free(D);
                            return l;
                        } else if (a === b) {
                            b = a = a.name;
                        } else {
                            a = a.name;
                        }
                    }
                    if (a instanceof er) {
                        var n = g;
                        var t = m;
                        if (m instanceof un) {
                            g = false;
                            m = m.fixed_value();
                        }
                        var r = m instanceof Qt && m.elements;
                        var i = [], o = g && [], s = 0;
                        a.elements.forEach(function(e, n) {
                            m = r && r[n];
                            if (m instanceof Mr) {
                                m = null;
                            } else if (m instanceof Vt) {
                                if (g) {
                                    o.length = s;
                                    ge(t, o);
                                    [].push.apply(o, r.slice(n));
                                    t.elements = o;
                                }
                                m = r = false;
                            }
                            e = e.transform(y);
                            if (e) i[s] = e;
                            if (g && m) o[s] = m;
                            if (e || m || !g || !r) s++;
                        });
                        m = r && Te(Qt, t, {
                            elements: r.slice(a.elements.length)
                        });
                        if (a.rest) {
                            var p = g;
                            g = false;
                            a.rest = a.rest.transform(D.option("rests") ? y : F);
                            g = p;
                            if (a.rest) i.length = s;
                        }
                        if (g) {
                            if (m && !a.rest) m = m.drop_side_effect_free(D);
                            if (m instanceof Qt) {
                                m = m.elements;
                            } else if (m instanceof an) {
                                m = m.expressions;
                            } else if (m) {
                                m = [ m ];
                            }
                            if (m && m.length) {
                                o.length = s;
                                [].push.apply(o, m);
                            }
                        }
                        m = t;
                        g = n;
                        if (r && o) {
                            ge(m, o);
                            m.elements = o;
                        }
                        if (!a.rest && (m instanceof Qt || m && m.is_string(D))) switch (i.length) {
                          case 0:
                            if (a === b) break;
                            if (g) m = m.drop_side_effect_free(D);
                            return null;

                          case 1:
                            if (!g) break;
                            if (a === b) break;
                            var d = i[0];
                            if (d.has_side_effects(D)) break;
                            if (m.has_side_effects(D) && d.match_symbol(function(e) {
                                return e instanceof Lt;
                            })) break;
                            m = Te(Ut, a, {
                                expression: m,
                                property: Te(Dr, a, {
                                    value: 0
                                })
                            });
                            return d;
                        }
                        ge(a, i);
                        a.elements = i;
                        return a;
                    }
                    if (a instanceof tr) {
                        var n = g;
                        var t = m;
                        if (m instanceof un) {
                            g = false;
                            m = m.fixed_value();
                        }
                        var f, u;
                        if (m instanceof rr) {
                            f = [];
                            u = new xn();
                            m.properties.forEach(function(e, n) {
                                if (e instanceof Vt) return u = false;
                                var t = e.key;
                                if (t instanceof nn) t = t.evaluate(D, true);
                                if (t instanceof nn) {
                                    u = false;
                                } else if (u && !(e instanceof sr)) {
                                    u.set(t, e);
                                }
                                f[n] = t;
                            });
                        }
                        if (a.rest) {
                            m = false;
                            a.rest = a.rest.transform(D.option("rests") ? y : F);
                        }
                        var v = new xn();
                        var c = g && new xn();
                        var h = [];
                        a.properties.map(function(e) {
                            var n = e.key;
                            if (n instanceof nn) {
                                e.key = n = n.transform(F);
                                n = n.evaluate(D, true);
                            }
                            if (n instanceof nn) {
                                c = false;
                            } else {
                                v.set(n, !v.has(n));
                            }
                            return n;
                        }).forEach(function(e, n) {
                            var t = a.properties[n], r;
                            if (e instanceof nn) {
                                g = false;
                                m = false;
                                r = t.value.transform(y) || x(t.value);
                            } else {
                                g = c && v.get(e);
                                var i = u && u.get(e);
                                if (i) {
                                    m = i.value;
                                    if (m instanceof Vn) m = false;
                                } else {
                                    m = false;
                                }
                                r = t.value.transform(y);
                                if (!r) {
                                    if (a.rest || w(t)) r = x(t.value);
                                    if (c && !c.has(e)) {
                                        if (i) {
                                            c.set(e, i);
                                            if (m === null) {
                                                u.set(e, w(i) && Te(ar, i, {
                                                    key: i.key,
                                                    value: Te(Dr, i, {
                                                        value: 0
                                                    })
                                                }));
                                            }
                                        } else {
                                            c.set(e, true);
                                        }
                                    }
                                } else if (c) {
                                    c.set(e, false);
                                }
                                if (m) i.value = m;
                            }
                            if (r) {
                                t.value = r;
                                h.push(t);
                            }
                        });
                        m = t;
                        g = n;
                        if (c && f) m.properties = _n(m.properties, function(e, n) {
                            if (e instanceof Vt) return e;
                            var t = f[n];
                            if (t instanceof nn) return e;
                            if (c.has(t)) {
                                var r = c.get(t);
                                if (!r) return e;
                                if (r === e) return u.get(t) || _n.skip;
                            } else if (a.rest) {
                                return e;
                            }
                            var i = e.value.drop_side_effect_free(D);
                            if (i) {
                                e.value = i;
                                return e;
                            }
                            return w(e) ? Te(ar, e, {
                                key: e.key,
                                value: Te(Dr, e, {
                                    value: 0
                                })
                            }) : _n.skip;
                        });
                        if (m && !a.rest) switch (h.length) {
                          case 0:
                            if (a === b) break;
                            if (m.may_throw_on_access(D, true)) break;
                            if (g) m = m.drop_side_effect_free(D);
                            return null;

                          case 1:
                            if (!g) break;
                            if (a === b) break;
                            var e = h[0];
                            if (e.key instanceof nn) break;
                            if (e.value.has_side_effects(D)) break;
                            if (m.has_side_effects(D) && e.value.match_symbol(function(e) {
                                return e instanceof Lt;
                            })) break;
                            m = Te(Ut, a, {
                                expression: m,
                                property: ce(e.key, e)
                            });
                            return e.value;
                        }
                        a.properties = h;
                        return a;
                    }
                    if (a instanceof Mr) {
                        a = null;
                    } else {
                        a = _(a);
                    }
                    if (!a && g && m) m = m.drop_side_effect_free(D);
                    return a;
                });
                return {
                    name: e.transform(y),
                    value: m
                };
                function w(e) {
                    return e.key instanceof nn && e.key.has_side_effects(D);
                }
                function x(e) {
                    if (e instanceof It) return x(e.name);
                    if (e instanceof Zt) {
                        if (m === null) {
                            m = Te(Dr, e, {
                                value: 0
                            });
                        } else if (m && (m.tail_node().write_only === true || m.may_throw_on_access(D, true))) {
                            m = Te(Qt, e, {
                                elements: m instanceof an ? m.expressions : [ m ]
                            });
                        }
                        return Te(tr, e, {
                            properties: []
                        });
                    }
                    e.unused = null;
                    return e;
                }
            }
        });
        Ln.DEFMETHOD("hoist_declarations", function(o) {
            if (o.has_directive("use asm")) return;
            var s = o.option("hoist_funs");
            var f = o.option("hoist_vars");
            var u = this;
            if (f) {
                var n = 0;
                u.walk(new Ir(function(e) {
                    if (n > 1) return true;
                    if (e instanceof Ft) return true;
                    if (e instanceof Ln && e !== u) return true;
                    if (e instanceof Ct) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) f = false;
            }
            if (!s && !f) return;
            var c = new xn();
            var h = [];
            var l = [];
            var p = new xn(), m = 0;
            var d = new Hr(function(e, n, t) {
                if (e === u) return;
                if (e instanceof An) {
                    h.push(e);
                    return t ? _n.skip : Te(Dn, e);
                }
                if (e instanceof it) {
                    if (!s) return e;
                    var r = d.parent();
                    if (r instanceof Ft) return e;
                    if (r instanceof Pt) return e;
                    if (r !== u && o.has_directive("use strict")) return e;
                    l.push(e);
                    return t ? _n.skip : Te(Dn, e);
                }
                if (e instanceof Ct) {
                    if (!f) return e;
                    var r = d.parent();
                    if (r instanceof Ft) return e;
                    if (!en(e.definitions, function(e) {
                        var n = e.name;
                        return n instanceof vr && !c.has(n.name) && u.find_variable(n.name) === n.definition();
                    })) return e;
                    e.definitions.forEach(function(e) {
                        p.set(e.name.name, e);
                        ++m;
                    });
                    var i = e.to_assignments();
                    if (r instanceof In && r.init === e) {
                        if (i) return i;
                        var a = e.definitions[0].name;
                        return Te(un, a, a);
                    }
                    if (r instanceof Nn && r.init === e) return i;
                    if (!i) return t ? _n.skip : Te(Dn, e);
                    return Te(tn, e, {
                        body: i
                    });
                }
                if (e instanceof Ln) return e;
                if (e instanceof lr) {
                    c.set(e.name, true);
                    return e;
                }
            });
            u.transform(d);
            if (m > 0) {
                var v = [];
                if (u instanceof Un) u.each_argname(function(e) {
                    p.del(e.name);
                });
                p.each(function(e, n) {
                    e = e.clone();
                    e.value = null;
                    v.push(e);
                    p.set(n, e);
                });
                if (v.length > 0) {
                    _(u.body);
                    v = Te(Ct, u, {
                        definitions: v
                    });
                    l.push(v);
                }
            }
            u.body = h.concat(l, u.body);
            function _(e) {
                while (e.length) {
                    var n = e[0];
                    if (n instanceof tn) {
                        var t = n.body, r, i;
                        if (t instanceof fn && t.operator == "=" && (r = t.left) instanceof ur && p.has(r.name)) {
                            var a = p.get(r.name);
                            if (a.value) break;
                            var o = t.right;
                            if (o instanceof an) o = o.clone();
                            a.value = o;
                            yn(v, a);
                            v.push(a);
                            e.shift();
                            continue;
                        }
                        if (t instanceof an && (i = t.expressions[0]) instanceof fn && i.operator == "=" && (r = i.left) instanceof ur && p.has(r.name)) {
                            var a = p.get(r.name);
                            if (a.value) break;
                            a.value = i.right;
                            yn(v, a);
                            v.push(a);
                            n.body = Ae(t, t.expressions.slice(1));
                            continue;
                        }
                    }
                    if (n instanceof Dn) {
                        e.shift();
                        continue;
                    }
                    if (n instanceof rn && !_(n.body)) {
                        e.shift();
                        continue;
                    }
                    break;
                }
                return e.length;
            }
        });
        function w(n, t) {
            n.walk(new Ir(function(e) {
                if (e instanceof _t) {
                    t(e);
                    return true;
                }
                if (e instanceof Ln && e !== n) return true;
            }));
        }
        function x(e) {
            var r = Object.create(null);
            w(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof un) {
                    var t = n.definition().id;
                    r[t] = (r[t] || 0) + 1;
                }
            });
            return r;
        }
        function H(e, n, t) {
            return e.bool_fn + (n[e.id] || 0) === e.references.length - e.replaced && !t.exposed(e);
        }
        function Y(e, r) {
            w(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = U(r, n);
                    if (!t) {
                        n = n.drop_side_effect_free(r);
                        e.value = n ? Ae(e.value, [ n, Te(Dr, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (!(t instanceof nn)) {
                        n = n.drop_side_effect_free(r);
                        e.value = n ? Ae(e.value, [ n, Te(Dr, e.value, {
                            value: 1
                        }) ]) : Te(Dr, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        Ln.DEFMETHOD("process_boolean_returns", pn);
        st.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = x(this);
            if (!H(this.name.definition(), n, e)) return;
            if (e.parent() instanceof Pt) return;
            Y(this, e);
        });
        tt.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = x(this);
            if (this.name && !H(this.name.definition(), n, e)) return;
            var t = e.parent();
            if (t instanceof fn) {
                if (t.operator != "=") return;
                var r = t.left;
                if (!(r instanceof un)) return;
                if (!H(r.definition(), n, e)) return;
            } else if (t instanceof Ht && t.expression !== this) {
                var i = t.expression;
                if (i instanceof un) i = i.fixed_value();
                if (!(i instanceof Un)) return;
                if (i.uses_arguments || i.pinned()) return;
                var r = i.argnames[t.args.indexOf(this)];
                if (r instanceof It) r = r.name;
                if (r instanceof hr && !H(r.definition(), n, e)) return;
            } else if (t.TYPE == "Call") {
                e.pop();
                var a = e.in_boolean_context();
                e.push(this);
                if (!a) return;
            } else return;
            Y(this, e);
        });
        $n.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = new xn();
                this.enclosed.forEach(function(e) {
                    t.set(e.name, true);
                });
                this.variables.each(function(e, n) {
                    t.set(n, true);
                });
            }
            return t;
        });
        Ln.DEFMETHOD("make_var", function(e, n, t) {
            var r = [ this ];
            if (n instanceof cr) n.definition().references.forEach(function(e) {
                var n = e.scope;
                if (cn(n, r)) return;
                do {
                    gn(r, n);
                    n = n.parent_scope;
                } while (n && n !== this);
            });
            t = t.replace(/^[^a-z_$]|[^a-z0-9_$]/gi, "_");
            var i = t;
            for (var a = 0; !en(r, function(e) {
                return !e.var_names().has(i);
            }); a++) i = t + "$" + a;
            var o = Te(e, n, {
                name: i,
                scope: this
            });
            var s = this.def_variable(o);
            r.forEach(function(e) {
                e.enclosed.push(s);
                e.var_names().set(i, true);
            });
            return o;
        });
        Ln.DEFMETHOD("hoist_properties", function(a) {
            if (!a.option("hoist_props") || a.has_directive("use asm")) return;
            var f = this;
            var o = f instanceof Bn && a.top_retain || dn;
            var u = Object.create(null);
            f.transform(new Hr(function(r, e) {
                if (r instanceof fn) {
                    if (r.operator != "=") return;
                    if (!r.write_only) return;
                    if (!c(r.left, r.right, 1)) return;
                    e(r, this);
                    var i = new xn();
                    var a = [];
                    var o = [];
                    r.right.properties.forEach(function(e) {
                        var n = s(vr, r.left, e.key);
                        o.push(Te(Mt, r, {
                            name: n,
                            value: null
                        }));
                        var t = Te(un, r, {
                            name: n.name,
                            scope: f,
                            thedef: n.definition()
                        });
                        t.reference();
                        a.push(Te(fn, r, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    i.value = r.right;
                    u[r.left.definition().id] = i;
                    f.body.splice(f.body.indexOf(this.stack[1]) + 1, 0, Te(Ct, r, {
                        definitions: o
                    }));
                    return Ae(r, a);
                }
                if (r instanceof Ln) return r === f ? undefined : r;
                if (r instanceof Mt) {
                    if (!c(r.name, r.value, 0)) return;
                    e(r, this);
                    var i = new xn();
                    var n = [];
                    var t = r.clone();
                    t.value = r.name instanceof lr ? Te(Dr, r, {
                        value: 0
                    }) : null;
                    n.push(t);
                    r.value.properties.forEach(function(e) {
                        n.push(Te(Mt, r, {
                            name: s(r.name.CTOR, r.name, e.key),
                            value: e.value
                        }));
                    });
                    i.value = r.value;
                    u[r.name.definition().id] = i;
                    return _n.splice(n);
                }
                function s(e, n, t) {
                    var r = f.make_var(e, n, n.name + "_" + t);
                    i.set(t, r.definition());
                    return r;
                }
            }));
            f.transform(new Hr(function(e, n) {
                if (e instanceof Lt) {
                    if (!(e.expression instanceof un)) return;
                    var t = u[e.expression.definition().id];
                    if (!t) return;
                    if (e.expression.fixed_value() !== t.value) return;
                    var r = t.get(e.get_property());
                    var i = Te(un, e, {
                        name: r.name,
                        scope: e.expression.scope,
                        thedef: r
                    });
                    i.reference();
                    return i;
                }
                if (e instanceof un) {
                    var t = u[e.definition().id];
                    if (!t) return;
                    if (e.fixed_value() !== t.value) return;
                    return Te(rr, e, {
                        properties: []
                    });
                }
            }));
            function c(e, n, t) {
                if (!(e instanceof ur)) return;
                var r = e.definition();
                if (r.assignments != t) return;
                if (r.references.length - r.replaced == t) return;
                if (r.single_use) return;
                if (o(r)) return;
                if (e.fixed_value() !== n) return;
                var i = e.fixed || r.fixed;
                if (i.direct_access) return;
                if (i.escaped && i.escaped.depth == 1) return;
                return n instanceof rr && n.properties.length > 0 && en(n.properties, Ke) && Se(e, a);
            }
        });
        function ye(e, n) {
            if (!e.name || !n.option("ie")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return en(t.references, function(e) {
                return !(e instanceof un);
            });
        }
        (function(e) {
            function c(e, n, t, r) {
                var i = e.length;
                var a = [], o = false;
                for (var s = 0; s < i; s++) {
                    var f = e[s];
                    var u;
                    if (r && f instanceof Vt) {
                        u = r(f, n, t);
                    } else {
                        u = f.drop_side_effect_free(n, t);
                    }
                    if (u !== f) o = true;
                    if (u) {
                        a.push(u);
                        t = false;
                    }
                }
                return a.length ? o ? a : e : null;
            }
            function l(e, n, t) {
                var r = e.expression;
                if (!r.is_string(n)) return e;
                return r.drop_side_effect_free(n, t);
            }
            function p(e) {
                return e instanceof Vt ? Te(Qt, e, {
                    elements: [ e ]
                }) : e;
            }
            e(nn, hn);
            e(Vn, mn);
            e(Qt, function(e, n) {
                var t = c(this.elements, e, n, l);
                if (!t) return null;
                if (t === this.elements && en(t, function(e) {
                    return e instanceof Vt;
                })) return this;
                return Ae(this, t.map(p));
            });
            e(fn, function(e) {
                var n = this.left;
                if (n instanceof Lt) {
                    var t = n.expression;
                    if (t.may_throw_on_access(e, true)) return this;
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                if ($e[this.operator.slice(0, -1)]) return this;
                this.write_only = true;
                if (!Rt(n).is_constant_expression(e.find_parent(Ln))) return this;
                return this.right.drop_side_effect_free(e);
            });
            e(Xt, function(e) {
                if (!e.option("awaits")) return this;
                var n = this.expression;
                if (!k(e, n)) return this;
                if (n instanceof on && n.operator == "!") n = n.expression;
                var t = n.drop_side_effect_free(e);
                if (t === n) return this;
                if (!t) {
                    t = Te(Dr, n, {
                        value: 0
                    });
                } else if (!k(e, t)) {
                    t = t.negate(e);
                }
                var r = this.clone();
                r.expression = t;
                return r;
            });
            e(sn, function(e, n) {
                var t = this.left;
                var r = this.right;
                var i = this.operator;
                if (i == "in" && !Ye(r)) {
                    var a = t.drop_side_effect_free(e, n);
                    if (a === t) return this;
                    var o = this.clone();
                    o.left = a || Te(Dr, t, {
                        value: 0
                    });
                    return o;
                }
                var s = r.drop_side_effect_free(e, n);
                if (!s) return t.drop_side_effect_free(e, n);
                if ($e[i] && s.has_side_effects(e)) {
                    var o = this;
                    if (s !== r) {
                        o = o.clone();
                        o.right = s.drop_side_effect_free(e);
                    }
                    if (i == "??") return o;
                    var f = Te(sn, this, {
                        operator: i == "&&" ? "||" : "&&",
                        left: t.negate(e, n),
                        right: o.right
                    });
                    return n ? u(o, f) : he(o, f);
                }
                var a = t.drop_side_effect_free(e, n);
                if (!a) return s;
                s = s.drop_side_effect_free(e);
                if (!s) return a;
                return Ae(this, [ a, s ]);
            });
            function d(o, n) {
                var e = Gn(n);
                var r = Jn(n);
                var s = false;
                var t = false;
                if (e && o.option("arrows")) {
                    if (!n.value) {
                        t = true;
                    } else if (!r || k(o, n.value)) {
                        var i = n.value.drop_side_effect_free(o);
                        if (i !== n.value) {
                            s = true;
                            n.value = i;
                        }
                    }
                } else if (n instanceof et || n instanceof tt) {
                    if (n.name) {
                        var a = n.name.definition();
                        t = a.references.length == a.replaced;
                    } else {
                        t = true;
                    }
                }
                if (t) {
                    n.process_expression(false, function(e) {
                        var n = e.value;
                        if (n) {
                            if (r && !k(o, n)) return e;
                            n = n.drop_side_effect_free(o, true);
                        }
                        s = true;
                        if (!n) return Te(Dn, e);
                        return Te(tn, e, {
                            body: n
                        });
                    });
                    w(n, function(e) {
                        var n = e.value;
                        if (n) {
                            if (r && !k(o, n)) return;
                            var t = n.drop_side_effect_free(o);
                            if (t !== n) {
                                s = true;
                                e.value = t;
                            }
                        }
                    });
                }
                if (r && o.option("awaits")) {
                    if (t) n.process_expression("awaits", function(e) {
                        var n = e.body;
                        if (n instanceof Xt) {
                            if (k(o, n.expression)) {
                                s = true;
                                n = n.expression.drop_side_effect_free(o, true);
                                if (!n) return Te(Dn, e);
                                e.body = n;
                            }
                        } else if (n instanceof an) {
                            var t = n.expressions;
                            for (var r = t.length; --r >= 0; ) {
                                var i = t[r];
                                if (!(i instanceof Xt)) break;
                                var a = i.expression;
                                if (!k(o, a)) break;
                                s = true;
                                if (t[r] = a.drop_side_effect_free(o)) break;
                            }
                            switch (r) {
                              case -1:
                                return Te(Dn, e);

                              case 0:
                                e.body = t[0];
                                break;

                              default:
                                t.length = r + 1;
                                break;
                            }
                        }
                        return e;
                    });
                    var f = !t && n.name || e && n.value && !k(o, n.value);
                    var c = new Ir(function(e) {
                        if (f) return true;
                        if (c.parent() === n && e.may_throw(o)) return f = true;
                        if (e instanceof Xt) return f = true;
                        if (e instanceof Yn) return f = true;
                        if (e instanceof _t) {
                            if (e.value && !k(o, e.value)) return f = true;
                            return;
                        }
                        if (e instanceof Ln && e !== n) return true;
                    });
                    n.walk(c);
                    if (!f) {
                        var u;
                        switch (n.CTOR) {
                          case Zn:
                            u = Qn;
                            break;

                          case et:
                            u = tt;
                            break;

                          case nt:
                            u = rt;
                            break;
                        }
                        return Te(u, n, n);
                    }
                }
                return s && n.clone();
            }
            function v(e, n) {
                e.new = true;
                var t = en(e.body, function(e) {
                    return !e.has_side_effects(n);
                }) && en(e.argnames, function(e) {
                    return !e.match_symbol(dn);
                }) && !(e.rest && e.rest.match_symbol(dn));
                e.new = false;
                return t;
            }
            e(Ht, function(e, n) {
                var t = this;
                if (t.is_expr_pure(e)) {
                    if (t.pure) nn.warn("Dropping __PURE__ call [{file}:{line},{col}]", t.start);
                    var r = c(t.args, e, n, l);
                    return r && Ae(t, r.map(p));
                }
                var i = t.expression;
                if (t.is_call_pure(e)) {
                    var a = t.args.slice();
                    a.unshift(i.expression);
                    a = c(a, e, n, l);
                    return a && Ae(t, a.map(p));
                }
                if (e.option("yields") && Xn(i)) {
                    var o = t.clone();
                    o.expression = Te(tt, i, i);
                    o.expression.body = [];
                    var s = o.transform(e);
                    if (s !== o) return s.drop_side_effect_free(e, n);
                }
                var f = d(e, i);
                if (f) {
                    t = t.clone();
                    t.expression = f;
                    if (i._squeezed) t.expression._squeezed = true;
                }
                if (t instanceof Yt) {
                    var u = i;
                    if (u instanceof un) u = u.fixed_value();
                    if (u instanceof Un) {
                        if (v(u, e)) {
                            var a = t.args.slice();
                            a.unshift(i);
                            a = c(a, e, n, l);
                            return a && Ae(t, a.map(p));
                        }
                        if (!u.contains_this()) {
                            t = Te(Ht, t, t);
                            t.expression = t.expression.clone();
                            t.args = t.args.slice();
                        }
                    }
                }
                t.call_only = true;
                return t;
            });
            e(lt, function(e, n) {
                var t = this;
                var r = [], i = [];
                var a = t.properties;
                for (var o = 0; o < a.length; o++) {
                    var s = a[o];
                    if (s.key instanceof nn) r.push(s.key);
                    if (s.static && s.value && s instanceof dt && s.value.has_side_effects(e)) {
                        if (s.value.contains_this()) return t;
                        i.push(s.value);
                    }
                }
                var f = t.extends;
                if (f) {
                    if (f instanceof un) f = f.fixed_value();
                    f = !h(f);
                    if (!f) r.unshift(t.extends);
                }
                r = c(r, e, n);
                if (r) n = false;
                i = c(i, e, n);
                if (!r) {
                    if (!f && !i && !t.name) return null;
                    r = [];
                }
                if (f || t.name || !e.has_directive("use strict")) {
                    var u = ee(t);
                    if (!f) u.extends = null;
                    u.properties = [];
                    if (i) {
                        u.properties.push(Te(dt, t, {
                            static: true,
                            key: r.length ? Ae(t, r) : "c",
                            value: Ae(t, i)
                        }));
                    } else if (r.length) {
                        u.properties.push(Te(vt, t, {
                            key: Ae(t, r),
                            value: Te(tt, t, {
                                argnames: [],
                                body: []
                            }).init_vars(u)
                        }));
                    }
                    return u;
                }
                if (i) r.push(Te(Ht, t, {
                    expression: Te(Qn, t, {
                        argnames: [],
                        body: [],
                        value: Ae(t, i)
                    }).init_vars(t.parent_scope),
                    args: []
                }));
                return Ae(t, r);
            });
            e(Jt, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var r;
                if (e.option("ie")) {
                    r = [];
                    if (n instanceof tt) {
                        r.push(n);
                        n = null;
                    }
                    if (t instanceof tt) {
                        r.push(t);
                        t = null;
                    }
                }
                var i;
                if (!n) {
                    i = t ? Te(sn, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    i = Te(sn, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    i = this.clone();
                    i.consequent = n;
                    i.alternative = t;
                }
                if (!r) return i;
                if (i) r.push(i);
                return r.length == 0 ? null : Ae(this, r);
            });
            e(Tr, mn);
            e(Bt, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(tt, function(e) {
                return ye(this, e) ? null : this;
            });
            e(Wn, mn);
            e(rr, function(e, n) {
                var t = [];
                this.properties.forEach(function(e) {
                    if (e instanceof Vt) {
                        t.push(e);
                    } else {
                        if (e.key instanceof nn) t.push(e.key);
                        t.push(e.value);
                    }
                });
                var r = c(t, e, n, function(e, n, t) {
                    var r = e.expression;
                    return r.safe_to_spread() ? r.drop_side_effect_free(n, t) : e;
                });
                if (!r) return null;
                if (r === t && !en(r, function(e) {
                    return !(e instanceof Vt);
                })) return this;
                return Ae(this, r.map(function(e) {
                    return e instanceof Vt ? Te(rr, e, {
                        properties: [ e ]
                    }) : e;
                }));
            });
            e(wr, mn);
            e(an, function(e, n) {
                var t = c(this.expressions, e, n);
                if (!t) return null;
                var r = t.length - 1;
                var i = t[r];
                if (e.option("awaits") && r > 0 && i instanceof Xt && i.expression.is_constant()) {
                    t = t.slice(0, -1);
                    r--;
                    var a = t[r];
                    i.expression = k(e, a) ? a : a.negate(e);
                    t[r] = i;
                }
                var o, s, f;
                if (e.option("conditionals") && r > 0 && (o = t[r - 1]) instanceof fn && o.operator == "=" && (f = o.left) instanceof un && (s = te(e, f.definition(), o.right, i))) {
                    o = o.clone();
                    o.right = s;
                    t = t.slice(0, -2);
                    t.push(o.drop_side_effect_free(e, n));
                }
                return t === this.expressions ? this : Ae(this, t);
            });
            e(Ut, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                var r = this.property;
                t = t.drop_side_effect_free(e, n);
                if (!t) return r.drop_side_effect_free(e, n);
                r = r.drop_side_effect_free(e);
                if (!r) return t;
                return Ae(this, [ t, r ]);
            });
            e(un, function(e) {
                return this.is_declared(e) && Se(this, e) ? null : this;
            });
            e(Sr, function(e, n) {
                var t = this;
                if (t.is_expr_pure(e)) {
                    var r = t.expressions;
                    if (r.length == 0) return null;
                    return Ae(t, r).drop_side_effect_free(e, n);
                }
                var i = t.tag;
                var a = d(e, i);
                if (a) {
                    t = t.clone();
                    t.tag = a;
                    if (i._squeezed) t.tag._squeezed = true;
                }
                return t;
            });
            e(Wt, function(e, n) {
                var t = this.expression;
                if (Gr[this.operator]) {
                    this.write_only = !t.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && t instanceof un && Se(t, e)) {
                    return null;
                }
                var r = t.drop_side_effect_free(e, n);
                if (n && r && de(r)) {
                    if (r === t && this.operator == "!") return this;
                    return r.negate(e, n);
                }
                return r;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(tn, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var r = t.drop_side_effect_free(n, true);
                if (!r) {
                    nn.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return Te(Dn, e);
                }
                if (r !== t) {
                    return Te(tn, e, {
                        body: r
                    });
                }
            }
            return e;
        });
        e(jn, function(e, n) {
            return n.option("loops") ? Te(Nn, e, e).optimize(n) : e;
        });
        function R(n, e, t) {
            if (!t) t = bt;
            var r = false;
            var i = new Ir(function(e) {
                if (r || e instanceof Ln) return true;
                if (e instanceof t && i.loopcontrol_target(e) === n) {
                    return r = true;
                }
            });
            if (e instanceof Cn) i.push(e);
            i.push(n);
            n.body.walk(i);
            return r;
        }
        e(Pn, function(t, e) {
            if (!e.option("loops")) return t;
            var n = U(e, t.condition);
            if (!(n instanceof nn)) {
                if (n && !R(t, e.parent(), wt)) return Te(Nn, t, {
                    body: Te(rn, t.body, {
                        body: [ t.body, Te(tn, t.condition, {
                            body: t.condition
                        }) ]
                    })
                }).optimize(e);
                if (!R(t, e.parent())) return Te(rn, t.body, {
                    body: [ t.body, Te(tn, t.condition, {
                        body: t.condition
                    }) ]
                }).optimize(e);
            }
            if (t.body instanceof rn && !R(t, e.parent(), wt)) {
                var r = t.body.body;
                for (var i = r.length; --i >= 0; ) {
                    var a = r[i];
                    if (a instanceof xt && !a.alternative && a.body instanceof yt && e.loopcontrol_target(a.body) === t) {
                        if (o(a.condition)) break;
                        t.condition = Te(sn, t, {
                            operator: "&&",
                            left: a.condition.negate(e),
                            right: t.condition
                        });
                        r.splice(i, 1);
                    } else if (a instanceof tn) {
                        if (o(a.body)) break;
                        t.condition = Ae(t, [ a.body, t.condition ]);
                        r.splice(i, 1);
                    } else if (!P(a, true)) {
                        break;
                    }
                }
                t.body = Z(t.body, e.parent());
            }
            if (t.body instanceof Dn) return Te(Nn, t, t).optimize(e);
            if (t.body instanceof tn) return Te(Nn, t, {
                condition: Ae(t.condition, [ t.body.body, t.condition ]),
                body: Te(Dn, t)
            }).optimize(e);
            return t;
            function o(e) {
                var n = false;
                e.walk(new Ir(function(e) {
                    if (n) return true;
                    if (e instanceof un) {
                        if (!cn(e.definition(), t.enclosed)) n = true;
                        return true;
                    }
                }));
                return n;
            }
        });
        function L(n, t) {
            var e = o(n.body);
            if (t.option("dead_code") && (e instanceof yt || e instanceof wt && s(e) || e instanceof mt)) {
                var r = [];
                if (On(n.init)) {
                    r.push(n.init);
                } else if (n.init) {
                    r.push(Te(tn, n.init, {
                        body: n.init
                    }));
                }
                var i = s(e) || e instanceof mt;
                if (n.condition && i) {
                    r.push(Te(xt, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    r.push(Te(tn, n.condition, {
                        body: n.condition
                    }));
                } else if (i) {
                    r.push(e);
                }
                N(t, n.body, r);
                return Te(rn, n, {
                    body: r
                });
            }
            if (e instanceof xt) {
                var a = o(e.body);
                if (a instanceof yt && !s(a)) {
                    if (n.condition) {
                        n.condition = Te(sn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var r = M(e.alternative);
                    N(t, e.body, r);
                    return f(r);
                }
                a = o(e.alternative);
                if (a instanceof yt && !s(a)) {
                    if (n.condition) {
                        n.condition = Te(sn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var r = M(e.body);
                    N(t, e.alternative, r);
                    return f(r);
                }
            }
            return n;
            function o(e) {
                return e instanceof rn ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof rn) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = Te(rn, n.body, {
                        body: e
                    }).transform(t);
                }
                return L(n, t);
            }
        }
        e(Nn, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = U(n, e.condition);
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        if (On(e.init)) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(Te(tn, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(Te(tn, e.condition, {
                            body: e.condition
                        }));
                        N(n, e.body, r);
                        return Te(rn, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (!(t instanceof nn)) {
                    e.body = Te(rn, e.body, {
                        body: [ Te(tn, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return L(e, n);
        });
        e(In, function(e, t) {
            if (t.option("varify") && C(e.init)) {
                var n = e.init.definitions[0].name;
                if ((n instanceof Zt || n instanceof dr) && !n.match_symbol(function(e) {
                    if (e instanceof cr) {
                        var n = e.definition();
                        return !Le(n) || G(t, n);
                    }
                }, true)) {
                    e.init = J(e.init);
                }
            }
            return e;
        });
        function B(e, n, t) {
            if (e instanceof an) e = e.tail_node();
            if (!(e instanceof sn)) return;
            if (!(e.left instanceof Ar)) {
                switch (e.operator) {
                  case "&&":
                    B(e.left, n);
                    B(e.right, n);
                    break;

                  case "||":
                    B(p(e.left), t);
                    B(p(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof on)) return;
            if (e.right.operator != "typeof") return;
            var r = e.right.expression;
            if (!De(r)) return;
            var i;
            var a = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                i = a ? t : n;
                break;

              case "!=":
                i = a ? n : t;
                break;

              default:
                return;
            }
            if (!i) return;
            var o = false;
            var c = r.definition();
            var s;
            var f = [];
            var l = [];
            var u = new Ir(function(e, n) {
                if (o) return true;
                if (e instanceof fn) {
                    var t = e.left;
                    if (!(t instanceof un && t.definition() === c)) return;
                    e.right.walk(u);
                    switch (e.operator) {
                      case "=":
                      case "&&=":
                        o = true;
                    }
                    return true;
                }
                if (e instanceof Ht) {
                    n();
                    s = e.expression.tail_node();
                    var r;
                    if (s instanceof un) {
                        s = s.fixed_value();
                        r = f.length;
                    }
                    if (!(s instanceof Un)) {
                        o = true;
                    } else if (gn(l, s)) {
                        s.walk(u);
                    }
                    if (r >= 0) f.length = r;
                    return true;
                }
                if (e instanceof Fn) {
                    var r = f.length;
                    n();
                    if (o) f.length = r;
                    return true;
                }
                if (e instanceof Nn) {
                    if (e.init) e.init.walk(u);
                    var r = f.length;
                    if (e.condition) e.condition.walk(u);
                    e.body.walk(u);
                    if (e.step) e.step.walk(u);
                    if (o) f.length = r;
                    return true;
                }
                if (e instanceof In) {
                    e.object.walk(u);
                    var r = f.length;
                    e.init.walk(u);
                    e.body.walk(u);
                    if (o) f.length = r;
                    return true;
                }
                if (e instanceof Ln) {
                    if (e === s) return;
                    return true;
                }
                if (e instanceof un) {
                    if (e.definition() === c) f.push(e);
                    return true;
                }
            });
            i.walk(u);
            f.forEach(function(e) {
                e.defined = true;
            });
            function p(e) {
                if (!(e instanceof sn)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        function U(e, n, t) {
            if (n.truthy) return true;
            if (n.falsy && !t) return false;
            if (n.is_truthy()) return true;
            return n.evaluate(e, true);
        }
        function V(e, n) {
            var t;
            var r = 0;
            var i = false;
            var a = e.self();
            if (!On(a)) while (true) {
                t = a;
                a = e.parent(r++);
                if (a instanceof sn) {
                    var o = a.operator;
                    if (!$e[o]) return;
                    var s = a.left;
                    if (s === t) continue;
                    if (u(s)) switch (o) {
                      case "&&":
                        n[i ? "falsy" : "truthy"] = true;
                        break;

                      case "||":
                      case "??":
                        n[i ? "truthy" : "falsy"] = true;
                        break;
                    }
                } else if (a instanceof Jt) {
                    var f = a.condition;
                    if (f === t) continue;
                    if (u(f)) switch (t) {
                      case a.consequent:
                        n[i ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[i ? "truthy" : "falsy"] = true;
                        break;
                    }
                } else if (a instanceof mt) {
                    break;
                } else if (a instanceof xt) {
                    break;
                } else if (a instanceof an) {
                    if (a.expressions[0] === t) continue;
                } else if (a instanceof tn) {
                    break;
                }
                return;
            }
            while (true) {
                t = a;
                a = e.parent(r++);
                if (a instanceof rn) {
                    if (a.body[0] === t) continue;
                } else if (a instanceof xt) {
                    if (u(a.condition)) switch (t) {
                      case a.body:
                        n[i ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[i ? "truthy" : "falsy"] = true;
                        break;
                    }
                }
                return;
            }
            function u(e) {
                if (n.equivalent_to(e)) return true;
                if (!(e instanceof on)) return false;
                if (e.operator != "!") return false;
                if (!n.equivalent_to(e.expression)) return false;
                i = true;
                return true;
            }
        }
        e(xt, function(e, u) {
            if (pe(e.alternative)) e.alternative = null;
            if (!u.option("conditionals")) return e;
            if (u.option("booleans") && !e.condition.has_side_effects(u)) {
                V(u, e.condition);
            }
            if (u.option("dead_code")) {
                var c = U(u, e.condition);
                if (!c) {
                    nn.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var n = [ Te(tn, e.condition, {
                        body: e.condition
                    }) ];
                    N(u, e.body, n);
                    if (e.alternative) n.push(e.alternative);
                    return Te(rn, e, {
                        body: n
                    }).optimize(u);
                } else if (!(c instanceof nn)) {
                    nn.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var n = [ Te(tn, e.condition, {
                        body: e.condition
                    }), e.body ];
                    if (e.alternative) N(u, e.alternative, n);
                    return Te(rn, e, {
                        body: n
                    }).optimize(u);
                }
            }
            var t = e.condition.negate(u);
            var l = e.condition.print_to_string().length;
            var p = t.print_to_string().length;
            var r = p < l;
            if (e.alternative && r) {
                r = false;
                e.condition = t;
                var d = e.body;
                e.body = e.alternative || Te(Dn, e);
                e.alternative = d;
            }
            var v = [];
            var i = [];
            var h = [];
            var a = y(e.body, v, i, h);
            var m = [];
            var o = [];
            var _ = [];
            var s = y(e.alternative, m, o, _);
            if (a instanceof rn || s instanceof rn) {
                var n = [], f = [];
                if (a) {
                    [].push.apply(n, v);
                    [].push.apply(f, i);
                    if (a instanceof rn) {
                        e.body = a;
                    } else if (a.length == 0) {
                        e.body = Te(Dn, e.body);
                    } else {
                        e.body = Te(tn, e.body, {
                            body: Ae(e.body, a)
                        });
                    }
                    h.forEach(function(e) {
                        e.definition().references.push(e);
                    });
                }
                if (s) {
                    [].push.apply(n, m);
                    [].push.apply(f, o);
                    if (s instanceof rn) {
                        e.alternative = s;
                    } else if (s.length == 0) {
                        e.alternative = null;
                    } else {
                        e.alternative = Te(tn, e.alternative, {
                            body: Ae(e.alternative, s)
                        });
                    }
                    _.forEach(function(e) {
                        e.definition().references.push(e);
                    });
                }
                if (f.length > 0) n.push(Te(Ct, e, {
                    definitions: f
                }));
                if (n.length > 0) {
                    n.push(e);
                    return Te(rn, e, {
                        body: n
                    }).optimize(u);
                }
            } else if (a && s) {
                var n = v.concat(m);
                if (i.length > 0 || o.length > 0) n.push(Te(Ct, e, {
                    definitions: i.concat(o)
                }));
                if (a.length == 0) {
                    n.push(Te(tn, e.condition, {
                        body: s.length > 0 ? Te(sn, e, {
                            operator: "||",
                            left: e.condition,
                            right: Ae(e.alternative, s)
                        }).transform(u) : e.condition.clone()
                    }).optimize(u));
                } else if (s.length == 0) {
                    if (l === p && !r && e.condition instanceof sn && e.condition.operator == "||") {
                        r = true;
                    }
                    n.push(Te(tn, e, {
                        body: Te(sn, e, {
                            operator: r ? "||" : "&&",
                            left: r ? t : e.condition,
                            right: Ae(e.body, a)
                        }).transform(u)
                    }).optimize(u));
                } else {
                    n.push(Te(tn, e, {
                        body: Te(Jt, e, {
                            condition: e.condition,
                            consequent: Ae(e.body, a),
                            alternative: Ae(e.alternative, s)
                        })
                    }).optimize(u));
                }
                h.forEach(function(e) {
                    e.definition().references.push(e);
                });
                _.forEach(function(e) {
                    e.definition().references.push(e);
                });
                return Te(rn, e, {
                    body: n
                }).optimize(u);
            }
            if (pe(e.body)) e = Te(xt, e, {
                condition: t,
                body: e.alternative,
                alternative: null
            });
            if (e.alternative instanceof mt && e.body.TYPE == e.alternative.TYPE) {
                var g = Te(e.body.CTOR, e, {
                    value: Te(Jt, e, {
                        condition: e.condition,
                        consequent: e.body.value || Te(Cr, e.body).transform(u),
                        alternative: e.alternative.value || Te(Cr, e.alternative).transform(u)
                    })
                });
                if (g instanceof _t) g.in_bool = e.body.in_bool || e.alternative.in_bool;
                return g;
            }
            if (e.body instanceof xt && !e.body.alternative && !e.alternative) {
                e = Te(xt, e, {
                    condition: Te(sn, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (O(e.body) && e.alternative) {
                var b = e.alternative;
                e.alternative = null;
                return Te(rn, e, {
                    body: [ e, b ]
                }).optimize(u);
            }
            if (O(e.alternative)) {
                var n = e.body;
                e.body = e.alternative;
                e.condition = r ? t : e.condition.negate(u);
                e.alternative = null;
                return Te(rn, e, {
                    body: [ e, n ]
                }).optimize(u);
            }
            if (u.option("typeofs")) B(e.condition, e.body, e.alternative);
            return e;
            function y(e, n, t, r) {
                if (e == null) return [];
                if (e instanceof rn) {
                    var i = [];
                    for (var a = 0; a < e.body.length; a++) {
                        var o = e.body[a];
                        if (o instanceof Dn) continue;
                        if (o instanceof mt) {
                            if (i.length == 0) return;
                            o = o.clone();
                            i.push(o.value || Te(Cr, o).transform(u));
                            o.value = Ae(e, i);
                            var s = e.clone();
                            s.body = s.body.slice(a + 1);
                            s.body.unshift(o);
                            return s;
                        }
                        if (o instanceof it) {
                            n.push(o);
                        } else if (o instanceof tn) {
                            if (!u.option("sequences") && i.length > 0) return;
                            i.push(o.body);
                        } else if (o instanceof Ct) {
                            if (!u.option("sequences") && i.length > 0) return;
                            o.remove_initializers(u, t);
                            o.definitions.forEach(f);
                        } else {
                            return;
                        }
                    }
                    return i;
                }
                if (e instanceof it) {
                    n.push(e);
                    return [];
                }
                if (e instanceof Dn) return [];
                if (e instanceof tn) return [ e.body ];
                if (e instanceof Ct) {
                    var i = [];
                    e.remove_initializers(u, t);
                    e.definitions.forEach(f);
                    return i;
                }
                function f(e) {
                    if (!e.value) return;
                    i.push(Te(fn, e, {
                        operator: "=",
                        left: e.name.convert_symbol(un, function(e) {
                            r.push(e);
                        }),
                        right: e.value
                    }));
                }
            }
        });
        e(kt, function(r, t) {
            if (!t.option("switches")) return r;
            if (!t.option("dead_code")) return r;
            var e = [];
            var n;
            var c = [];
            var i;
            var l;
            var a = [];
            for (var o = 0, p = r.body.length; o < p; o++) {
                n = r.body[o];
                if (n instanceof St) {
                    var s = e[e.length - 1];
                    if (i || w(n.body[0], t) && (!s || O(s))) {
                        k(n, s);
                        continue;
                    } else {
                        i = n;
                    }
                } else {
                    var f = n.expression;
                    var d = Te(sn, r, {
                        operator: "===",
                        left: r.expression,
                        right: f
                    }).evaluate(t, true);
                    if (!d) {
                        if (f.has_side_effects(t)) a.push(f);
                        k(n, e[e.length - 1]);
                        continue;
                    }
                    if (!(d instanceof nn)) {
                        if (i) {
                            var v = e.indexOf(i);
                            e.splice(v, 1);
                            k(i, e[v - 1]);
                            i = null;
                        }
                        if (f.has_side_effects(t)) {
                            l = n;
                        } else {
                            i = n = Te(St, n, n);
                        }
                        while (++o < p) k(r.body[o], n);
                    }
                }
                if (o + 1 >= p || O(n)) {
                    var s = e[e.length - 1];
                    var u = n.body;
                    if (O(s)) switch (s.body.length - u.length) {
                      case 1:
                        var h = s.body[s.body.length - 1];
                        if (!w(h, t)) break;
                        u = u.concat(h);

                      case 0:
                        var m = Te(rn, s, s);
                        var _ = Te(rn, n, {
                            body: u
                        });
                        if (m.equivalent_to(_)) s.body = [];
                    }
                }
                if (a.length) {
                    if (n instanceof St) {
                        e.push(Te(Tt, r, {
                            expression: Ae(r, a),
                            body: []
                        }));
                    } else {
                        a.push(n.expression);
                        n.expression = Ae(r, a);
                    }
                    a = [];
                }
                e.push(n);
            }
            if (a.length && !l) {
                e.push(Te(Tt, r, {
                    expression: Ae(r, a),
                    body: []
                }));
            }
            while (n = e[e.length - 1]) {
                var h = n.body[n.body.length - 1];
                if (w(h, t)) n.body.pop();
                if (n === i) {
                    if (!A(n)) break;
                } else if (n.expression.has_side_effects(t)) {
                    break;
                } else if (i) {
                    if (!A(i)) break;
                    if (e[e.length - 2] !== i) break;
                    i.body = i.body.concat(n.body);
                    n.body = [];
                } else if (!A(n)) break;
                k(n);
                if (e.pop() === i) i = null;
            }
            if (!n) {
                c.push(Te(tn, r.expression, {
                    body: r.expression
                }));
                if (a.length) c.push(Te(tn, r, {
                    body: Ae(r, a)
                }));
                return Te(rn, r, {
                    body: c
                }).optimize(t);
            }
            if (n === i) while (n = e[e.length - 2]) {
                if (n instanceof St) break;
                if (!A(n)) break;
                var f = n.expression;
                if (f.has_side_effects(t)) {
                    var s = e[e.length - 3];
                    if (s && !O(s)) break;
                    i.body.unshift(Te(tn, r, {
                        body: f
                    }));
                }
                k(n);
                e.splice(-2, 1);
            }
            e[0].body = c.concat(e[0].body);
            r.body = e;
            if (t.option("conditionals")) switch (e.length) {
              case 1:
                if (!x(e[0])) break;
                var f = e[0].expression;
                var u = e[0].body.slice();
                if (e[0] !== i && e[0] !== l) return Te(xt, r, {
                    condition: Te(sn, r, {
                        operator: "===",
                        left: r.expression,
                        right: f
                    }),
                    body: Te(rn, r, {
                        body: u
                    }),
                    alternative: null
                }).optimize(t);
                if (f) u.unshift(Te(tn, f, {
                    body: f
                }));
                u.unshift(Te(tn, r.expression, {
                    body: r.expression
                }));
                return Te(rn, r, {
                    body: u
                }).optimize(t);

              case 2:
                if (!cn(i, e) || !x(e[1])) break;
                var u = e[0].body.slice();
                var g = u.length && w(u[u.length - 1], t);
                if (g) u.pop();
                if (!en(u, x)) break;
                var b = e[1].body.length && Te(rn, e[1], e[1]);
                var y = Te(xt, r, {
                    condition: Te(sn, r, e[0] === i ? {
                        operator: "!==",
                        left: r.expression,
                        right: e[1].expression
                    } : {
                        operator: "===",
                        left: r.expression,
                        right: e[0].expression
                    }),
                    body: Te(rn, e[0], {
                        body: u
                    }),
                    alternative: g && b || null
                });
                if (!g && b) y = Te(rn, r, {
                    body: [ y, b ]
                });
                return y.optimize(t);
            }
            return r;
            function w(e, n) {
                return e instanceof yt && n.loopcontrol_target(e) === r;
            }
            function x(e) {
                var n = false;
                var t = new Ir(function(e) {
                    if (n || e instanceof Un || e instanceof tn) return true;
                    if (w(e, t)) n = true;
                });
                t.push(r);
                e.walk(t);
                return !n;
            }
            function k(e, n) {
                if (n && !O(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    N(t, e, c);
                }
            }
        });
        e(At, function(e, n) {
            e.body = c(e.body, n);
            if (n.option("dead_code")) {
                if (A(e) && !(e.bcatch && e.bcatch.argname && e.bcatch.argname.match_symbol(function(e) {
                    return e instanceof br && !Se(e);
                }, true))) {
                    var t = [];
                    if (e.bcatch) {
                        N(n, e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof Ct)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    t.unshift(Te(rn, e, e).optimize(n));
                    if (e.bfinally) {
                        t.push(Te(rn, e.bfinally, e.bfinally).optimize(n));
                    }
                    return Te(rn, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && A(e.bfinally)) {
                    var t = Te(rn, e.bfinally, e.bfinally).optimize(n);
                    t = e.body.concat(t);
                    if (!e.bcatch) return Te(rn, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        function W(i) {
            return function(n, t) {
                var r = false;
                this.definitions.forEach(function(e) {
                    if (e.value) r = true;
                    e.name.match_symbol(function(e) {
                        if (e instanceof cr) t.push(Te(Mt, e, {
                            name: e,
                            value: i(n, e)
                        }));
                    }, true);
                });
                return r;
            };
        }
        qt.DEFMETHOD("remove_initializers", W(function(e, n) {
            return Te(Cr, n).optimize(e);
        }));
        zt.DEFMETHOD("remove_initializers", W(mn));
        Ct.DEFMETHOD("remove_initializers", W(mn));
        $t.DEFMETHOD("to_assignments", function() {
            var e = this.definitions.reduce(function(e, t) {
                var n = t.name.definition();
                var r = t.value;
                if (r) {
                    if (r instanceof an) r = r.clone();
                    var i = Te(un, t.name, t.name);
                    var a = Te(fn, t, {
                        operator: "=",
                        left: i,
                        right: r
                    });
                    e.push(a);
                    var o = function() {
                        return a.right;
                    };
                    o.assigns = [ a ];
                    o.direct_access = n.direct_access;
                    o.escaped = n.escaped;
                    i.fixed = o;
                    n.references.forEach(function(e) {
                        var n = e.fixed && e.fixed.assigns;
                        if (n && n[0] === t) n[0] = a;
                    });
                    n.references.push(i);
                }
                n.assignments++;
                n.eliminated++;
                n.single_use = false;
                return e;
            }, []);
            if (e.length == 0) return null;
            return Ae(this, e);
        });
        function ne(e) {
            return e.name != "arguments" && e.orig.length < (e.orig[0] instanceof _r ? 3 : 2);
        }
        function G(e, n) {
            if (e.exposed(n)) return true;
            var t = n.scope.resolve();
            for (var r = n.scope; r !== t; ) {
                r = r.parent_scope;
                if (r.var_names().has(n.name)) return true;
            }
        }
        function J(e) {
            return Te(Ct, e, {
                definitions: e.definitions.map(function(e) {
                    return Te(Mt, e, {
                        name: e.name.convert_symbol(vr, function(e, n) {
                            var t = e.definition();
                            t.orig[t.orig.indexOf(n)] = e;
                            var r = t.scope.resolve();
                            if (t.scope === r) return;
                            t.scope = r;
                            r.variables.set(t.name, t);
                            r.enclosed.push(t);
                            r.var_names().set(t.name, true);
                        }),
                        value: e.value
                    });
                })
            });
        }
        function X(e, n) {
            if (!n.fixed_value()) return false;
            var t = n.definition();
            return ne(t) && Le(t) && !G(e, t);
        }
        function K(e, n) {
            return n.option("varify") && en(e.definitions, function(e) {
                return !e.name.match_symbol(function(e) {
                    if (e instanceof cr) return !X(n, e);
                }, true);
            }) ? J(e) : e;
        }
        e(qt, K);
        e(zt, K);
        function we(e, n) {
            if (!n.option("optional_chains")) return;
            if (e.terminal) do {
                var t = e.expression;
                if (e.optional) {
                    var r = U(n, t, true);
                    if (r == null) return Te(on, e, {
                        operator: "void",
                        expression: t
                    }).optimize(n);
                    if (!(r instanceof nn)) e.optional = false;
                }
                e = t;
            } while ((e.TYPE == "Call" || e instanceof Lt) && !e.terminal);
        }
        function xe(e, n) {
            var t = e.expression;
            if (!(t instanceof an)) return e;
            var r = t.expressions.slice();
            var i = e.clone();
            i.expression = r.pop();
            r.push(i);
            return Ae(e, r);
        }
        function ke(e, t, c) {
            var l = e.expression;
            var n = l instanceof un ? l.fixed_value() : l;
            if (!(n instanceof Un)) return;
            if (n.uses_arguments) return;
            if (n.pinned()) return;
            if (c && c.indexOf(n) < 0) return;
            var r = e.args;
            if (!en(r, function(e) {
                return !(e instanceof Vt);
            })) return;
            var i = n.argnames;
            var p = n === l && !n.name;
            if (n.rest) {
                if (!(p && t.option("rests"))) return;
                var d = i.length;
                r = r.slice(0, d);
                while (r.length < d) r.push(Te(Cr, e).optimize(t));
                r.push(Te(Qt, e, {
                    elements: e.args.slice(d)
                }));
                i = i.concat(n.rest);
                n.rest = null;
            } else {
                r = r.slice();
                i = i.slice();
            }
            var a = 0, v = 0;
            var h = p && t.option("default_values");
            var m = p && t.drop_fargs(n, e) ? function(e, n) {
                if (!e) return true;
                if (e instanceof er) {
                    return e.elements.length == 0 && !e.rest && n instanceof Qt;
                }
                if (e instanceof tr) {
                    return e.properties.length == 0 && !e.rest && n && !n.may_throw_on_access(t);
                }
                return e.unused;
            } : dn;
            var o = [];
            for (var s = 0; s < r.length; s++) {
                var f = i[s];
                if (h && f instanceof It && r[s].is_defined(t)) {
                    i[s] = f = f.name;
                }
                if (!f || f.unused !== undefined) {
                    var u = r[s].drop_side_effect_free(t);
                    if (m(f)) {
                        if (f) i.splice(s, 1);
                        r.splice(s, 1);
                        if (u) o.push(u);
                        s--;
                        continue;
                    } else if (u) {
                        o.push(u);
                        r[a++] = Ae(e, o);
                        o = [];
                    } else if (f) {
                        if (o.length) {
                            r[a++] = Ae(e, o);
                            o = [];
                        } else {
                            r[a++] = Te(Dr, r[s], {
                                value: 0
                            });
                            continue;
                        }
                    }
                } else if (m(f, r[s])) {
                    var u = r[s].drop_side_effect_free(t);
                    i.splice(s, 1);
                    r.splice(s, 1);
                    if (u) o.push(u);
                    s--;
                    continue;
                } else {
                    o.push(r[s]);
                    r[a++] = Ae(e, o);
                    o = [];
                }
                v = a;
            }
            for (;s < i.length; s++) {
                if (m(i[s])) i.splice(s--, 1);
            }
            n.argnames = i;
            r.length = v;
            e.args = r;
            if (!o.length) return;
            var _ = Ae(e, o);
            r.push(r.length < i.length ? Te(on, e, {
                operator: "void",
                expression: _
            }) : _);
        }
        function Ee(e) {
            var n = [];
            if (Jn(e)) n.push("await");
            if (Xn(e)) n.push("yield");
            return n.length && wn(n);
        }
        function He(t, r) {
            if (!r) return true;
            var i = true;
            var a = new Ir(function(e) {
                if (!i) return true;
                if (e instanceof Ln) {
                    if (e === t) return;
                    if (Gn(e)) {
                        for (var n = 0; i && n < e.argnames.length; n++) e.argnames[n].walk(a);
                    } else if (e instanceof it && r[e.name.name]) {
                        i = false;
                    }
                    return true;
                }
                if (e instanceof ur && r[e.name] && e !== t.name) i = false;
            });
            t.walk(a);
            return i;
        }
        e(Ht, function(p, u) {
            var a = p.expression;
            var r = we(p, u);
            if (r) return r;
            if (u.option("sequences")) {
                if (a instanceof Lt) {
                    var i = xe(a, u);
                    if (i !== a) {
                        var o = p.clone();
                        o.expression = i.expressions.pop();
                        i.expressions.push(o);
                        return i.optimize(u);
                    }
                } else if (!le(u, a.tail_node())) {
                    var i = xe(p, u);
                    if (i !== p) return i.optimize(u);
                }
            }
            if (u.option("unused")) ke(p, u);
            if (u.option("unsafe")) {
                if (De(a)) switch (a.name) {
                  case "Array":
                    if (p.args.length == 1) {
                        var s = p.args[0];
                        if (s instanceof Dr) try {
                            var f = s.value;
                            if (f > 6) break;
                            var e = Array(f);
                            for (var l = 0; l < f; l++) e[l] = Te(Mr, p);
                            return Te(Qt, p, {
                                elements: e
                            });
                        } catch (e) {
                            nn.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: f,
                                file: p.start.file,
                                line: p.start.line,
                                col: p.start.col
                            });
                            break;
                        }
                        if (!s.is_boolean(u) && !s.is_string(u)) break;
                    }
                    return Te(Qt, p, {
                        elements: p.args
                    });

                  case "Object":
                    if (p.args.length == 0) return Te(rr, p, {
                        properties: []
                    });
                    break;

                  case "String":
                    if (p.args.length == 0) return Te(Ar, p, {
                        value: ""
                    });
                    if (p.args.length == 1) return Te(sn, p, {
                        operator: "+",
                        left: Te(Ar, p, {
                            value: ""
                        }),
                        right: p.args[0]
                    }).optimize(u);
                    break;

                  case "Number":
                    if (p.args.length == 0) return Te(Dr, p, {
                        value: 0
                    });
                    if (p.args.length == 1) return Te(on, p, {
                        operator: "+",
                        expression: Te(sn, p, {
                            operator: "+",
                            left: Te(Ar, p, {
                                value: ""
                            }),
                            right: p.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "Boolean":
                    if (p.args.length == 0) return Te(jr, p).optimize(u);
                    if (p.args.length == 1) return Te(on, p, {
                        operator: "!",
                        expression: Te(on, p, {
                            operator: "!",
                            expression: p.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "RegExp":
                    var m = [];
                    if (en(p.args, function(e) {
                        var n = e.evaluate(u);
                        m.unshift(n);
                        return e !== n;
                    })) try {
                        return me(u, p, Te($r, p, {
                            value: RegExp.apply(RegExp, m)
                        }));
                    } catch (e) {
                        nn.warn("Error converting {expr} [{file}:{line},{col}]", {
                            expr: p,
                            file: p.start.file,
                            line: p.start.line,
                            col: p.start.col
                        });
                    }
                    break;
                } else if (a instanceof Bt) switch (a.property) {
                  case "toString":
                    var _ = a.expression;
                    if (p.args.length == 0 && !(_.may_throw_on_access(u) || _ instanceof xr)) {
                        return Te(sn, p, {
                            operator: "+",
                            left: Te(Ar, p, {
                                value: ""
                            }),
                            right: _
                        }).optimize(u);
                    }
                    break;

                  case "join":
                    if (a.expression instanceof Qt && p.args.length < 2) e: {
                        var n = p.args[0];
                        if (a.expression.elements.length == 0 && !(n instanceof Vt)) {
                            return n ? Ae(p, [ n, Te(Ar, p, {
                                value: ""
                            }) ]).optimize(u) : Te(Ar, p, {
                                value: ""
                            });
                        }
                        if (n) {
                            n = n.evaluate(u);
                            if (n instanceof nn) break e;
                        }
                        var e = [];
                        var g = [];
                        for (var l = 0; l < a.expression.elements.length; l++) {
                            var b = a.expression.elements[l];
                            var y = b.evaluate(u);
                            if (y !== b) {
                                g.push(y);
                            } else if (b instanceof Vt) {
                                break e;
                            } else {
                                if (g.length > 0) {
                                    e.push(Te(Ar, p, {
                                        value: g.join(n)
                                    }));
                                    g.length = 0;
                                }
                                e.push(b);
                            }
                        }
                        if (g.length > 0) e.push(Te(Ar, p, {
                            value: g.join(n)
                        }));
                        if (e.length == 1) {
                            if (e[0].is_string(u)) return e[0];
                            return Te(sn, e[0], {
                                operator: "+",
                                left: Te(Ar, p, {
                                    value: ""
                                }),
                                right: e[0]
                            });
                        }
                        if (n == "") {
                            var s;
                            if (e[0].is_string(u) || e[1].is_string(u)) {
                                s = e.shift();
                            } else {
                                s = Te(Ar, p, {
                                    value: ""
                                });
                            }
                            return e.reduce(function(e, n) {
                                return Te(sn, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, s).optimize(u);
                        }
                        var t = p.clone();
                        t.expression = t.expression.clone();
                        t.expression.expression = t.expression.expression.clone();
                        t.expression.expression.elements = e;
                        return me(u, p, t);
                    }
                    break;

                  case "charAt":
                    if (p.args.length < 2) {
                        var t = Te(sn, p, {
                            operator: "||",
                            left: Te(Ut, p, {
                                expression: a.expression,
                                property: p.args.length ? Te(sn, p.args[0], {
                                    operator: "|",
                                    left: Te(Dr, p, {
                                        value: 0
                                    }),
                                    right: p.args[0]
                                }) : Te(Dr, p, {
                                    value: 0
                                })
                            }).optimize(u),
                            right: Te(Ar, p, {
                                value: ""
                            })
                        });
                        t.is_string = vn;
                        return t.optimize(u);
                    }
                    break;

                  case "apply":
                    if (p.args.length == 2 && p.args[1] instanceof Qt) {
                        var w = p.args[1].elements.slice();
                        w.unshift(p.args[0]);
                        return Te(Ht, p, {
                            expression: Te(Bt, a, {
                                expression: a.expression,
                                property: "call"
                            }),
                            args: w
                        }).optimize(u);
                    }
                    break;

                  case "call":
                    var x = a.expression;
                    if (x instanceof un) {
                        x = x.fixed_value();
                    }
                    if (x instanceof Un && !x.contains_this()) {
                        return (p.args.length ? Ae(this, [ p.args[0], Te(Ht, p, {
                            expression: a.expression,
                            args: p.args.slice(1)
                        }) ]) : Te(Ht, p, {
                            expression: a.expression,
                            args: []
                        })).optimize(u);
                    }
                    break;
                }
            }
            if (u.option("unsafe_Function") && De(a) && a.name == "Function") {
                if (p.args.length == 0) return Te(tt, p, {
                    argnames: [],
                    body: []
                }).init_vars(a.scope);
                if (en(p.args, function(e) {
                    return e instanceof Ar;
                })) {
                    try {
                        var k = "n(function(" + p.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join() + "){" + p.args[p.args.length - 1].value + "})";
                        var E = Vr(k);
                        var S = {
                            ie: u.option("ie")
                        };
                        E.figure_out_scope(S);
                        var T = new Xr(u.options);
                        E = E.transform(T);
                        E.figure_out_scope(S);
                        E.compute_char_frequency(S);
                        E.mangle_names(S);
                        var A;
                        E.walk(new Ir(function(e) {
                            if (A) return true;
                            if (e instanceof Un) {
                                A = e;
                                return true;
                            }
                        }));
                        var k = Kr();
                        rn.prototype._codegen.call(A, k);
                        p.args = [ Te(Ar, p, {
                            value: A.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join()
                        }), Te(Ar, p.args[p.args.length - 1], {
                            value: k.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return p;
                    } catch (e) {
                        if (e instanceof Lr) {
                            nn.warn("Error parsing code passed to new Function [{file}:{line},{col}]", p.args[p.args.length - 1].start);
                            nn.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var d = a instanceof un ? a.fixed_value() : a;
            var D = u.parent(), O = u.self();
            var $ = d instanceof Un && (!Jn(d) || u.option("awaits") && D instanceof Xt) && (!Xn(d) || u.option("yields") && O instanceof Kt && O.nested);
            var q = $ && d.first_statement();
            var c = 0, z = false;
            var C = !en(p.args, function(e) {
                return !(e instanceof Vt);
            });
            var M = $ && en(d.argnames, function(e, n) {
                if (c == 1 && p.args[n] instanceof Vt) c = 2;
                if (e instanceof It) {
                    if (!c) c = 1;
                    var t = c == 1 && p.args[n];
                    if (!Oe(t)) c = 2;
                    if (Ze(d, e.value)) return false;
                    e = e.name;
                }
                if (e instanceof Zt) {
                    z = true;
                    if (Ze(d, e)) return false;
                }
                return true;
            }) && !(d.rest instanceof Zt && Ze(d, d.rest));
            var F = M && u.option("inline") && !p.is_expr_pure(u);
            if (F && q instanceof _t) {
                var y = q.value;
                if (a === d && !d.name && (!y || y.is_constant_expression()) && He(d, Ee(u.find_parent(Ln)))) {
                    return Ae(p, W(y)).optimize(u);
                }
            }
            if ($) {
                var P, y, j = false;
                if (F && !d.uses_arguments && !d.pinned() && !(d.name && d instanceof Wn) && (a === d || !Re(u, P = a.definition(), d) && d.is_constant_expression(fe(u))) && (y = X(q)) && !d.contains_this()) {
                    var N = a === d || P.single_use && P.references.length - P.replaced == 1;
                    if (Q()) {
                        var w = p.args.slice();
                        var I = [];
                        var H = y.clone(true).transform(new Hr(function(e) {
                            if (e instanceof un) {
                                var n = e.definition();
                                if (d.variables.get(e.name) !== n) {
                                    I.push(e);
                                    return e;
                                }
                                var t = K(n);
                                var r = w[t];
                                if (!r) return Te(Cr, p);
                                w[t] = null;
                                var i = this.parent();
                                return i ? Fe(u, i, e, r) : r;
                            }
                        }));
                        var Y = d.inlined;
                        if (a !== d) d.inlined = true;
                        var R = [];
                        w.forEach(function(e) {
                            if (!e) return;
                            e = e.clone(true);
                            e.walk(new Ir(function(e) {
                                if (e instanceof un) I.push(e);
                            }));
                            R.push(e);
                        }, []);
                        R.push(H);
                        var t = Ae(p, R).optimize(u);
                        d.inlined = Y;
                        t = Fe(u, D, O, t);
                        if (N || he(t, p) === t) {
                            I.forEach(function(e) {
                                e.scope = a === d ? d.parent_scope : a.scope;
                                e.reference();
                                var n = e.definition();
                                if (N) n.replaced++;
                                n.single_use = false;
                            });
                            return t;
                        } else if (!t.has_side_effects(u)) {
                            p.drop_side_effect_free = function(e, n) {
                                var t = this;
                                var r = t.args.slice();
                                r.unshift(t.expression);
                                return Ae(t, r).drop_side_effect_free(e, n);
                            };
                        }
                    }
                    var L, B, v, h;
                    if (N && te()) {
                        d._squeezed = true;
                        if (a !== d) d.parent_scope = a.scope;
                        var t = Ae(p, se()).optimize(u);
                        return Fe(u, D, O, t);
                    }
                }
                if (u.option("side_effects") && M && en(d.body, pe) && (d === a ? ye(d, u) : !c && !z && !d.rest) && !(Gn(d) && d.value) && He(d, Ee(u.find_parent(Ln)))) {
                    return Ae(p, W()).optimize(u);
                }
            }
            if (u.option("drop_console")) {
                if (a instanceof Lt) {
                    var U = a.expression;
                    while (U.expression) {
                        U = U.expression;
                    }
                    if (De(U) && U.name == "console") {
                        return Te(Cr, p).optimize(u);
                    }
                }
            }
            if (u.option("negate_iife") && D instanceof tn && de(O)) {
                return p.negate(u, true);
            }
            return _e(u, p);
            function V(e) {
                return Te(Bt, e, {
                    expression: Te(Qt, e, {
                        elements: []
                    }),
                    property: "e"
                });
            }
            function W(e) {
                var n = p.args.slice();
                var t = c > 1 || z || d.rest;
                if (t || C) n = [ Te(Qt, p, {
                    elements: n
                }) ];
                if (t) {
                    var o = new Hr(function(r, e) {
                        if (r instanceof It) return Te(It, r, {
                            name: r.name.transform(o) || V(r),
                            value: r.value
                        });
                        if (r instanceof er) {
                            var t = [];
                            r.elements.forEach(function(e, n) {
                                e = e.transform(o);
                                if (e) t[n] = e;
                            });
                            ge(r, t);
                            return Te(er, r, {
                                elements: t
                            });
                        }
                        if (r instanceof tr) {
                            var i = [], a = [];
                            r.properties.forEach(function(e) {
                                var n = e.key;
                                var t = e.value.transform(o);
                                if (t) {
                                    if (a.length) {
                                        if (!(n instanceof nn)) n = ce(n, e);
                                        a.push(n);
                                        n = Ae(r, a);
                                        a = [];
                                    }
                                    i.push(Te(nr, e, {
                                        key: n,
                                        value: t
                                    }));
                                } else if (n instanceof nn) {
                                    a.push(n);
                                }
                            });
                            if (a.length) i.push(Te(nr, r, {
                                key: Ae(r, a),
                                value: V(r)
                            }));
                            return Te(tr, r, {
                                properties: i
                            });
                        }
                        if (r instanceof hr) return null;
                    });
                    var r = [];
                    d.argnames.forEach(function(e, n) {
                        e = e.transform(o);
                        if (e) r[n] = e;
                    });
                    var i = d.rest && d.rest.transform(o);
                    if (i) r.length = d.argnames.length;
                    ge(d, r);
                    n[0] = Te(fn, p, {
                        operator: "=",
                        left: Te(er, d, {
                            elements: r,
                            rest: i
                        }),
                        right: n[0]
                    });
                } else d.argnames.forEach(function(e) {
                    if (e instanceof It) n.push(e.value);
                });
                n.push(e || Te(Cr, p));
                return n;
            }
            function G() {
                return p.call_only ? Te(Dr, p, {
                    value: 0
                }) : Te(Cr, p);
            }
            function J(e) {
                if (!e) return G();
                if (e instanceof _t) return e.value || G();
                if (e instanceof tn) {
                    return p.call_only ? e.body : Te(on, e, {
                        operator: "void",
                        expression: e.body
                    });
                }
            }
            function X(e) {
                var n = d.body.length;
                if (n < 2) {
                    e = J(e);
                    if (e) return e;
                }
                if (u.option("inline") < 3) return false;
                e = null;
                for (var t = 0; t < n; t++) {
                    var r = d.body[t];
                    if (r instanceof Ct) {
                        if (j) {
                            if (!e) continue;
                            if (!(e instanceof tn)) return false;
                            if (!ve(r)) e = null;
                        } else if (!ve(r)) {
                            if (e && !(e instanceof tn)) return false;
                            e = null;
                            j = true;
                        }
                    } else if (r instanceof at || r instanceof st || r instanceof Dn) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = r;
                    }
                }
                return J(e);
            }
            function K(e) {
                for (var n = d.argnames.length; --n >= 0; ) {
                    if (d.argnames[n].definition() === e) return n;
                }
            }
            function Q() {
                if (c || z || C || j || d.rest) return;
                if (u.option("inline") < 2 && d.argnames.length) return;
                if (!d.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof hr;
                })) return;
                var n = u.find_parent(Ln);
                var i = false;
                var a = Ee(n);
                var o;
                var s = [];
                var f = false;
                y.walk(new Ir(function(e, n) {
                    if (i) return true;
                    if (e instanceof sn && $e[e.operator] || e instanceof Jt) {
                        s = null;
                        return;
                    }
                    if (e instanceof Ln) return i = true;
                    if (a && e instanceof ur && a[e.name]) return i = true;
                    if (e instanceof un) {
                        var t = e.definition();
                        if (d.variables.get(e.name) !== t) {
                            s = null;
                            return;
                        }
                        if (t.init instanceof it) return i = true;
                        if (Jr(e, this.parent())) return i = true;
                        var r = K(t);
                        if (!(o < r)) o = r;
                        if (!s) return;
                        if (f) {
                            s = null;
                        } else {
                            s.push(d.argnames[r]);
                        }
                        return;
                    }
                    if (e.has_side_effects(u)) {
                        n();
                        f = true;
                        return true;
                    }
                }));
                if (i) return;
                var e = p.args.length;
                if (s && d.argnames.length >= e) {
                    e = d.argnames.length;
                    while (e-- > o && d.argnames[e] === s.pop());
                    e++;
                }
                return e <= o || en(p.args.slice(o, e), f && !s ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(u);
                });
            }
            function Z(e, n) {
                return e.has(n) || ue[n] || h.var_names().has(n);
            }
            function ee(n, t) {
                var r = false;
                d.each_argname(function(e) {
                    if (r) return;
                    if (e.unused) return;
                    if (!t || Z(n, e.name)) return r = true;
                    L.set(e.name, true);
                    if (v) v.push(e.definition());
                });
                return !r;
            }
            function ne(n, e) {
                for (var t = 0; t < d.body.length; t++) {
                    var r = d.body[t];
                    if (r instanceof it) {
                        var i = r.name;
                        if (!e) return false;
                        if (L.has(i.name)) return false;
                        if (Z(n, i.name)) return false;
                        if (!en(r.enclosed, function(e) {
                            return e.scope === h || e.scope === r || !n.has(e.name);
                        })) return false;
                        if (v) v.push(i.definition());
                        continue;
                    }
                    if (!(r instanceof Ct)) continue;
                    if (!e) return false;
                    for (var a = r.definitions.length; --a >= 0; ) {
                        var i = r.definitions[a].name;
                        if (Z(n, i.name)) return false;
                        if (v) v.push(i.definition());
                    }
                }
                return true;
            }
            function te() {
                var n = new xn();
                var e = 0, t;
                h = O;
                do {
                    if (h.variables) h.variables.each(function(e) {
                        n.set(e.name, true);
                    });
                    t = h;
                    h = u.parent(e++);
                    if (h instanceof Fn) {
                        v = [];
                    } else if (h instanceof Nn) {
                        if (h.init === t) continue;
                        v = [];
                    } else if (h instanceof In) {
                        if (h.init === t) continue;
                        if (h.object === t) continue;
                        v = [];
                    }
                } while (!(h instanceof Ln));
                B = h.body.indexOf(t) + 1;
                if (!B) return false;
                if (!He(d, Ee(h))) return false;
                var r = a !== d || d.parent_scope.resolve() === h;
                if (h instanceof Bn) {
                    if (u.toplevel.vars) {
                        n.set("arguments", true);
                    } else {
                        r = false;
                    }
                }
                L = new xn();
                var i = u.option("inline");
                if (!ee(n, i >= 2 && r)) return false;
                if (!ne(n, i >= 3 && r)) return false;
                return !v || v.length == 0 || !We(d, v);
            }
            function re(e, n, t, r) {
                var i = t.definition();
                if (!h.var_names().has(t.name)) {
                    h.var_names().set(t.name, true);
                    e.push(Te(Mt, t, {
                        name: t,
                        value: null
                    }));
                }
                h.variables.set(t.name, i);
                h.enclosed.push(i);
                if (!r) return;
                var a = Te(un, t, t);
                i.references.push(a);
                n.push(Te(fn, p, {
                    operator: "=",
                    left: a,
                    right: r
                }));
            }
            function ie(e, n) {
                var t = d.argnames.length;
                for (var r = p.args.length; --r >= t; ) {
                    n.push(p.args[r]);
                }
                var i = [];
                for (r = t; --r >= 0; ) {
                    var a = d.argnames[r];
                    var o;
                    if (a instanceof It) {
                        i.push(a);
                        o = a.name;
                    } else {
                        o = a;
                    }
                    var s = p.args[r];
                    if (o.unused || h.var_names().has(o.name)) {
                        if (s) n.push(s);
                    } else {
                        var f = Te(vr, o, o);
                        var c = o.definition();
                        c.orig.push(f);
                        c.eliminated++;
                        if (o.unused !== undefined) {
                            re(e, n, f);
                            if (s) n.push(s);
                        } else {
                            if (!s && v && a === o) s = Te(Cr, p);
                            re(e, n, f, s);
                        }
                    }
                }
                e.reverse();
                n.reverse();
                for (r = i.length; --r >= 0; ) {
                    var u = i[r];
                    if (u.name.unused !== undefined) {
                        n.push(u.value);
                    } else {
                        var l = Te(un, u.name, u.name);
                        u.name.definition().references.push(l);
                        n.push(Te(fn, u, {
                            operator: "=",
                            left: l,
                            right: u.value
                        }));
                    }
                }
            }
            function ae(i, a) {
                a.push(Te(fn, p, {
                    operator: "=",
                    left: Te(er, p, {
                        elements: d.argnames.map(function(e) {
                            if (e.unused) return Te(Mr, e);
                            return e.convert_symbol(un, n);
                        }),
                        rest: d.rest && d.rest.convert_symbol(un, n)
                    }),
                    right: Te(Qt, p, {
                        elements: p.args.slice()
                    })
                }));
                function n(e, n) {
                    var t = n.definition();
                    t.references.push(e);
                    var r = Te(vr, n, n);
                    t.orig.push(r);
                    t.eliminated++;
                    re(i, a, r);
                }
            }
            function oe(r, e) {
                var t = [ B, 0 ];
                var s = [], i = [], f = [], u = [], c = [];
                d.body.filter(v ? function(e) {
                    if (!(e instanceof it)) return true;
                    var n = Te(vr, e.name, Qe(e.name));
                    var t = n.definition();
                    t.fixed = false;
                    t.orig.push(n);
                    t.eliminated++;
                    re(r, i, n, be(e, true));
                    return false;
                } : function(e) {
                    if (!(e instanceof it)) return true;
                    var n = e.name.definition();
                    h.functions.set(n.name, n);
                    h.variables.set(n.name, n);
                    h.enclosed.push(n);
                    h.var_names().set(n.name, true);
                    t.push(e);
                    return false;
                }).forEach(function(e) {
                    if (!(e instanceof Ct)) {
                        if (e instanceof tn) c.push(e.body);
                        return;
                    }
                    for (var n = 0; n < e.definitions.length; n++) {
                        var t = e.definitions[n];
                        var r = Qe(t.name);
                        var i = t.value;
                        if (i && c.length > 0) {
                            c.push(i);
                            i = Ae(t, c);
                            c = [];
                        }
                        re(s, f, r, i);
                        if (!v) continue;
                        if (L.has(r.name)) continue;
                        var a = r.definition();
                        if (a.orig.length == 1 && d.functions.has(r.name)) continue;
                        var o = Te(un, r, r);
                        a.assignments++;
                        a.references.push(o);
                        u.push(Te(fn, t, {
                            operator: "=",
                            left: o,
                            right: Te(Cr, r)
                        }));
                    }
                });
                [].push.apply(r, s);
                [].push.apply(e, u);
                [].push.apply(e, i);
                [].push.apply(e, f);
                return t;
            }
            function se() {
                var e = [];
                var n = [];
                if (c > 1 || z || C || d.rest) {
                    ae(e, n);
                } else {
                    ie(e, n);
                }
                var t = oe(e, n);
                n.push(y);
                if (e.length) t.push(Te(Ct, d, {
                    definitions: e
                }));
                [].splice.apply(h.body, t);
                d.enclosed.forEach(function(e) {
                    if (h.var_names().has(e.name)) return;
                    h.enclosed.push(e);
                    h.var_names().set(e.name, true);
                });
                return n;
            }
        });
        e(Yt, function(e, n) {
            if (n.option("sequences")) {
                var t = xe(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unused")) ke(e, n);
            if (n.option("unsafe")) {
                var r = e.expression;
                if (De(r)) {
                    switch (r.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return Te(Ht, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        function te(t, r, e, n) {
            if (!(n instanceof sn)) return;
            if (!(n.operator == "&&" || n.operator == "||")) return;
            if (!(n.right instanceof fn)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof un)) return;
            if (n.right.left.definition() !== r) return;
            if (e.has_side_effects(t)) return;
            if (!i(n.left)) return;
            if (!i(n.right.right)) return;
            r.replaced++;
            return n.operator == "&&" ? Te(Jt, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : Te(Jt, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function i(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new Ir(function(e) {
                    if (n) return true;
                    if (e instanceof un && e.definition() === r) return n = true;
                }));
                return !n;
            }
        }
        e(an, function(e, a) {
            var o = n();
            var s = o.length - 1;
            r();
            t();
            if (s == 0) {
                e = Fe(a, a.parent(), a.self(), o[0]);
                if (!(e instanceof an)) e = e.optimize(a);
                return e;
            }
            e.expressions = o;
            return e;
            function n() {
                if (!a.option("side_effects")) return e.expressions;
                var t = [];
                var r = En(a);
                var i = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < i) e = e.drop_side_effect_free(a, r);
                    if (e) {
                        S(t, e);
                        r = false;
                    }
                });
                return t;
            }
            function t() {
                if (!a.option("side_effects")) return;
                while (s > 0 && Oe(o[s], a)) s--;
                if (s < o.length - 1) {
                    o[s] = Te(on, e, {
                        operator: "void",
                        expression: o[s]
                    });
                    o.length = s + 1;
                }
            }
            function f(e) {
                return e instanceof fn && e.operator == "=" && e.left instanceof un && e.left.definition();
            }
            function r() {
                for (var e = 1; e < s; e++) {
                    var n = o[e - 1];
                    var t = f(n);
                    if (!t) continue;
                    var r = o[e];
                    if (a.option("conditionals")) {
                        var i = te(a, t, n.right, r);
                        if (i) {
                            n.right = i;
                            o.splice(e--, 1);
                            s--;
                            continue;
                        }
                    }
                    if (a.option("dead_code") && f(r) === t && r.right.is_constant_expression(t.scope.resolve())) {
                        o[--e] = n.right;
                    }
                }
            }
        });
        e(Gt, function(e, n) {
            if (n.option("sequences")) {
                var t = xe(e, n);
                if (t !== e) return t.optimize(n);
            }
            return _e(n, e);
        });
        var re = wn("+ -");
        var ie = wn("* / %");
        e(on, function(e, n) {
            var t = e.operator;
            var r = e.expression;
            if (n.option("sequences") && s()) {
                var i = xe(e, n);
                if (i !== e) return i.optimize(n);
            }
            switch (t) {
              case "-":
                if (r instanceof Fr) r = r.transform(n);
                if (r instanceof Dr || r instanceof Fr) return e;
                break;

              case "!":
                if (!n.option("booleans")) break;
                if (r.is_truthy()) return Ae(e, [ r, Te(jr, e) ]).optimize(n);
                if (n.in_boolean_context()) {
                    if (r instanceof on && r.operator == "!") return r.expression;
                    if (r instanceof sn) {
                        e = me(n, e, r.negate(n, En(n)));
                    }
                }
                break;

              case "delete":
                if (!n.option("evaluate")) break;
                if (o(r)) break;
                return Ae(e, [ r, Te(Nr, e) ]).optimize(n);

              case "typeof":
                if (!n.option("booleans")) break;
                if (!n.in_boolean_context()) break;
                nn.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                var a = [ Te(Nr, e) ];
                if (!(r instanceof un && Se(r, n))) a.unshift(r);
                return Ae(e, a).optimize(n);

              case "void":
                if (!n.option("side_effects")) break;
                r = r.drop_side_effect_free(n);
                if (!r) return Te(Cr, e).optimize(n);
                e.expression = r;
                return e;
            }
            if (n.option("evaluate") && r instanceof sn && re[t] && ie[r.operator] && (r.left.is_constant() || !r.right.has_side_effects(n))) {
                return Te(sn, e, {
                    operator: r.operator,
                    left: Te(on, r.left, {
                        operator: t,
                        expression: r.left
                    }),
                    right: r.right
                });
            }
            return _e(n, e);
            function o(e) {
                return e instanceof Fr || e instanceof zr || e instanceof Er || e instanceof Lt || e instanceof un || e instanceof Cr;
            }
            function s() {
                switch (t) {
                  case "delete":
                    return !o(r.tail_node());

                  case "typeof":
                    return !De(r.tail_node());

                  default:
                    return true;
                }
            }
        });
        e(Xt, function(e, n) {
            if (!n.option("awaits")) return e;
            if (n.option("sequences")) {
                var t = xe(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("side_effects")) {
                var r = e.expression;
                if (r instanceof Xt) return r.optimize(n);
                if (r instanceof on && r.expression instanceof Xt) return r.optimize(n);
                for (var i = 0, a = e, o; o = n.parent(i++); a = o) {
                    if (Gn(o)) {
                        if (o.value === a) return r.optimize(n);
                    } else if (o instanceof _t) {
                        var s = true;
                        do {
                            a = o;
                            o = n.parent(i++);
                            if (o instanceof At && (o.bfinally || o.bcatch) !== a) {
                                s = false;
                                break;
                            }
                        } while (o && !(o instanceof Ln));
                        if (s) return r.optimize(n);
                    } else if (o instanceof an) {
                        if (o.tail_node() === a) continue;
                    }
                    break;
                }
            }
            return e;
        });
        e(Kt, function(e, n) {
            if (!n.option("yields")) return e;
            if (n.option("sequences")) {
                var t = xe(e, n);
                if (t !== e) return t.optimize(n);
            }
            var r = e.expression;
            if (e.nested && r.TYPE == "Call") {
                var i = r.clone().optimize(n);
                if (i.TYPE != "Call") return i;
            }
            return e;
        });
        sn.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof Lt) {
                if (!(this.left.expression instanceof an)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return Ae(this, n);
            }
            if (this.left instanceof an) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return Ae(this, n);
            }
            if (this.right instanceof an) {
                if (this.left.has_side_effects(e)) return this;
                var r = this.operator == "=" && this.left instanceof un;
                var n = this.right.expressions;
                var i = n.length - 1;
                for (var a = 0; a < i; a++) {
                    if (!r && n[a].has_side_effects(e)) break;
                }
                if (a == i) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return Ae(this, n);
                }
                if (a > 0) {
                    var t = this.clone();
                    t.right = Ae(this.right, n.slice(a));
                    n = n.slice(0, a);
                    n.push(t);
                    return Ae(this, n);
                }
            }
            return this;
        });
        var ae = wn("indexOf lastIndexOf");
        var oe = wn("== === != !== * & | ^");
        function Ye(e) {
            if (e instanceof fn) return e.operator == "=" && Ye(e.right);
            if (e instanceof an) return Ye(e.tail_node());
            if (e instanceof un) return Ye(e.fixed_value());
            return e instanceof Qt || e instanceof ut || e instanceof Un || e instanceof Yt || e instanceof rr;
        }
        function k(e, n) {
            if (n.is_constant()) return true;
            if (n instanceof fn) return n.operator != "=" || k(e, n.right);
            if (n instanceof sn) {
                return !$e[n.operator] || k(e, n.left) && k(e, n.right);
            }
            if (n instanceof Jt) {
                return k(e, n.consequent) && k(e, n.alternative);
            }
            if (n instanceof an) return k(e, n.tail_node());
            if (n instanceof un) {
                var t = n.fixed_value();
                return t && k(e, t);
            }
            if (n instanceof Sr) return !n.tag || Be(e, n.tag);
            if (n instanceof Wt) return true;
        }
        function se(e, n) {
            if (n instanceof Bt) return se(e, n.expression);
            if (n instanceof Ut) {
                return se(e, n.expression) && se(e, n.property);
            }
            if (n instanceof ur) return true;
            return !n.has_side_effects(e);
        }
        e(sn, function(r, o) {
            if (oe[r.operator] && r.right.is_constant() && !r.left.is_constant() && !(r.left instanceof sn && Ur[r.left.operator] >= Ur[r.operator])) {
                D();
            }
            if (o.option("sequences")) {
                var c = r.lift_sequences(o);
                if (c !== r) return c.optimize(o);
            }
            if (o.option("assignments") && $e[r.operator]) {
                var e = r.right;
                if (r.left instanceof un && e instanceof fn && e.operator == "=" && r.left.equivalent_to(e.left)) {
                    r.right = e.right;
                    e.right = r;
                    return e;
                }
            }
            if (o.option("comparisons")) switch (r.operator) {
              case "===":
              case "!==":
                if (Oe(r.left, o) && r.right.is_defined(o)) {
                    nn.warn("Expression always defined [{file}:{line},{col}]", r.start);
                    return Ae(r, [ r.right, Te(r.operator == "===" ? jr : Nr, r) ]).optimize(o);
                }
                var l = true;
                if (r.left.is_string(o) && r.right.is_string(o) || r.left.is_number(o) && r.right.is_number(o) || r.left.is_boolean(o) && r.right.is_boolean(o) || se(o, r.left) && r.left.equivalent_to(r.right)) {
                    r.operator = r.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!l && Oe(r.left, o)) {
                    r.left = Te(qr, r.left);
                } else if (o.option("typeofs") && r.left instanceof Ar && r.left.value == "undefined" && r.right instanceof on && r.right.operator == "typeof") {
                    var n = r.right.expression;
                    if (n instanceof un ? n.is_declared(o) : !(n instanceof Lt && o.option("ie"))) {
                        r.right = n;
                        r.left = Te(Cr, r.left).optimize(o);
                        if (r.operator.length == 2) r.operator += "=";
                    }
                } else if (r.left instanceof un && r.right instanceof un && r.left.definition() === r.right.definition() && Ye(r.left)) {
                    return Te(r.operator[0] == "=" ? Nr : jr, r).optimize(o);
                }
                break;

              case "&&":
              case "||":
                var t = r.left;
                if (t.operator == r.operator) {
                    t = t.right;
                }
                if (t instanceof sn && t.operator == (r.operator == "&&" ? "!==" : "===") && r.right instanceof sn && t.operator == r.right.operator && (Oe(t.left, o) && r.right.left instanceof qr || t.left instanceof qr && Oe(r.right.left, o)) && !t.right.has_side_effects(o) && t.right.equivalent_to(r.right.right)) {
                    var p = Te(sn, r, {
                        operator: t.operator.slice(0, -1),
                        left: Te(qr, r),
                        right: t.right
                    });
                    if (t !== r.left) {
                        p = Te(sn, r, {
                            operator: r.operator,
                            left: r.left.left,
                            right: p
                        });
                    }
                    return p;
                }
                break;
            }
            var i = false;
            var a = o.parent();
            if (o.option("booleans")) {
                var t = r.left;
                if ($e[r.operator] && !t.has_side_effects(o)) {
                    if (t.equivalent_to(r.right)) {
                        return Fe(o, a, o.self(), t).optimize(o);
                    }
                    V(o, t);
                }
                i = o.in_boolean_context();
            }
            if (i) switch (r.operator) {
              case "+":
                var s = r.left.evaluate(o);
                var f = r.right.evaluate(o);
                if (s && typeof s == "string") {
                    nn.warn("+ in boolean context always true [{file}:{line},{col}]", r.start);
                    return Ae(r, [ r.right, Te(Nr, r) ]).optimize(o);
                }
                if (f && typeof f == "string") {
                    nn.warn("+ in boolean context always true [{file}:{line},{col}]", r.start);
                    return Ae(r, [ r.left, Te(Nr, r) ]).optimize(o);
                }
                break;

              case "==":
                if (r.left instanceof Ar && r.left.value == "" && r.right.is_string(o)) {
                    return Te(on, r, {
                        operator: "!",
                        expression: r.right
                    }).optimize(o);
                }
                break;

              case "!=":
                if (r.left instanceof Ar && r.left.value == "" && r.right.is_string(o)) {
                    return r.right.optimize(o);
                }
                break;
            }
            if (o.option("comparisons") && r.is_boolean(o)) {
                if (!(a instanceof sn) || a instanceof fn) {
                    var d = me(o, r, Te(on, r, {
                        operator: "!",
                        expression: r.negate(o, En(o))
                    }));
                    if (d !== r) return d;
                }
                switch (r.operator) {
                  case ">":
                    D("<");
                    break;

                  case ">=":
                    D("<=");
                    break;
                }
            }
            if (o.option("conditionals") && $e[r.operator] && r.right instanceof sn && r.operator == r.right.operator) {
                O();
            }
            if (o.option("strings") && r.operator == "+") {
                if (r.right instanceof Ar && r.right.value == "" && r.left.is_string(o)) {
                    return r.left.optimize(o);
                }
                if (r.left instanceof Ar && r.left.value == "" && r.right.is_string(o)) {
                    return r.right.optimize(o);
                }
                if (r.left instanceof sn && r.left.operator == "+" && r.left.left instanceof Ar && r.left.left.value == "" && r.right.is_string(o) && (r.left.right.is_constant() || !r.right.has_side_effects(o))) {
                    r.left = r.left.right;
                    return r.optimize(o);
                }
                if (r.right instanceof sn && r.operator == r.right.operator && (r.left.is_string(o) && r.right.is_string(o) || r.right.left.is_string(o) && (r.left.is_constant() || !r.right.right.has_side_effects(o)))) {
                    O();
                }
            }
            if (o.option("evaluate")) {
                var v = true;
                switch (r.operator) {
                  case "&&":
                    var s = U(o, r.left);
                    if (!s) {
                        nn.warn("Condition left of && always false [{file}:{line},{col}]", r.start);
                        return Fe(o, a, o.self(), r.left).optimize(o);
                    } else if (!(s instanceof nn)) {
                        nn.warn("Condition left of && always true [{file}:{line},{col}]", r.start);
                        return Ae(r, [ r.left, r.right ]).optimize(o);
                    }
                    var f = r.right.evaluate(o);
                    if (!f) {
                        if (i) {
                            nn.warn("Boolean && always false [{file}:{line},{col}]", r.start);
                            return Ae(r, [ r.left, Te(jr, r) ]).optimize(o);
                        } else r.falsy = true;
                    } else if (!(f instanceof nn)) {
                        if (i || a.operator == "&&" && a.left === o.self()) {
                            nn.warn("Dropping side-effect-free && [{file}:{line},{col}]", r.start);
                            return r.left.optimize(o);
                        }
                    }
                    if (r.left.operator == "||") {
                        var h = U(o, r.left.right);
                        if (!h) return Te(Jt, r, {
                            condition: r.left.left,
                            consequent: r.right,
                            alternative: r.left.right
                        }).optimize(o);
                    }
                    break;

                  case "??":
                    var u = true;

                  case "||":
                    var s = U(o, r.left, u);
                    if (u ? s == null : !s) {
                        nn.warn("Condition left of {operator} always {value} [{file}:{line},{col}]", {
                            operator: r.operator,
                            value: u ? "nulish" : "false",
                            file: r.start.file,
                            line: r.start.line,
                            col: r.start.col
                        });
                        return Ae(r, [ r.left, r.right ]).optimize(o);
                    } else if (!(s instanceof nn)) {
                        nn.warn("Condition left of {operator} always {value} [{file}:{line},{col}]", {
                            operator: r.operator,
                            value: u ? "defined" : "true",
                            file: r.start.file,
                            line: r.start.line,
                            col: r.start.col
                        });
                        return Fe(o, a, o.self(), r.left).optimize(o);
                    }
                    var f = r.right.evaluate(o);
                    if (!f) {
                        if (i || a.operator == "||" && a.left === o.self()) {
                            nn.warn("Dropping side-effect-free {operator} [{file}:{line},{col}]", {
                                operator: r.operator,
                                file: r.start.file,
                                line: r.start.line,
                                col: r.start.col
                            });
                            return r.left.optimize(o);
                        }
                    } else if (!u && !(f instanceof nn)) {
                        if (i) {
                            nn.warn("Boolean || always true [{file}:{line},{col}]", r.start);
                            return Ae(r, [ r.left, Te(Nr, r) ]).optimize(o);
                        } else r.truthy = true;
                    }
                    if (!u && r.left.operator == "&&") {
                        var h = U(o, r.left.right);
                        if (h && !(h instanceof nn)) return Te(Jt, r, {
                            condition: r.left.left,
                            consequent: r.left.right,
                            alternative: r.right
                        }).optimize(o);
                    }
                    break;

                  case "+":
                    if (r.left instanceof Tr && r.right instanceof sn && r.right.operator == "+" && r.right.left instanceof Tr && r.right.is_string(o)) {
                        r = Te(sn, r, {
                            operator: "+",
                            left: Te(Ar, r.left, {
                                value: "" + r.left.value + r.right.left.value,
                                start: r.left.start,
                                end: r.right.left.end
                            }),
                            right: r.right.right
                        });
                    }
                    if (r.right instanceof Tr && r.left instanceof sn && r.left.operator == "+" && r.left.right instanceof Tr && r.left.is_string(o)) {
                        r = Te(sn, r, {
                            operator: "+",
                            left: r.left.left,
                            right: Te(Ar, r.right, {
                                value: "" + r.left.right.value + r.right.value,
                                start: r.left.right.start,
                                end: r.right.end
                            })
                        });
                    }
                    if (r.right instanceof on && r.right.operator == "-" && r.left.is_number(o)) {
                        r = Te(sn, r, {
                            operator: "-",
                            left: r.left,
                            right: r.right.expression
                        });
                        break;
                    }
                    if (r.left instanceof on && r.left.operator == "-" && A() && r.right.is_number(o)) {
                        r = Te(sn, r, {
                            operator: "-",
                            left: r.right,
                            right: r.left.expression
                        });
                        break;
                    }
                    if (o.option("unsafe_math") && r.left instanceof sn && Ur[r.left.operator] == Ur[r.operator] && r.right.is_constant() && (r.right.is_boolean(o) || r.right.is_number(o)) && r.left.is_number(o) && !r.left.right.is_constant() && (r.left.left.is_boolean(o) || r.left.left.is_number(o))) {
                        r = Te(sn, r, {
                            operator: r.left.operator,
                            left: Te(sn, r, {
                                operator: r.operator,
                                left: r.right,
                                right: r.left.left
                            }),
                            right: r.left.right
                        });
                        break;
                    }

                  case "-":
                    if (r.right instanceof on && r.right.operator == "-" && r.left.is_number(o) && r.right.expression.is_number(o)) {
                        r = Te(sn, r, {
                            operator: "+",
                            left: r.left,
                            right: r.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    v = o.option("unsafe_math");
                    if (r.operator != "+") [ "left", "right" ].forEach(function(e) {
                        var n = r[e];
                        if (n instanceof on && n.operator == "+") {
                            var t = n.expression;
                            if (t.is_boolean(o) || t.is_number(o) || t.is_string(o)) {
                                r[e] = t;
                            }
                        }
                    });

                  case "&":
                  case "|":
                  case "^":
                    if (r.operator != "-" && r.operator != "/" && (r.left.is_boolean(o) || r.left.is_number(o)) && (r.right.is_boolean(o) || r.right.is_number(o)) && A() && !(r.left instanceof sn && r.left.operator != r.operator && Ur[r.left.operator] >= Ur[r.operator])) {
                        var m = Te(sn, r, {
                            operator: r.operator,
                            left: r.right,
                            right: r.left
                        });
                        if (r.right instanceof Tr && !(r.left instanceof Tr)) {
                            r = me(o, m, r);
                        } else {
                            r = me(o, r, m);
                        }
                    }
                    if (!v || !r.is_number(o)) break;
                    if (r.right instanceof sn && r.right.operator != "%" && Ur[r.right.operator] == Ur[r.operator] && r.right.is_number(o) && (r.operator != "+" || r.right.left.is_boolean(o) || r.right.left.is_number(o)) && (r.operator != "-" || !r.left.is_negative_zero()) && (r.right.left.is_constant_expression() || !r.right.right.has_side_effects(o)) && !x(r.right.right)) {
                        r = Te(sn, r, {
                            operator: k(r.operator, r.right.operator),
                            left: Te(sn, r.left, {
                                operator: r.operator,
                                left: r.left,
                                right: r.right.left,
                                start: r.left.start,
                                end: r.right.left.end
                            }),
                            right: r.right.right
                        });
                        if (r.operator == "+" && !r.right.is_boolean(o) && !r.right.is_number(o)) {
                            r.right = Te(on, r.right, {
                                operator: "+",
                                expression: r.right
                            });
                        }
                    }
                    if (r.right instanceof Tr && r.left instanceof sn && r.left.operator != "%" && Ur[r.left.operator] == Ur[r.operator] && r.left.is_number(o)) {
                        if (r.left.left instanceof Tr) {
                            var t = E(r.left, r.operator, r.left.left, r.right, r.left.left.start, r.right.end);
                            r = E(r, r.left.operator, _e(o, t), r.left.right);
                        } else if (r.left.right instanceof Tr) {
                            var _ = k(r.left.operator, r.operator);
                            var g = _e(o, E(r.left, _, r.left.right, r.right));
                            if (g.is_constant() && !(r.left.operator == "-" && r.right.value != 0 && +g.value == 0 && r.left.left.is_negative_zero())) {
                                r = E(r, r.left.operator, r.left.left, g);
                            }
                        }
                    }
                    break;
                }
                if (!(a instanceof on && a.operator == "delete")) {
                    if (r.left instanceof Dr && !r.right.is_constant()) switch (r.operator) {
                      case "+":
                        if (r.left.value == 0) {
                            if (r.right.is_boolean(o)) return Te(on, r, {
                                operator: "+",
                                expression: r.right
                            }).optimize(o);
                            if (r.right.is_number(o) && !r.right.is_negative_zero()) return r.right;
                        }
                        break;

                      case "*":
                        if (r.left.value == 1) {
                            return r.right.is_number(o) ? r.right : Te(on, r, {
                                operator: "+",
                                expression: r.right
                            }).optimize(o);
                        }
                        break;
                    }
                    if (r.right instanceof Dr && !r.left.is_constant()) switch (r.operator) {
                      case "+":
                        if (r.right.value == 0) {
                            if (r.left.is_boolean(o)) return Te(on, r, {
                                operator: "+",
                                expression: r.left
                            }).optimize(o);
                            if (r.left.is_number(o) && !r.left.is_negative_zero()) return r.left;
                        }
                        break;

                      case "-":
                        if (r.right.value == 0) {
                            return r.left.is_number(o) ? r.left : Te(on, r, {
                                operator: "+",
                                expression: r.left
                            }).optimize(o);
                        }
                        break;

                      case "/":
                        if (r.right.value == 1) {
                            return r.left.is_number(o) ? r.left : Te(on, r, {
                                operator: "+",
                                expression: r.left
                            }).optimize(o);
                        }
                        break;
                    }
                }
            }
            if (o.option("typeofs")) switch (r.operator) {
              case "&&":
                B(r.left, r.right, null);
                break;

              case "||":
                B(r.left, null, r.right);
                break;
            }
            if (o.option("unsafe")) {
                var b = S(r.right);
                if (i && b && (r.operator == "==" || r.operator == "!=") && r.left instanceof Dr && r.left.value == 0) {
                    return (r.operator == "==" ? Te(on, r, {
                        operator: "!",
                        expression: r.right
                    }) : r.right).optimize(o);
                }
                var y = S(r.left);
                if (o.option("comparisons") && T()) {
                    var w = Te(on, r, {
                        operator: "!",
                        expression: Te(on, r, {
                            operator: "~",
                            expression: y ? r.left : r.right
                        })
                    });
                    switch (r.operator) {
                      case "<":
                        if (y) break;

                      case "<=":
                      case "!=":
                        w = Te(on, r, {
                            operator: "!",
                            expression: w
                        });
                        break;
                    }
                    return w.optimize(o);
                }
            }
            return _e(o, r);
            function x(e) {
                var n = false;
                e.walk(new Ir(function(e) {
                    if (n) return true;
                    if (e instanceof fn) {
                        if (e.left instanceof Lt) return n = true;
                    } else if (e instanceof Wt) {
                        if (Gr[e.operator] && e.expression instanceof Lt) {
                            return n = true;
                        }
                    }
                }));
                return n;
            }
            function k(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function E(e, n, t, r, i, a) {
                if (n == "+") {
                    if (!t.is_boolean(o) && !t.is_number(o)) {
                        t = Te(on, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                    if (!r.is_boolean(o) && !r.is_number(o)) {
                        r = Te(on, r, {
                            operator: "+",
                            expression: r
                        });
                    }
                }
                return Te(sn, e, {
                    operator: n,
                    left: t,
                    right: r,
                    start: i,
                    end: a
                });
            }
            function S(e) {
                return e.TYPE == "Call" && e.expression instanceof Bt && ae[e.expression.property];
            }
            function T() {
                switch (r.operator) {
                  case "<=":
                    return b && r.left instanceof Dr && r.left.value == 0;

                  case "<":
                    if (y && r.right instanceof Dr && r.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!b) return false;
                    return r.left instanceof Dr && r.left.value == -1 || r.left instanceof on && r.left.operator == "-" && r.left.expression instanceof Dr && r.left.expression.value == 1;
                }
            }
            function A() {
                return r.left.is_constant() || r.right.is_constant() || !r.left.has_side_effects(o) && !r.right.has_side_effects(o);
            }
            function D(e) {
                if (A()) {
                    if (e) r.operator = e;
                    var n = r.left;
                    r.left = r.right;
                    r.right = n;
                }
            }
            function O() {
                var e = r.right;
                r.left = Te(sn, r, {
                    operator: r.operator,
                    left: r.left,
                    right: e.left,
                    start: r.left.start,
                    end: e.left.end
                });
                r.right = e.right;
                r.left = r.left.transform(o);
            }
        });
        e(yr, function(e) {
            return e;
        });
        function Re(e, n, t) {
            var r = 0, i = e.self();
            do {
                if (i === t) return i;
                if ($(i) && i.name && i.name.definition() === n) return i;
            } while (i = e.parent(r++));
        }
        function Le(e) {
            var n = e.scope.resolve();
            return en(e.references, function(e) {
                return n === e.scope.resolve();
            });
        }
        e(un, function(t, e) {
            if (!e.option("ie") && De(t) && !(t.scope.resolve().uses_with && e.find_parent(Rn))) {
                switch (t.name) {
                  case "undefined":
                    return Te(Cr, t).optimize(e);

                  case "NaN":
                    return Te(zr, t).optimize(e);

                  case "Infinity":
                    return Te(Fr, t).optimize(e);
                }
            }
            var c = e.parent();
            if (e.option("reduce_vars") && Jr(e.self(), c) !== e.self()) {
                var n = t.definition();
                var r = t.fixed_value();
                var i = n.single_use && !(c instanceof Ht && c.is_expr_pure(e));
                if (i) {
                    if ($(r)) {
                        if ((n.scope !== t.scope.resolve() || n.in_loop) && (!e.option("reduce_funcs") || n.escaped.depth == 1 || r.inlined)) {
                            i = false;
                        } else if (Re(e, n, r)) {
                            i = false;
                        } else if (r.name && r.name.definition() !== n) {
                            i = false;
                        } else if (r.parent_scope !== t.scope || Wr(n)) {
                            i = r.is_constant_expression(t.scope);
                            if (i == "f") {
                                var a = t.scope;
                                do {
                                    if (a instanceof it || a instanceof Wn) {
                                        a.inlined = true;
                                    }
                                } while (a = a.parent_scope);
                            }
                        } else if (r.name && (r.name.name == "await" && Jn(r) || r.name.name == "yield" && Xn(r))) {
                            i = false;
                        } else if (r.has_side_effects(e)) {
                            i = false;
                        } else if (e.option("ie") && r instanceof ut) {
                            i = false;
                        }
                        if (i) r.parent_scope = t.scope;
                    } else if (!r || n.recursive_refs > 0 || !r.is_constant_expression() || r.drop_side_effect_free(e)) {
                        i = false;
                    }
                }
                if (i) {
                    n.single_use = false;
                    r._squeezed = true;
                    r.single_use = true;
                    if (r instanceof ct) r = ee(r);
                    if (r instanceof it) r = be(r);
                    if ($(r)) {
                        var a = t.scope.resolve();
                        r.enclosed.forEach(function(e) {
                            if (r.variables.has(e.name)) return;
                            if (a.var_names().has(e.name)) return;
                            a.enclosed.push(e);
                            a.var_names().set(e.name, true);
                        });
                    }
                    var o;
                    if (n.recursive_refs > 0) {
                        o = r.clone(true);
                        var l = o.name.definition();
                        var p = o.variables.get(o.name.name);
                        var s = p && p.orig[0];
                        var d, v;
                        if (o instanceof ut) {
                            d = "def_function";
                            v = gr;
                        } else {
                            d = "def_variable";
                            v = _r;
                        }
                        if (!(s instanceof v)) {
                            s = Te(v, o.name, o.name);
                            s.scope = o;
                            o.name = s;
                            p = o[d](s);
                            p.recursive_refs = n.recursive_refs;
                        }
                        o.walk(new Ir(function(e) {
                            if (e instanceof cr) {
                                if (e !== s) {
                                    var n = e.definition();
                                    n.orig.push(e);
                                    n.eliminated++;
                                }
                                return;
                            }
                            if (!(e instanceof un)) return;
                            var n = e.definition();
                            if (n === l) {
                                e.thedef = n = p;
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if ($(t) && t.name && t.name.definition() === n && n.scope === t.name.scope && r.variables.get(t.name.name) === n) {
                                    t.name = t.name.clone();
                                    e.thedef = n = o.variables.get(t.name.name) || o[d](t.name);
                                }
                            }
                            n.references.push(e);
                        }));
                    } else {
                        if (r instanceof Ln) {
                            e.push(r);
                            o = r.optimize(e);
                            e.pop();
                        } else {
                            o = r.optimize(e);
                        }
                        o = o.transform(new Hr(function(e, n) {
                            if (e instanceof Ln) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    n.replaced++;
                    return o;
                }
                var h;
                if (r && (h = t.fixed || n.fixed).should_replace !== false) {
                    var f, u;
                    if (r instanceof kr) {
                        if (!Wr(n) && Le(n) && !b(n)) u = r;
                    } else if ((f = r.evaluate(e, true)) !== r && typeof f != "function" && (f === null || typeof f != "object" || e.option("unsafe_regexp") && f instanceof RegExp && !n.cross_loop && Le(n))) {
                        u = ce(f, r);
                    }
                    if (u) {
                        if (h.should_replace === undefined) {
                            var m = u.optimize(e).print_to_string().length;
                            if (!y(r)) {
                                m = Math.min(m, r.print_to_string().length);
                            }
                            var _ = n.name.length;
                            if (e.option("unused") && !e.exposed(n)) {
                                var g = n.references.length - n.replaced - n.assignments;
                                g = Math.min(g, n.references.filter(function(e) {
                                    return e.fixed === h;
                                }).length);
                                _ += (_ + 2 + m) / Math.max(1, g);
                            }
                            h.should_replace = m - Math.floor(_) < e.eval_threshold;
                        }
                        if (h.should_replace) {
                            var o;
                            if (y(r)) {
                                o = u.optimize(e);
                                if (o === u) o = o.clone(true);
                            } else {
                                o = he(u.optimize(e), r);
                                if (o === u || o === r) o = o.clone(true);
                            }
                            n.replaced++;
                            return o;
                        }
                    }
                }
            }
            return t;
            function b(e) {
                var n = t.scope;
                while (n !== e.scope) {
                    if (n instanceof ut) return true;
                    n = n.parent_scope;
                }
            }
            function y(e) {
                var n;
                e.walk(new Ir(function(e) {
                    if (e instanceof un) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function Be(e, n) {
            return e.option("unsafe") && n instanceof Bt && n.property == "raw" && De(n.expression) && n.expression.name == "String";
        }
        function Ue(e) {
            var r = false;
            e = e.replace(/\\(u\{[^{}]*\}?|u[\s\S]{0,4}|x[\s\S]{0,2}|[0-9]+|[\s\S])/g, function(e, n) {
                var t = Rr(n);
                if (typeof t == "string") return t;
                r = true;
            });
            if (!r) return e;
        }
        e(Sr, function(e, t) {
            if (!t.option("templates")) return e;
            var r = e.tag;
            if (!r || Be(t, r)) {
                var n = [];
                var i = [];
                for (var a = 0, c; a < e.strings.length; a++) {
                    var o = e.strings[a];
                    if (!r) {
                        var s = Ue(o);
                        if (s) o = h(s);
                    }
                    if (a > 0) {
                        var l = e.expressions[a - 1];
                        var p = m(l);
                        if (p) {
                            var d = i[i.length - 1];
                            var v = d + p + o;
                            var f;
                            if (r || typeof (f = Ue(v)) == c) {
                                i[i.length - 1] = f ? h(f) : v;
                                continue;
                            }
                        }
                        n.push(l);
                    }
                    i.push(o);
                    if (!r) c = typeof s;
                }
                if (!r && i.length > 1) {
                    if (i[i.length - 1] == "") return Te(sn, e, {
                        operator: "+",
                        left: Te(Sr, e, {
                            expressions: n.slice(0, -1),
                            strings: i.slice(0, -1),
                            tag: r
                        }).transform(t),
                        right: n[n.length - 1]
                    }).optimize(t);
                    if (i[0] == "") {
                        var u = Te(sn, e, {
                            operator: "+",
                            left: Te(Ar, e, {
                                value: ""
                            }),
                            right: n[0]
                        });
                        for (var a = 1; i[a] == "" && a < n.length; a++) {
                            u = Te(sn, e, {
                                operator: "+",
                                left: u,
                                right: n[a]
                            });
                        }
                        return me(t, e, Te(sn, e, {
                            operator: "+",
                            left: u.transform(t),
                            right: Te(Sr, e, {
                                expressions: n.slice(a),
                                strings: i.slice(a),
                                tag: r
                            }).transform(t)
                        }).optimize(t));
                    }
                }
                e.expressions = n;
                e.strings = i;
            }
            return _e(t, e);
            function h(e) {
                return e.replace(/\r|\\|`|\${/g, function(e) {
                    return "\\" + (e == "\r" ? "r" : e);
                });
            }
            function m(e) {
                var n = e.evaluate(t);
                if (n === e) return;
                if (r && /\r|\\|`/.test(n)) return;
                n = h("" + n);
                if (n.length > e.print_to_string().length + "${}".length) return;
                return n;
            }
        });
        function Ve(e, n) {
            return e instanceof un || e.TYPE === n.TYPE;
        }
        e(Cr, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = fe(n).find_variable("undefined");
                if (t) {
                    var r = Te(un, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    r.is_undefined = true;
                    return r;
                }
            }
            var i = Jr(n.self(), n.parent());
            if (i && Ve(i, e)) return e;
            return Te(on, e, {
                operator: "void",
                expression: Te(Dr, e, {
                    value: 0
                })
            });
        });
        e(Fr, function(e, n) {
            var t = Jr(n.self(), n.parent());
            if (t && Ve(t, e)) return e;
            if (n.option("keep_infinity") && !t && !fe(n).find_variable("Infinity")) {
                return e;
            }
            return Te(sn, e, {
                operator: "/",
                left: Te(Dr, e, {
                    value: 1
                }),
                right: Te(Dr, e, {
                    value: 0
                })
            });
        });
        e(zr, function(e, n) {
            var t = Jr(n.self(), n.parent());
            if (t && Ve(t, e)) return e;
            if (!t && !fe(n).find_variable("NaN")) return e;
            return Te(sn, e, {
                operator: "/",
                left: Te(Dr, e, {
                    value: 0
                }),
                right: Te(Dr, e, {
                    value: 0
                })
            });
        });
        function We(t, n) {
            var r = false;
            var i = new Ir(function(e) {
                if (r) return true;
                if (e instanceof un && cn(e.definition(), n)) return r = true;
            });
            var a = new Ir(function(e) {
                if (r) return true;
                if (e instanceof Un && e !== t) {
                    if (!(e.name || Jn(e) || Xn(e))) {
                        var n = a.parent();
                        if (n instanceof Ht && n.expression === e) return;
                    }
                    e.walk(i);
                    return true;
                }
            });
            t.walk(a);
            return r;
        }
        var Ge = wn("+ - * / % >> << >>> | ^ &");
        var Je = wn("* | ^ &");
        e(fn, function(a, o) {
            if (o.option("dead_code")) {
                if (a.left instanceof Lt) {
                    if (a.operator == "=") {
                        if (a.redundant) {
                            var e = [ a.left.expression ];
                            if (a.left instanceof Ut) e.push(a.left.property);
                            e.push(a.right);
                            return Ae(a, e).optimize(o);
                        }
                        if (a.left.equivalent_to(a.right) && !a.left.has_side_effects(o)) {
                            return a.right;
                        }
                        var n = a.left.expression;
                        if (n instanceof Un || !o.has_directive("use strict") && n instanceof Tr && !n.may_throw_on_access(o)) {
                            return a.left instanceof Bt ? a.right : Ae(a, [ a.left.property, a.right ]).optimize(o);
                        }
                    }
                } else if (a.left instanceof un && Se(a.left, o)) {
                    var t;
                    if (a.operator == "=" && a.left.equivalent_to(a.right) && !((t = o.parent()) instanceof on && t.operator == "delete")) {
                        return a.right;
                    }
                    if (a.left.is_immutable()) return u();
                    var r = a.left.definition();
                    var s = r.scope.resolve();
                    var c = s === o.find_parent(Un);
                    var i = 0, l;
                    t = o.self();
                    if (!(s.uses_arguments && Wr(r)) || o.has_directive("use strict")) do {
                        l = t;
                        t = o.parent(i++);
                        if (t instanceof fn) {
                            if (t.left instanceof un && t.left.definition() === r) {
                                if (_(i, t)) break;
                                return u(r);
                            }
                            if (t.left.match_symbol(function(e) {
                                if (e instanceof Lt) return true;
                            })) break;
                            continue;
                        }
                        if (t instanceof mt) {
                            if (!c) break;
                            if (_(i, t)) break;
                            if (We(s, [ r ])) break;
                            return u(r);
                        }
                        if (t instanceof tn) {
                            if (!c) break;
                            if (We(s, [ r ])) break;
                            var p;
                            do {
                                p = t;
                                t = o.parent(i++);
                                if (t === s && j(t.body, p)) return u(r);
                            } while (m(p, t));
                            break;
                        }
                        if (t instanceof Mt) {
                            if (!(t.name instanceof cr)) continue;
                            if (t.name.definition() !== r) continue;
                            if (_(i, t)) break;
                            return u(r);
                        }
                    } while (h(l, t));
                }
            }
            if (o.option("sequences")) {
                var d = a.lift_sequences(o);
                if (d !== a) return d.optimize(o);
            }
            if (o.option("assignments")) {
                if (a.operator == "=" && a.left instanceof un && a.right instanceof sn) {
                    var f;
                    if ((f = a.right.left) instanceof un && f.name == a.left.name && Ge[a.right.operator]) {
                        if (a.left.fixed) a.left.fixed.to_binary = function() {
                            return f;
                        };
                        return Te(fn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.right
                        });
                    }
                    if ((f = a.right.right) instanceof un && f.name == a.left.name && Je[a.right.operator] && !a.right.left.has_side_effects(o)) {
                        if (a.left.fixed) a.left.fixed.to_binary = function() {
                            return f;
                        };
                        return Te(fn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.left
                        });
                    }
                }
                if ((a.operator == "-=" || a.operator == "+=" && (a.left.is_boolean(o) || a.left.is_number(o))) && a.right instanceof Dr && a.right.value == 1) {
                    var v = a.operator.slice(0, -1);
                    return Te(on, a, {
                        operator: v + v,
                        expression: a.left
                    });
                }
            }
            return _e(o, a);
            function h(e, n) {
                if (n instanceof sn) {
                    return n.right === e || n.right.is_constant_expression(s);
                }
                if (n instanceof Jt) {
                    return n.condition !== e || n.consequent.is_constant_expression(s) && n.alternative.is_constant_expression(s);
                }
                if (n instanceof an) {
                    var t = n.expressions;
                    var r = t.indexOf(e);
                    if (r < 0) return false;
                    for (var i = t.length; --i > r; ) {
                        if (!t[i].is_constant_expression(s)) return false;
                    }
                    return true;
                }
                if (n instanceof on) return true;
            }
            function m(e, n) {
                if (n instanceof rn) return j(n.body, e);
                if (n instanceof Dt) return j(n.body, e);
                if (n instanceof Ot) return j(n.body, e);
                if (n instanceof xt) return n.body === e || n.alternative === e;
                if (n instanceof At) return n.bfinally ? n.bfinally === e : n.bcatch === e;
            }
            function _(e, n) {
                var t = a.right;
                a.right = Te(qr, t);
                var r = n.may_throw(o);
                a.right = t;
                for (var i; i = o.parent(e++); n = i) {
                    if (i === s) return false;
                    if (i instanceof At) {
                        if (i.bfinally && i.bfinally !== n) return true;
                        if (r && i.bcatch && i.bcatch !== n) return true;
                    }
                }
            }
            function u(e) {
                if (e) e.fixed = false;
                return (a.operator != "=" ? Te(sn, a, {
                    operator: a.operator.slice(0, -1),
                    left: a.left,
                    right: a.right
                }) : Fe(o, o.parent(), a, a.right)).optimize(o);
            }
        });
        e(Jt, function(i, n) {
            if (n.option("sequences") && i.condition instanceof an) {
                var e = i.condition.expressions.slice();
                i.condition = e.pop();
                e.push(i);
                return Ae(i, e);
            }
            if (!n.option("conditionals")) return i;
            var a = i.condition;
            if (n.option("booleans") && !a.has_side_effects(n)) {
                V(n, a);
            }
            a = U(n, a);
            if (!a) {
                nn.warn("Condition always false [{file}:{line},{col}]", i.start);
                return Ae(i, [ i.condition, i.alternative ]).optimize(n);
            } else if (!(a instanceof nn)) {
                nn.warn("Condition always true [{file}:{line},{col}]", i.start);
                return Ae(i, [ i.condition, i.consequent ]).optimize(n);
            }
            var t = a.negate(n, En(n));
            if (me(n, a, t) === t) {
                i = Te(Jt, i, {
                    condition: t,
                    consequent: i.alternative,
                    alternative: i.consequent
                });
                t = a;
                a = i.condition;
            }
            var r = i.consequent;
            var o = i.alternative;
            if (se(n, a)) {
                if (a.equivalent_to(r)) return Te(sn, i, {
                    operator: "||",
                    left: a,
                    right: o
                }).optimize(n);
                if (a.equivalent_to(o)) return Te(sn, i, {
                    operator: "&&",
                    left: a,
                    right: r
                }).optimize(n);
            }
            var s = r.tail_node();
            if (s instanceof fn) {
                var c = s.operator == "=";
                var l = c ? o.tail_node() : o;
                if ((c || r === s) && l instanceof fn && s.operator == l.operator && s.left.equivalent_to(l.left) && (c && s.left instanceof un || !a.has_side_effects(n) && w(r) && w(o))) {
                    return Te(fn, i, {
                        operator: s.operator,
                        left: s.left,
                        right: Te(Jt, i, {
                            condition: a,
                            consequent: x(r),
                            alternative: x(o)
                        })
                    });
                }
            }
            if (r.equivalent_to(o)) return Ae(i, [ a, r ]).optimize(n);
            var p = y(r, o, true);
            if (p) return p;
            var f;
            if (r instanceof Ht && o.TYPE == r.TYPE && (f = g(r, o)) >= 0 && r.expression.equivalent_to(o.expression) && !a.has_side_effects(n) && !r.expression.has_side_effects(n)) {
                var d = r.clone();
                var v = r.args[f];
                d.args[f] = v instanceof Vt ? Te(Vt, i, {
                    expression: Te(Jt, i, {
                        condition: a,
                        consequent: v.expression,
                        alternative: o.args[f].expression
                    })
                }) : Te(Jt, i, {
                    condition: a,
                    consequent: v,
                    alternative: o.args[f]
                });
                return d;
            }
            if (r instanceof Jt && r.alternative.equivalent_to(o)) {
                return Te(Jt, i, {
                    condition: Te(sn, i, {
                        left: a,
                        operator: "&&",
                        right: r.condition
                    }),
                    consequent: r.consequent,
                    alternative: o
                });
            }
            if (r instanceof Jt && r.consequent.equivalent_to(o)) {
                return Te(Jt, i, {
                    condition: Te(sn, i, {
                        left: t,
                        operator: "||",
                        right: r.condition
                    }),
                    consequent: o,
                    alternative: r.alternative
                });
            }
            if (o instanceof Jt && r.equivalent_to(o.consequent)) {
                return Te(Jt, i, {
                    condition: Te(sn, i, {
                        left: a,
                        operator: "||",
                        right: o.condition
                    }),
                    consequent: r,
                    alternative: o.alternative
                });
            }
            if (o instanceof Jt && r.equivalent_to(o.alternative)) {
                return Te(Jt, i, {
                    condition: Te(sn, i, {
                        left: t,
                        operator: "&&",
                        right: o.condition
                    }),
                    consequent: o.consequent,
                    alternative: r
                });
            }
            if ((r instanceof an || o instanceof an) && r.tail_node().equivalent_to(o.tail_node())) {
                return Ae(i, [ Te(Jt, i, {
                    condition: a,
                    consequent: k(r),
                    alternative: k(o)
                }), r.tail_node() ]).optimize(n);
            }
            if (r instanceof sn && r.operator == "&&" && r.right.equivalent_to(o)) {
                return Te(sn, i, {
                    operator: "&&",
                    left: Te(sn, i, {
                        operator: "||",
                        left: t,
                        right: r.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (r instanceof sn && r.operator == "||" && r.right.equivalent_to(o)) {
                return Te(sn, i, {
                    operator: "||",
                    left: Te(sn, i, {
                        operator: "&&",
                        left: a,
                        right: r.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (o instanceof sn && o.operator == "&&" && o.right.equivalent_to(r)) {
                return Te(sn, i, {
                    operator: "&&",
                    left: Te(sn, i, {
                        operator: "||",
                        left: a,
                        right: o.left
                    }),
                    right: r
                }).optimize(n);
            }
            if (o instanceof sn && o.operator == "||" && o.right.equivalent_to(r)) {
                return Te(sn, i, {
                    operator: "||",
                    left: Te(sn, i, {
                        operator: "&&",
                        left: t,
                        right: o.left
                    }),
                    right: r
                }).optimize(n);
            }
            var h = n.option("booleans") && n.in_boolean_context();
            if (m(r)) {
                if (_(o)) {
                    return u(a);
                }
                return Te(sn, i, {
                    operator: "||",
                    left: u(a),
                    right: o
                });
            }
            if (_(r)) {
                if (m(o)) {
                    return u(a.negate(n));
                }
                return Te(sn, i, {
                    operator: "&&",
                    left: u(a.negate(n)),
                    right: o
                });
            }
            if (m(o)) {
                return Te(sn, i, {
                    operator: "||",
                    left: u(a.negate(n)),
                    right: r
                });
            }
            if (_(o)) {
                return Te(sn, i, {
                    operator: "&&",
                    left: u(a),
                    right: r
                });
            }
            if (n.option("typeofs")) B(a, r, o);
            return i;
            function u(e) {
                if (e.is_boolean(n)) return e;
                return Te(on, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function m(e) {
                return e instanceof Nr || h && e instanceof Tr && e.value || e instanceof on && e.operator == "!" && e.expression instanceof Tr && !e.expression.value;
            }
            function _(e) {
                return e instanceof jr || h && (e instanceof Tr && !e.value || e instanceof on && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof on && e.operator == "!" && e.expression instanceof Tr && e.expression.value;
            }
            function g(e, n) {
                var t = e.args;
                var r = n.args;
                var i = t.length;
                if (i != r.length) return -2;
                for (var a = 0; a < i; a++) {
                    if (!t[a].equivalent_to(r[a])) {
                        if (t[a] instanceof Vt !== r[a] instanceof Vt) return -3;
                        for (var o = a + 1; o < i; o++) {
                            if (!t[o].equivalent_to(r[o])) return -2;
                        }
                        return a;
                    }
                }
                return -1;
            }
            function b(e, n) {
                if (e.TYPE != n.TYPE) return;
                if (e.optional != n.optional) return;
                if (e instanceof Ht) {
                    if (g(e, n) != -1) return;
                    return e.TYPE != "Call" || !(e.expression instanceof Lt || n.expression instanceof Lt) || b(e.expression, n.expression);
                }
                if (!(e instanceof Lt)) return;
                var t = e.property;
                var r = n.property;
                return (t instanceof nn ? t.equivalent_to(r) : t == r) && !(e.expression instanceof xr || n.expression instanceof xr);
            }
            function y(e, n, t) {
                if (!b(e, n)) return !t && Te(Jt, i, {
                    condition: a,
                    consequent: e,
                    alternative: n
                });
                var r = e.clone();
                r.expression = y(e.expression, n.expression);
                return r;
            }
            function w(e) {
                return e === e.tail_node() || en(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function x(e) {
                if (!(e instanceof an)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return Ae(e, n);
            }
            function k(e) {
                if (!(e instanceof an)) return Te(Dr, e, {
                    value: 0
                });
                return Ae(e, e.expressions.slice(0, -1));
            }
        });
        e(Pr, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return Te(Dr, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof sn && (t.operator == "==" || t.operator == "!=")) {
                nn.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return Te(Dr, e, {
                    value: +e.value
                });
            }
            return Te(on, e, {
                operator: "!",
                expression: Te(Dr, e, {
                    value: 1 - e.value
                })
            });
        });
        e(Vt, function(e, n) {
            var t = e.expression;
            if (n.option("spreads") && t instanceof Qt && !(n.parent() instanceof rr)) {
                return _n.splice(t.elements.map(function(e) {
                    return e instanceof Mr ? Te(Cr, e).optimize(n) : e;
                }));
            }
            return e;
        });
        function Xe(e, n) {
            if (!e) return false;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            if (e instanceof un) {
                e = e.fixed_value();
                if (!e) return false;
            }
            return e instanceof Un && !e.contains_this();
        }
        e(Ut, function(e, t) {
            var n = e.expression;
            var r = e.property;
            var c = we(e, t);
            if (c) return c;
            if (t.option("properties")) {
                var i = r.evaluate(t);
                if (i !== r) {
                    if (typeof i == "string") {
                        if (i == "undefined") {
                            i = undefined;
                        } else {
                            var a = parseFloat(i);
                            if (a.toString() == i) {
                                i = a;
                            }
                        }
                    }
                    r = e.property = he(r, ce(i, r).transform(t));
                    var l = "" + i;
                    if (Yr(l) && l.length <= r.print_to_string().length + 1) {
                        return Te(Bt, e, {
                            optional: e.optional,
                            expression: n,
                            property: l
                        }).optimize(t);
                    }
                }
            }
            var p = t.parent();
            var d = Jr(t.self(), p);
            var o, s, v, f;
            if (t.option("arguments") && n instanceof un && ze(o = n.definition()) && !n.in_arg && r instanceof Dr && Math.floor(f = r.value) == f && (s = o.scope) === S() && s.uses_arguments < (d ? 2 : 3)) {
                if (p instanceof on && p.operator == "delete") {
                    if (!o.deleted) o.deleted = [];
                    o.deleted[f] = true;
                }
                var u = s.argnames[f];
                if (o.deleted && o.deleted[f]) {
                    u = null;
                } else if (u) {
                    var h;
                    if (!(u instanceof hr) || u.name == "await" || n.scope.find_variable(u.name) !== (h = u.definition())) {
                        u = null;
                    } else if (t.has_directive("use strict") || s.name || s.rest || !(v instanceof Ht && f < v.args.length && en(v.args.slice(0, f + 1), function(e) {
                        return !(e instanceof Vt);
                    })) || !en(s.argnames, function(e) {
                        return e instanceof hr;
                    })) {
                        if (T() || h.assignments || h.orig.length > 1) u = null;
                    }
                } else if ((d || !T()) && f < s.argnames.length + 5 && t.drop_fargs(s, v) && !s.rest) {
                    while (f >= s.argnames.length) {
                        u = s.make_var(hr, s, "argument_" + s.argnames.length);
                        s.argnames.push(u);
                    }
                }
                if (u && ln(function(e) {
                    return e.name === u.name;
                }, s.argnames) === u) {
                    if (d) o.reassigned--;
                    var m = Te(un, e, u);
                    m.reference();
                    u.unused = undefined;
                    return m;
                }
            }
            if (d) return e;
            if (t.option("sequences") && p.TYPE != "Call" && !(p instanceof In && p.init === e)) {
                var _ = xe(e, t);
                if (_ !== e) return _.optimize(t);
            }
            if (i !== r) {
                var g = e.flatten_object(l, t);
                if (g) {
                    n = e.expression = g.expression;
                    r = e.property = g.property;
                }
            }
            var b;
            if (t.option("properties") && t.option("side_effects") && r instanceof Dr && n instanceof Qt && en(b = n.elements, function(e) {
                return !(e instanceof Vt);
            })) {
                var f = r.value;
                var y = b[f];
                if (Xe(y, t)) {
                    var w = y instanceof Mr;
                    var x = !w;
                    var k = [];
                    for (var E = b.length; --E > f; ) {
                        var a = b[E].drop_side_effect_free(t);
                        if (a) {
                            k.unshift(a);
                            if (x && a.has_side_effects(t)) x = false;
                        }
                    }
                    if (!x) k.unshift(y);
                    while (--E >= 0) {
                        var a = b[E].drop_side_effect_free(t);
                        if (a) {
                            k.unshift(a);
                        } else if (w) {
                            k.unshift(Te(Mr, b[E]));
                        } else {
                            f--;
                        }
                    }
                    if (x) {
                        k.push(y);
                        return Ae(e, k).optimize(t);
                    } else return Te(Ut, e, {
                        expression: Te(Qt, n, {
                            elements: k
                        }),
                        property: Te(Dr, r, {
                            value: f
                        })
                    });
                }
            }
            return _e(t, e);
            function S() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof Un) {
                        if (n instanceof Vn) return;
                        if (Gn(n)) continue;
                        v = t.parent(e);
                        return n;
                    }
                }
            }
            function T() {
                return !t.option("reduce_vars") || o.reassigned;
            }
        });
        Wn.DEFMETHOD("contains_super", function() {
            var n = false;
            var t = this;
            t.walk(new Ir(function(e) {
                if (n) return true;
                if (e instanceof xr) return n = true;
                if (e !== t && e instanceof Ln && !Gn(e)) return true;
            }));
            return n;
        });
        (function(e) {
            e(Qn, dn);
            e(Zn, dn);
            e(nn, function() {
                var n = false;
                var t = this;
                t.walk(new Ir(function(e) {
                    if (n) return true;
                    if (e instanceof kr) return n = true;
                    if (e !== t && e instanceof Ln && !Gn(e)) return true;
                }));
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("contains_this", n);
        });
        function Ke(e) {
            return e instanceof ar && typeof e.key == "string" && !(e instanceof or && e.value.contains_super());
        }
        Lt.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            if (e === "__proto__") return;
            var t = this.expression;
            if (t instanceof rr) {
                var r = t.properties;
                for (var i = r.length; --i >= 0; ) {
                    var c = r[i];
                    if (c.key !== e) continue;
                    if (!en(r, Ke)) return;
                    if (!Xe(c.value, n)) return;
                    var a, l = [];
                    for (var o = 0; o < r.length; o++) {
                        var s = r[o].value;
                        if (r[o] instanceof or) {
                            var f = !(s.uses_arguments || Xn(s) || s.contains_this());
                            if (f) {
                                if (!a) a = n.find_parent(Ln);
                                var p = Ee(a);
                                s.each_argname(function(e) {
                                    if (p[e.name]) f = false;
                                });
                            }
                            var u;
                            if (f) {
                                u = Jn(s) ? Zn : Qn;
                            } else if (i === o && !(n.parent() instanceof Ht)) {
                                return;
                            } else {
                                u = s.CTOR;
                            }
                            s = Te(u, s, s);
                        }
                        l.push(s);
                    }
                    return Te(Ut, this, {
                        expression: Te(Qt, t, {
                            elements: l
                        }),
                        property: Te(Dr, this, {
                            value: i
                        })
                    });
                }
            }
        });
        e(Bt, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                nn.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            var t = n.parent();
            if (Jr(n.self(), t)) return e;
            var r = we(e, n);
            if (r) return r;
            if (n.option("sequences") && t.TYPE != "Call" && !(t instanceof In && t.init === e)) {
                var i = xe(e, n);
                if (i !== e) return i.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof Bt && e.expression.property == "prototype") {
                var a = e.expression.expression;
                if (De(a)) switch (a.name) {
                  case "Array":
                    e.expression = Te(Qt, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = Te(tt, e.expression, {
                        argnames: [],
                        body: []
                    }).init_vars(a.scope);
                    break;

                  case "Number":
                    e.expression = Te(Dr, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = Te(rr, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = Te($r, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = Te(Ar, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var o = e.flatten_object(e.property, n);
            if (o) return o.optimize(n);
            return _e(n, e);
        });
        e(er, function(e, n) {
            if (n.option("rests") && e.rest instanceof er) {
                return Te(er, e, {
                    elements: e.elements.concat(e.rest.elements),
                    rest: e.rest.rest
                });
            }
            return e;
        });
        e(nr, function(e, n) {
            if (n.option("objects")) {
                var t = e.key;
                if (t instanceof nn) {
                    t = t.evaluate(n);
                    if (t !== e.key) e.key = "" + t;
                }
            }
            return e;
        });
        e(rr, function(r, i) {
            if (!i.option("objects")) return r;
            var a = false;
            var t = false;
            var o = false;
            var l = i.has_directive("use strict");
            var s = [];
            var f = new xn();
            var u = [];
            r.properties.forEach(function(e) {
                if (!(e instanceof Vt)) return p(e);
                t = true;
                var n = e.expression;
                if (i.option("spreads") && n instanceof rr && en(n.properties, function(e) {
                    if (e instanceof fr) return false;
                    if (e instanceof Vt) return false;
                    if (e.key !== "__proto__") return true;
                    if (e instanceof sr) return true;
                    return !e.value.has_side_effects(i);
                })) {
                    a = true;
                    n.properties.forEach(function(e) {
                        var n = e.key;
                        var t = e instanceof sr;
                        if (n === "__proto__") {
                            if (!t) return;
                            n = ce(n, e);
                        }
                        p(t ? Te(ar, e, {
                            key: n,
                            value: Te(Cr, e).optimize(i)
                        }) : e);
                    });
                } else {
                    o = true;
                    c();
                    u.push(e);
                }
            });
            c();
            if (!a) return r;
            if (t && o && u.length == 1) {
                var e = u[0];
                if (e instanceof ir && e.key instanceof Dr) {
                    e.key = "" + e.key.value;
                }
            }
            return Te(rr, r, {
                properties: u
            });
            function c() {
                s.forEach(function(e) {
                    var n = f.get(e);
                    switch (n.length) {
                      case 0:
                        return;

                      case 1:
                        return u.push(n[0]);
                    }
                    a = true;
                    var t = l && !o && n.pop();
                    u.push(n.length == 1 ? n[0] : Te(ar, r, {
                        key: n[0].key,
                        value: Ae(r, n.map(function(e) {
                            return e.value;
                        }))
                    }));
                    if (t) u.push(t);
                    n.length = 0;
                });
                s = [];
                f = new xn();
            }
            function p(e) {
                var n = e.key;
                if (n instanceof nn) {
                    t = true;
                    n = n.evaluate(i);
                    if (n === e.key || n === "__proto__") {
                        o = true;
                    } else {
                        n = e.key = "" + n;
                    }
                }
                if (Ke(e)) {
                    if (e.value.has_side_effects(i)) c();
                    s.push(n);
                    f.add(n, e);
                } else {
                    c();
                    u.push(e);
                }
                if (t && !o && typeof n == "string" && q.test(n)) {
                    o = true;
                    if (f.has(n)) e = f.get(n)[0];
                    e.key = Te(Dr, e, {
                        value: +n
                    });
                }
            }
        });
        function Qe(e) {
            var n = e.definition().redefined();
            if (n) {
                e = e.clone();
                e.thedef = n;
            }
            return e;
        }
        function Ze(n, e) {
            var t = false;
            e.walk(new Ir(function(e) {
                if (t) return true;
                if (e instanceof un && n.variables.get(e.name) === e.definition()) {
                    return t = true;
                }
            }));
            return t;
        }
        (function(e) {
            e(nn, pn);
            e(fn, pn);
            e(Xt, function(t, e, r, n) {
                var i = this;
                var a = o(i.expression).try_inline(t, e, r, n);
                if (!a) return;
                if (!r) w(a, function(e) {
                    e.in_bool = false;
                    var n = e.value;
                    if (n instanceof Xt) return;
                    e.value = Te(Xt, i, {
                        expression: n || Te(Cr, e).transform(t)
                    });
                });
                return O(a) ? a : Te(rn, i, {
                    body: [ a, Te(tn, i, {
                        body: Te(Xt, i, {
                            expression: Te(Dr, i, {
                                value: 0
                            })
                        })
                    }) ]
                });
                function o(e) {
                    if (!r) return e;
                    if (e.TYPE != "Call") return e;
                    var n = e.expression;
                    switch (n.CTOR) {
                      case Zn:
                        n = Te(Qn, n, n);
                        break;

                      case et:
                        n = Te(tt, n, n);
                        break;

                      case nt:
                        n = Te(rt, n, n);
                        break;

                      default:
                        return e;
                    }
                    e = e.clone();
                    e.expression = n;
                    return e;
                }
            });
            e(sn, function(n, e, t, r) {
                if (t === undefined) return;
                var i = this;
                var a = i.operator;
                if (!$e[a]) return;
                var o = i.right.try_inline(n, e, t, r);
                if (!o) return;
                return Te(xt, i, {
                    condition: s(i.left),
                    body: o,
                    alternative: t ? null : Te(_t, i, {
                        value: null
                    })
                });
                function s(e) {
                    switch (a) {
                      case "&&":
                        return e;

                      case "||":
                        return e.negate(n);

                      case "??":
                        return Te(sn, i, {
                            operator: "==",
                            left: Te(qr, i),
                            right: e
                        });
                    }
                }
            });
            e(rn, function(e, n, t, r) {
                if (t) return;
                if (!this.variables) return;
                var i = this.body;
                var a = i.length - 1;
                if (a < 0) return;
                var o = i[a].try_inline(e, this, t, r);
                if (!o) return;
                i[a] = o;
                return this;
            });
            e(Ht, function(i, a, e, o) {
                if (i.option("inline") < 4) return;
                var t = this;
                if (t.is_expr_pure(i)) return;
                var s = t.expression;
                if (!(s instanceof Wn)) return;
                if (s.name) return;
                if (s.uses_arguments) return;
                if (Xn(s)) return;
                var r = Gn(s);
                if (r && s.value) return;
                if (s.body[0] instanceof An) return;
                if (s.contains_this()) return;
                if (!a) a = fe(i);
                var f = new xn();
                while (!(a instanceof Ln)) {
                    a.variables.each(function(e) {
                        f.set(e.name, true);
                    });
                    a = a.parent_scope;
                }
                if (!cn(a, i.stack)) return;
                if (a instanceof Bn && s.variables.size() > (r ? 0 : 1)) {
                    if (!i.toplevel.vars) return;
                    if (s.functions.size() > 0 && !i.toplevel.funcs) return;
                    f.set("arguments", true);
                }
                var u = Jn(s);
                if (u) {
                    if (!i.option("awaits")) return;
                    if (!Jn(a)) return;
                    if (t.may_throw(i)) return;
                }
                var p = a.var_names();
                if (o) o = [];
                if (!s.variables.all(function(e, n) {
                    if (o) o.push(e);
                    if (!f.has(n) && !p.has(n)) return true;
                    return !r && n == "arguments" && e.orig.length == 1;
                })) return;
                if (o && o.length > 0 && We(s, o)) return;
                var c = true;
                if (!en(s.argnames, function(e) {
                    var n = false;
                    var t = new Ir(function(e) {
                        if (n) return true;
                        if (e instanceof It) {
                            if (Ze(s, e.value)) return n = true;
                            e.name.walk(t);
                            return true;
                        }
                        if (e instanceof nr) {
                            if (e.key instanceof nn && Ze(s, e.key)) return n = true;
                            e.value.walk(t);
                            return true;
                        }
                        if (e instanceof hr && !en(e.definition().orig, function(e) {
                            return !(e instanceof mr);
                        })) return n = true;
                    });
                    e.walk(t);
                    if (n) return false;
                    if (!(e instanceof hr)) c = false;
                    return true;
                })) return;
                if (s.rest) {
                    if (Ze(s, s.rest)) return;
                    c = false;
                }
                if (e && !en(s.body, function(e) {
                    var n = false;
                    e.walk(new Ir(function(e) {
                        if (n) return true;
                        if (u && e instanceof Xt || e instanceof _t) return n = true;
                        if (e instanceof Ln && e !== s) return true;
                    }));
                    return !n;
                })) return;
                if (!He(s, Ee(a))) return;
                s.functions.each(function(e, n) {
                    a.functions.set(n, e);
                });
                var l = [];
                s.variables.each(function(n, e) {
                    if (e == "arguments") return;
                    p.set(e, true);
                    a.enclosed.push(n);
                    a.variables.set(e, n);
                    n.single_use = false;
                    if (!o) return;
                    if (n.references.length == n.replaced) return;
                    if (n.orig.length == 1 && s.functions.has(e)) return;
                    if (!en(n.orig, function(e) {
                        if (e instanceof lr) return false;
                        if (e instanceof hr) return n.scope.resolve() !== s;
                        if (e instanceof dr) return false;
                        return true;
                    })) return;
                    var t = n.orig[0];
                    if (t instanceof br) return;
                    var r = Te(un, t, Qe(t));
                    n = r.definition();
                    n.assignments++;
                    n.references.push(r);
                    l.push(Te(tn, t, {
                        body: Te(fn, t, {
                            operator: "=",
                            left: r,
                            right: Te(Cr, t).transform(i)
                        })
                    }));
                });
                if (s.variables.has("NaN")) a.transform(new Hr(function(e) {
                    if (e instanceof zr) return Te(sn, e, {
                        operator: "/",
                        left: Te(Dr, e, {
                            value: 0
                        }),
                        right: Te(Dr, e, {
                            value: 0
                        })
                    });
                }));
                var d = Object.create(null), v = new xn();
                if (c && en(t.args, function(e) {
                    return !(e instanceof Vt);
                })) {
                    var h = t.args.slice();
                    s.argnames.forEach(function(e) {
                        var n = h.shift();
                        if (e.unused) {
                            if (n) l.push(Te(tn, t, {
                                body: n
                            }));
                            return;
                        }
                        l.push(Te(Ct, t, {
                            definitions: [ Te(Mt, t, {
                                name: e.convert_symbol(vr, m),
                                value: n || Te(Cr, t).transform(i)
                            }) ]
                        }));
                    });
                    if (h.length) l.push(Te(tn, t, {
                        body: Ae(t, h)
                    }));
                } else {
                    l.push(Te(Ct, t, {
                        definitions: [ Te(Mt, t, {
                            name: Te(er, t, {
                                elements: s.argnames.map(function(e) {
                                    if (e.unused) return Te(Mr, e);
                                    return e.convert_symbol(vr, m);
                                }),
                                rest: s.rest && s.rest.convert_symbol(vr, m)
                            }),
                            value: Te(Qt, t, {
                                elements: t.args.slice()
                            })
                        }) ]
                    }));
                }
                v.each(function(e, n) {
                    var t = d[n];
                    [].unshift.apply(t.orig, e);
                    t.eliminated += e.length;
                });
                [].push.apply(l, o ? s.body.filter(function(e) {
                    if (!(e instanceof it)) return true;
                    var n = Te(vr, e.name, Qe(e.name));
                    var t = n.definition();
                    t.fixed = false;
                    t.orig.push(n);
                    t.eliminated++;
                    l.push(Te(Ct, e, {
                        definitions: [ Te(Mt, e, {
                            name: n,
                            value: be(e, true)
                        }) ]
                    }));
                    return false;
                }) : s.body);
                var n = Te(rn, t, {
                    body: l
                });
                if (!e) {
                    if (u) w(n, function(e) {
                        var n = e.value;
                        if (Oe(n)) return;
                        e.value = Te(Xt, t, {
                            expression: n
                        });
                    });
                    l.push(Te(_t, t, {
                        value: null
                    }));
                }
                return n;
                function m(e, n) {
                    var t = n.definition();
                    d[t.id] = t;
                    v.add(t.id, e);
                }
            });
            e(Jt, function(e, n, t, r) {
                var i = this;
                var a = i.consequent.try_inline(e, n, t, r);
                var o = i.alternative.try_inline(e, n, t, r);
                if (!a && !o) return;
                return Te(xt, i, {
                    condition: i.condition,
                    body: a || s(i.consequent),
                    alternative: o || s(i.alternative)
                });
                function s(e) {
                    if (t) return Te(tn, e, {
                        body: e
                    });
                    return Te(_t, e, {
                        value: e
                    });
                }
            });
            e(Nn, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (i) this.body = i;
                var a = this.init;
                if (a) {
                    a = a.try_inline(e, n, true, r);
                    if (a) {
                        this.init = null;
                        a.body.push(this);
                        return a;
                    }
                }
                return i && this;
            });
            e(In, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (i) this.body = i;
                var a = this.object;
                if (a instanceof an) {
                    var o = f(e, n, true, r, a, 1);
                    if (o) {
                        this.object = a.tail_node();
                        o.body.push(this);
                        return o;
                    }
                }
                return i && this;
            });
            e(xt, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (i) this.body = i;
                var a = this.alternative;
                if (a) {
                    a = a.try_inline(e, n, t, r);
                    if (a) this.alternative = a;
                }
                var o = this.condition;
                if (o instanceof an) {
                    var s = f(e, n, true, r, o, 1);
                    if (s) {
                        this.condition = o.tail_node();
                        s.body.push(this);
                        return s;
                    }
                }
                return (i || a) && this;
            });
            e(Mn, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (!i) return;
                this.body = i;
                return this;
            });
            e(Cn, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (!i) return;
                this.body = i;
                return this;
            });
            e(Yt, pn);
            e(_t, function(e, n, t, r) {
                var i = this.value;
                return i && i.try_inline(e, n, undefined, r === "try");
            });
            function f(e, c, n, l, t, p) {
                var r = [], i = t.expressions, a = n;
                for (var o = i.length - (p || 0), s = o; --o >= 0; a = true) {
                    var f = i[o].try_inline(e, c, a, l);
                    if (!f) continue;
                    u();
                    r.push(f);
                }
                if (r.length == 0) return;
                u();
                if (!n && r[0] instanceof tn) {
                    r[0] = Te(_t, t, {
                        value: r[0].body
                    });
                }
                return Te(rn, t, {
                    body: r.reverse()
                });
                function u() {
                    if (s > o + 1) r.push(Te(tn, t, {
                        body: Ae(t, i.slice(o + 1, s))
                    }));
                    s = o;
                }
            }
            e(an, function(e, n, t, r) {
                return f(e, n, t, r, this);
            });
            e(tn, function(e, n, t, r) {
                var i = this.body;
                while (i instanceof on) {
                    var a = i.operator;
                    if (Gr[a]) break;
                    if (a == "void") break;
                    i = i.expression;
                }
                if (!t && !Oe(i)) i = Te(on, this, {
                    operator: "void",
                    expression: i
                });
                return i.try_inline(e, n, t || false, r);
            });
            e(on, function(t, e, n, r) {
                var i = this;
                var a = i.operator;
                if (Gr[a]) return;
                if (!n && a == "void") n = false;
                var o = i.expression.try_inline(t, e, n, r);
                if (!o) return;
                if (!n) w(o, function(e) {
                    e.in_bool = false;
                    var n = e.value;
                    if (a == "void" && Oe(n)) return;
                    e.value = Te(on, i, {
                        operator: a,
                        expression: n || Te(Cr, e).transform(t)
                    });
                });
                return o;
            });
            e(Rn, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (i) this.body = i;
                var a = this.expression;
                if (a instanceof an) {
                    var o = f(e, n, true, r, a, 1);
                    if (o) {
                        this.expression = a.tail_node();
                        o.body.push(this);
                        return o;
                    }
                }
                return i && this;
            });
            e(Kt, function(e, n, t, r) {
                if (!e.option("yields")) return;
                if (!this.nested) return;
                var i = this.expression;
                if (i.TYPE != "Call") return;
                var a = i.expression;
                switch (a.CTOR) {
                  case nt:
                    a = Te(et, a, a);
                    break;

                  case rt:
                    a = Te(tt, a, a);
                    break;

                  default:
                    return;
                }
                i = i.clone();
                i.expression = a;
                return i.try_inline(e, n, t, r);
            });
        })(function(e, n) {
            e.DEFMETHOD("try_inline", n);
        });
        e(_t, function(e, n) {
            var t = e.value;
            if (t && n.option("side_effects") && Oe(t, n) && !E(n.find_parent(Ln))) {
                e.value = null;
            }
            return e;
        });
    })(function(e, r) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = r(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function ie(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function Kr(f) {
        f = be(f, {
            annotations: false,
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            galio: false,
            ie: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            v8: false,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var h = dn;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var e = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, e - 1), f.comments.substr(e + 1));
            }
            if (n instanceof RegExp) {
                h = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                h = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                h = ie;
            } else {
                h = vn;
            }
        }
        var a = 0;
        var o = 1;
        var u = 0;
        var t = f.indent_start;
        var s;
        var i = 0;
        var m = true;
        var c = f.source_map && [];
        var _;
        var g;
        var l;
        var p;
        var b = false;
        var y = false;
        var w = -1;
        var r;
        var d;
        function x() {
            s = "";
            l = false;
            p = false;
            r = [];
            var e = d;
            d = "";
            return e;
        }
        x();
        var k = f.ascii_only ? function(e, t) {
            if (t) e = e.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(e) {
                return "\\u{" + (e.charCodeAt(0) - 55232 << 10 | e.charCodeAt(1) - 56320).toString(16) + "}";
            });
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, r = 0; t < e.length; t++) {
                var i = e.charCodeAt(t);
                if (ne(i)) {
                    if (te(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!te(i)) {
                    continue;
                }
                n += e.slice(r, t) + "\\u" + i.toString(16);
                r = t + 1;
            }
            return r == 0 ? e : n + e.slice(r);
        };
        function E(e) {
            return "'" + e.replace(/\x27/g, "\\'") + "'";
        }
        function S(e) {
            return '"' + e.replace(/\x22/g, '\\"') + '"';
        }
        var T = [ null, E, S, function(e, n) {
            return n == "'" ? E(e) : S(e);
        } ][f.quote_style] || function(e, n, t, r) {
            return t > r ? E(e) : S(e);
        };
        function A(t, e) {
            var r = 0, i = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++r;
                    return '"';

                  case "'":
                    ++i;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            return T(k(t), e, r, i);
        }
        var D = c ? function(n, t) {
            c.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : pn;
        var O = c ? function() {
            c.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            c = [];
        } : pn;
        function $(e) {
            var n = d.lastIndexOf("\n");
            if (i < n) i = n;
            var t = d.slice(0, i);
            var r = d.slice(i);
            D(e, r.length - a);
            o += e;
            u += e;
            a = r.length;
            d = t;
            while (e--) d += "\n";
            d += r;
        }
        var q = f.max_line_len ? function() {
            if (m) {
                if (a > f.max_line_len) {
                    nn.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (a > f.max_line_len) $(1);
            m = true;
            O();
        } : pn;
        var z = wn("( [ + * / - , .");
        var v = f.beautify || f.comments || f.max_line_len || f.preserve_line || f.shebang || !f.semicolons || f.source_map || f.width ? function(e) {
            var n = e.charAt(0);
            if (b && n) {
                b = false;
                if (n != "\n") {
                    v("\n");
                    M();
                }
            }
            if (y && n) {
                y = false;
                if (!/[\s;})]/.test(n)) {
                    C();
                }
            }
            w = -1;
            var t = s.slice(-1);
            if (p) {
                p = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    if (f.semicolons || z[n]) {
                        d += ";";
                        a++;
                        u++;
                    } else {
                        q();
                        d += "\n";
                        u++;
                        o++;
                        a = 0;
                        if (/^\s+$/.test(e)) {
                            p = true;
                        }
                    }
                    if (!f.beautify) l = false;
                }
            }
            if (l) {
                if (re(t) && (re(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == s || e == "--" && s == "!" || e == "in" && t == "/" || s == "--" && n == ">") {
                    d += " ";
                    a++;
                    u++;
                }
                if (t != "<" || e != "!") l = false;
            }
            if (g) {
                c.push({
                    token: g,
                    name: _,
                    line: o,
                    col: a
                });
                g = false;
                if (m) O();
            }
            d += e;
            u += e.length;
            var r = e.split(/\r?\n/), i = r.length - 1;
            o += i;
            a += r[0].length;
            if (i > 0) {
                q();
                a = r[i].length;
            }
            s = e;
        } : function(e) {
            var n = e.charAt(0);
            var t = s.slice(-1);
            if (p) {
                p = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    d += ";";
                    l = false;
                }
            }
            if (l) {
                if (re(t) && (re(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == s || e == "--" && s == "!" || e == "in" && t == "/" || s == "--" && n == ">") {
                    d += " ";
                }
                if (t != "<" || e != "!") l = false;
            }
            d += e;
            s = e;
        };
        var C = f.beautify ? function() {
            v(" ");
        } : function() {
            l = true;
        };
        var M = f.beautify ? function(e) {
            if (b) v("\n");
            v(Z(" ", e ? t - (f.indent_level >> 1) : t));
        } : pn;
        var F = f.beautify ? function(e) {
            var n = t;
            t += f.indent_level;
            e();
            t = n;
        } : function(e) {
            e();
        };
        var P = f.max_line_len || f.preserve_line ? function() {
            q();
            i = d.length;
            m = false;
        } : pn;
        var j = f.beautify ? function() {
            if (w < 0) return v("\n");
            if (d[w] != "\n") {
                d = d.slice(0, w) + "\n" + d.slice(w);
                u++;
                o++;
            }
            w++;
        } : P;
        var N = f.beautify ? function() {
            v(";");
        } : function() {
            p = true;
        };
        function I() {
            if (p) v(";");
            v(";");
        }
        function H(e) {
            v("{");
            j();
            F(e);
            M();
            v("}");
        }
        function Y(e) {
            v("(");
            P();
            e();
            P();
            v(")");
        }
        function R(e) {
            v("[");
            P();
            e();
            P();
            v("]");
        }
        function L() {
            P();
            v(",");
            P();
            C();
        }
        function B() {
            v(":");
            C();
        }
        var U = c ? function(e, n) {
            g = e;
            _ = n;
        } : pn;
        function V() {
            if (!m) q();
            return d;
        }
        function W() {
            var e = d.lastIndexOf("\n");
            return /^ *$/.test(d.slice(e + 1));
        }
        function G(e, n) {
            if (b) return;
            if (e.nlb && (n || !W())) {
                b = true;
            } else if (n) {
                y = true;
            }
        }
        function J(e) {
            var n = e.value.replace(/[@#]__PURE__/g, " ");
            if (/^\s*$/.test(n) && !/^\s*$/.test(e.value)) return false;
            if (/comment[134]/.test(e.type)) {
                v("//" + n);
                b = true;
            } else if (e.type == "comment2") {
                v("/*" + n + "*/");
            }
            return true;
        }
        function X(e, n) {
            if (n instanceof sn) return n.left === e;
            if (n.TYPE == "Call") return n.expression === e;
            if (n instanceof Jt) return n.condition === e;
            if (n instanceof Bt) return n.expression === e;
            if (n instanceof mt) return true;
            if (n instanceof an) return n.expressions[0] === e;
            if (n instanceof Ut) return n.expression === e;
            if (n instanceof Gt) return true;
            if (n instanceof Kt) return true;
        }
        function K(e) {
            var r = this;
            var i;
            if (e instanceof mt) {
                i = e.value;
            } else if (e instanceof Kt) {
                i = e.expression;
            }
            var t = s(e);
            if (!t) t = [];
            if (i) {
                var a = new Ir(function(e) {
                    if (!X(e, a.parent())) return true;
                    var n = s(e);
                    if (n) t = t.concat(n);
                });
                a.push(e);
                i.walk(a);
            }
            if (u == 0) {
                if (t.length > 0 && f.shebang && t[0].type == "comment5") {
                    v("#!" + t.shift().value + "\n");
                    M();
                }
                var n = f.preamble;
                if (n) v(n.replace(/\r\n?|\u2028|\u2029|(^|\S)\s*$/g, "$1\n"));
            }
            t = t.filter(h, e);
            var o = false;
            t.forEach(function(e, n) {
                G(e, n);
                if (J(e)) o = true;
            });
            if (o) G(e.start, true);
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!i) return;
                    e.start = n = new ee();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!i) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === r) return;
                t._dumped = r;
                return t;
            }
        }
        function Q(e, t) {
            var n = this;
            var r = e.end;
            if (!r) return;
            var i = r[t ? "comments_before" : "comments_after"];
            if (!i || i._dumped === n) return;
            if (!(e instanceof Sn || en(i, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            i._dumped = n;
            var a = d.length;
            i.filter(h, e).forEach(function(e, n) {
                G(e, n || !t);
                J(e);
            });
            if (d.length > a) w = a;
        }
        return {
            get: V,
            reset: x,
            indent: M,
            should_break: f.width ? function() {
                return a - t >= f.width;
            } : dn,
            has_parens: function() {
                return s.slice(-1) == "(";
            },
            newline: j,
            print: v,
            space: C,
            comma: L,
            colon: B,
            last: function() {
                return s;
            },
            semicolon: N,
            force_semicolon: I,
            to_utf8: k,
            print_name: function(e) {
                v(k(e.toString(), true));
            },
            print_string: f.inline_script ? function(e, n) {
                e = A(e, n).replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                v(e.replace(/\x3c!--/g, "\\x3c!--").replace(/--\x3e/g, "--\\x3e"));
            } : function(e, n) {
                v(A(e, n));
            },
            with_indent: F,
            with_block: H,
            with_parens: Y,
            with_square: R,
            add_mapping: U,
            option: function(e) {
                return f[e];
            },
            prepend_comments: f.comments || f.shebang ? K : pn,
            append_comments: f.comments ? Q : pn,
            push_node: function(e) {
                r.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = r.pop();
                if (e.start && e.start.line > o) {
                    $(e.start.line - o);
                }
            } : function() {
                r.pop();
            },
            parent: function(e) {
                return r[r.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var c = false;
        nn.DEFMETHOD("print", function(e, n) {
            var t = this;
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(r);
            } else {
                r();
            }
            e.pop_node();
            function r() {
                e.prepend_comments(t);
                t.add_source_map(e);
                t._codegen(e);
                e.append_comments(t);
            }
        });
        var l = Kr({
            inline_script: false,
            shebang: false,
            width: false
        });
        nn.DEFMETHOD("print_to_string", function(e) {
            if (e) {
                var n = Kr(e);
                this.print(n);
                return n.get();
            }
            this.print(l);
            return l.reset();
        });
        function n(e, n) {
            e.DEFMETHOD("needs_parens", n);
        }
        n(nn, dn);
        function t(e) {
            var n = e.parent();
            if (!e.has_parens() && En(e, false, true)) {
                return this.name || !(n instanceof Pt);
            }
            if (e.option("webkit") && n instanceof Lt && n.expression === this) return true;
            if (e.option("wrap_iife") && n instanceof Ht && n.expression === this) return true;
        }
        n(et, t);
        n(nt, t);
        n(lt, t);
        n(tt, t);
        n(rt, t);
        function p(e) {
            return !e.has_parens() && En(e, true);
        }
        n(rr, p);
        function d(e) {
            var n = e.parent();
            if (n instanceof sn) return n.operator == "**" && n.left === this;
            if (n instanceof Ht) return n.expression === this;
            if (n instanceof ut) return true;
            if (n instanceof Lt) return n.expression === this;
            if (n instanceof Sr) return n.tag === this;
        }
        n(Xt, d);
        n(Wt, d);
        n(an, function(e) {
            var n = e.parent();
            return n instanceof Qt || Gn(n) && n.value === this || n instanceof Xt || n instanceof sn || n instanceof Ht || n instanceof ut || n instanceof pt || n instanceof Jt || n instanceof It || n instanceof nr || n instanceof Pt || n instanceof ye || n instanceof ir || n instanceof Lt && n.expression === this || n instanceof Vt || n instanceof Sr && n.tag === this || n instanceof Wt || n instanceof Mt || n instanceof Kt;
        });
        n(sn, function(e) {
            var n = e.parent();
            if (n instanceof Xt) return true;
            if (n instanceof sn) {
                var t = n.operator, r = Ur[t];
                var i = this.operator, a = Ur[i];
                return r > a || t == "??" && (i == "&&" || i == "||") || r == a && this === n[t == "**" ? "left" : "right"];
            }
            if (n instanceof Ht) return n.expression === this;
            if (n instanceof ut) return true;
            if (n instanceof Lt) return n.expression === this;
            if (n instanceof Sr) return n.tag === this;
            if (n instanceof Wt) return true;
        });
        function v(e, n) {
            if (!e.terminal) return false;
            if (!(n instanceof Ht || n instanceof Lt)) return false;
            return n.expression === e;
        }
        n(Lt, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof Yt && t.expression === n && Rt(n).TYPE == "Call") return true;
            return v(n, t);
        });
        n(Ht, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof Yt) return t.expression === n;
            if (e.option("webkit") && n.expression instanceof tt && t instanceof Lt && t.expression === n) {
                var r = e.parent(1);
                if (r instanceof fn && r.left === t) return true;
            }
            return v(n, t);
        });
        n(Yt, function(e) {
            if (z(this, e)) return false;
            var n = e.parent();
            if (n instanceof Ht) return n.expression === this;
            if (n instanceof Lt) return true;
            if (n instanceof Sr) return n.tag === this;
        });
        n(Dr, function(e) {
            if (!e.option("galio")) return false;
            var n = e.parent();
            return n instanceof Lt && n.expression === this && /^0/.test(M(this.value));
        });
        function r(e, n) {
            var t = n.parent();
            if (t instanceof Xt) return true;
            if (t instanceof sn) return !(t instanceof fn);
            if (t instanceof Ht) return t.expression === e;
            if (t instanceof ut) return true;
            if (t instanceof Jt) return t.condition === e;
            if (t instanceof Lt) return t.expression === e;
            if (t instanceof Sr) return t.tag === e;
            if (t instanceof Wt) return true;
        }
        n(Qn, function(e) {
            return r(this, e);
        });
        n(fn, function(e) {
            if (r(this, e)) return true;
            if (e.option("v8")) return this.left instanceof Zt;
            if (this.left instanceof tr) return p(e);
        });
        n(Zn, function(e) {
            return r(this, e);
        });
        n(Jt, function(e) {
            return r(this, e);
        });
        n(Kt, function(e) {
            return r(this, e);
        });
        e(An, function(e) {
            var n = this.quote;
            var t = this.value;
            switch (e.option("quote_style")) {
              case 0:
              case 2:
                if (t.indexOf('"') == -1) n = '"';
                break;

              case 1:
                if (t.indexOf("'") == -1) n = "'";
                break;
            }
            e.print(n + t + n);
            e.semicolon();
        });
        e(Tn, function(e) {
            e.print("debugger");
            e.semicolon();
        });
        function h(e, t, r, n) {
            var i = e.length - 1;
            var a = n;
            var o = c;
            e.forEach(function(e, n) {
                if (a) {
                    if (e instanceof An) {
                        if (e.value == "use asm") c = true;
                    } else if (!(e instanceof Dn)) {
                        if (e instanceof tn && e.body instanceof Ar) {
                            r.force_semicolon();
                        }
                        a = false;
                    }
                }
                if (e instanceof Dn) return;
                r.indent();
                e.print(r);
                if (n == i && t) return;
                r.newline();
                if (t) r.newline();
            });
            c = o;
        }
        e(Bn, function(e) {
            h(this.body, true, e, true);
            e.print("");
        });
        e(Cn, function(e) {
            this.label.print(e);
            e.colon();
            this.body.print(e);
        });
        e(tn, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        function a(e, n) {
            n.print("{");
            n.with_indent(function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function i(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    h(e.body, false, n, t);
                });
            } else a(e, n);
        }
        e(rn, function(e) {
            i(this, e);
        });
        e(Dn, function(e) {
            e.semicolon();
        });
        e(Pn, function(e) {
            var n = this;
            e.print("do");
            F(n.body, e);
            e.space();
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.semicolon();
        });
        e(jn, function(e) {
            var n = this;
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            u(n.body, e);
        });
        e(Nn, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                if (n.init) {
                    if (n.init instanceof $t) {
                        n.init.print(e);
                    } else {
                        A(n.init, e, true);
                    }
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.condition) {
                    n.condition.print(e);
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.step) {
                    n.step.print(e);
                }
            });
            u(n.body, e);
        });
        function m(t, r) {
            return function(e) {
                var n = this;
                e.print(t);
                e.space();
                e.with_parens(function() {
                    n.init.print(e);
                    e.space();
                    e.print(r);
                    e.space();
                    n.object.print(e);
                });
                u(n.body, e);
            };
        }
        e(Yn, m("for await", "of"));
        e(Hn, m("for", "in"));
        e(ye, m("for", "of"));
        e(Rn, function(e) {
            var n = this;
            e.print("with");
            e.space();
            e.with_parens(function() {
                n.expression.print(e);
            });
            u(n.body, e);
        });
        e(Ft, function(e) {
            e.print("export");
            e.space();
            this.body.print(e);
        });
        e(Pt, function(e) {
            e.print("export");
            e.space();
            e.print("default");
            e.space();
            var n = this.body;
            n.print(e);
            if (n instanceof lt) {
                if (!n.name) return;
            }
            if (n instanceof ct) return;
            if (n instanceof it) return;
            if (n instanceof Wn) {
                if (!n.name && !Gn(n)) return;
            }
            e.semicolon();
        });
        e(ke, function(r) {
            var i = this;
            r.print("export");
            r.space();
            var n = i.keys.length;
            if (n == 0) {
                a(i, r);
            } else if (i.keys[0] == "*") {
                t(0);
            } else r.with_block(function() {
                r.indent();
                t(0);
                for (var e = 1; e < n; e++) {
                    r.print(",");
                    r.newline();
                    r.indent();
                    t(e);
                }
                r.newline();
            });
            r.space();
            r.print("from");
            r.space();
            r.print_string(i.path, i.quote);
            r.semicolon();
            function t(e) {
                var n = i.aliases[e];
                var t = i.keys[e];
                r.print_name(t);
                if (n != t) {
                    r.space();
                    r.print("as");
                    r.space();
                    r.print_name(n);
                }
            }
        });
        e(jt, function(e) {
            var n = this;
            e.print("export");
            e.space();
            $(n, e);
            e.semicolon();
        });
        e(Nt, function(e) {
            var n = this;
            e.print("import");
            e.space();
            if (n.default) n.default.print(e);
            if (n.all) {
                if (n.default) e.comma();
                n.all.print(e);
            }
            if (n.properties) {
                if (n.default) e.comma();
                $(n, e);
            }
            if (n.all || n.default || n.properties) {
                e.space();
                e.print("from");
                e.space();
            }
            e.print_string(n.path, n.quote);
            e.semicolon();
        });
        function _(e, t) {
            t.with_parens(function() {
                e.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (e.rest) {
                    if (e.argnames.length) t.comma();
                    t.print("...");
                    e.rest.print(t);
                }
            });
        }
        function g(e, n) {
            var t = e.argnames.length == 1 && !e.rest && e.argnames[0];
            if (t instanceof hr && t.name != "yield") {
                t.print(n);
            } else {
                _(e, n);
            }
            n.space();
            n.print("=>");
            n.space();
            if (e.value) {
                e.value.print(n);
            } else {
                i(e, n, true);
            }
        }
        e(Qn, function(e) {
            g(this, e);
        });
        e(Zn, function(e) {
            e.print("async");
            e.space();
            g(this, e);
        });
        function o(e, n) {
            if (e.name) {
                n.space();
                e.name.print(n);
            }
            _(e, n);
            n.space();
            i(e, n, true);
        }
        e(Un, function(e) {
            e.print("function");
            o(this, e);
        });
        function b(e) {
            e.print("async");
            e.space();
            e.print("function");
            o(this, e);
        }
        e(at, b);
        e(et, b);
        function y(e) {
            e.print("async");
            e.space();
            e.print("function*");
            o(this, e);
        }
        e(ot, y);
        e(nt, y);
        function w(e) {
            e.print("function*");
            o(this, e);
        }
        e(ft, w);
        e(rt, w);
        e(ut, function(e) {
            var n = this;
            e.print("class");
            if (n.name) {
                e.space();
                n.name.print(e);
            }
            if (n.extends) {
                e.space();
                e.print("extends");
                e.space();
                n.extends.print(e);
            }
            e.space();
            $(n, e, true);
        });
        e(dt, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            s(n, e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                n.value.print(e);
            }
            e.semicolon();
        });
        e(we, q("get"));
        e(xe, q("set"));
        function x(e, n) {
            var t = e.value;
            if (Jn(t)) {
                n.print("async");
                n.space();
            }
            if (Xn(t)) n.print("*");
            s(e, n);
            o(e.value, n);
        }
        e(vt, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            x(n, e);
        });
        function k(t, r) {
            return function(e) {
                e.print(t);
                var n = this[r];
                if (n) {
                    e.space();
                    n.print(e);
                }
                e.semicolon();
            };
        }
        e(_t, k("return", "value"));
        e(gt, k("throw", "value"));
        e(yt, k("break", "label"));
        e(wt, k("continue", "label"));
        function E(e, n) {
            var t = e.body;
            if (n.option("braces") && !(t instanceof qt || t instanceof zt) || n.option("ie") && t instanceof Pn) return F(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof xt) {
                    if (!t.alternative) {
                        F(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof j) {
                    t = t.body;
                } else break;
            }
            u(e.body, n);
        }
        e(xt, function(e) {
            var n = this;
            e.print("if");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            if (n.alternative) {
                E(n, e);
                e.space();
                e.print("else");
                if (n.alternative instanceof xt) {
                    e.space();
                    n.alternative.print(e);
                } else {
                    u(n.alternative, e);
                }
            } else {
                u(n.body, e);
            }
        });
        e(kt, function(t) {
            var e = this;
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var r = e.body.length - 1;
            if (r < 0) a(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < r && e.body.length > 0) t.newline();
                });
            });
        });
        function S(e, n) {
            n.newline();
            e.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        e(St, function(e) {
            e.print("default:");
            S(this, e);
        });
        e(Tt, function(e) {
            var n = this;
            e.print("case");
            e.space();
            n.expression.print(e);
            e.print(":");
            S(n, e);
        });
        e(At, function(e) {
            var n = this;
            e.print("try");
            e.space();
            i(n, e);
            if (n.bcatch) {
                e.space();
                n.bcatch.print(e);
            }
            if (n.bfinally) {
                e.space();
                n.bfinally.print(e);
            }
        });
        e(Dt, function(e) {
            var n = this;
            e.print("catch");
            if (n.argname) {
                e.space();
                e.with_parens(function() {
                    n.argname.print(e);
                });
            }
            e.space();
            i(n, e);
        });
        e(Ot, function(e) {
            e.print("finally");
            e.space();
            i(this, e);
        });
        function T(r) {
            return function(t) {
                var e = this;
                t.print(r);
                t.space();
                e.definitions.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                var n = t.parent();
                if (!(n instanceof Mn && n.init === e)) t.semicolon();
            };
        }
        e(qt, T("const"));
        e(zt, T("let"));
        e(Ct, T("var"));
        function A(e, n, t) {
            var r = false;
            if (t) e.walk(new Ir(function(e) {
                if (r) return true;
                if (e instanceof sn && e.operator == "in") return r = true;
                if (e instanceof Ln && !(Gn(e) && e.value)) return true;
            }));
            e.print(n, r);
        }
        e(Mt, function(e) {
            var n = this;
            n.name.print(e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                var t = e.parent(1);
                var r = t instanceof Nn || t instanceof In;
                A(n.value, e, r);
            }
        });
        e(It, function(e) {
            var n = this;
            n.name.print(e);
            e.space();
            e.print("=");
            e.space();
            n.value.print(e);
        });
        function D(e, n) {
            if (!n.option("annotations")) return;
            if (!e.pure) return;
            var t = 0, r = e, i;
            do {
                i = r;
                r = n.parent(t++);
                if (r instanceof Ht && r.expression === i) return;
            } while (r instanceof Lt && r.expression === i);
            n.print("/*@__PURE__*/");
        }
        function O(e, t) {
            if (e.expression instanceof Ht || e.expression instanceof Un) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        }
        e(Ht, function(e) {
            var n = this;
            D(n, e);
            n.expression.print(e);
            if (n.optional) e.print("?.");
            O(n, e);
        });
        e(Yt, function(e) {
            var n = this;
            D(n, e);
            e.print("new");
            e.space();
            n.expression.print(e);
            if (z(n, e)) O(n, e);
        });
        e(an, function(t) {
            this.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(Bt, function(e) {
            var n = this;
            var t = n.expression;
            t.print(e);
            var r = n.property;
            if (e.option("ie") && N[r]) {
                e.print(n.optional ? "?.[" : "[");
                e.add_mapping(n.end);
                e.print_string(r);
                e.print("]");
            } else {
                if (t instanceof Dr && !/[ex.)]/i.test(e.last())) e.print(".");
                e.print(n.optional ? "?." : ".");
                e.add_mapping(n.end);
                e.print_name(r);
            }
        });
        e(Ut, function(e) {
            var n = this;
            n.expression.print(e);
            e.print(n.optional ? "?.[" : "[");
            n.property.print(e);
            e.print("]");
        });
        e(Vt, function(e) {
            e.print("...");
            this.expression.print(e);
        });
        e(on, function(e) {
            var n = this.operator;
            var t = this.expression;
            e.print(n);
            if (/^[a-z]/i.test(n) || /[+-]$/.test(n) && t instanceof on && /^[+-]/.test(t.operator)) {
                e.space();
            }
            t.print(e);
        });
        e(Gt, function(e) {
            this.expression.print(e);
            e.print(this.operator);
        });
        e(sn, function(e) {
            var n = this;
            n.left.print(e);
            e.space();
            e.print(n.operator);
            e.space();
            n.right.print(e);
        });
        e(Jt, function(e) {
            var n = this;
            n.condition.print(e);
            e.space();
            e.print("?");
            e.space();
            n.consequent.print(e);
            e.space();
            e.colon();
            n.alternative.print(e);
        });
        e(Xt, function(e) {
            e.print("await");
            e.space();
            this.expression.print(e);
        });
        e(Kt, function(e) {
            e.print(this.nested ? "yield*" : "yield");
            if (this.expression) {
                e.space();
                this.expression.print(e);
            }
        });
        e(Qt, function(t) {
            var e = this.elements, r = e.length;
            t.with_square(r > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === r - 1 && e instanceof Mr) t.comma();
                });
                t.space();
            } : pn);
        });
        e(er, function(t) {
            var e = this.elements, n = e.length, r = this.rest;
            t.with_square(n || r ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (r) {
                    if (n) t.comma();
                    t.print("...");
                    r.print(t);
                } else if (e[n - 1] instanceof Mr) {
                    t.comma();
                }
                t.space();
            } : pn);
        });
        e(nr, function(e) {
            var n = this;
            var t = s(n, e);
            var r = n.value;
            if (t) {
                if (r instanceof It) {
                    if (r.name instanceof ur && t == f(r.name)) {
                        e.space();
                        e.print("=");
                        e.space();
                        r.value.print(e);
                        return;
                    }
                } else if (r instanceof ur) {
                    if (t == f(r)) return;
                }
            }
            e.colon();
            r.print(e);
        });
        e(tr, function(t) {
            var e = this.properties, n = e.length, r = this.rest;
            if (n || r) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                if (r) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    t.print("...");
                    r.print(t);
                }
                t.newline();
            }); else a(this, t);
        });
        function $(e, t, r) {
            var n = e.properties;
            if (n.length > 0) t.with_block(function() {
                n.forEach(function(e, n) {
                    if (n) {
                        if (!r) t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else a(e, t);
        }
        e(rr, function(e) {
            $(this, e);
        });
        function s(e, n) {
            var t = e.key;
            if (t instanceof nn) return n.with_square(function() {
                t.print(n);
            });
            var r = e.start && e.start.quote;
            if (n.option("quote_keys") || r && n.option("keep_quoted_props")) {
                n.print_string(t, r);
            } else if ("" + +t == t && t >= 0) {
                n.print(M(t));
            } else if (e.private) {
                n.print_name(t);
            } else if (N[t] ? !n.option("ie") : Yr(t)) {
                n.print_name(t);
                return t;
            } else {
                n.print_string(t, r);
            }
        }
        e(ar, function(e) {
            var n = this;
            s(n, e);
            e.colon();
            n.value.print(e);
        });
        e(or, function(e) {
            x(this, e);
        });
        function q(t) {
            return function(e) {
                var n = this;
                if (n.static) {
                    e.print("static");
                    e.space();
                }
                e.print(t);
                e.space();
                s(n, e);
                o(n.value, e);
            };
        }
        e(fr, q("get"));
        e(sr, q("set"));
        function f(e) {
            var n = e.definition();
            return n && n.mangled_name || e.name;
        }
        e(ur, function(e) {
            e.print_name(f(this));
        });
        e(yr, function(e) {
            var n = this;
            var t = f(n);
            e.print_name(t);
            var r = n.alias;
            if (r != t) {
                e.space();
                e.print("as");
                e.space();
                e.print_name(r);
            }
        });
        e(pr, function(e) {
            var n = this;
            var t = f(n);
            var r = n.key;
            if (r && r != t) {
                e.print_name(r);
                e.space();
                e.print("as");
                e.space();
            }
            e.print_name(t);
        });
        e(Mr, pn);
        e(Sr, function(e) {
            var n = this;
            if (n.tag) n.tag.print(e);
            e.print("`");
            for (var t = 0; t < n.expressions.length; t++) {
                e.print(n.strings[t]);
                e.print("${");
                n.expressions[t].print(e);
                e.print("}");
            }
            e.print(n.strings[t]);
            e.print("`");
        });
        e(Tr, function(e) {
            e.print("" + this.value);
        });
        e(Ar, function(e) {
            e.print_string(this.value, this.quote);
        });
        e(Dr, function(e) {
            var n = this.start;
            if (c && n && n.raw != null) {
                e.print(n.raw);
            } else {
                e.print(M(this.value));
            }
        });
        e($r, function(e) {
            var n = this.value;
            var t = n.toString();
            var r = t.lastIndexOf("/");
            if (n.raw_source) {
                t = "/" + n.raw_source + t.slice(r);
            } else if (r == 1) {
                t = "/(?:)" + t.slice(r);
            } else if (t.indexOf("/", 1) < r) {
                t = "/" + t.slice(1, r).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + t.slice(r);
            }
            e.print(e.to_utf8(t).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
            var i = e.parent();
            if (i instanceof sn && /^in/.test(i.operator) && i.left === this) e.print(" ");
        });
        function u(e, n) {
            if (n.option("braces") && !(e instanceof qt || e instanceof zt)) {
                F(e, n);
            } else if (e instanceof Dn) {
                n.force_semicolon();
            } else {
                n.space();
                e.print(n);
            }
        }
        function z(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function C(e) {
            var n = e[0], t = n.length;
            for (var r = 1; r < e.length; ++r) {
                if (e[r].length < t) {
                    n = e[r];
                    t = n.length;
                }
            }
            return n;
        }
        function M(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var r, i, a;
            if (r = /^\.0+/.exec(n)) {
                i = r[0].length;
                a = n.slice(i);
                t.push(a + "e-" + (a.length + i - 1));
            } else if (r = /[^0]0+$/.exec(n)) {
                i = r[0].length - 1;
                t.push(n.slice(0, -i) + "e" + i);
            } else if (r = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(r[1] + r[2] + "e" + (r[3] - r[2].length));
            }
            return C(t);
        }
        function F(e, n) {
            n.space();
            if (e instanceof Dn) {
                a(e, n);
            } else if (e instanceof rn) {
                e.print(n);
            } else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function P(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        P([ nn, Cn ], pn);
        P([ Qt, rn, Dt, Tr, Tn, $t, Zt, Ot, ht, Un, Yt, rr, j, ur, kt, Et, At ], function(e) {
            e.add_mapping(this.start);
        });
        P([ pt, nr, ir ], function(e) {
            if (typeof this.key == "string") e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var S = n("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var T = S.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function A(e, n) {
        var t = 0;
        var r = 0;
        for (var i = 0, a = 0; i < n.length; i++) {
            var o = T[n[i]];
            t += (o & 31) << r;
            if (o & 32) {
                r += 5;
            } else {
                e[a++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = r = 0;
            }
        }
        return a;
    }
    function D(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += S[t];
        } while (e);
        return n;
    }
    function O() {
        var t = new xn();
        var r = [];
        r.index = function(e) {
            var n = t.get(e);
            if (!(n >= 0)) {
                n = r.length;
                r.push(e);
                t.set(e, n);
            }
            return n;
        };
        return r;
    }
    function $(l) {
        var f = O();
        var a = l.includeSources && new xn();
        var u = O();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, A(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!a || !n.sourcesContent) return;
            for (var r = 0; r < n.sources.length; r++) {
                var i = n.sourcesContent[r];
                if (i) a.set(n.sources[r], i);
            }
        });
        var p;
        var d = 1;
        var v = 0;
        var h = 0;
        var m = 1;
        var _ = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, c, t, r, i) {
                var a = l.orig[e];
                if (a) {
                    var o = a.mappings[t - 1];
                    if (!o) return;
                    var s;
                    for (var f = 0; f < o.length; f++) {
                        var u = o[f][0];
                        if (r >= u) s = o[f];
                        if (r <= u) break;
                    }
                    if (!s || s.length < 4) {
                        e = null;
                    } else {
                        e = a.sources[s[1]];
                        t = s[2];
                        r = s[3];
                        if (s.length > 4) i = a.names[s[4]];
                    }
                }
                b(e, n, c, t, r, i);
            } : b,
            setSourceContent: a ? function(e, n) {
                if (!a.has(e)) {
                    a.set(e, n);
                }
            } : pn,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: a ? f.map(function(e) {
                        return a.get(e) || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, r, i, a) {
            if (p == null && e == null) return;
            p = e;
            if (d < n) {
                v = 0;
                do {
                    c += ";";
                } while (++d < n);
            } else if (c) {
                c += ",";
            }
            c += D(t - v);
            v = t;
            if (e == null) return;
            var o = f.index(e);
            c += D(o - h);
            h = o;
            c += D(r - m);
            m = r;
            c += D(i - _);
            _ = i;
            if (l.names && a != null) {
                var s = u.index(a);
                c += D(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        var r = {
            Program: function(e) {
                return new Bn({
                    start: s(e),
                    end: f(e),
                    body: d(e.body.map(u))
                });
            },
            ArrowFunctionExpression: function(e) {
                var n = [], t = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = u(e.argument);
                    } else {
                        n.push(u(e));
                    }
                });
                var r = new (e.async ? Zn : Qn)({
                    start: s(e),
                    end: f(e),
                    argnames: n,
                    rest: t
                });
                var i = u(e.body);
                if (i instanceof rn) {
                    r.body = d(i.body);
                    r.value = null;
                } else {
                    r.body = [];
                    r.value = i;
                }
                return r;
            },
            FunctionDeclaration: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? ot : at;
                } else {
                    n = e.generator ? ft : st;
                }
                var t = [], r = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        r = u(e.argument);
                    } else {
                        t.push(u(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: t,
                    rest: r,
                    body: d(u(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? nt : et;
                } else {
                    n = e.generator ? rt : tt;
                }
                var t = [], r = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        r = u(e.argument);
                    } else {
                        t.push(u(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: t,
                    rest: r,
                    body: d(u(e.body).body)
                });
            },
            ClassDeclaration: function(e) {
                return new ct({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    extends: u(e.superClass),
                    properties: e.body.body.map(u)
                });
            },
            ClassExpression: function(e) {
                return new lt({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    extends: u(e.superClass),
                    properties: e.body.body.map(u)
                });
            },
            MethodDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = u(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = a(n);
                }
                var r = vt, i = u(e.value);
                switch (e.kind) {
                  case "get":
                    r = we;
                    i = new Vn(i);
                    break;

                  case "set":
                    r = xe;
                    i = new Vn(i);
                    break;
                }
                return new r({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: i
                });
            },
            PropertyDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = u(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = a(n);
                }
                return new dt({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: u(e.value)
                });
            },
            ForOfStatement: function(e) {
                return new (e.await ? Yn : ye)({
                    start: s(e),
                    end: f(e),
                    init: u(e.left),
                    object: u(e.right),
                    body: u(e.body)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new At({
                    start: s(e),
                    end: f(e),
                    body: u(e.block).body,
                    bcatch: u(n[0]),
                    bfinally: e.finalizer ? new Ot(u(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.computed ? u(e.key) : a(e.key);
                var t = {
                    start: s(e),
                    end: f(e),
                    key: n,
                    value: u(e.value)
                };
                if (e.kind == "init") return new (e.method ? or : ar)(t);
                t.value = new Vn(t.value);
                if (e.kind == "get") return new fr(t);
                if (e.kind == "set") return new sr(t);
            },
            ArrayExpression: function(e) {
                return new Qt({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new Mr() : u(e);
                    })
                });
            },
            ArrayPattern: function(e) {
                var n = [], t = null;
                e.elements.forEach(function(e) {
                    if (e === null) {
                        n.push(new Mr());
                    } else if (e.type == "RestElement") {
                        t = u(e.argument);
                    } else {
                        n.push(u(e));
                    }
                });
                return new er({
                    start: s(e),
                    end: f(e),
                    elements: n,
                    rest: t
                });
            },
            ObjectPattern: function(e) {
                var n = [], t = null;
                e.properties.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = u(e.argument);
                    } else {
                        n.push(new nr(u(e)));
                    }
                });
                return new tr({
                    start: s(e),
                    end: f(e),
                    properties: n,
                    rest: t
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? Ut : Bt)({
                    start: s(e),
                    end: f(e),
                    optional: e.optional,
                    expression: u(e.object),
                    property: e.computed ? u(e.property) : e.property.name
                });
            },
            MetaProperty: function(e) {
                var n = u(e.meta);
                var t = a(e.property);
                if (n.name == "new" && t == "target") return new Er({
                    start: s(e),
                    end: f(e),
                    name: "new.target"
                });
                return new Bt({
                    start: s(e),
                    end: f(e),
                    expression: n,
                    property: t
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? Tt : St)({
                    start: s(e),
                    end: f(e),
                    expression: u(e.test),
                    body: e.consequent.map(u)
                });
            },
            ExportAllDeclaration: function(e) {
                var n = e.exported ? a(e.exported) : "*";
                return new ke({
                    start: s(e),
                    end: f(e),
                    aliases: [ n ],
                    keys: [ "*" ],
                    path: e.source.value
                });
            },
            ExportDefaultDeclaration: function(e) {
                var n = u(e.declaration);
                if (!n.name) switch (n.CTOR) {
                  case at:
                    n = new et(n);
                    break;

                  case ot:
                    n = new nt(n);
                    break;

                  case ct:
                    n = new lt(n);
                    break;

                  case st:
                    n = new tt(n);
                    break;

                  case ft:
                    n = new rt(n);
                    break;
                }
                return new Pt({
                    start: s(e),
                    end: f(e),
                    body: n
                });
            },
            ExportNamedDeclaration: function(e) {
                if (e.declaration) return new Ft({
                    start: s(e),
                    end: f(e),
                    body: u(e.declaration)
                });
                if (e.source) {
                    var n = [], t = [];
                    e.specifiers.forEach(function(e) {
                        n.push(a(e.exported));
                        t.push(a(e.local));
                    });
                    return new ke({
                        start: s(e),
                        end: f(e),
                        aliases: n,
                        keys: t,
                        path: e.source.value
                    });
                }
                return new jt({
                    start: s(e),
                    end: f(e),
                    properties: e.specifiers.map(function(e) {
                        var n = new yr(u(e.local));
                        n.alias = a(e.exported);
                        return n;
                    })
                });
            },
            ImportDeclaration: function(e) {
                var t = null, r = null, i = null;
                e.specifiers.forEach(function(e) {
                    var n = new pr(u(e.local));
                    switch (e.type) {
                      case "ImportDefaultSpecifier":
                        r = n;
                        r.key = "";
                        break;

                      case "ImportNamespaceSpecifier":
                        t = n;
                        t.key = "*";
                        break;

                      default:
                        n.key = e.imported.name || syn.name;
                        if (!i) i = [];
                        i.push(n);
                        break;
                    }
                });
                return new Nt({
                    start: s(e),
                    end: f(e),
                    all: t,
                    default: r,
                    properties: i,
                    path: e.source.value
                });
            },
            ImportExpression: function(e) {
                var n = s(e);
                var t = u(e.source);
                return new Ht({
                    start: n,
                    end: f(e),
                    expression: new un({
                        start: n,
                        end: t.start,
                        name: "import"
                    }),
                    args: [ t ]
                });
            },
            VariableDeclaration: function(e) {
                return new ({
                    const: qt,
                    let: zt
                }[e.kind] || Ct)({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(u)
                });
            },
            Literal: function(e) {
                var n = {
                    start: s(e),
                    end: f(e)
                };
                if (e.bigint) {
                    n.value = e.bigint.toLowerCase() + "n";
                    return new Or(n);
                }
                var t = e.value;
                if (t === null) return new qr(n);
                var r = e.regex;
                if (r && r.pattern) {
                    n.value = new RegExp(r.pattern, r.flags);
                    n.value.raw_source = r.pattern;
                    return new $r(n);
                } else if (r) {
                    n.value = e.regex && e.raw ? e.raw : t;
                    return new $r(n);
                }
                switch (typeof t) {
                  case "string":
                    n.value = t;
                    return new Ar(n);

                  case "number":
                    if (isNaN(t)) return new zr(n);
                    var i, a;
                    if (isFinite(t)) {
                        i = 1 / t < 0;
                        n.value = i ? -t : t;
                        a = new Dr(n);
                    } else {
                        i = t < 0;
                        a = new Fr(n);
                    }
                    return i ? new on({
                        start: n.start,
                        end: n.end,
                        operator: "-",
                        expression: a
                    }) : a;

                  case "boolean":
                    return new (t ? Nr : jr)(n);
                }
            },
            TemplateLiteral: function(e) {
                return new Sr({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(u),
                    strings: e.quasis.map(function(e) {
                        return e.value.raw;
                    })
                });
            },
            TaggedTemplateExpression: function(e) {
                var n = u(e.quasi);
                n.start = s(e);
                n.end = f(e);
                n.tag = u(e.tag);
                return n;
            },
            Identifier: function(e) {
                var n, t = i.length - 1;
                do {
                    n = i[--t];
                } while (n.type == "ArrayPattern" || n.type == "AssignmentPattern" && n.left === i[t + 1] || n.type == "ObjectPattern" || n.type == "Property" && n.value === i[t + 1] || n.type == "VariableDeclarator" && n.id === i[t + 1]);
                var r = un;
                switch (n.type) {
                  case "ArrowFunctionExpression":
                    if (n.body !== i[t + 1]) r = hr;
                    break;

                  case "BreakStatement":
                  case "ContinueStatement":
                    r = Te;
                    break;

                  case "CatchClause":
                    r = br;
                    break;

                  case "ClassDeclaration":
                    if (n.id === i[t + 1]) r = Ee;
                    break;

                  case "ClassExpression":
                    if (n.id === i[t + 1]) r = gr;
                    break;

                  case "FunctionDeclaration":
                    r = n.id === i[t + 1] ? mr : hr;
                    break;

                  case "FunctionExpression":
                    r = n.id === i[t + 1] ? _r : hr;
                    break;

                  case "LabeledStatement":
                    r = Se;
                    break;

                  case "VariableDeclaration":
                    r = {
                        const: lr,
                        let: dr
                    }[n.kind] || vr;
                    break;
                }
                return new r({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            Super: function(e) {
                return new xr({
                    start: s(e),
                    end: f(e),
                    name: "super"
                });
            },
            ThisExpression: function(e) {
                return new kr({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            },
            ParenthesizedExpression: function(e) {
                var n = u(e.expression);
                if (!n.start.parens) n.start.parens = [];
                n.start.parens.push(s(e));
                if (!n.end.parens) n.end.parens = [];
                n.end.parens.push(f(e));
                return n;
            },
            ChainExpression: function(e) {
                var n = u(e.expression);
                n.terminal = true;
                return n;
            }
        };
        r.UpdateExpression = r.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? on : Gt)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: u(n.argument)
            });
        };
        e("EmptyStatement", Dn);
        e("ExpressionStatement", tn, "expression>body");
        e("BlockStatement", rn, "body@body");
        e("IfStatement", xt, "test>condition, consequent>body, alternate>alternative");
        e("LabeledStatement", Cn, "label>label, body>body");
        e("BreakStatement", yt, "label>label");
        e("ContinueStatement", wt, "label>label");
        e("WithStatement", Rn, "object>expression, body>body");
        e("SwitchStatement", kt, "discriminant>expression, cases@body");
        e("ReturnStatement", _t, "argument>value");
        e("ThrowStatement", gt, "argument>value");
        e("WhileStatement", jn, "test>condition, body>body");
        e("DoWhileStatement", Pn, "test>condition, body>body");
        e("ForStatement", Nn, "init>init, test>condition, update>step, body>body");
        e("ForInStatement", Hn, "left>init, right>object, body>body");
        e("DebuggerStatement", Tn);
        e("VariableDeclarator", Mt, "id>name, init>value");
        e("CatchClause", Dt, "param>argname, body%body");
        e("BinaryExpression", sn, "operator=operator, left>left, right>right");
        e("LogicalExpression", sn, "operator=operator, left>left, right>right");
        e("AssignmentExpression", fn, "operator=operator, left>left, right>right");
        e("AssignmentPattern", It, "left>name, right>value");
        e("ConditionalExpression", Jt, "test>condition, consequent>consequent, alternate>alternative");
        e("NewExpression", Yt, "callee>expression, arguments@args, pure=pure");
        e("CallExpression", Ht, "callee>expression, arguments@args, optional=optional, pure=pure");
        e("SequenceExpression", an, "expressions@expressions");
        e("SpreadElement", Vt, "argument>expression");
        e("ObjectExpression", rr, "properties@properties");
        e("AwaitExpression", Xt, "argument>expression");
        e("YieldExpression", Kt, "argument>expression, delegate=nested");
        c(Bn, function e(n) {
            return p("Program", n);
        });
        c(it, function e(n) {
            var t = n.argnames.map(l);
            if (n.rest) t.push({
                type: "RestElement",
                argument: l(n.rest)
            });
            return {
                type: "FunctionDeclaration",
                id: l(n.name),
                async: Jn(n),
                generator: Xn(n),
                params: t,
                body: p("BlockStatement", n)
            };
        });
        c(Un, function e(n) {
            var t = n.argnames.map(l);
            if (n.rest) t.push({
                type: "RestElement",
                argument: l(n.rest)
            });
            if (Gn(n)) return {
                type: "ArrowFunctionExpression",
                async: Jn(n),
                params: t,
                body: n.value ? l(n.value) : p("BlockStatement", n)
            };
            return {
                type: "FunctionExpression",
                id: l(n.name),
                async: Jn(n),
                generator: Xn(n),
                params: t,
                body: p("BlockStatement", n)
            };
        });
        c(ct, function e(n) {
            return {
                type: "ClassDeclaration",
                id: l(n.name),
                superClass: l(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(l)
                }
            };
        });
        c(lt, function e(n) {
            return {
                type: "ClassExpression",
                id: l(n.name),
                superClass: l(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(l)
                }
            };
        });
        function n(r) {
            return function(e) {
                var n = e.key instanceof nn;
                var t = n ? l(e.key) : e.private ? {
                    type: "PrivateIdentifier",
                    name: e.key.slice(1)
                } : {
                    type: "Literal",
                    value: e.key
                };
                return {
                    type: "MethodDefinition",
                    kind: r,
                    computed: n,
                    key: t,
                    static: e.static,
                    value: l(e.value)
                };
            };
        }
        c(we, n("get"));
        c(xe, n("set"));
        c(vt, n("method"));
        c(dt, function e(n) {
            var t = n.key instanceof nn;
            var r = t ? l(n.key) : n.private ? {
                type: "PrivateIdentifier",
                name: n.key.slice(1)
            } : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "PropertyDefinition",
                computed: t,
                key: r,
                static: n.static,
                value: l(n.value)
            };
        });
        function t(n) {
            return function(e) {
                return {
                    type: "ForOfStatement",
                    await: n,
                    left: l(e.init),
                    right: l(e.object),
                    body: l(e.body)
                };
            };
        }
        c(Yn, t(true));
        c(ye, t(false));
        c(An, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: h(n, {
                    type: "Literal",
                    value: n.value
                })
            };
        });
        c(Et, function e(n) {
            return {
                type: "SwitchCase",
                test: l(n.expression),
                consequent: n.body.map(l)
            };
        });
        c(At, function e(n) {
            return {
                type: "TryStatement",
                block: m(n),
                handler: l(n.bcatch),
                guardedHandlers: [],
                finalizer: l(n.bfinally)
            };
        });
        c(Dt, function e(n) {
            return {
                type: "CatchClause",
                param: l(n.argname),
                guard: null,
                body: m(n)
            };
        });
        c(Ft, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                declaration: l(n.body)
            };
        });
        c(Pt, function e(n) {
            return {
                type: "ExportDefaultDeclaration",
                declaration: l(n.body)
            };
        });
        c(ke, function e(n) {
            if (n.keys[0] == "*") return {
                type: "ExportAllDeclaration",
                exported: n.aliases[0] == "*" ? null : {
                    type: "Identifier",
                    name: n.aliases[0]
                },
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
            var t = [];
            for (var r = 0; r < n.aliases.length; r++) {
                t.push({
                    type: "ExportSpecifier",
                    exported: {
                        type: "Identifier",
                        name: n.aliases[r]
                    },
                    local: {
                        type: "Identifier",
                        name: n.keys[r]
                    }
                });
            }
            return {
                type: "ExportNamedDeclaration",
                specifiers: t,
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
        });
        c(jt, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                specifiers: n.properties.map(function(e) {
                    return {
                        type: "ExportSpecifier",
                        local: l(e),
                        exported: {
                            type: "Identifier",
                            name: e.alias
                        }
                    };
                })
            };
        });
        c(Nt, function e(n) {
            var t = n.properties ? n.properties.map(function(e) {
                return {
                    type: "ImportSpecifier",
                    local: l(e),
                    imported: {
                        type: "Identifier",
                        name: e.key
                    }
                };
            }) : [];
            if (n.all) t.unshift({
                type: "ImportNamespaceSpecifier",
                local: l(n.all)
            });
            if (n.default) t.unshift({
                type: "ImportDefaultSpecifier",
                local: l(n.default)
            });
            return {
                type: "ImportDeclaration",
                specifiers: t,
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
        });
        c($t, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: n.TYPE.toLowerCase(),
                declarations: n.definitions.map(l)
            };
        });
        c(Lt, function e(n) {
            var t = n instanceof Ut;
            var r = {
                type: "MemberExpression",
                object: l(n.expression),
                computed: t,
                optional: n.optional,
                property: t ? l(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
            return n.terminal ? {
                type: "ChainExpression",
                expression: r
            } : r;
        });
        c(Wt, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof on,
                argument: l(n.expression)
            };
        });
        c(sn, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: l(n.left),
                operator: n.operator,
                right: l(n.right)
            };
        });
        c(Qt, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(l)
            };
        });
        c(er, function e(n) {
            var t = n.elements.map(l);
            if (n.rest) t.push({
                type: "RestElement",
                argument: l(n.rest)
            });
            return {
                type: "ArrayPattern",
                elements: t
            };
        });
        c(nr, function e(n) {
            var t = n.key instanceof nn;
            var r = t ? l(n.key) : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "Property",
                kind: "init",
                computed: t,
                key: r,
                value: l(n.value)
            };
        });
        c(tr, function e(n) {
            var t = n.properties.map(l);
            if (n.rest) t.push({
                type: "RestElement",
                argument: l(n.rest)
            });
            return {
                type: "ObjectPattern",
                properties: t
            };
        });
        c(ir, function e(n) {
            var t = n.key instanceof nn;
            var r = t ? l(n.key) : {
                type: "Literal",
                value: n.key
            };
            var i;
            if (n instanceof ar) {
                i = "init";
            } else if (n instanceof fr) {
                i = "get";
            } else if (n instanceof sr) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                computed: t,
                method: n instanceof or,
                key: r,
                value: l(n.value)
            };
        });
        c(ur, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        c(xr, function e() {
            return {
                type: "Super"
            };
        });
        c(kr, function e() {
            return {
                type: "ThisExpression"
            };
        });
        c(Er, function e() {
            return {
                type: "MetaProperty",
                meta: {
                    type: "Identifier",
                    name: "new"
                },
                property: {
                    type: "Identifier",
                    name: "target"
                }
            };
        });
        c($r, function e(n) {
            var t = n.value.toString().match(/\/([gimuy]*)$/)[1];
            var r = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: r,
                raw: r,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        c(Or, function e(n) {
            var t = n.value;
            return {
                type: "Literal",
                bigint: t.slice(0, -1),
                raw: t
            };
        });
        function o(e) {
            var n = e.value;
            if (typeof n === "number" && (n < 0 || n === 0 && 1 / n < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -n,
                        raw: e.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: n,
                raw: e.start.raw
            };
        }
        c(Pr, o);
        c(Tr, o);
        c(qr, o);
        c(g, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        c(Sr, function e(n) {
            var t = n.strings.length - 1;
            var r = {
                type: "TemplateLiteral",
                expressions: n.expressions.map(l),
                quasis: n.strings.map(function(e, n) {
                    return {
                        type: "TemplateElement",
                        tail: n == t,
                        value: {
                            raw: e
                        }
                    };
                })
            };
            if (!n.tag) return r;
            return {
                type: "TaggedTemplateExpression",
                tag: l(n.tag),
                quasi: r
            };
        });
        zn.DEFMETHOD("to_mozilla_ast", rn.prototype.to_mozilla_ast);
        Mr.DEFMETHOD("to_mozilla_ast", mn);
        nn.DEFMETHOD("to_mozilla_ast", function() {
            throw new Error("Cannot convert AST_" + this.TYPE);
        });
        function d(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof tn)) break;
                var r = t.body;
                if (!(r instanceof Ar)) break;
                if (t.start.pos !== r.start.pos) break;
                e[n] = new An(r);
            }
            return e;
        }
        function v(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var r = e.range;
            return new ee({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: r ? r[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: r ? r[0] : e.start,
                raw: v(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var r = e.range;
            return new ee({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: r ? r[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: r ? r[1] : e.end,
                raw: v(e)
            });
        }
        function a(e) {
            return "" + e[e.type == "Identifier" ? "name" : "value"];
        }
        function e(e, n, t) {
            var a = [ "start: my_start_token(M)", "end: my_end_token(M)" ];
            var o = [ "type: " + JSON.stringify(e) ];
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], r = n[2], i = n[3];
                switch (r) {
                  case "@":
                    a.push(i + ": M." + t + ".map(from_moz)");
                    o.push(t + ": M." + i + ".map(to_moz)");
                    break;

                  case ">":
                    a.push(i + ": from_moz(M." + t + ")");
                    o.push(t + ": to_moz(M." + i + ")");
                    break;

                  case "=":
                    a.push(i + ": M." + t);
                    o.push(t + ": M." + i);
                    break;

                  case "%":
                    a.push(i + ": from_moz(M." + t + ").body");
                    o.push(t + ": to_moz_block(M)");
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            r[e] = new Function("U2", "my_start_token", "my_end_token", "from_moz", [ "return function From_Moz_" + e + "(M) {", "    return new U2.AST_" + n.TYPE + "({", a.join(",\n"), "    });", "};" ].join("\n"))(_, s, f, u);
            c(n, new Function("to_moz", "to_moz_block", "to_moz_scope", [ "return function To_Moz_" + e + "(M) {", "    return {", o.join(",\n"), "    };", "};" ].join("\n"))(l, m, p));
        }
        var i = null;
        function u(e) {
            i.push(e);
            var n = null;
            if (e) {
                if (!kn(r, e.type)) throw new Error("Unsupported type: " + e.type);
                n = r[e.type](e);
            }
            i.pop();
            return n;
        }
        nn.from_mozilla_ast = function(e) {
            var n = i;
            i = [];
            var t = u(e);
            i = n;
            t.walk(new Ir(function(e) {
                if (e instanceof Te) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof Ln) break;
                        if (t instanceof Cn && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var r = e.start;
                        Oe("Undefined label " + e.name, r.file, r.line, r.col, r.pos);
                    }
                }
            }));
            return t;
        };
        function h(e, n) {
            var t = e.start;
            var r = e.end;
            if (t.pos != null && r.endpos != null) {
                n.range = [ t.pos, r.endpos ];
            }
            if (t.line) {
                n.loc = {
                    start: {
                        line: t.line,
                        column: t.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (t.file) {
                    n.loc.source = t.file;
                }
            }
            return n;
        }
        function c(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return h(this, n(this));
            });
        }
        function l(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function m(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(l)
            };
        }
        function p(e, n) {
            var t = n.body.map(l);
            if (n.body[0] instanceof tn && n.body[0].body instanceof Ar) {
                t.unshift(l(new Dn(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var q = function() {
        var n = new xn();
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(new e()).map(t);
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        return n;
        function t(e) {
            n.set(e, true);
        }
    }();
    function z(e, n) {
        e.walk(new Ir(function(e) {
            if (e instanceof pt) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof ir) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof Ut) {
                W(e.property, t);
            }
        }));
        function t(e) {
            gn(n, e);
        }
    }
    function W(e, n) {
        if (e instanceof Jt) {
            W(e.consequent, n);
            W(e.alternative, n);
        } else if (e instanceof an) {
            W(e.tail_node(), n);
        } else if (e instanceof Ar) {
            n(e.value);
        }
    }
    function G(e, t) {
        t = be(t, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            regex: null,
            reserved: null
        }, true);
        var n = t.builtins ? new xn() : q.clone();
        if (Array.isArray(t.reserved)) t.reserved.forEach(function(e) {
            n.set(e, true);
        });
        var c = -1;
        var r;
        if (t.cache) {
            r = t.cache.props;
            r.each(function(e) {
                n.set(e, true);
            });
        } else {
            r = new xn();
        }
        var i = t.regex;
        var a = t.debug !== false;
        var l;
        if (a) l = t.debug === true ? "" : t.debug;
        var p = new xn();
        var d = n.clone();
        e.walk(new Ir(function(e) {
            if (e instanceof sn) {
                if (e.operator == "in") W(e.left, s);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Bt) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof un)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    W(e.args[1], s);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    W(e.args[0], s);
                    break;
                }
            } else if (e instanceof pt) {
                if (typeof e.key == "string") s(e.key);
            } else if (e instanceof Bt) {
                s(e.property);
            } else if (e instanceof ir) {
                if (typeof e.key == "string") s(e.key);
            } else if (e instanceof Ut) {
                W(e.property, s);
            }
        }));
        e.walk(new Ir(function(e) {
            if (e instanceof sn) {
                if (e.operator == "in") u(e.left);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Bt) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof un)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    u(e.args[1]);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    u(e.args[0]);
                    break;
                }
            } else if (e instanceof pt) {
                if (typeof e.key == "string") e.key = f(e.key);
            } else if (e instanceof Bt) {
                e.property = f(e.property);
            } else if (e instanceof ir) {
                if (typeof e.key == "string") e.key = f(e.key);
            } else if (e instanceof Ut) {
                if (!t.keep_quoted) u(e.property);
            }
        }));
        function o(e) {
            if (d.has(e)) return false;
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function v(e) {
            if (n.has(e)) return false;
            if (i && !i.test(e)) return false;
            return r.has(e) || p.has(e);
        }
        function s(e) {
            if (o(e)) p.set(e, true);
            if (!v(e)) d.set(e, true);
        }
        function f(e) {
            if (!v(e)) return e;
            var n = r.get(e);
            if (!n) {
                if (a) {
                    var t = "_$" + e + "$" + l + "_";
                    if (o(t)) n = t;
                }
                if (!n) do {
                    n = E(++c);
                } while (!o(n));
                if (/^#/.test(e)) n = "#" + n;
                r.set(e, n);
            }
            return n;
        }
        function u(e) {
            if (e instanceof an) {
                u(e.expressions.tail_node());
            } else if (e instanceof Ar) {
                e.value = f(e.value);
            } else if (e instanceof Jt) {
                u(e.consequent);
                u(e.alternative);
            }
        }
    }
    "use strict";
    var J, X;
    if (typeof Buffer == "undefined") {
        J = atob;
        X = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        J = function(e) {
            return new Buffer(e, "base64").toString();
        };
        X = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        J = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        X = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function K(e, n) {
        var t = n.end.comments_after;
        for (var r = t.length; --r >= 0; ) {
            var i = t[r];
            if (i.type != "comment1") break;
            var a = /^# ([^\s=]+)=(\S+)\s*$/.exec(i.value);
            if (!a) break;
            if (a[1] == "sourceMappingURL") {
                a = /^data:application\/json(;.*?)?;base64,([^,]+)$/.exec(a[2]);
                if (!a) break;
                return J(a[2]);
            }
        }
        nn.warn("inline source map not found: {name}", {
            name: e
        });
    }
    function Q(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function ae(n, t, e) {
        e.forEach(function(e) {
            if (t[e]) {
                if (typeof t[e] != "object") t[e] = {};
                if (!(n in t[e])) t[e][n] = t[n];
            }
        });
    }
    function oe(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new xn();
        } else if (!(e.props instanceof xn)) {
            e.props = xn.fromObject(e.props);
        }
    }
    function se(e) {
        return {
            props: e.props.toObject()
        };
    }
    function fe(r, i) {
        try {
            i = be(i, {
                annotations: undefined,
                compress: {},
                enclose: false,
                ie: false,
                ie8: false,
                keep_fargs: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                v8: false,
                validate: false,
                warnings: false,
                webkit: false,
                wrap: false
            }, true);
            if (i.validate) nn.enable_validation();
            var e = i.timings && {
                start: Date.now()
            };
            if (i.rename === undefined) i.rename = i.compress && i.mangle;
            if (i.annotations !== undefined) ae("annotations", i, [ "compress", "output" ]);
            if (i.ie8) i.ie = i.ie || i.ie8;
            if (i.ie) ae("ie", i, [ "compress", "mangle", "output" ]);
            if (i.keep_fargs) ae("keep_fargs", i, [ "compress", "mangle" ]);
            if (i.keep_fnames) ae("keep_fnames", i, [ "compress", "mangle" ]);
            if (i.toplevel) ae("toplevel", i, [ "compress", "mangle" ]);
            if (i.v8) ae("v8", i, [ "mangle", "output" ]);
            if (i.webkit) ae("webkit", i, [ "compress", "mangle", "output" ]);
            var n;
            if (i.mangle) {
                i.mangle = be(i.mangle, {
                    cache: i.nameCache && (i.nameCache.vars || {}),
                    eval: false,
                    ie: false,
                    keep_fargs: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false,
                    v8: false,
                    webkit: false
                }, true);
                if (i.mangle.properties) {
                    if (typeof i.mangle.properties != "object") {
                        i.mangle.properties = {};
                    }
                    if (i.mangle.properties.keep_quoted) {
                        n = i.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        i.mangle.properties.reserved = n;
                    }
                    if (i.nameCache && !("cache" in i.mangle.properties)) {
                        i.mangle.properties.cache = i.nameCache.props || {};
                    }
                }
                oe(i.mangle.cache);
                oe(i.mangle.properties.cache);
            }
            if (i.sourceMap) {
                i.sourceMap = be(i.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (i.warnings) nn.log_function(function(e) {
                t.push(e);
            }, i.warnings == "verbose");
            if (e) e.parse = Date.now();
            var a;
            if (r instanceof Bn) {
                a = r;
            } else {
                if (typeof r == "string") {
                    r = [ r ];
                }
                i.parse = i.parse || {};
                i.parse.toplevel = null;
                var o = i.sourceMap && i.sourceMap.content;
                if (typeof o == "string" && o != "inline") {
                    o = Q(o);
                }
                if (o) i.sourceMap.orig = Object.create(null);
                for (var s in r) if (kn(r, s)) {
                    i.parse.filename = s;
                    i.parse.toplevel = a = Vr(r[s], i.parse);
                    if (o == "inline") {
                        var c = K(s, a);
                        if (c) {
                            i.sourceMap.orig[s] = Q(c);
                        }
                    } else if (o) {
                        i.sourceMap.orig[s] = o;
                    }
                }
            }
            if (n) {
                z(a, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = i[e];
                if (!n) return;
                var t = a.print_to_string().slice(0, -1);
                a = a[e](n);
                r[a.start.file] = a.print_to_string().replace(t, "");
            });
            if (i.validate) a.validate_ast();
            if (e) e.rename = Date.now();
            if (i.rename) {
                a.figure_out_scope(i.mangle);
                a.expand_names(i.mangle);
            }
            if (e) e.compress = Date.now();
            if (i.compress) {
                a = new Xr(i.compress).compress(a);
                if (i.validate) a.validate_ast();
            }
            if (e) e.scope = Date.now();
            if (i.mangle) a.figure_out_scope(i.mangle);
            if (e) e.mangle = Date.now();
            if (i.mangle) {
                a.compute_char_frequency(i.mangle);
                a.mangle_names(i.mangle);
            }
            if (e) e.properties = Date.now();
            if (i.mangle && i.mangle.properties) G(a, i.mangle.properties);
            if (e) e.output = Date.now();
            var f = {};
            var u = be(i.output, {
                ast: false,
                code: true
            });
            if (u.ast) f.ast = a;
            if (u.code) {
                if (i.sourceMap) {
                    u.source_map = $(i.sourceMap);
                    if (i.sourceMap.includeSources) {
                        if (r instanceof Bn) {
                            throw new Error("original source content unavailable");
                        } else for (var s in r) if (kn(r, s)) {
                            u.source_map.setSourceContent(s, r[s]);
                        }
                    }
                }
                delete u.ast;
                delete u.code;
                var l = Kr(u);
                a.print(l);
                f.code = l.get();
                if (i.sourceMap) {
                    f.map = u.source_map.toString();
                    var p = i.sourceMap.url;
                    if (p) {
                        f.code = f.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (p == "inline") {
                            f.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + X(f.map);
                        } else {
                            f.code += "\n//# sourceMappingURL=" + p;
                        }
                    }
                }
            }
            if (i.nameCache && i.mangle) {
                if (i.mangle.cache) i.nameCache.vars = se(i.mangle.cache);
                if (i.mangle.properties && i.mangle.properties.cache) {
                    i.nameCache.props = se(i.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                f.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                f.warnings = t;
            }
            return f;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            nn.log_function();
            nn.disable_validation();
        }
    }
    _["Dictionary"] = xn;
    _["is_statement"] = On;
    _["List"] = _n;
    _["minify"] = fe;
    _["parse"] = Vr;
    _["push_uniq"] = gn;
    _["TreeTransformer"] = Hr;
    _["TreeWalker"] = Ir;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
